﻿define([],function(){
    return {
        widgetTest:[{
            fixed:"top",
            type:"topBar",
            label:"组件测试",
            left:[{
                type:"iconMenuItem",
                label:"返回",
                icon:"",
                arrow:"left",
                href:"back"
            }]
        },{
            type:"flexBar",
            fixed:"top",
            buttons:[{
                //分类选择
                id:"groupId",
                dojoType:"cq/app/widget/mobile/menu/DropDownButton",
                label:"全部",
                dropdownInfo:{
                    items:[{
                        _id:"12345",
                        label:"12345"
                    },{
                        _id:"12346",
                        label:"12346"
                    },{
                        _id:"12347",
                        label:"12347"
                    },{
                        _id:"12348",
                        label:"12348"
                    },{
                        _id:"12349",
                        label:"12349"
                    }]
                }
            },{
                //排序选择
                id:"orderBy",
                dojoType:"cq/app/widget/mobile/menu/DropDownButton",
                label:"未分类",
                dropdownInfo:{
                    items:[{
                        _id:"12345",
                        label:"12345"
                    },{
                        _id:"12346",
                        label:"12346"
                    },{
                        _id:"12347",
                        label:"12347"
                    },{
                        _id:"12348",
                        label:"12348"
                    },{
                        _id:"12349",
                        label:"12349"
                    }]
                }
            },{
                id:"hahha",
                dojoType:"cq/app/widget/mobile/menu/DropDownButton",
                label:"认证",
                dropdownInfo:{
                    dataProvider:"cq/bo/shop",
                    targetMethod: "getPlatformShopListUrl",
                    itemPropMethod: "getShopItemProp",
                    queryParamMethod: "getPlatformShopListParam",
                    labelField:"shopName"
                }
            }]
        },{
            dojoType: "cq/app/widget/web/DataLayout",
            dataProvider: "cq/bo/widgetTest",
            layoutMethod: "getMobileTestLayout"
        },{
            fixed:"bottom",
            type:"footerBar",
            buttons:[{
                dojoType:"cq/app/widget/mobile/menu/ColumnButton",
                //正常按钮，链接
                className:"footer-tab-dark",
                label:"找回密码",
                href:"#retrieve"
            },{
                dojoType:"cq/app/widget/mobile/menu/ColumnButton",
                className:"footer-tab-highlight",
                label:"注销",
                dataProvider:"cq/bo/user",
                action:"logout"
            },{
                dojoType:"cq/app/widget/mobile/menu/ColumnButton",
                label:"首页",
                labelClass:"font-size1",
                icon:"images/icon/shop_footer.png",
                iconClass:"footer-tab-img"
            }]
        },{
            //商品列表
            //类型是确定的
            dojoType: "cq/app/widget/mobile/List",
            //数据提供者
            dataProvider: "cq/bo/mat/mat",
            //获取读取数据地址的方法名
            targetMethod: "getOtherShopMatUrl",
            //获取ListItem属性的方法，返回的参数中包含data属性——对应的数据
            itemPropMethod: "getMatCard",
            //依据列表的依赖关系，获取查询参数的方法名
            queryParamMethod: "getOtherShopMatQuery",
            //列表项的类型，对应的对象分别放在web/item和mobile/item中
            itemType: "IconLabel",
            //工作模式：
            //  single单选(会触发onCqChanged)
            //  multi多选(点击之后选中，不触发事件)
            //  其他点击之后调用dataProvider的方法
            workMode: "action",
            //点击事件响应时，点击之后调用的dataProvider的方法名
            clickMethod: "onMatListClick",
            //列表呈现方式
            //  列表呈现方式：cq-card显示为卡片模式，row-list单行列表模式
            //  图标大小：mini-card小图宽度44px，middle-card中图宽度72px，big-card大图宽度128px
            listClass: "cq-card middle-card",
            waitFor: {
                "0": "cqViewParam",
                "orderBy":"orderBy",
                "groupId":"groupId"
            }
        }]
    };
});
