﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-construct",
    "dojo/keys",
    "dojo/on",
    "dojo/query",
    "dojox/mobile/SearchBox",
    "../_WidgetBase"
],function(declare,lang,domConstruct,keys,on,query,SearchBox,_CqWidgetBase){
    //搜索框对象，用于触发其他对象的刷新操作
    return declare("",[SearchBox,_CqWidgetBase],{
        //html模版
        htmlTemp:'<input id="{id}" type="search" class="mblTextBox mblSearchBox cq-search" data-dojo-type="cq/app/widget/mobile/SearchBox" />',
        //执行初始化
        buildRendering:function(){
            this.inherited(arguments);
            this.own(on(this.domNode,"input, paste, cut, compositionend",lang.hitch(this,function(){
                this.onCqChanged(this,this.get("value"));
            })));
            var node = this.domNode;
            this.formNode = domConstruct.create("form",{},this.domNode,"before");
            this.formNode.appendChild(this.domNode);
            this.formNode.onsubmit = function(){
                return false;
            };
        }
    });
});