﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-style",
    "dojo/touch",
    "dojox/mobile/ListItem",
    "cq/biz/blob/blob",
    "cq/widgets/bigImg"
],function(declare,lang,domStyle,touch,ListItem,blob,bigImg){
    //列表选项，呈现为一个ListItem，内容显示在右侧
    return declare("",[ListItem],{
        htmlTemp:'<li class="cq-form-img cq-field-input li-icon" data-dojo-type="cq/app/widget/mobile/edit/Image" data-dojo-props=\'sizeType:"{sizeType}",canEdit:"{canEdit}",clickImg:"{clickImg}",field:"{field}",label:"{label}",size:{j:size}\'></li>',
        field:"",
        label:"",
        size:{},
        //默认为压缩
        sizeType:"",
        clickable:true,
        clickImg:false,
        canEdit:true,
        
        buildRendering:function(){
            this.clickImg = this.clickImg!==false&&this.clickImg!=="false"&&this.clickImg!=="";
            this.canEdit = this.canEdit!==false&&this.canEdit!=="false";
            this.inherited(arguments);
            var size = {};
            if(this.size.width||this.size.height){
            }else{
                this.size = {width:128,height:128};
            }
            /*
            this.own(touch.release(this.domNode,lang.hitch(this,function(e){
                if(!this.canEdit){
                    return;
                }
                if(!this.rightIcon2||e.target===this.rightIcon2Node){
                    blob.selectAndUpload(this.size,0.7,this.sizeType).then(lang.hitch(this,function(data){
                        if(data.items && data.items.length == 1){
                            var value = data.items[0].uri;
                            this.setValue(value);
                            this.onFieldChanged(this,this.field,value);
                        }
                    }));
                }
            })));
            */
            this.domNode.addEventListener("click",lang.hitch(this,function(e){
                if(!this.canEdit){
                    return;
                }
                if(!this.rightIcon2||e.target===this.rightIcon2Node){
                    blob.selectAndUpload(this.size,0.7,this.sizeType).then(lang.hitch(this,function(data){
                        if(data.items && data.items.length == 1){
                            var value = data.items[0].uri;
                            this.setValue(value);
                            this.onFieldChanged(this,this.field,value);
                        }
                    }));
                }
            }));
        },
        setCanEdit:function(canEdit){
            this.canEdit=canEdit;
            if(this.rightIconNode){
                domStyle.set(this.rightIconNode,"opacity",this.canEdit?1:0);
            }
        },
        getValue:function(){
            return this.get("value");
        },
        setValue:function(value){
            if(!this.canEdit){
                //this.rightIconNode.innerHTML="";
                domStyle.set(this.rightIconNode,"opacity",0);
            }
            this.set("value",value);
            this.set("rightIcon2",value||"");
        },
        onClick:function(){
            //return false;
            
            if(this.clickImg&&!this.canEdit&&this.value){
                var imgSrcUrl = this.value;
                bigImg.show(imgSrcUrl);
            }else{
                return false;
            }
        },
        onFieldChanged:function(widget,field,value){
            
        }
    });
});