//更改人：郭周全 
//原因：实现enabled和disabled
//2016/09/30  
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/xhr",
    "dojo/dom-style",
	"dojo/query",
    "dojox/mobile/ListItem",
    "dojox/mobile/TextBox",
    "dojox/mobile/EdgeToEdgeList",
    "dijit/_WidgetBase",
    "cq/biz/user/user",
    "cq/util/css/clearButtonUtil",
    "cq/util/config/config"
],function(declare,lang,xhr,domStyle,query,ListItem,TextBox,EdgeToEdgeList,_WidgetBase,user,clearButtonUtil,config){
    return declare("",[EdgeToEdgeList],{
        htmlTemp:'<div class="cq-form-vcode cq-field-input" data-dojo-type="cq/app/widget/mobile/edit/VCode" data-dojo-props=\'label:"{label}",canEdit:"{canEdit}",field:"{field}",errorMsg:"{errorMsg}",unExists:"{unExists}"\'></div>',
        field:"",
        canEdit:true,
        errorMsg:"",
        unExists:"",
        label:"手机号,验证码",
        placeholder:"",
        buildRendering:function(){
            this.inherited(arguments);
            this.containerNode = this.containerNode||this.domNode;
            this.canEdit = this.canEdit!==false&&this.canEdit!=="false";
            this.label = this.label||"手机号,验证码";
            this.errorMsg = this.errorMsg||"请输入正确的11位电话号码";
            this.unExists = this.unExists||"账号已经存在,请直接登陆";
            this.placeholder = this.placeholder||"请填写手机号,请填写短信验证码";
            this.un = new ListItem({
                label:this.label.split(",")[0],
                //canEditList : true
            });
            this.unTextBox = new TextBox({
                placeholder:this.placeholder.split(",")[0],
                className:"cq-form-input cq-field-input"
            });
            this.vcode = new ListItem({
                label:this.label.split(",")[1],
                rightText:"获取验证码",
                className:"mblListItem cq-li-vcode"
            });
            this.vcodeTextBox = new TextBox({
                placeholder:this.placeholder.split(",")[1],
                className:"cq-form-input cq-field-input"
            });
            //domStyle.set(this.vcode.labelNode,"overflow","visible");
			domStyle.set(this.vcodeTextBox.domNode,"width","48%");
            /*this.btn = new ListItem({
                rightText:"获取验证码",
                className:"mblListItem cq-li-vcode"
            });*/
            this.un.placeAt(this.containerNode);
            this.unTextBox.placeAt(this.un, "first");
            clearButtonUtil.initClearButton(this.unTextBox.domNode);
            this.vcode.placeAt(this.containerNode);
            this.vcodeTextBox.placeAt(this.vcode, 1);
            // this.btn.placeAt(this.containerNode);
            this.unTextBox.connect(this.unTextBox.domNode, "oninput", lang.hitch(this, function(evt){
                this.onFieldChanged(this, this.field.split(",")[0], this.unTextBox.get("value"));
                this.value[0] = this.unTextBox.get("value");
                this.value[1] = this.vcodeTextBox.get("value");
            }));
            this.vcodeTextBox.connect(this.vcodeTextBox.domNode, "oninput", lang.hitch(this, function(evt){
                this.onFieldChanged(this, this.field.split(",")[1], this.vcodeTextBox.get("value"));
                this.value[0] = this.unTextBox.get("value");
                this.value[1] = this.vcodeTextBox.get("value");
            }));
            /*this.btn.connect(this.btn.domNode, "onclick", lang.hitch(this, function(evt){
                var target = evt.target;
                if(target.className !== "mblListItemRightText"){
                    return;
                }
                this.validateUserName();
            }));*/
            this.vcodeTextBox.connect(this.vcode.domNode, "onclick", lang.hitch(this, function(evt){
                var target = evt.target;
                if(target.className !== "mblListItemRightText"){
                    return;
                }
                this.validateUserName();
            }));
        },
        validateUserName:function(){
            var username = this.unTextBox.get("value");
            if(this.isCellPhone(username)){
                //user.checkPlatformUser(username).then(lang.hitch(this, function(data) {
                //    if (data.data.ok === 1) {
                //        this.unTextBox.set("value", "");
                //        alert(this.unExists||"账号已经存在,请直接登陆");
                //        setTimeout(function() {
                //            window.moveToView("login");
                //        }, 300);
                //    } else {
                        this.getVCode();
                //    }
                //}));
            }else {
                alert(this.errorMsg||"请输入正确的11位电话号码");
            }
        },
        getVCode:function(){
            if(this.sendingTime){
                alert("请稍后再发!");
                return;
            }
            xhr("POST", {
                url:config.getDataOrigin() + "/biz/sms/sms/send_vcode",
                handleAs:"json",
                content:{
                    tel:this.unTextBox.get("value")
                },
                load:lang.hitch(this, function(rt){
                    if(rt.ok === 1){
                        alert("验证码已发出，请注意查收！");
                        this.sendingTime = Date.now();
                        this.vCodeInterval = setInterval(lang.hitch(this, this.updateVCode), 1000);
                    }
                })
            });
        },
        updateVCode:function(){
            var diff = 60- (Date.now() - this.sendingTime)/1000;
            if(diff > 0){
                diff = diff.toFixed(0);
				query(".mblListItemRightText",this.vcode.domNode)[0].innerHTML = diff + "秒后重发";
                // this.vcode.rightText = diff + "秒后重发";
            }else{
                this.sendingTime = null;
                clearInterval(this.vCodeInterval);
                this.vCodeInterval = null;
                query(".mblListItemRightText",this.vcode.domNode)[0].innerHTML = "获取验证码";
            }
        },
        isCellPhone:function(phone){
            return /(^1[3|4|5|7|8][0-9]{9}$)/.test(phone) && phone.length==11;
        },
        getValue:function(){
            return [this.unTextBox.get("value")||"", this.vcodeTextBox.get("value")||""];
        },
        setValue:function(value){
            this.value = value||[];
            this.unTextBox.set("value", this.value[0]||"");
            this.vcodeTextBox.set("value", this.value[1]||"");
        },
        onFieldChanged:function(widget,field,value){
            
        }
    });
});