﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-construct",
    "dijit/_Widget",
    "../../_WidgetBase"
],function(declare,lang,domConstruct,_Widget,_CqWidgetBase){
    return declare("",[_Widget,_CqWidgetBase],{
        htmlTemp:'<div id="{id}" class="flex1 {className}" data-dojo-type="cq/app/widget/mobile/menu/ColumnButton" data-dojo-props="label:\'{label}\',labelClass:\'{labelClass}\',icon:\'{icon}\',iconClass:\'{iconClass}\',href:\'{href}\',dataProvider:\'{dataProvider}\',action:\'{action}\'"></div>',
        label:"",
        labelClass:"",
        icon:"",
        iconClass:"",
        href:"",
        dataProvider:"",
        action:"",
        buildRendering:function(){
            this.inherited(arguments);
            if(this.icon){
                this.iconArea = domConstruct.create("div",{
                    "class":"full-width h-center"
                },this.domNode);
                this.iconNode = domConstruct.create("img",{
                    style:"display:inline-block;",
                    "class":this.iconClass||"",
                    src:this.icon
                },this.iconArea);
            }
            this.labelNode = domConstruct.create("div",{
                "class":"full-width h-center "+(this.labelClass||""),
                innerHTML:this.label||""
            },this.domNode);
            this.connect(this.domNode,"onclick",this.onClick);
        },
        _clickTimer:null,
        onClick:function(){
            clearTimeout(this._clickTimer);
            this._clickTimer = setTimeout(lang.hitch(this,function(){
                if(this.href){
                    if("back"===this.href){
                        history.back();
                    }else{
                        location.href = this.href;
                    }
                }else if(this.dataProvider&&this.action){
                    var action = this.action;
					var _this = this;
                    require([this.dataProvider],function(dataProvider){
                        dataProvider[action](_this);
                    });
                }
            }),300);
        }
    });
});