﻿define([
    "dojo/_base/declare",
    "dojo/_base/array",
    "dojo/dom-class",
    "dijit/_WidgetBase"
],function(declare,array,domClass,_WidgetBase){
    return declare("",[_WidgetBase],{
        baseClass:"list-layout-item",
        data:null,
        layout:null,
        checked:false,
        buildRendering:function(){
            this.inherited(arguments);
            var getValue = function(column,data){
                return data?(
                    column.formatter?column.formatter(column.field,data):data[column.field]
                ):column.label;
            };
            this.domNode.innerHTML = array.map(this.layout,function(column){
                return '<span class="list-column '+(column.className)+'">'+getValue(column,this.data)+'</span>';
            },this).join("");
            this.connect(this.domNode,"onclick",this.onClick);
        },
        _setCheckedAttr:function(checked){
            this.inherited(arguments);
            this.checked = !!checked;
            domClass[this.checked?"add":"remove"](this.domNode,"label-checked");
        },
        onClick:function(e){
            if(this.data){
                return this.getParent().onItemClick(this,e);
            }
        }
    });
});