﻿// 支持dataProvider(字符串)  contentMethod(字符串)
// 支持属性options 类型object
// 支持属性label
// 支持联动刷新
// cqRefresh
//      有dataProvider  和 contentMethod
//          this.dataProvider[this.contentMethod](this.cqRefInfo,this.options).then(设置label，刷新)
//      否则 依据this.label刷新
// 依据label刷新的方法:支持label为domNode和字符串
// 
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dijit/_WidgetBase",
    "../../_WidgetBase"
],function(declare, lang, _widgetBase,_CqWidgetBase){
    return declare("cq.app.widget.web.menu.Datamenu",[_widgetBase,_CqWidgetBase],{
        htmlTemp:'<div id="{id}" class="cq-view-datamenu" data-dojo-type="cq/app/widget/web/menu/DataMenu" data-dojo-props=\'dataProvider:"{dataProvider}",dataMethod:"{dataMethod}",label:"{label}",options:{j:options}\'></div>',
        dataProvider:"",
        dataMethod:"",
        options:{},
        label:"",
        buildRendering:function(){
            this.inherited(arguments);
            this.cqRefresh();
        },
        cqRefresh:function(){
        // cqRefresh
        //      有dataProvider  和 contentMethod
        //          this.dataProvider[this.contentMethod](this.cqRefInfo,this.options).then(设置label，刷新)
        //      否则 依据this.label刷新
        // 依据label刷新的方法:支持label为domNode和字符串  
            if(this.dataProvider&&this.dataMethod){
                require([this.dataProvider],lang.hitch(this,function(dataProvider){
                    dataProvider[this.dataMethod](this.cqRefInfo,this.options).then(lang.hitch(this,function(label){
                        this.label = label;
                        this._refreshByLabel();
                    }));
                }));    
            }else{
                this._refreshByLabel();
            }
        },
        _refreshByLabel:function(){
            this.label = this.label||"";
            if("string"===typeof(this.label)){
                this.domNode.innerHTML = this.label;
            }else{
                this.domNode.innerHTML = "";
                this.domNode.appendChild(this.label);
            }
        }
    });
});