define([
    "dojo/_base/declare",
    "dojo/_base/array",
    "dojo/_base/json",
    "dojo/_base/lang",
    "cq/biz/object"
],function(declare, array, json, lang, object){
    var O = declare("", object.Schema, {
        modalName:"article/auto_reply",
        loadByShopId:function(){
            return this.getBaseUrl()+"/load?shopId="+this.getShopId();
        },
        loadData:function(param){
            return this.execInCurrentShop("load",param);
        },//添加一个取得数据的方法
        save:function(item){
            return this.execInCurrentShop("save",item);
        },
        loadById:function(id){
            return this.execInCurrentShop("load_by_id",{_id:id});
        },
		deleteById:function(id){
			return this.execInCurrentShop("delete_by_id",{_id:id});
		}
    });
    var o = new O();
    lang.setObject("cq.biz.article.auto_reply", o);
    o.Schema = O;
    return o;
});