﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "cq/biz/object",
    "cq/util/config/config"
], function(declare, lang, object, config) {
    var O = declare("", object.Schema, {
        modalName: "article/pm/rich_text_temp",
        //资讯详情
        loadById: function(id) {
            return this.exec("load_by_id", {
                _id: id,
                shopId: config.getPlatformShopId()
            });
        },
        save: function(item) {
            item.shopId = config.getPlatformShopId();
            // if (item.replaceTxt) {
                // item.replaceTxt = JSON.stringify(item.replaceTxt);
            // }else{
                // item.replaceTxt = '[]';
            // }
            if(!item.replaceTxt) {
                item.replaceTxt = [];
            }
            return this.exec("save", item);
        },
        getLoadUrl: function() {
            //从config中读取platformID
            return this.getBaseUrl() + "/load?shopId=" + config.getPlatformShopId();
        },
        //加载方法,肖芳圆,2016.07.20
        load: function (params) {
            if (!params) {
                params = {};
            }
            params.shopId = config.getPlatformShopId();
            return this.exec("load", params);
        },
        //加载方法,肖芳圆,2016.07.20
        loadByIds:function(ids){
            var i=ids.length;
            while(i--){
                if(!ids[i]){
                    ids.splice(i,1);
                }
            }
            if(ids.length){
                return this.exec("load_by_ids", {ids:ids,shopId:config.getPlatformShopId()});
            }else{
                return this.defTest({data:{ok:1,items:[]}});
            }
        }
    });
    var o = new O();
    lang.setObject("cq.biz.article.pm.richTextTemp", o);
    o.Schema = O;
    return o;
});
