define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "cq/biz/object",
    "cq/util/config/config"
],function(declare, lang, object,config){
    var O = declare("", object.Schema, {
        modalName:"im/channel",
        //资讯详情
        loadById:function(id){
            return this.execInCurrentShop("load_by_id",{_id:id});
        },
        save:function(item){
            return this.execInCurrentShop("save",this.filterSaveData(item));
        },
        getLoadUrl:function(){
            return this.getBaseUrl()+"/load?shopId="+this.getShopId();
        },
        getPlatformLoadUrl:function(){
            return this.getBaseUrl()+"/load?shopId="+config.getPlatformShopId();
        }
    });
    var o = new O();
    lang.setObject("cq.biz.im.channel", o);
    o.Schema = O;
    return o;
});