define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/connect",
    "cq/biz/object",
	"cq/util/config/config"
],function(declare, lang, connect, object, config){
    var O = declare("", object.Schema, {
        modalName:"im/questionMsg",
        getLoadUrl:function(){
            return this.getBaseUrl()+"/load?shopId="+this.getShopId();
        },
        loadById:function(id){
            return this.execInCurrentShop("load_by_id", {_id:id});
        },
		deleteById:function(id){
            return this.execInCurrentShop("delete_by_id", {_id:id});
        },
        save:function(params){
          return this.execInCurrentShop("save", params);
        },
		loadByPlatfrom:function(condition){
			if(!condition){
				var condition={};
			}
			condition.shopId=config.getPlatformShopId();
			return this.exec("load", condition);
		}
    });
    //创建消息对象
    var o = new O();
    lang.setObject("cq.biz.im.questionMsg", o);
    o.Schema = O;
    return o;
});