define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/connect",
    "cq/biz/object",
	"cq/util/config/config"
],function(declare, lang, connect, object, config){
    var O = declare("", object.Schema, {
        modalName:"im/time_line",
        getLoadUrl:function(){
            return this.getBaseUrl()+"/load?shopId="+this.getShopId();
        },
        getPlatformLoadUrl:function(){
            return this.getBaseUrl()+"/load?shopId="+config.getPlatformShopId();
        },
        loadById:function(id){
            return this.execInCurrentShop("load_by_id", {_id:id});
        },
        loadPlatformById:function(id){
            return this.exec("load_by_id", {_id:id,shopId:config.getPlatformShopId()});
        },
        save:function(params){
          return this.execInCurrentShop("save", params);
        },
        savePlatform:function(params){
		  params.shopId = config.getPlatformShopId();
          return this.exec("save", params);
        },
		loadByPlatfrom:function(condition){
			if(!condition){
				var condition={};
			}
			condition.shopId=config.getPlatformShopId();
			return this.exec("load", condition);
		}
    });
    //创建消息对象
    var o = new O();
    lang.setObject("cq.biz.im.timeLine", o);
    o.Schema = O;
    return o;
});