define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "cq/biz/log/log"
],function(declare, lang, log){
    var O = declare("", log.Schema, {
        modalName:"log/shop_log",
        showByFrom:function(fromStr){
            return this.exec("show_by_from",{
                from:fromStr
            });
        },
        add:function(fromStr, msg){
            return this.exec("add", {
                from:fromStr,
                msg:msg
            });
        }
    });
    var o = new O();
    lang.setObject("cq.biz.log.shopLog", o);
    o.Schema = O;
    return o;
});