﻿define([
    "dojo/_base/declare",
    "dojo/_base/array",
    "dojo/Deferred",
    "dojo/_base/lang",
    "cq/biz/object",
    "cq/util/config/config"
],function(declare, array,Deferred, lang, object, config){
    var O = declare("", object.Schema, {
        //后台模块路径
        modalName:"mat/icon",
        //保存数据接口
        save:function(data){
            return this.execInCurrentShop("save",data);
        },
        //为查询界面准备数据源，获取执行操作的地址
        getIconUrl:function(){
            return this.getBaseUrl()+"/load?shopId="+this.getShopId();
        },
        //加载
        load : function(param){
            //param obj
            return this.execInCurrentShop("load",param);
        },
        //删除
        remove:function(data){
            return this.execInCurrentShop("delete_by_id",data);
        },
        //获取平台数据url
        getPlatIconUrl:function(){
            return this.getBaseUrl()+"/load?shopId="+config.getPlatformShopId();
        }
    });
    var o = new O();
        lang.setObject("cq.biz.mat.icon", o);
        o.Schema = O;
        return o;
});