// 创建人：赵春辉
// 功能：畜牧商品
// 创建日期：2016-06-03
define([
   "dojo/_base/declare",
   "dojo/_base/lang",
   "cq/biz/object",
   "cq/util/config/config"
],function(declare,lang,object,config){
    var XmMat = declare("",object.Schema,{
        modalName:"mat/xm_mat",
        // 保存商品，必须保存到当前商家库，有服务器端程序保证向平台库的数据同步
        save:function(data){
            // data = this.filterSaveData(data);
            // return this.execInCurrentShop("save",{data:JSON.stringify(data)});
            return this.execInCurrentShop("save", data);
        },
        // 加载指定商品，直接从平台库加载，只有平台库才有辅助资料信息
        loadById:function(id){
            return this.exec("load_by_id",{
                shopId:config.getPlatformShopId(),
                _id:id
            });
        },
        // 加载商品列表时从平台库加载，同时每个商家只能加载自己的商品
        getLoadUrl:function(){
            return this.getBaseUrl()+"/load?shopId="+config.getPlatformShopId()+"&fromShopId="+this.getShopId();
        },
        //返回mat的load方法的URL,肖芳圆20160802;
        getOnSaleUrl:function (shopId) {
            return this.getBaseUrl()+"/load?shopId="+(shopId||this.getShopId());
        },
        getShopQtyUrl:function(){
            return this.getBaseUrl()+"/load_shop_qty?shopId="+config.getPlatformShopId();
        },
		getShopQty:function(params){
			params.shopId=config.getPlatformShopId();
            return this.exec("load_shop_qty",params);
        }
    });
    var xmMat = new XmMat();
    lang.setObject("cq.biz.mat.xmMat",xmMat);
    return xmMat;
});
