﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "cq/util/config/config",
    "cq/biz/object"
],function(declare,lang,config,object){
    var Price = declare("",object.Schema,{
        modalName:"mk/price",
        save:function(params){
            return this.execInCurrentShop("save",this.filterSaveData(params));
        },
        loadById:function(id){
            return this.execInCurrentShop("load_by_id",{_id:id});
        },
        getLoadUrl:function(){
            return this.getBaseUrl()+"/load?shopId="+this.getShopId();
        },
		getLoadData:function(condition){
            return this.execInCurrentShop("load",condition);
        },
        deleteById:function(id){
            return this.execInCurrentShop("delete_by_id",{_id:id});
        },
        getLatesPrice:function(){
            return this.exec("get_latest",{shopId:config.getPlatformShopId()});
        }
    });
    var price = new Price();
    lang.setObject("cq.biz.mk.price",price);
    return price;
});