﻿// 创建人 : 潘云
// 创建时间 : 2016-7-19
// 创建内容 : 产仔记录后台代理接口
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/_base/json",
    "dojo/Deferred",
    "cq/biz/object"
],function(declare, lang, array, json, Deferred, object){
    var O = declare("",object.Schema,{
        modalName:"pr/deliver_record",
        //加载
        loadById : function(id){
            return this.execInCurrentShop("load_by_id", {_id : id});
        },
        //保存
        save : function(data){
            //data = this.filterSaveData(data);
            return this.execInCurrentShop("save", data);
        },
        //为查询界面准备数据源
        getDeliverRecordUrl : function(){
            return this.getBaseUrl()+"/load?shopId="+this.getShopId();
        },
        //加载
        load : function(param){
           //param obj
           return this.execInCurrentShop("load",param);
        },
        // 获取指定母畜，指定状态的产仔记录
        // 参数 ： cattleId://母畜ID，ablactationState://断奶状态
        loadByStateCattleId : function (param) {
            return this.execInCurrentShop("load_by_State_cattleId",param);
        },
        loadByStateCattleIdUrl : function () {
            return this.getBaseUrl() + "/load_by_State_cattleId?shopId=" + this.getShopId();
        }
    });
    var o = new O();
        lang.setObject("cq.biz.pr.deliverRecord", o);
        o.Schema = O;
        return o;
})