// 创建人：赵春辉
// 内容：提供操作辅助资料的js接口
// 创建日期：2016-06-03
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "cq/biz/object",
    "cq/util/config/config"
], function (declare, lang, object, config) {
    var BillCode = declare("", object.Schema, {
        modalName: "shop/bs/bill_code",
        //  code编码规则
        //      DD@yyyy@@mm@@4@
        //      DD@YY@@mm@@4@
        getBillCode:function(code,num){
            return this.execInCurrentShop("get_bill_code",{
                code:code,
                count:num||1
            });
        }
    });
    var billCode = new BillCode();
    lang.setObject("cq.biz.shop.bs.billCode", billCode);
    return billCode;
});