define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "cq/biz/object",
    "cq/biz/user/user",
    "cq/util/config/config"
],function(declare, lang, object, user, config){
    var O = declare("", object.Schema, {
        modalName:"shop/cm/frequently_purchased_mat",
        // 获取当前用户买了的商品的url
        getLoadUrl:function(){
            return this.getBaseUrl() + "/load?shopId=" + config.getPlatformShopId() + "&userId=" + user.getCurrentUserId();
        },
        //加载购买过的商品-肖芳圆20160804
        load:function () {
            var params = {
                shopId : config.getPlatformShopId(),
                userId : user.getCurrentUserId()
            }
            return this.exec("load", params);
        }
    });
    var o = new O();
    lang.setObject("cq.biz.shop.cm.frequentlyPurchasedMat", o);
    o.Schema = O;
    return o;
});
