﻿// 创建人 : 潘云
// 创建时间 : 2016-7-19
// 创建内容 : 出入库管理后台代理接口
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/_base/json",
    "dojo/Deferred",
    "cq/biz/object"
], function(declare, lang, array, json, Deferred, object) {
    var O = declare("", object.Schema, {
        modalName: "ts/godown_bill",
        //加载
        loadById: function(id) {
            return this.execInCurrentShop("load_by_id", { _id: id });
        },
        //保存
        save: function(data) {
            data = this.filterSaveData(data);
            return this.execInCurrentShop("save", data);
        },
        //为查询界面准备数据源
        getLoadUrl: function() {
            return this.getBaseUrl() + "/load?shopId=" + this.getShopId();
        },
        //加载
        load: function(param) {
            //param obj
            return this.execInCurrentShop("load", param);
        },
        // 出入库审核
        verify: function(param) {
            return this.execInCurrentShop("verify", param);
        },
        // 出入库撤销审核
        unVerify: function(param) {
            return this.execInCurrentShop("unverify", param);
        }
    });
    var o = new O();
    lang.setObject("cq.biz.ts.godownBill", o);
    o.Schema = O;
    return o;
})
