define([
    "dojo/_base/declare",
    "dojo/_base/array",
    "dojo/_base/json",
    "dojo/_base/lang",
    "cq/util/config/config",
    "cq/biz/object"
],function(declare, array, json, lang, config,object){
    var O = declare("", object.Schema, {
        modalName:"ts/pm/shop_pay_log",
        loadById:function(id){
            return this.execInCurrentShop("load_by_id",{
                _id:id
            });
        },
        verify:function(params){
            return this.execInCurrentShop("verify",params);
        },
        save:function(item){
            return this.execInCurrentShop("save",item);
        },
        loadByPlatformId:function(){
            return this.getBaseUrl()+"/load_by_type?shopId="+this.getShopId();
        },
        loadByShopId:function(item){
            return this.execInCurrentShop("load_by_type",item);
        }
    });
    var o = new O();
    lang.setObject("cq.biz.ts.pm.shop_pay_log", o);
    o.Schema = O;
    return o;
});