﻿// 创建人 : 潘云
// 创建时间 : 2016-8-1
// 创建内容 : 库存后台代理接口
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/_base/json",
    "dojo/Deferred",
    "cq/biz/object"
],function(declare, lang, array, json, Deferred, object){
    var O = declare("",object.Schema,{
        modalName:"ts/st/summary_stock",
        //加载
        loadById : function(id){
            return this.execInCurrentShop("load_by_id", {_id : id});
        },
        loadByBatch : function (batch) {
            return this.execInCurrentShop("load_by_batch", {batch : batch});
        },
        //为查询界面准备数据源
        getLoadUrl : function(){
            return this.getBaseUrl()+"/load?shopId="+this.getShopId();
        },
        //加载
        load : function(param){
           //param obj
           return this.execInCurrentShop("load",param);
        }
    });
    var o = new O();
        lang.setObject("cq.biz.ts.st.summaryStock", o);
        o.Schema = O;
        return o;
})