﻿// 创建人 : 潘云
// 创建时间 : 2016-9-30
// 创建内容 : 提醒任务的后台代理接口
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/_base/json",
    "dojo/Deferred",
    "cq/biz/object"
], function(declare, lang, array, json, Deferred, object) {
    var O = declare("", object.Schema, {
        modalName: "ts/today_task",
        //加载
        loadById: function(id) {
            return this.execInCurrentShop("load_by_id", { _id: id });
        },
        //保存
        save: function(data) {
            //data = this.filterSaveData(data);
            return this.execInCurrentShop("save", data);
        },
        //为查询界面准备数据源
        getLoadUrl: function() {
            return this.getBaseUrl() + "/load?shopId=" + this.getShopId();
        },
        //加载
        load: function(param) {
            //param obj
            return this.execInCurrentShop("load", param);
        },
        // 根据任务类型获取当前待完成的数量
        getCountByTaskType : function (param) {
            return this.execInCurrentShop("get_count_by_tasktype", param);
        },
        // 标记一天任务提醒为已完成
        completeById : function (id) {
            return this.execInCurrentShop("complete_by_id", { _id: id });
        } 
    });
    var o = new O();
    lang.setObject("cq.biz.ts.todayTask", o);
    o.Schema = O;
    return o;
})
