define([
    "dojo/_base/declare",
    "dojo/_base/array",
    "dojo/_base/json",
    "dojo/_base/lang",
    "cq/biz/object"
],function(declare, array, json, lang, object){
    var O = declare("", object.Schema, {
        modalName:"ts/xm/immune",
        loadById:function(id){
            return this.execInCurrentShop("load_by_id",{
                _id:id
            });
        },
        save:function(item){
            return this.execInCurrentShop("save",this.filterSaveData(item));
        },
        delete:function(id){
            return this.execInCurrentShop("delete_by_id",{
                _id:id
            });
        },
        load:function(condition){
            return this.getBaseUrl()+"/load?shopId="+this.getShopId();
        }
    });
    var o = new O();
    lang.setObject("cq.biz.ts.xm.immune", o);
    o.Schema = O;
    return o;
});