define([
    "dojo/_base/declare",
    "dojo/_base/array",
    "dojo/_base/json",
    "dojo/_base/lang",
    "dojo/cookie",
    "cq/biz/object",
    "dojo/Deferred"
],function(declare, array, json, lang, cookie, object,Deferred){
    var O = declare("", object.Schema, {
        modalName:"user/care",
        loadUrl:function(condition){
            //return this.execInCurrentShop("load",condition);
            return this.getBaseUrl()+"/load?shopId="+this.getShopId();
        },
        load:function(condition){
            return this.execInCurrentShop("load",condition);
        },
        save:function(item){
            return this.execInCurrentShop("save",item);
        },
        delete:function(id){
            return this.execInCurrentShop("delete_by_id",{_id:id});
        },
        loadById:function(id){
            return this.execInCurrentShop("load_by_id",{_id:id});
        },
        updateCaresOrder:function(cares){
            return this.execInCurrentShop("update_order",{data:json.toJson(cares)});
        }
    });
    var o = new O();
    lang.setObject("cq.biz.user.care", o);
    o.Schema = O;
    return o;
});