define([
    "dojo/_base/declare",
    "dojo/_base/array",
    "dojo/_base/json",
    "dojo/_base/lang",
    "dojo/cookie",
    "cq/biz/object",
    "dojo/Deferred",
    "dojo/topic",
    "cq/util/config/config"
],function(declare, array, json, lang, cookie, object, Deferred, topic,config) {
    var O = declare("", object.Schema, {
        modalName : "user/expert",
        loadById : function(id) {
            return this.execInCurrentShop("load_by_id", {_id : id});
        },
        save : function(item) {
            return this.execInCurrentShop("save", item);
        },
        load : function(condition) {
            return this.getBaseUrl() + "/load?shopId="+ config.getPlatformShopId();
        },
		loadDataByPlatform : function(condition) {
			condition.shopId=config.getPlatformShopId();
            return this.exec("load", condition);
        }
    });
    var o = new O();
    lang.setObject("cq.biz.user.expert", o);
    o.Schema = O;
    return o;
});