define([
    "dojo/_base/declare",
    "dojo/_base/array",
    "dojo/_base/json",
    "dojo/_base/lang",
    "dojo/cookie",
    "cq/biz/object",
    "dojo/Deferred",
    "dojo/topic",
    "cq/util/config/config",
    "cq/widgets/item/itemProp"
],function(declare, array, json, lang, cookie, object,Deferred,topic,config,itemProp){
    var O = declare("", object.Schema, {
        modalName:"user/user_farmer",
        getLoadUrl: function(){
            return this.getBaseUrl() + "/load?shopId=" + this.getShopId();
        },
        load:function(condition){
            condition.shopId = condition.shopId||this.getShopId();
            return this.exec("load",condition);
        },
        loadById : function(id){
            return this.execInCurrentShop("load_by_id", {_id: id}); 
        },
        //xuaxue 2016/8/17 乡村需要的格式
        loadAsBoxes:function(params){
            var def =new Deferred();
            params.shopId = params.shopId||this.getShopId();
            this.exec("load",params).then(lang.hitch(this,function(data){
                itemProp.initReVillagerPersonBox(data);
                def.resolve(data.data.items);
            }));
            return def;
        },
    });
    var o = new O();
    lang.setObject("cq.biz.user.user_farmer", o);
    o.Schema = O;
    return o;
});
