﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array"
],function(declare,lang,array){
    return declare("",null,{
        constructor:function(params){
            lang.mixin(this,params);
        },
        fields:null,
        _getFieldItem:function(field,canEdit){
            var fieldItem = null;
            if(lang.isString(field)){
                fieldItem = lang.clone(this.fields[field]);
            }else{
                fieldItem = lang.clone(this.fields[field.field]);
            }
            if("button"===fieldItem.type){
                fieldItem.type = "action";
            }else if("link"===fieldItem.type){
            }else{
                fieldItem.canEdit = false===fieldItem.canEdit||false===canEdit||false===field.canEdit?false:true;
            }
            fieldItem.field = field&&field.field||field;
            return fieldItem;
        },
        getFormItems:function(fields,canEdit){
            return [].concat(array.map(fields,function(field){
                return this._getFieldItem(field,canEdit);
            },this));
        }
    });
});
