define([
    "cq/biz/mat/group",
    "cq/util/sys/query"
], function(group, query) {
    var userBo = {
        getShopMatUrl: function() {
            return group.getGroupUrl();
        },
        getMatCard: function(data) {
            return {
                icon: data.logo,
                label: data.gName,
                data: data
            };
        },
        getMatQuery: function(cqRefInfo) {
            var params = {},
                value = "";
            value = query.getQueryValue(cqRefInfo.search);
            if (value) {
                params.search = value;
            }
            value = query.getQueryValue(cqRefInfo.groupId);
            if (value) {
                params.groupId = value;
            }
            value = query.getQueryValue(cqRefInfo.orderBy);
            if (value) {
                params.orderBy = value;
            }
            return params;
        },
        onMatListClick: function(data, action) {
            window.moveToView('matGroup', data._id);
        }
    };
    return userBo;
});
