﻿require([
    "dojo/ready",
    "dojo/_base/array",
    "dojo/_base/lang",
    "dojo/_base/json",
    "dojo/_base/xhr",
    "dojo/_base/connect",
    "dojo/sniff",
    "dojo/dom-attr",
    "dojo/dom-construct",
    "dojo/dom-style",
    "dojo/query",
    "dojo/topic",
    "dojo/Deferred",
    "dijit/registry",
    "cq/util/config/config",
    "dojox/mobile/parser",
    "dojox/mobile/compat",
    "dojox/mobile/ProgressIndicator",
    "dojox/mobile/ContentPane",
    "dojox/dtl/tag/logic",
    "dojo/parser"
], function(ready, array, lang, json, xhr, connect, has, domAttr, domConstruct, domStyle, query, topic, Deferred, registry,config) {
    var url = document.location.href.split(/#|\?/),
        pane = null;
    //openId保存用户名算了，原来的openId保存在属性window.wxId中
    window.getOpenId = function() {
        return window.openId = localStorage.getItem(window.code) || "";
    };
    window.setOpenId = function(openId) {
        window.openId = openId;
        localStorage.setItem(window.code, openId);
    };
    window.viewGH = function() {
        WeixinJSBridge.invoke('profile', {
            'username': window.g_sys_info.ghCode,
            'scene': '57'
        });
    };
    //初始化用户和服务参数
    window.wxId = url.shift().split("/").pop().split("-");
    //赵春辉    兼容网站版本程序，桌面版本的网页可能是/index.html    2014-06-23
    window.code = window.wxId.shift();
    if((!window.code)||-1<(window.code||"").indexOf(".")){
        window.code = window.g_sys_info&&g_sys_info.code;
    }
    window.wxId = window.wxId.join("-");
    window.openId = window.getOpenId();
    window.util = {
        versions:function(){
            var u = navigator.userAgent || navigator.vendor || window.opera;
            //只用到了这两个，处理这两个就足够了
            return {//移动终端浏览器版本信息
                weixin: /MicroMessenger/.test(u),//是微信浏览器
                mobile: /(android|bb\d+|meego).+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|iris|kindle|lge |maemo|midp|mmp|mobile.+firefox|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\.(browser|link)|vodafone|wap|windows ce|xda|xiino/i.test(u) || /1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s\-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|\-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw\-(n|u)|c55\/|capi|ccwa|cdm\-|cell|chtm|cldc|cmd\-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc\-s|devi|dica|dmob|do(c|p)o|ds(12|\-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(\-|_)|g1 u|g560|gene|gf\-5|g\-mo|go(\.w|od)|gr(ad|un)|haie|hcit|hd\-(m|p|t)|hei\-|hi(pt|ta)|hp( i|ip)|hs\-c|ht(c(\-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i\-(20|go|ma)|i230|iac( |\-|\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\/)|klon|kpt |kwc\-|kyo(c|k)|le(no|xi)|lg( g|\/(k|l|u)|50|54|\-[a-w])|libw|lynx|m1\-w|m3ga|m50\/|ma(te|ui|xo)|mc(01|21|ca)|m\-cr|me(rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(\-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)\-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|\-([1-8]|c))|phil|pire|pl(ay|uc)|pn\-2|po(ck|rt|se)|prox|psio|pt\-g|qa\-a|qc(07|12|21|32|60|\-[2-7]|i\-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h\-|oo|p\-)|sdk\/|se(c(\-|0|1)|47|mc|nd|ri)|sgh\-|shar|sie(\-|m)|sk\-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h\-|v\-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl\-|tdg\-|tel(i|m)|tim\-|t\-mo|to(pl|sh)|ts(70|m\-|m3|m5)|tx\-9|up(\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|\-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(\-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|yas\-|your|zeto|zte\-/i.test(u.substr(0, 4)) //是否为移动终端
            };
        }()
    };
    ready(function() {
        //赵春辉    处理IE的view切换和导航栏的导航问题(dojo/hash的方法不适用)    2014-06-20
        var hash = "",
            frame = null,
            IFRAME_ID = "dojo-hash-iframe",
            ifrSrc = require.toUrl("dojo/resources/blank.html").split("?")[0];
            getHash = function(str, spliter) {
                var index = str.indexOf(spliter);
                return -1 < index ? str.substr(index + 1) : "";
            }, _pollLocation = document.addEventListener ? function() {
                //从dojo/hash抄过来的，这时浏览器会记录浏览历史，直接判断地址栏是否发生变化即可
                if (hash !== getHash(location.href, "#")) {
                    _despatchEvent();
                }
            } : function() {
                //浏览器不记录浏览历史，需要通过一个iframe来记录
                if (hash !== getHash(location.href, "#")) {
                    //地址栏发生了变化，修改iframe的url，触发地址变化的操作
                    frame.src = ifrSrc + "?" + getHash(location.href, "#");
                    _despatchEvent();
                } else if (hash !== getHash(frame.contentWindow.location.href, "?")) {
                    //用户点击了导航栏上的前进或者后退按钮，iframe的url发生了变化，修改当前页面的地址，触发地址变化的操作
                    window.location.href = "#" + getHash(frame.contentWindow.location.href, "?");
                    _despatchEvent();
                }
                setTimeout(_pollLocation, 200);
            }, _despatchEvent = function() {
                //地址栏发生变化的响应函数，修改当前hash，发布事件
                hash = getHash(location.href, "#");
                topic.publish("/loader/hashchange");
            };
        if ("onhashchange" in dojo.global && (!has("ie") || (has("ie") >= 8 && document.compatMode != "BackCompat"))) {
            //need this IE browser test because "onhashchange" exists in IE8 in IE7 mode
            //如果有onhashchange的事件，直接侦听浏览器的事件
            window.onhashchange = _despatchEvent;
        } else {
            //在IE的部分版本下通过轮询侦听地址的变化
            hash = getHash(location.href, "#");
            if (!document.addEventListener) {
                frame = document.createElement("iframe");
                frame.id = IFRAME_ID;
                frame.src = ifrSrc + "?" + hash;
                frame.style.display = "none";
                document.body.appendChild(frame);
            }
            setTimeout(_pollLocation, 200);
        }
        //视图高度的问题
        connect.connect(window,"onresize",window,function(){
            var view = window.curView&&window.viewParam[window.curView].view;
            if(view){
                view.set("height","100%");
                view.resize();
            }
        });
        //处理view切换动画还没结束就启动新的view切换的问题
        var oldParam="";
        var curViewBak = "", sliding = false,uinfo = null,_addLog = function(){
            if(window.oldView){
                //设置页面切换的特有参数
                window.addLog({
                    logType:"viewChangeTime",                                                        //日志类型
                    oldView:window.oldView,                                                              //来源view
                    oldParam:oldParam,                                                            //来源view参数
                    duration:g_s.dateDiff("s",g_s.curPageLoadTime,g_s.getDateTime())            //停留时间  单位：秒
                });
            }
            //初始化页面进入时间
            g_s.curPageLoadTime=g_s.getDateTime();
            //处理view切换日志
            window.addLog({
                logType:"viewChange",
                oldView:window.oldView||"",
                oldParam:oldParam||""
            });
        };
        //插入日志
        window.addLog=function(specificParam,async,isClose){
            //SpecificParam  每种日志特有的字段  json格式
            try
            {
                //数据准备
                var data = {
                    //logType:"wxShare",               //日志类型
                    logTime:g_s.getDateTime(),         //时间
                    host:location.hostname,            //域名
                    code:g_sys_info.code,              //服务号
                    newView:curView,                   //当前页面view
                    param:window.did                   //当前页面参数
                };
                if(window.wx_openId){
                    data.wxId = window.wx_openId;     //微信关注者
                }
                //来源客户
                if(window.srcPid){
                    data.spid=window.srcPid;
                }
                //来源关注者
                if(window.srcWxId){
                    data.swxid=window.srcWxId
                }
                //参数合并
                lang.mixin(specificParam,data);
                if(true===isClose){
                    new Image().src=config.getDataOrigin()+"/log/add?data="+encodeURIComponent(json.toJson(specificParam));
                }
                else{
                    //调用接口插入日志
                    xhr("POSt",{
                        async:async!==false,
                        url:config.getDataOrigin()+"/log/add",
                        content:{
                            data:json.toJson(specificParam)
                        }
                    });
                }
            }
            catch(e)
            {
            }
        };
        window.onHashChange = function (e) {
            window.busy();
            window.oldView = window.curView;
            oldParam=window.did;
            var params = null;
            //处理新老接口的兼容性
            var hash = (window.location.hash || "#").split("?")[0].split("&")[0].substr(1).split("-");
            window.curView = hash.shift() || "main";
            window.did = hash.join("-") || "";
            //赵春辉    有时候?出现在#之后，会导致错误    2015-12-18
            window.did = window.did.split("?")[0];
            sliding = true;
            setTimeout(function () {
                sliding = false;
            }, 500);
            curViewBak = window.oldView||"";
            //两种都没取到时的默认值
            var newView = window.curView = window.curView || "main";
            window.did = window.did || 0 === window.did ? window.did : "";
            // console.error(newView);
            // console.error(window.viewParam);
            // console.error(window.viewParam[newView]);
            if (window.viewParam[newView].view) {
                window.viewParam[newView].view.show();
                _addLog();
            } else {
                return require([window.viewParam[newView].dojoType], function (View) {
                    var v = window.viewParam[newView].view = new View(lang.mixin(window.viewParam[newView], {
                        id: newView,
                        style: "position:relative;display:block;",
                        height: "100%"
                    }));
                    v.connect(v, "onAfterTransitionIn", function () {
                        topic.publish("widgets/show/view", this.id);
                    });
                    pane.appendChild(v.domNode);
                    v.startup();
                    v.show();
                    _addLog();
                });
            }
            setTimeout(function () {
                window.viewParam[newView].view.resize();
                window.viewParam[newView].view.initData();
            });
        };
        //页面关闭之后执行的事件
        window.onbeforeunload=function(){
            //插入页面关闭日志
            window.addLog({
                logType:"viewCloseTime",
                duration:g_s.dateDiff("s",g_s.firstPageLoadTime,g_s.getDateTime())            //停留时间  单位：秒
            },false,true);
            window.addLog({
                logType:"viewChangeTime",                                                        //日志类型
                oldView:window.curView,                                                              //来源view
                oldParam:window.did,                                                            //来源view参数
                duration:g_s.dateDiff("s",g_s.curPageLoadTime,g_s.getDateTime())            //停留时间  单位：秒
            },false,true);
            g_s.firstPageLoadTime=null;
        }
        topic.subscribe("/loader/hashchange", window.onHashChange);
        //window.onhashchange = window.onHashChange;
        window.moveToView = function(view, did,target) {
			if("_blank"===target){
				return window.open("#" + view + (did || 0 === did ? "-" + did : ""),target);
			}
            return window.location.href = "#" + view + (did || 0 === did ? "-" + did : "");
        };
        window.fixedTo = function(value, cm) {
            // 有值才处理小数
            if (value || 0 === value) {
                cm = parseInt(cm, 10);
                if (cm && cm < 8) {
                    //有效数字为 0 到 6 位时
                    value = parseFloat(value, 10).toFixed(cm - 1);
                } else {
                    //不控制时，解析为正常的小数
                    value = parseFloat(value, 10);
                }
            } else {
                value = "";
            }
            return value;
        };
        window.busy = function() {
            domStyle.set("__loader", "display", "");
        };
        window.free = function() {
            domStyle.set("__loader", "display", "none");
        };
        var topPane = registry.byId("topPane");
        if (topPane.get("href")) {
            topPane.connect(topPane,"onLoad",function() {
                pane = query(".centerPane")[0];
                window.onHashChange();
                topPane.resize();
            });
        } else {
            pane = query(".centerPane")[0];
            window.onHashChange();
            topPane.resize();
        }
        //取数据的方法
        //param的内容1：{modalName:"",where:"",orderBy:"",pageSize:"",pageIndex:""},modalName和where是必须的
        //param的内容2：{modalName:"",filter:"",param:{},orderBy:"",pageSize:"",pageIndex:""},modalName/filter/param是必须的，param属性为hash
        window.loadData = function(param) {
            if (param.filter) {
                param.hash = encodeURIComponent(json.toJson(param.param));
                delete param.param;
            }
            var def = new Deferred();
            xhr("GET", {
                url: g_sys_info.url_usr,
                handleAs: "json",
                load: function(data) {
                    def.resolve((data && data.data && data.data.items) || []);
                }, //load中可以获取数据
                sync: false,
                preventCache: true,
                content: param
            });
            return def;
        };
    });
    //工具函数
    //工具函数
    g_s = {
        datePart: function (interval, dtTmp) {
            try {
                var partStr = "";
                //如果是字符串转换为日期型
                if (typeof dtTmp == 'string') myDate = this.stringToDate(dtTmp);
                var Week = ['日', '一', '二', '三', '四', '五', '六'];
                switch (interval) {
                case 'y': partStr = myDate.getFullYear(); break;
                case 'm': partStr = myDate.getMonth() + 1; break;
                case 'd': partStr = myDate.getDate(); break;
                case 'w': partStr = Week[myDate.getDay()]; break;
                case 'wm': partStr = this.weekNumOfMonth(myDate); break;
                case 'wy': partStr = this.weekNumOfYear(myDate); break;
                case 'h': partStr = myDate.getHours(); break;
                case 'n': partStr = myDate.getMinutes(); break;
                case 's': partStr = myDate.getSeconds(); break;
                default:
                }
                return partStr;
            } catch (e) {
                RSAlert(g_sExcept + "datePart()" + e);
            }
            return 1;
        },
        stringToDate: function (DateStr) {
            //try {
            //    var converted = Date.parse(DateStr);
            //    var myDate = new Date(converted);
                //格式为YYYY-MM-dd的日期
            //    if (isNaN(myDate)) {
            //        var dt = DateStr.split(/\s+/),date,time;
            //        if(0<dt[0].indexOf("-")){
            //            date = dt[0].split("-");
            //            time = 1<dt.length?dt[1].split(/[:.]+/):[0,0,0,0];
            //        }else{
            //            date = this.getDate().split("-");
            //            time = dt[0].split(/[:.]+/);
            //        }
            //        time.push(0,0,0,0);
            //        myDate = new Date(date[0], date[1]-1, date[2], time[0], time[1], time[2], time[3]);
            //    }
            //    return myDate;
            //} catch (e) {
            //    RSAlert(gExcept + "stringToDate()" + e);
            //}
            //return 1;
            if(typeof(DateStr)==="string"){
                var dateArray = array.map(DateStr.split(/[ \-:]/g),function(i){
                    return i-0;
                });
                if(dateArray.length!==6){
                    if(dateArray[0]>1000){
                        dateArray.push(0,0,0);
                    }else{
                        dateArray.splice(0,0,1970,1,1);
                    }
                }
                return new Date(dateArray[0],dateArray[1]-1,dateArray[2],dateArray[3],dateArray[4],dateArray[5]);
            }else if("number"===typeof(DateStr)){
                return new Date(DateStr);
            }else{
                return DateStr;
            }
        },
        weekNumOfMonth: function (dtTmp) {
            try {
                var ary = this.toArray(dtTmp);
                var date = new Date(ary[0], parseInt(ary[1]), ary[2]);
                var w = date.getDay();
                var d = date.getDate();
                //(6-w)当前周的还有几天过完（不算今天）。ceil返回大于等于其数字参数的最小整数。
                var monthWeek = Math.ceil((d + 6 - w) / 7);
                return monthWeek;
            } catch (e) {
                RSAlert(g_sExcept + "weekNumOfMonth()" + e);
            }
            return 1;
        },
        toArray:function(dtTmp){
            var dateArr = [];
            if(dtTmp&&typeof(dtTmp)==="object"){
                dateArr = this.toDateString(dtTmp).split("-");
                dateArr[1] = dateArr[1]-1;
            }
            return dateArr;
        },
        weekNumOfYear: function (dtTmp) {
            try {
                var ary = this.toArray(dtTmp);
                var date1 = new Date(ary[0], parseInt(ary[1]), ary[2]);
                //当年第一天
                var date2 = new Date(ary[0], 0, 1);
                //d是当前日期是今年第多少天
                var d = Math.round((date1.valueOf() - date2.valueOf()) / 86400000) + 1;
                //用d + 当前年的第一天的周差距的和在除以7就是本年第几周
                var yearWeek = Math.ceil((d + date2.getDay()) / 7);
                return yearWeek;
            } catch (e) {
            }
            return 1;
        },
        getGuid:function(){
            var guid = window.wx_openId||localStorage.getItem((window.code||g_sys_info.code)+"guid");
            if(!guid){
                guid = this.newGuid();
                localStorage.setItem((window.code||g_sys_info.code)+"guid",guid);
            }
            return guid;
        },
        newGuid:function(){
            var guid = "";
            for (var i = 1; i <= 32; i++){
                var n = Math.floor(Math.random()*16.0).toString(16);
                guid += n;
                if((i==8)||(i==12)||(i==16)||(i==20))
                    guid += "-";
            }
            return guid;
        },
        getDate:function(){
            return this.toDateString(new Date());
        },
        getDateTime:function(){
            return this.toDateTimeString(new Date());
        },
        //提供日期相关函数
        //日期转日期字符串
        toDateString:function(date){
            return typeof(date)==="string"?date:date.getFullYear()+"-"+(date.getMonth()<9?"0":"")+(date.getMonth()+1)+"-"+(date.getDate()<10?"0":"")+date.getDate();
        },
        //日期转时间字符串
        toTimeString:function(date){
            return typeof(date)==="string"?date:(date.getHours()<10?"0":"")+date.getHours()+":"+(date.getMinutes()<10?"0":"")+date.getMinutes()+":"+(date.getSeconds()<10?"0":"")+date.getSeconds();
        },
        //日期转日期时间字符串
        toDateTimeString:function(date){
            return typeof(date)==="string"?date:this.toDateString(date)+" "+this.toTimeString(date);
        },
        //字符串转日期，若没有时间部分，时间部分设置为00:00:00
        toDate:function(dateString){
            return this.stringToDate(dateString);
        },
        //时间增加
        dateAdd:function (dtTmp,strInterval,Number){
            try {
                var myDate = this.toDate(dtTmp);
                switch (strInterval) {
                case 's': return new Date(Date.parse(myDate) + (1000 * Number));
                case 'n': return new Date(Date.parse(myDate) + (60000 * Number));
                case 'h': return new Date(Date.parse(myDate) + (3600000 * Number));
                case 'd': return new Date(Date.parse(myDate) + (86400000 * Number));
                case 'w': return new Date(Date.parse(myDate) + ((86400000 * 7) * Number));
                case 'm': return new Date(myDate.getFullYear(), (myDate.getMonth()) + Number, myDate.getDate(), myDate.getHours(), myDate.getMinutes(), myDate.getSeconds());
                case 'q': return new Date(myDate.getFullYear(), (myDate.getMonth()) + Number * 3, myDate.getDate(), myDate.getHours(), myDate.getMinutes(), myDate.getSeconds());
                case 'y': return new Date((myDate.getFullYear() + Number), myDate.getMonth(), myDate.getDate(), myDate.getHours(), myDate.getMinutes(), myDate.getSeconds());
                default:
                }
            } catch (e) {
                RSAlert(g_sExcept + "dateAdd()" + e);
            }
            return 1;
        },
        dateDiff: function (strInterval, dateStart, dateEnd) {
            var dtStart = dateStart;
            var dtEnd = dateEnd;
            //如果是字符串转换为日期型
            if (typeof dateStart == 'string') dtStart = this.stringToDate(dateStart);
            if (typeof dateEnd == 'string') dtEnd = this.stringToDate(dateEnd);
            switch (strInterval) {
            case 's': return parseInt((dtEnd - dtStart) / 1000);
            case 'n': return parseInt((dtEnd - dtStart) / 60000);
            case 'h': return parseInt((dtEnd - dtStart) / 3600000);
            case 'd': return parseInt((dtEnd - dtStart) / 86400000);
            case 'w': return parseInt((dtEnd - dtStart) / (86400000 * 7));
            case 'm': return (dtEnd.getMonth() + 1) + ((dtEnd.getFullYear() - dtStart.getFullYear()) * 12) - (dtStart.getMonth() + 1);
            case 'y': return dtEnd.getFullYear() - dtStart.getFullYear();
            default:
            }
            return 1;
        }
    };
    var isSend = true; //定义全局变量 是否发送的标志  60秒内不能重复发送
    var isVari = true; //定义全局变量  验证码是否有效  5分钟内验证码有效
    //发送验证码
    window.sendMsg = function(phone) { //发送验证码
        if (isSend) {
            isSend = false; //60秒后方可再次发送
            var def = new Deferred();
            xhr("GET", {
                url: "/w/data/getSmsPwd/" + g_sys_info.code + "?phone=" + phone,
                handleAs: "json",
                /*content: {
                    msgPre: "验证码"
                },*/
                load: lang.hitch(this, function(result) {
                    if (1 === result.rtnType) {
                        alert("验证码已发送，请查看新的手机短信息！如果您的手机具备手机拦截功能，也请检查被拦截的短信息。");
                        def.resolve(true);
                        isVari = true; //验证码5分钟内有效
                        setTimeout(function(){
                            isSend=true;
                        }, 60000); //60 000ms后即60秒可以发送
                        setTimeout(function(){
                            isVari=false;
                        }, 300000); //30 000ms后即5分钟后，验证码过期，需重新发送
                    } else {
                        //执行失败
                        alert("验证码发送失败，请稍后重试。如您长时间未收到系统发送的验证码，请检查是否被拦截功能拦截，或请致电400-023-8993咨询！");
                        def.resolve(false);
                    }
                }),
                error: function() {
                    isSend = true; //60秒后方可再次发送
                    //出错
                    def.resolve();
                }
            });
            return def;
        } else {
            alert("您的发送验证码请求间隔太短，请稍候再发送验证码！");
            window.free();
        }
    };
});