//变更人:肖芳圆
//变更时间:2016-06-03
//变更原因:增加编辑修改畜牧商品辅助资料的接口,提供给XmMat.js使用
//变更时间:2016-06-06
//变更原因:增加加载商品的接口
//变更人:母浚驰
//变更时间:2016-06-22
//变更原因:验证字段
//变更人:冉伟
//变更时间:2016-06-24
//修改内容:处理保存时的busy和free，防止重复提交
//变更人:冉伟
//变更时间:2016-07-7
//修改内容:详细信息填写后没必要还显示必填
// 变更人：张松
// 变更时间：216-07-20
// 修改内容：编辑页面添加标准分类
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/dom-class",
    "dojo/dom-attr",
    "dojo/dom-style",
    "dojo/dom-construct",
    "dojo/query",
    "dojo/Deferred",
    "dojox/mobile/View",
    "dojox/mobile/IconItem",
    "dijit/registry",
    "cq/ui/view/_ViewMixin",
    "cq/biz/mat/mat",
    "cq/biz/mat/group",
    "cq/biz/mat/sort",
    "cq/biz/shop/freightTemplate"
], function(declare, lang, array, domClass, domAttr, domStyle, domConstruct, query, Deferred, View, IconItem, registry, _ViewMixin, mat, group, sort, freightTemplate) {
    var SortPane = declare("", [View, _ViewMixin], {
        indexElement: function() {
            // 添加底部按钮
            var option = {
                isFooter: true,
                forceWidth: false,
                columns: [{
                    label: "确定",
                    className: "flex2 footer-tab-dark",
                    onClick: lang.hitch(this, function(evt) {
                        this.onConfirmBtnClicked(evt);
                    })
                }, {
                    label: "取消",
                    className: "flex2 footer-tab-highlight",
                    onClick: lang.hitch(this, function(evt) {
                        this.onCancleBtnClicked(evt);
                    })
                }]
            };
            this.footerPaner = this.addColumns(option);
            this.createCenterPane();
        },
        createCenterPane: function() {
            var centerPane = this.centerPane = domConstruct.create("div", {
                style: "width:100%;"
            }, this.centerPanel.containerNode);
            var titlePane = this.titlePane = domConstruct.create("div", {
                style: "width:100%;height: 30px;line-height: 30px;font-size: 16px;color: #9e3716;margin-left: 30px;text-align:left;",
                innerHTML: "<a sortid='' style='text-decoration:none;cursor:pointer;'>全部</a>"
            }, this.centerPane);
            var sortPane = this.sortPane = domConstruct.create("div", {
                style: "width:100%;font-size:18px;"
            }, this.centerPane);
            this.loadSorts();
        },
        loadSorts: function(id) {
            // 加载平台标准分类
            sort.loadSubSorts(id, "code").then(lang.hitch(this, function(data) {
                data.data.items.sort(function(item1, item2) {
                    return item1.code - item2.code;
                });
                this.sortData = data.data;
                // 判断是否有下级
                array.forEach(data.data.items, lang.hitch(this, function(item) {
                    domConstruct.create("div", {
                        noSub: item.noSub,
                        innerHTML: item.sortName,
                        sortId: item._id,
                        "class": "sort"
                    }, this.sortPane);
                }));
            }));
        },
        initEvent: function() {
            this.connect(this.titlePane, "onclick", lang.hitch(this, function(e) {
                var target = e.target;
                if (target.tagName == "A") {
                    var newHtml = this.titlePane.innerHTML.substring(0, this.titlePane.innerHTML.indexOf(target.innerHTML) + target.innerHTML.length + 4);
                    if (this.titlePane.innerHTML != newHtml) {
                        this.__data["sortName"] = this.__data["sortName"] && (target.innerHTML == "全部" ? "" : this.__data["sortName"].substring(0, this.__data["sortName"].indexOf(target.innerHTML) + target.innerHTML.length));
                        this.__data["sortId"] = domAttr.get(target, "sortId");
                        for (var p in this.__data) {
                            if (p != "sortName" && p != "sortId") {
                                delete this.__data[p];
                            }
                        }
                        this.titlePane.innerHTML = newHtml;
                        this.currSort = null;
                        this.sortPane.innerHTML = "";
                        domStyle.set(this.sortPane, "display", "block");
                        this.lists && this.lists.destroy();
                        this.loadSorts(domAttr.get(target, "sortId"));
                    }
                }
            }));
            this.connect(this.sortPane, "onclick", lang.hitch(this, function(evt) {
                var target = evt.target;
                if (domClass.contains(target, "sort")) {
                    this.sortPane.innerHTML = "";
                    this.__data["sortName"] = (this.__data["sortName"] ? (this.__data["sortName"] + "/") : "") + target.innerHTML.trim();
                    this.titlePane.innerHTML = (this.titlePane.innerHTML ? (this.titlePane.innerHTML + "/") : "") + "<a style='text-decoration:none;cursor:pointer;' sortid='" + domAttr.get(target, "sortId") + "'>" + target.innerHTML.trim() + "</a>";
                    this.__data["sortId"] = domAttr.get(target, "sortId");
                    if (domAttr.get(target, "noSub")) {
                        // 没有下级，则直接加载属性
                        domStyle.set(this.sortPane, { display: "none" });
                        // domStyle.set(this.titlePane, {display:"none"});
                        var option = {
                            isEdge: true,
                            'class': "top-bottom-margin16",
                            lists: this.loadLists(domAttr.get(target, "sortId"))
                        };
                        this.lists = this.addLists(option);
                        setTimeout(lang.hitch(this, function() {
                            this.connect(this.lists.domNode, "onclick", lang.hitch(this, function(evt1) {
                                var target1 = evt1.target;
                                if (domClass.contains(target1, "propDiv")) {
                                    this.__data[domAttr.get(target1, "title")] = target1.innerHTML.trim();
                                    query(".selected", target1.parentNode)[0] && domClass.remove(query(".selected", target1.parentNode)[0], "selected");
                                    domClass.add(target1, "selected");
                                }
                            }));
                            array.forEach(query(".propInput", this.domNode), lang.hitch(this, function(dom) {
                                this.connect(dom, "onchange", lang.hitch(this, function(evt1) {
                                    var target1 = evt1.target;
                                    if (target1.value == "" || target1.value == null || target1.value == undefined) {
                                        return;
                                    } else {
                                        this.__data[domAttr.get(target1, "title")] = target1.value;
                                        domClass.remove(query(".selected", target1.parentNode)[0], "selected");
                                    }
                                }));
                            }));
                        }), 100);
                    } else {
                        this.loadSorts(domAttr.get(target, "sortId"));
                        // sort.loadSubSorts(domAttr.get(target, "sortId")).then(lang.hitch(this, function(data){
                        //    this.sortData = data.data;
                        //    array.forEach(data.data.items, lang.hitch(this, function(item){
                        //        domConstruct.create("div", {
                        //            noSub:item.noSub,
                        //            innerHTML:item.sortName,
                        //            sortId:item._id,
                        //            "class":"sort"
                        //        }, this.sortPane);
                        //    }));
                        // }));
                    }
                }
            }));
        },
        loadLists: function(sortId) {
            var currSort = this.currSort = array.filter(this.sortData.items, function(item) {
                return item._id == sortId;
            })[0];
            return array.map(currSort.props, lang.hitch(this, function(item) {
                return {
                    label: item.title,
                    rightText: this.getRightText(item),
                    variableHeight: true,
                    noArrow: true
                };
            }));
        },
        getRightText: function(item) {
            var rightText = "<div class='props' style='width:100%;text-align:center;'>";
            array.forEach(item.values, function(value) {
                rightText += "<div class='propDiv' title='" + item.title + "' style='height:30px;line-height:30px;text-align:center;padding-left:10px;" + "padding-right:10px;margin-left:10px;margin-right:10px;display:inline-block;border:1px dashed gray;'>" + value + "</div>";
            });
            if (item.isDefine) {
                rightText += "<input type='text' class='propInput' title='" + item.title + "'>";
            }
            rightText += "</div>";
            return rightText;
        },
        onConfirmBtnClicked: function(evt) {
            // 检查是否全部选择或者填写
            if (!this.currSort || !this.currSort.noSub) {
                alert("请选择标准分类!");
                return;
            }
            var flag;
            array.some(this.currSort.props, lang.hitch(this, function(prop) {
                if (!this.__data[prop["title"]]) {
                    flag = prop;
                    return true;
                }
            }));
            if (flag) {
                alert("参数 " + flag.title + " 必须填写!");
                return;
            }
            this.sortEditDef.resolve(this.getData());
        },
        onCancleBtnClicked: function(evt) {
            this.sortEditDef.resolve();
        },
        startEditSort: function() {
            this.sortEditDef = new Deferred();
            this.setData({});
            return this.sortEditDef;
        }
    });
    return declare("cq.ui.b.m.Mat", [View, _ViewMixin], {
        // 初始化商品的状态  未提交
        verifyState: 0,
        onAfterShow: function() {
            // 如果是修改，加载商品信息
            // registry.byNode(query(".sortLi", this.domNode)[0]).set('rightText', "");
            if (!this.isEditing) {
                this.isEditing = true;
                registry.byNode(query(".propLi", this.domNode)[0]).set("rightText", "");
                if (!window.did) {
                    // 修改上架设置 默认为不上架
                    // 默认库存9999个
                    this.setData({
                        isUse: false,
                        qty: 9999
                    });
                    this.refreshData();
                    this.header.set("label", "添加商品");
                } else {
                    this.header.set("label", "商品");
                    this.loadMatData().then(lang.hitch(this, function(data) {
                        if (data.data.ok == 1) {
                            mat.loadById(data.data.item._id).then(lang.hitch(this, function(dt) {
                                // 如果差到了这个商品 修改商品的状态
                                this.verifyState = dt.data.item.verifyState;
                                data.data.item.groupId = dt.data.item.groupId;
                                // 添加加载的商品信息 作为原始数据
                                this.dataInfo = lang.clone(data.data.item);
                                this.setData(data.data.item);
                                // registry.byNode(query(".sortLi", this.domNode)[0]).set('rightText', this.getData().sortName||"");
                                this.refreshPropLi();
                                this.refreshData();
                            }));
                        } else {
                            // 修改上架设置 默认为不上架
                            // 默认库存9999个
                            this.setData({
                                isUse: false,
                                qty: 9999
                            });
                            this.refreshData();
                        }
                    }));
                }
            }
        },
        refreshPropLi: function() {
            if (this.getData().props) {
                var rightText = "";
                array.forEach(this.getData().props, lang.hitch(this, function(prop) {
                    rightText += prop.value + " ";
                }));
                registry.byNode(query(".propLi", this.domNode)[0]).set("rightText", rightText);
            }
        },
        //加载商品的接口
        loadMatData: function() {
            return mat.loadById(window.did);
        },
        refreshData: function() {
            this.inherited(arguments);
            if (this.__data) {
                if (!this.__data.totalSale) {
                    this.__data.totalSale = '0';
                }
            }
            // 判断是否有主图，如果有，插入到图 片列表中
            // 删除添加按钮外的所有图标
            var m = this.getData();
            if (m.logo) {
                if (!m.images) {
                    m.images = [];
                }
                if (m.images[0] != m.logo) {
                    m.images.splice(0, 0, m.logo);
                }
            }
            this.iconContainer.refreshItems(array.map(m.images || [], function(icon) {
                return {
                    icon: icon
                };
            }));
            //判断详细内容里面有无内容，更改rightText内容
            if (m.content) {
                registry.byNode(query(".content", this.domNode)[0]).set('rightText', '');
            } else {
                registry.byNode(query(".content", this.domNode)[0]).set('rightText', '必填');
            }
        },
        onSortClicked: function() {
            domClass.remove(query(".sortLi", this.domNode)[0], "mblListItemSelected");
            // 如果没有overlay则创建
            if (!this.sortPane) {
                this.sortPane = domConstruct.create("div", {
                    style: "width:100%;height:400px;text-align:left;"
                });
            }
            // 如果已经加载过overlay，则销毁原来的并重新创建
            if (this.sortView) {
                this.sortView.destroy();
            }
            this.sortView = new SortPane();
            this.sortPane.appendChild(this.sortView.domNode);
            this.sortView.startup();
            this.showInOverlay(this.sortPane);
            this.sortView.startEditSort().then(lang.hitch(this, function(data) {
                if (data) {
                    // registry.byNode(query(".sortLi", this.domNode)[0]).set('rightText', data['sortName']);
                    // query(".right-textbox", query(".sortLi", this.domNode)[0])[0].value = data['sortName'];
                    this.__data["sortName"] = data["sortName"];
                    delete data["sortName"];
                    this.__data["sortId"] = data["sortId"];
                    delete data["sortId"];
                    var props = [];
                    for (var title in data) {
                        props.push({ name: title, value: data[title] });
                    }
                    this.__data["props"] = props;
                    this.refreshPropLi();

                    // 设置主图细节图，否则刷新之后，之前上传的图片全部消失
                    var iconItems = this.iconContainer.getChildren();
                    if (iconItems.length > 1) {
                        this.__data.logo = iconItems[0].icon;
                    }
                    var detailImages = [];
                    if (iconItems.length > 2) {
                        for (var i = 1; i < iconItems.length - 1; i++) {
                            detailImages.push(iconItems[i].icon);
                        }
                    }
                    this.__data.images = detailImages;
                    this.refreshData();
                }
                this.hideOverlay();
            }));
        },
        loadList: function() {
            return [{
                    label: '商品编码',
                    noArrow: true,
                    edit: {
                        type: 'text',
                        field: 'code',
                        placeHolder: '必填'
                    }
                }, {
                    label: '商品名称',
                    noArrow: true,
					className: "mblListItem matName",
                    edit: {
                        type: 'text',
                        field: 'mName',
                        placeHolder: '必填'
                    }
                }, {
                    label: '标准分类',
                    moveTo: '#',
                    rightText: "{{sortName}}",
                    className: "mblListItem sortLi",
                    onClick: lang.hitch(this, function() {
                        this.onSortClicked();
                        return false;
                    }),
                    edit: {
                        // moveTo : "#",
                        // type : 'text',
                        field: 'sortName',
                        disabled: true
                    }
                }, {
                    label: "参数",
                    rightText: "",
                    noArrow: true,
                    className: "mblListItem propLi"
                }, {
                    label: '品类',
                    rightText: '',
                    moveTo: "#",
                    __view_id: this.id,
                    edit: {
                        type: 'ref',
                        field: 'groupId',
                        moveTo: "#",
                        params: {
                            // 解决点击添加按钮后，引用界面显示顺序改变的问题
                            target: group.getGroupUrl() + "&orderBy=createAt",
                            query: {
                                isUse: true
                            },
                            searchField: "gName",
                            labelField: "gName",
                            addPageId: "matGroup"
                        }
                    }
                }, {
                    label: '规格',
                    noArrow: true,
                    edit: {
                        type: 'text',
                        field: 'sizeType',
                        placeHolder: '必填'
                    }
                }, {
                    label: "运费",
                    edit: {
                        type: 'text',
                        field: 'freight'
                    }
                }, {
                    label: "运费模板",
                    moveTo: "#",
                    edit: {
                        type: 'ref',
                        field: 'freightTplId',
                        params: {
                            target: freightTemplate.getLoadUrl(),
                            query: {
                                isUse: true
                            },
                            searchField: "title",
                            labelField: "title"
                        }
                    }
                }, {
                    label: '价格',
                    noArrow: true,
                    edit: {
                        type: 'text',
                        field: 'retailPrice',
                        placeHolder: '必填'
                    }
                },
                /*{
                label : '分销价',
                noArrow : true,
                edit : {type : 'text', field : 'settlePrice'}
                },*/
                {
                    label: '市场价',
                    noArrow: true,
                    edit: { type: 'text', field: 'marketPrice' }
                }, {
                    label: '详细信息',
                    rightText: '必填',
                    moveTo: "#",
                    className: 'content mblListItem',
                    edit: {
                        field: "content",
                        type: "richEdit",
                        tempType: "mat"
                    }
                },
                /*{
                label : '配送次数',
                noArrow : true,
                edit : {type : 'text', field : 'deliveryTimes'}
                },*/
                {
                    label: '库存',
                    noArrow: true,
                    edit: {
                        type: 'text',
                        field: 'qty',
                        placeHolder: '必填'
                    }
                }, {
                    label: '销量',
                    noArrow: true,
                    //edit : {type : 'text', field : 'totalSale', placeHolder : '必填'}
                    edit: {
                        type: 'text',
                        field: 'totalSale',
                        disabled: 'true'
                    }
                }
            ];
        },
        onFirstShow: function() {
            var option = {
                left: {
                    iconButton: ' ',
                    arrow: "left",
                    label: "返回",
                    onClick: lang.hitch(this, function() {
                        this.isEditing = false;
                        //window.moveToView("matList");
                        history.back();
                    })
                },
                title: window.did ? "商品" : "添加商品",
                right: {
                    iconButton: ' ',
                    onClick: this.onSaveStore,
                    label: "完成"
                }
            };
            this.addHeader(option);
            option = {
                canAdd: true,
                icons: [],
                editable: true,
                class: "no-shake",
                size: {
                    width: 640,
                    height: 640
                }
            };
            this.iconContainer = this.addImagePicker(option);
            option = {
                isEdge: true,
                'class': "top-bottom-margin16",
                lists: this.loadList()
            };
            this.addLists(option);
			
            //辅助资料修改list的接口
            this.addXmAssistList();
            this.onAfterShow();
        },
        //辅助资料修改list的接口
        addXmAssistList: function() {},
        getData: function() {
            var data = lang.clone(this.inherited(arguments));
            if (data.groupId && data.groupId._id) {
                data.groupId = data.groupId._id;
            }
            //转换畜牧辅助资料的obj为id
            this.xmAssistObjToId(data);
            return data;
        },
        //辅助资料的obj转成id方便保存
        xmAssistObjToId: function(data) {},
        // 用于会员价格按钮使用的接口
        addLeavelPrice: function() {},
        //供重载的保存方法
        saveMat: function(m) {
            var id = m._id;
            mat.save(m).then(function(data) {
                if (!id && m.qty && parseInt(m.qty) > 0 && confirm("上架该商品吗？")) {
                    mat.b2bOnShelf({ _id: data.data.item._id }).then(function(data) {
                        if (data && data.data && data.data.ok === 1) {
                            //保存后执行free操作
                            window.free();
                            //window.moveToView("matList");
                            history.back();
                        } else {
                            alert(data.data.msg);
                        }
                    });
                } else {
                    //保存后执行free操作
                    window.free();
                    //window.moveToView("matList");
                    history.back();
                }

            });
        },
        onSaveStore: function() {
            if (this.isEditing) {
                //点击完成触发onSaveStore函数执行busy操作
                window.busy();
                this.isEditing = false;
                // 保存数据
                var m = this.getData();
                var iconItems = this.iconContainer.getChildren();
                //检查是否设置了主图
                if (iconItems.length > 1) {
                    m.logo = iconItems[0].icon;
                }
                //检查编码重复性
                mat.checkCodeRepeat(m.code).then(lang.hitch(this, function(data) {
                    var dataCode = "";
                    if (data.data.item) {
                        dataCode = data.data.item;
                    }
                    if (dataCode) {
                        //判断有异常，执行free操作
                        window.free();
                        alert("商品编码重复，请重新填写");
                        this.isEditing = true;
                        return;
                    }
                    // 检查必填项是否已填
                    var msg = this.verify(m);
                    if (msg) {
                        //判断有异常，执行free操作
                        window.free();
                        alert(msg);
                        this.isEditing = true;
                        return;
                    }
                    //检查是否设置了细节图
                    var detailImages = [];
                    if (iconItems.length > 2) {
                        for (var i = 1; i < iconItems.length - 1; i++) {
                            detailImages.push(iconItems[i].icon);
                        }
                    }
                    m.images = detailImages;
                    this.saveMat(m);
                }));
            }
        },
        //验证畜牧商品辅助资料检查的接口
        verifyXmAssist: function() {},
        verify: function(data) {
            var msg = "";
            if (!data.logo) {
                msg = "必须设置主图";
            } else if (!data.code) {
                msg = "商品编码必须填写";
            } else if (!data.mName) {
                msg = "商品名称必须填写";
            } else if (!data.sizeType) {
                msg = "规格必须填写";
            } else if (!data.retailPrice) {
                msg = "价格必须填写";
            } else if (!data.content) { // 张松   添加商品详情内容的审核   2016/06/20
                msg = "商品详情必须填写";
            } else if (!data.qty) {
                msg = "库存必须填写";
            } else {
                msg = this.verifyXmAssist(data);
            }
            return msg;
        },
        //加入onDataChanged函数
        onDataChanged: function(field, oldValue, newValue) {
            if (field == "content" && newValue) {
                registry.byNode(query(".content", this.domNode)[0]).set('rightText', '');
            } else if (field == "content") {
                registry.byNode(query(".content", this.domNode)[0]).set('rightText', '必填');
            }
        }
    });
});
