//变更人:肖芳圆
//变更时间:2016-06-03
//变更原因:留出通过辅助资料筛选商品的接口
//变更人: 杜飞军
//变更时间: 2016-06-07
//变更原因: 没有预留按钮对象
//变更人: 杜飞军
//变更时间: 2016-06-07
//变更原因:
//        条件查询后离开页面 再进入时没有刷新页面
//        查询后没有内容提示
//变更人:冉伟
//变更时间:2016/6/22
//变更原因:设置客户端底部图标的高度使其与农企宝底部高度保持一致
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-attr",
    "dojo/dom-class",
    "dojo/dom-construct",
    "dojo/dom-style",
    "dojo/query",
    "dojo/on",
    "dojo/when",
    "dojo/store/JsonRest",
    "dijit/registry",
    "dojox/mobile/View",
    "dojox/mobile/EdgeToEdgeStoreList",
    "cq/ui/view/_ViewMixin",
    "cq/biz/mat/mat",
    "cq/biz/mat/group",
    "cq/util/edit/jsonRef",
    "dijit/_WidgetBase"
], function(declare, lang, domAttr, domClass, domConstruct, domStyle, query, on, when, JsonRest, registry, View, EdgeToEdgeStoreList, _ViewMixin, mat, group, jsonRef, _WidgetBase) {
    return declare("cq.ui.b.m.MatList", [View, _ViewMixin], {
        //筛选条件
        params: null,
        start: 0,
        pageSize: 10,
        hideBottom: false,
        // 用于判断是否在选择状态中
        selectState: false,
        totalCount: 0,
        // 控制选项的显示隐藏
        displaySelect: false,
        // 用于显示品类数据
        matGroup: false,
        isEditing: false,
        onAfterShow: function() {
            //创建数据源
            if (!this.isEditing) {
                // 清除数据
                this.storeList.destroyDescendants();
                var queryResult;
                if (!this.store) {
                    this.params = {
                        isUse: true,
                        //fromShopId:mat.getShopId(),
                        qty: 1
                    };
                    this.store = new JsonRest({
                        target: this.getMatUrl()
                    });
                    queryResult = this.storeList.setStore(this.store, this.params, {
                        start: this.start,
                        count: this.pageSize
                    });
                    this.onLoadListData(queryResult, this.start, this.pageSize);
                } else {
                    // 重置筛选
                    //var condition = this.storeList.get("query");
                    //condition.mName = "";
                    //this.setQuery(condition);

                    // queryResult = this.storeList.setStore(this.store, this.params, {
                    //     start: this.start,
                    //     count: this.pageSize
                    // });
                    // this.onLoadListData(queryResult, this.start, this.pageSize);
                    this.clearSelected();
                    this.changeOnSale({
                        target: query(".tab-selector", this.conditMenus)[0]
                    });
                }
                // 将数据源赋值给storeList

            }
        },
        //获取头部option的函数,可重载
        getHeadOption: function() {
            return {
                left: {
                    iconButton: ' ',
                    arrow: "left",
                    label: "返回",
                    onClick: function() {
                        this.displaySelect = false;
                        domClass.add(this.selectObject, 'none');
                        //window.moveToView("home");
                        history.back();
                    }
                },
                title: "商品管理",
                right: {
                    iconButton: ' ',
                    onClick: function() {
                        this.selectOption();
                    },
                    label: "+",
                }
            };
        },
        //获取商品链接可重载
        getMatUrl: function() {
            return mat.getOnSaleUrl();
        },
        // 设置header右边的class
        setHeadRightClass: function(className) {
            var dom = query('.float-right', this.headerNode.domNode)[0];
            if (dom) {
                domClass.add(dom, className);
            }
        },
        onFirstShow: function() {
            var option = this.getHeadOption();
            this.headerNode = this.addHeader(option);
            // 设置header右边的class
            this.setHeadRightClass('rightFontSize24');
            // 右边显示
            option = {
                left: {
                    iconButton: ' ',
                    arrow: "left",
                    label: "<span class='isSelectAll'>全选</span>",
                    onClick: function() {
                        this.getAllSelect();
                    }
                },
                title: "商品管理",
                right: {
                    iconButton: ' ',
                    onClick: function() {
                        this.exitSelect();
                    },
                    label: "取消",
                }
            };
            this.addSelectHead = this.addHeader(option);
            // 追加后隐藏
            domClass.add(this.addSelectHead.domNode, 'none');
            this.selectObject = domConstruct.create('ul', {
                class: 'selectOption none'
            }, this.domNode);
            domConstruct.create('li', {
                innerHTML: '品类管理',
                click: lang.hitch(this, function() {
                    this.displaySelect = true;
                    this.selectOption();
                    window.moveToView("matGroupList");
                })
            }, this.selectObject);
            domConstruct.create('li', {
                innerHTML: '批量管理',
                click: lang.hitch(this, function() {
                    this.selectState = true;
                    this.selectOption();
                    this.goToSelect();
                })
            }, this.selectObject);
            option = {
                isHeader: true,
                placeHolder: "请输入要查询的条件，按回车查询",
                class: "cqSearchBox",
                type: "search",
                onInput: lang.hitch(this, function(evt) {
                    if (evt.keyCode == 13) {
                        // this.search = evt.target.value;
                        // var condition = this.storeList.get("query");
                        // condition.mName = evt.target.value;
                        // this.setQuery(condition);
                        // condition.mName='';
                        this.params.mName = evt.target.value;
                        this.setQuery(this.params);
                        this.params.mName = '';
                        evt.target.value = "";
                    }
                })
            };
            this.addTextBox(option);
            //this.addSearchInput();
            option = {
                isHeader: true,
                columns: [{
                        label: '出售中',
                        onClick: this.changeOnSale
                    }, {
                        label: '已售罄',
                        onClick: this.changeSaleOut
                    }, {
                        label: '已下架',
                        onClick: this.changeNoSale
                    }
                    /*,{
                    label:'分类'
                    }*/
                ],
                labelClass: 'font-size1 tab-selector'
            };
            this.conditMenus = this.addColumns(option);
            option = {
                columns: [{
                        className: 'flex2 footer-tab-highlight',
                        label: '添加商品',
                        onClick: function() {
                            window.moveToView("mat");
                        }
                    },
                    // {
                    //     /*icon : 'images/icon/mat.png',*/
                    //     /*iconClass:'width-16',*/
                    //     /*iconClass:'footer-tab-img',*/
                    //     label : '管理品类',
                    //     onClick : function () {
                    //         window.moveToView("matGroupList");
                    //     }
                    // }
                ],
                /*valueClass : 'font-size3',*/
                labelClass: 'font-size1',
                className: 'fix-footer',
                isFooter: true
            };
            this.footerButton = this.addColumns(option);
            // 提供隐藏底部按钮
            if (this.hideBottom) {
                this.hideFooterButton();
            }
            // 用于编辑多个商品处理
            option = {
                columns: [{
                    label: '改品类',
                    className: "footer-tab-highlight",
                    onClick: function() {
                        this.matGroupList();
                    }
                }, {
                    label: '上架',
                    onClick: function() {
                        this.onShopGoodUp();
                    },
                    className: "footer-tab-dark"
                }, {
                    label: "下架",
                    onClick: lang.hitch(this, function() {
                        this.onShopGoodDown();
                    })
                }],
                labelClass: 'font-size1',
                // className: 'padding-top-bottom16',
                isFooter: true
            };
            this.addNoneNode = this.addColumns(option);
            // 如果直接添加none会导致计算错误 先创建后隐藏
            domClass.add(this.addNoneNode, 'none');
            // 用于编辑多个商品处理
            // option = {
            //     columns: [{
            //         label: '确认',
            //         onClick: function() {
            //             this.matGroupSave();
            //         }
            //     }],
            //     labelClass: 'font-size1',
            //     className: 'padding-top-bottom16',
            //     isFooter: true
            // };
            // this.groupSave = this.addColumns(option);
            // // 如果直接添加none会导致计算错误 先创建后隐藏
            // domClass.add(this.groupSave, 'none');
            this.storeList = new EdgeToEdgeStoreList({
                append: true,
                constraint: false,
                query: {},
                class: "icon-list-item imgSize64",
                variableHeight: true,
                //获取数据完成后调用的的处理方法
                onComplete: lang.hitch(this, function(data) {
                    /*if(!data.length){
                        this.promptMessage();
                    }*/
                    for (var i = 0; i < data.length; i++) {
                        //隐藏选择框
                        data[i]._label = this.isAllSelectState();
                        if (!this.matGroup) {
                            data[i]._label += "<div class='selectedState'><div class='mat-list-left'><img src='" + (data[i].logo ? data[i].logo : 'images/nomat.png') + "'></div><div class='mat-list-right'>" +
                                "<div class='mat-list-mname mat-list-margin margin-top5'>" + data[i].mName +
                                "</div><div class='mat-list-price mat-list-margin margin-top5'>￥" + window.fixedTo(data[i].retailPrice, 3) +
                                "</div><div class='mat-list-qty mat-list-margin margin-top5'><div class='halfwidth'>库存：" + window.fixedTo(data[i].qty, 1) +
                                "</div><div class='margin-top5 halfwidth'>销量：" + window.fixedTo(data[i].totalSale, 1) +
                                "</div></div>" +
                                "<div>";
                        } else {
                            data[i]._label += "<div class='mat-list-mname mat-list-margin margin-top5>" + data[i].gName + "</div>";
                        }

                        data[i].moveTo = "#";
                        //data[i]._logo = data[i].logo ? data[i].logo : 'images/nomat.png';
                        //data[i]._logo='images/nomat.png';
                    }
                    this.storeList.generateList(data);
                    if (this.selectState) {
                        query(".selectLi", this.domNode).forEach(function(node) {
                            domClass.remove(node, "none");
                        });
                    }
                    this.busy = false;
                }),
                queryOptions: {
                    count: this.pageSize,
                    start: this.start
                },
                itemMap: {
                    _label: "label",
                    _logo: "icon",
                    moveTo: "moveTo"
                }
            });
            domClass.add(query('.tab-selector', this.domNode)[0], "selected");
            this.storeList.placeAt(this.centerPanel.containerNode, "last");
            this.storeList.on("click", lang.hitch(this, this.onClickList));
            this.centerPanel.on("afterscroll", lang.hitch(this, this.onLoadMore));
            this.onAfterShow();
        },
        // 用于保存选中的商品品类
        matGroupSave: function(groupId) {
            if (!this.busy) {
                this.busy = true;
                mat.setGroupByIds({
                    ids: this.matGroupData,
                    groupId: groupId
                }).then(lang.hitch(this, function(matData) {
                    if (matData && matData.data && matData.data.ok === 1) {
                        alert('设置品类成功');
                        this.busy = false;
                        this.exitSelect();
                    } else {
                        this.busy = false;
                        alert('设置品类失败');
                    }
                }));
            }
        },
        // 创建选项盒子
        selectOption: function() {
            if (this.displaySelect) {
                domClass.add(this.selectObject, 'none');
                this.displaySelect = false;
            } else {
                domClass.remove(this.selectObject, 'none');
                this.displaySelect = true;
            }
        },
        //全选/取消全选样式控制
        allSelectStayle: function(selectAll) {
            query(".selectLi", this.domNode).forEach(function(matItem) {
                //已经选中的畜只不需要再次选中...待处理
                if (selectAll !== false) {
                    domAttr.set(matItem, "checked", "checked");
                    domClass.add(matItem, "isSelect");
                } else {
                    domAttr.set(matItem, "checked", "");
                    domClass.remove(matItem, "isSelect");
                }
            }, this);
        },
        // 获得选中对象的信息
        getSelectInfo: function() {
            var cattleArr = [];
            //遍历所有列表，若已选中，则将其数据存储
            query(".selectLi", this.domNode).forEach(function(node) {
                if (domClass.contains(node, "isSelect")) {
                    var li = registry.getEnclosingWidget(node);
                    //获取该条信息
                    var cattleData = {};
                    cattleData._id = li.params._id;
                    cattleData.verifyState = li.params.verifyState;
                    cattleData.mName = li.params.mName;
                    //数组追加
                    cattleArr.push(cattleData);
                }
            });
            return cattleArr;
        },
        //全选/取消按钮显示控制
        selectAllInner: function() {
            var targ = query(".isSelectAll", this.domNode)[0];
            if (targ.innerHTML == "全选") {
                targ.innerHTML = "取消全选";
            } else {
                targ.innerHTML = "全选";
            }
        },
        // 判断是否点击了全选:加载更多之后的单选框选择样式处理
        isAllSelectState: function() {
            var label;
            var targ = query(".isSelectAll", this.domNode)[0];
            if (targ.innerHTML == "取消全选") {
                label = "<label class='edit-car-checkbox selectLi isSelect none' checked='checked' style='float: left;top: 22px'></label>";
            } else {
                label = "<label class='edit-car-checkbox selectLi none'  checked='' style='float: left;top: 22px'></label>";
            }
            return label;
        },
        // 验证状态只有重盐有 默认不开启
        matVerify: false,
        // 多选择上架处理
        onShopGoodUp: function() {
            var data = this.getSelectInfo(),
                info;
            if (data.length === 0) {
                alert('没有选择商品');
                return;
            }
            // 验证商品是否被审核
            if (this.matVerify) {
                info = this.matVerifyState(data);
            } else {
                info = { state: true };
            }
            if (info.state) {
                if (confirm("批量上架商品，确定上架选中的商品吗？") && !this.busy) {
                    this.busy = true;
                    this.onMatUseUp(data).then(lang.hitch(this, function(matData) {
                        if (matData && matData.data && matData.data.ok === 1) {
                            this.busy = false;
                            this.exitSelect();
                        } else {
                            this.busy = false;
                            alert("批量上架失败");
                        }
                    }));
                }
            } else {
                alert(info.msg);
            }
        },
        // 多选上架接口 可重写
        onMatUseUp: function(data) {
            return mat.matUseUpByIds({
                ids: data
            });
        },
        // 用于判断商品是否审核通过
        matVerifyState: function(data) {
            var info = {
                state: true,
                msg: ''
            };
            for (var i = 0; i < data.length; i++) {
                if (data[i].verifyState !== 2) {
                    info.state = false;
                    info.msg = data[i].mName + '商品还没有通过审核,不能上架';
                    return info;
                }
            }
            return info;
        },
        // 多选择下架处理
        onShopGoodDown: function() {
            var data = this.getSelectInfo();
            if (data.length === 0) {
                alert('没有选择商品');
                return;
            }
            if (confirm("批量下架商品，确定下架选中的商品吗？") && !this.busy) {
                this.busy = true;
                this.onMatUseDown(data).then(lang.hitch(this, function(matData) {
                    if (matData && matData.data && matData.data.ok === 1) {
                        this.busy = false;
                        this.exitSelect();
                    } else {
                        this.busy = false;
                        alert("批量下架架失败");
                    }
                }));
            }
        },
        // 多选下架接口 可重写
        onMatUseDown: function(data) {
            return mat.matUseDownByIds({
                ids: data
            });
        },
        // 用于退回当开始界面 退出选择
        exitSelect: function() {
            this.matGroup = false;
            this.selectState = false;
            this.isEditing = false;
            // 修改头部显示
            domClass.remove(this.headerNode.containerNode, 'none');
            domClass.add(this.addSelectHead.containerNode, 'none');
            // 修改底部显示
            domClass.add(this.addNoneNode, 'none');
            // domClass.add(this.groupSave, 'none');
            domClass.remove(this.footerButton, 'none');
            //单选框隐藏清空样式暂不处理
            query(".selectLi", this.domNode).forEach(function(node) {
                domClass.add(node, "none");
            });
            this.onAfterShow();
            this.resize();
        },
        //判断是否所有单选框都已选中，更改全选字样
        isAllComSelect: function() {
            var tar;
            //字样变化
            var targ = query(".isSelectAll", this.domNode)[0];
            query(".selectLi", this.domNode).forEach(function(node) {
                if (!domClass.contains(node, "isSelect")) {
                    targ.innerHTML = "全选";
                    //单选框复原（回复非全选）
                    tar = true;
                }
            });
            if (tar === true) {
                this.selectAll = true;
            } else if (tar === false) {
                targ.innerHTML = "取消全选";
                this.selectAll = false;
            }
        },
        initJsonRefEdit: function(edit) {
            if (edit && edit.params && edit.params.target && edit.params.labelField && edit.params.searchField) {
                if (edit.queryChange) {
                    if (jsonRef.jsonStoreListHash[edit.params.target]) {
                        jsonRef.jsonStoreListHash[edit.params.target].query = edit.queryChange();
                    } else {
                        edit.params.query = edit.queryChange();
                    }
                }
                jsonRef.startEdit("", this, edit.params).then(lang.hitch(this, function(data) {
                    if (data) {
                        this.matGroupSave(data._id);
                    } else {
                        //alert('获取品类数据失败');
                    }

                }));
            } else {
                console.error("参数错误:" + edit);
            }
        },
        // 显示品类列表
        matGroupList: function() {
            // 获得选中的数据
            this.matGroupData = this.getSelectInfo();
            if (!this.matGroupData.length) {
                alert('没有选择要修改品类的商品');
                return;
            }
            // 定义引用
            this.initJsonRefEdit({
                type: "ref",
                field: "orderCheckerId",
                params: {
                    searchField: "gName",
                    target: group.getGroupUrl() + "&orderBy=createAt",
                    labelField: "gName"
                }
            });
            this.isEditing = true;
            // domClass.remove(this.groupSave, 'none');
            this.resize();
        },
        // 用于多个 选项操作
        goToSelect: function() {
            // 修改头部显示
            domClass.add(this.headerNode.containerNode, 'none');
            domClass.remove(this.addSelectHead.containerNode, 'none');
            // 修改底部显示
            domClass.remove(this.addNoneNode, 'none');
            // domClass.add(this.groupSave, 'none');
            domClass.add(this.footerButton, 'none');
            this.showAllSelect();
            //this.resize();
        },
        // 用于显示列表的选项框
        showAllSelect: function() {
            query(".selectLi", this.domNode).forEach(function(node) {
                domClass.remove(node, "none");
            }, this);
            query('.selectedState', this.domNode).forEach(function(node) {
                domStyle.set(node, 'margin-left', '30px');
            });
        },
        //全选/取消全选
        getAllSelect: function() {
            //this.getAllSelectCattle();
            //全选样式变化
            // 只能在没有非品类选择中使用
            if (!this.matGroup) {
                if (this.selectAll === false) {
                    //选择匡变化:未选中样式
                    this.allSelectStayle(this.selectAll);
                    //在全选之后，全选变为取消全选
                    this.selectAllInner();
                    this.selectAll = true;
                } else {
                    //选择匡变化：选中样式
                    this.allSelectStayle(this.selectAll);
                    //在全选之后，全选变为取消全选
                    this.selectAllInner();
                    this.selectAll = false;
                }
            } else {
                alert('品类选择不能使用');
            }
        },
        onClickList: function(evt) {
            // 得到点击的ListItem
            var li = registry.getEnclosingWidget(evt.target);
            if (domClass.contains(evt.target, 'selectLi')) {
                this.checkClick(evt);
                return;
            }
            if (li.declaredClass != "dojox.mobile.ListItem" || this.selectState)
                return;
            var _id = li.params._id;
            window.moveToView("matDetailB", _id);
        },
        // 提示信息
        promptMessage: function() {
            alert("没有查到内容");
        },
        onLoadMore: function(evt) {
            if (!this.busy && evt.afterBottom) {
                this.start = this.start + this.pageSize;
                if (this.canLoadMore(this.start)) {
                    console.log("加载更多商品");
                    this.busy = true;
                    setTimeout(lang.hitch(this, function() {
                        var queryResult = this.storeList.setQuery(this.storeList.get("query"), {
                            start: this.start,
                            count: this.pageSize
                        });
                        this.onLoadListData(queryResult, this.start, this.pageSize);
                    }), 1000);
                }
            }
        },
        // 新增隐藏底部按钮接口
        hideFooterButton: function() {
            domStyle.set(this.footerButton, "display", "none");
        },
        clearSelected: function() {
            var items = query('.tab-selector', this.domNode);
            for (var i = 0; i < items.length; i++) {
                domClass.remove(items[i], "selected");
            }
        },
        //在售
        changeOnSale: function(evt) {
            this.clearSelected();
            domClass.add(evt.target, "selected");
            this.params.isUse = true;
            this.params.qty = 1;
            this.setQuery(this.params);
        },
        //售罄
        changeSaleOut: function(evt) {
            this.clearSelected();
            domClass.add(evt.target, "selected");
            this.params.isUse = true;
            this.params.qty = 0;
            this.setQuery(this.params);
        },
        //下架
        changeNoSale: function(evt) {
            this.clearSelected();
            domClass.add(evt.target, "selected");
            this.params.isUse = false;
            delete this.params.qty;
            this.setQuery(this.params);
        },
        setQuery: function(query) {
            this.start = 0;
            this.end = -1;
            this.totalCount = 0;
            this.storeList.destroyDescendants();
            // 依据查询条件加载数据
            var queryResult = this.storeList.setQuery(query, {
                start: this.start,
                count: this.pageSize
            });
            //依据加载数据得结果处理界面显示
            this.onLoadListData(queryResult, this.start, this.pageSize);
        },
        //单个选中
        checkClick: function(e) {
            //判定是否点击单选框
            var dom;
            query(".selectLi", this.domNode).forEach(function(node) {
                if (e.target == node) {
                    dom = true;
                }
            });
            if (dom) {
                var isChecked; //= this.isChecked;

                //this.isChecked为true时 变为未选中样式，false或未定义为已选中样式
                if (!domClass.contains(e.target, "isSelect")) {
                    isChecked = false;
                } else {
                    isChecked = true;
                }
                query(".selectLi", this.domNode).forEach(lang.hitch(this, function(node) {
                    // 如果是品类选择 只能单选
                    if (this.matGroup) {
                        if (e.target == node) {
                            domAttr.set(e.target, "checked", isChecked ? "" : "checked");
                        } else {
                            domAttr.set(node, "checked", "");
                        }
                    } else {
                        if (e.target == node) {
                            domAttr.set(e.target, "checked", isChecked ? "" : "checked");
                        }
                    }
                }));
                //保证在点击其他单选框时this.isChecked为false
                if (domClass.contains(e.target, "isSelect")) {
                    //如果是处于选中状态
                    domClass.remove(e.target, "isSelect");
                } else {
                    domClass.add(e.target, "isSelect");
                }
                //判断是否为全选,并做处理
                this.isAllComSelect();
            }
        }
    });
});
