define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-style",
    "dojo/query",
    "dojox/mobile/View",
    "dojox/mobile/ContentPane",
    "cq/ui/view/_ViewMixin",
    "cq/biz/article/article",
    "dijit/registry",
    ],function(declare,lang,domStyle,query,View,ContentPane,_ViewMixin,article,registry){
    return declare("cq.ui.b.s.HelpVerification",[View,_ViewMixin],{
        //初始化相关接口
        //索引界面元素
        indexElement:function(){
            this.newsDtlScroll = this.centerPanel;
        },
        //初始化事件
        initEvent:function(){
        },
        //第一次加载
        onFirstShow:function(){
            var option={
                left:{
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick:function(){
                        history.back();
                    }
                },
                title:"店铺认证",
            }
            this.addHeader(option);
            domStyle.set(this.domNode,"background-color","white");
            this.onAfterShow();
        },
        onAfterShow:function(){
            this.inherited(arguments);
            article.loadPlatformByTitle(window.did).then(lang.hitch(this,function(data){
                if(data&&data.data&&data.data.item){
                    if(this.dtlPane){
                        this.dtlPane.destroy();
                    }
                    data=data.data.item;
                    data.createAt=new Date(data.createAt);
                    var contentHtm="<div class='title main-title'>"+data.title+"说明</div>";
                    //contentHtm+="<div class='time sub-title'>"+data.createAt.toLocaleDateString()+"</div>";
                    //contentHtm+="<img class='img' src='"+data.logo+"' />";
                    contentHtm+="<div class='content'>"+data.content+"</div>";
                    this.dtlPane=new ContentPane({
                        content:contentHtm
                    });
                    this.dtlPane.placeAt(this.newsDtlScroll.containerNode,"last");
                }
            }));
        }
    });
});