//变更人:肖爱玲，变更时间:2016/5/21，变更原因:底部按钮样式修改
define(
    [
        "dojo/_base/declare", "dojo/_base/lang", "dojo/topic", "dojox/mobile/View",
        "dojo/store/Memory", "dojox/mobile/EdgeToEdgeStoreList", "cq/ui/view/_ViewMixin",
        "dojo/request/xhr", "dojo/query", "dijit/registry", "cq/biz/shop/shop","cq/biz/user/user",
        "dojo/on"
    ],
    function(declare, lang, topic, View, Memory, EdgeToEdgeStoreList, _ViewMixin, xhr,
             query, registry, shop, user,on) {
        return declare("cq.ui.b.s.ShopBail", [ View, _ViewMixin ], {
            onAfterShow:function(){
                shop.loadCurrentShop().then(lang.hitch(this, function(data) {
                    // 显示信息
                    data.data.bailText = "当店铺余额不足时，用于发生维权退款时及时赔付给买家，保障消费者权益。";
                    this.setData(data.data);
                    this.refreshData();
                }));
            },
            onFirstShow : function() {
                var option = {
                    left : {
                        iconButton : ' ',
                        arrow : "left",
                        label : "返回",
                        onClick:function(){
                            //window.moveToView("shopConfig");
                            history.back();
                        }
                    },
                    title : "保证金缴纳"
                };
                this.addHeader(option);
                option = {
                isEdge: true,
                class: "",
                lists: [{
                    label:'保证金余额',
                    rightText: '{{bailAmount}}'
                },{
                    label:'保证金介绍',
                    rightText: '',
                    //箭头
                    noArrow: true,
                    moveTo: "#",
                },{
                    noArrow:true,
                    rightText:"{{bailText}}"
                }]
                };
                this.addLists(option);
                option = {
                isEdge:true,
                className: "flex2 footer-tab-highlight",
                columns:[{
                    label:"缴纳保证金",
                    onClick: lang.hitch(this, function(){
                        window.moveToView("shopBailTransaction");
                    })
                }],
                forceWidth: true,
                isFooter: true
            }
            this.addColumns(option);
            this.onAfterShow();
            }/*,
            onSaveStore : function() {
                var shopData = this.getData();
                // 重置内容
                shopData.svcId = shopData.svcId && shopData.svcId._id;
                shopData.orderCheckerId = shopData.orderCheckerId && shopData.orderCheckerId._id;
                for(var e in shopData){
                    if(shopData[e] == "" || shopData[e] === undefined) {
                        delete shopData[e];
                    }
                }
                shop.save(shopData).then(function() {
                    topic.publish("whz/shop/changed",shopData);
                    this.isEditing=false;
                    window.moveToView("home");
                });
            }*/
        });
    });