define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/topic",
    "dojox/mobile/View",
    "dojox/mobile/EdgeToEdgeStoreList",
    "cq/ui/view/_ViewMixin",
    "dojo/request/xhr",
    "dojo/query",
    "dijit/registry",
    "cq/biz/shop/shop",
    "cq/biz/user/user",
    "dojo/on"
],function(declare, lang, topic, View, EdgeToEdgeStoreList, _ViewMixin, xhr,
    query, registry, shop, user,on) {
    return declare("cq.ui.b.s.ShopClub", [ View, _ViewMixin ], {
        onAfterShow:function(){
            shop.loadCurrentShop().then(lang.hitch(this, function(data) {
                this.setData(data.data);
                this.refreshData();
            }));
        },
        onFirstShow : function() {
            var option = {
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick:function(){
                        //window.moveToView("shopConfig");
                        history.back();
                    }
                },
                title : "会员俱乐部"
            };
            this.addHeader(option);
            this.onAfterShow();
        },
        onSaveStore : function() {
            var shopData = this.getData();
            shop.save(shopData).then(function() {
                window.moveToView("shopConfig");
            });
        }
    });
});