define([
    "dojo/_base/declare", "dojo/_base/lang", "dojo/topic", "dojox/mobile/View",
    "dojo/store/Memory", "dojox/mobile/EdgeToEdgeStoreList", "cq/ui/view/_ViewMixin",
    "dojo/request/xhr", "dojo/query", "dijit/registry", "cq/biz/shop/shop","cq/biz/user/user",
    "dojo/on","cq/biz/article/article"
],function(declare, lang, topic, View, Memory, EdgeToEdgeStoreList, _ViewMixin, xhr,
    query, registry, shop, user,on, article) {
    //
    return declare("cq.ui.b.s.ShopSecure", [ View, _ViewMixin ], {
        onAfterShow:function(){
            shop.loadCurrentShop().then(lang.hitch(this, function(data) {
                // 显示信息
                article.loadPlatformByTitle("担保交易").then(lang.hitch(this,function(artData){
                    if(artData && artData.data && artData.data.item){
                         data.data.secureText = artData.data.item.content;
                    }
                    /*var btn = query(".btn-trusted-pay",this.domNode)[0];
                    if(data.data.isTrustedPay){
                        btn.innerHTML="退出担保交易";
                    }
                    else{
                        btn.innerHTML="加入担保交易";
                    }*/
                    this.setData(data.data);
                    this.refreshData();
                }));
            }));
        },
        onFirstShow : function() {
            var option = {
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick:function(){
                    //    window.moveToView("shopConfig");
                        history.back();
                    }
                },
                title : "担保交易"
            };
            this.addHeader(option);
            this.onAfterShow();
            option = {
                isEdge: true,
                class: "",
                lists: [{
                    label:'担保交易介绍',
                    rightText: '',
                    //箭头
                    noArrow: true,
                    moveTo: "#",
                },{
                    noArrow:true,
                    rightText:"{{secureText}}",
                     variableHeight : true
                }]
            };
            this.addLists(option);
            /*var secureButton="<div class='li-right-div color-bg-h btn-trusted-pay color-white h-center li-center-div'>立即加入担保交易</div>";
            option = {
                isEdge:true,
                className: "bottom-margin16 operation",
                columns:[{
                    label:secureButton,
                    onClick: lang.hitch(this, function(){
                        //this.onChangeType();
                        var shopData = this.getData();
                        shopData={isTrustedPay:!shopData.isTrustedPay};
                        shop.save(shopData).then(function(data){
                            if(data.data.ok==0){
                                alert("操作失败");
                            }
                            if(shopData.isTrustedPay){
                                alert("成功加入担保交易计划");
                            }
                            else{
                                alert("已退出担保交易计划");
                            }
                            window.moveToView("shopConfig");
                        });
                    })
                }],
                forceWidth: true,
                isFooter: true
            }
            this.addColumns(option);*/
            this.onAfterShow();
        }
    });
});