//变更人：周超  变更时间:2016-5-17  变更事件：代码规范
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/topic",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "dojo/request/xhr",
    "dojo/query",
    "cq/biz/object"
],function (declare, lang, topic, View, _ViewMixin,xhr, query, object) {
    return declare("cq.ui.b.s.Welcome", [View, _ViewMixin], {
        destroyOnSvcChanged : false,
        //初始化相关接口
        onFirstShow : function () {
            //添加幻灯片
            var data = {
                boxes : [{
                    icon : "images/home3.jpg"
                }, {
                    icon : "images/home4.jpg"
                }],
                options : {
                    height : document.body.clientHeight - 40
                }
            };
            //调用接口实现幻灯片的接口，参数data：幻灯片的属性配置参数，返回值:slideShow对象
            this.addSlideShow(data);
            //登录注册栏
            var option = {
                columns : [{
                    label : '登录',
                    className : "flex1 text-button-base",
                    onClick : function () {
                        window.moveToView('login');
                    }
                }, {
                    label : '注册',
                    className : "flex1 text-button-fill",
                    onClick : function () {
                        window.moveToView('register');
                    }
                }],
                forceWidth : false,
                isFooter : true
            };
            //添加登录注册栏，参数：option，两按钮的属性配置参数，返回值：container节点
            this.addColumns(option);
        },
        //方法，采用get方式进行数据交互，获取登录者信息
        loginSubmit : function () {
            xhr("GET", {
                url :
                "http://log.cqthink.com/biz/shop/storage_shop/storage_shop/load_shops_by_username?userName="
                 + this.loginUser.value,
                handleAs : "json",
                load : lang.hitch(this,function (data) {
                    if (data.items && data.items.length > 0){
                        localStorage.setItem("shopId", data.items[0]._id);
                    }
                    xhr("GET", {
                        url : "http://log.cqthink.com/biz/shop/shop/login?shopId="
                         + object.getShopId()
                         + "&userName="
                         + this.loginUser.value
                         + "&password="
                         + this.loginPassword.value,
                        handleAs : "json",
                        load : lang.hitch(this,
                            function (result) {
                            if (1 === result.ok) {
                                // alert("登录成功");
                                window.__shop = result.shop;
                                topic.publish("whz/shop/changed", window.__shop);
                                window.moveToView("home");
                            } else {
                                alert(result.msg);
                            }
                        })
                    });
                })
            });
        }
    });
});