/**
    变更人员： 杜飞军
    变更内容： 代码规范，添加注释，文件迁移
    变更时间： 2016/05/17
    变更内容： 删除m.id = window.did 这里导致保存失败
    变更时间： 2016/05/19
 */
 /* 修改人员：胡飞
    修改日期：20160621
    修改内容：1.新增/编辑会员时，添加会员头像与会员其他信息ul之间的间隔
              2.修改会员地址为选填项
 */
/**
    变更人员： 程磊
    变更时间： 2016/06/24
    变更内容： 界面busy /free
 */
 /**
    变更人员： 冉伟
    变更时间： 2016/06/27
    变更内容： 客户余额小数位数控制
 */
  /**
    变更人员： 冉伟
    变更时间： 2016/07/13
    变更内容： 客户管理编辑页面中显示score字段和userDesc字段,显示在余额后面，并设置scor字段默认值为5
 */
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
	"dojo/dom-class",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "cq/util/sys/date",
    "dijit/focus",
    "cq/biz/user/user"
],function(declare,lang, domClass,View,_ViewMixin,date,focusUtil,user){
    // module:
    //      cq/ui/b/u/User
    return declare("cq.ui.b.u.User", [View, _ViewMixin], {
        // 检测是否编辑状态
        isEditing: false,
        // 初始化相关接口
        onAfterShow: function () {
            if (!this.isEditing) {
                this.isEditing = true;
                if (!window.did) {
                    this.setData({
                        sex: 1,
                        birthday: '1990-01-01',
                        //增加设置星级默认值为5
                        score:5
                    });
                    this.refreshData();
                } else {					
                    user.loadById(window.did).then(lang.hitch(this, function (data) {
						data.data.item.amount = window.fixedTo(data.data.item.amount,3);
                        this.setData(data && data.data && data.data.item || {});
                        this.refreshData();
                    }))
                }
            }
        },
        // 更新数据
        // refreshData: function () {
        //     if (this.__data) {
        //         if (this.__data.birthday) {
        //             this.__data.birthday = date.formatISODate(this.__data.birthday);
        //         };
        //         this.iconLi.set("rightIcon2", this.__data.logo || "");
        //     };
        //     // var data = this.getData();
        //     // if(data){
        //     //     if(data.birthday){
        //     //         this.setData({birthday: date.formatISODate(data.birthday)});
        //     //     }
        //     //     this.iconLi.set("rightIcon2", data.logo || "");
        //     // }
        //     this.inherited(arguments);
        // },
        // 初始化加载显示内容
        //增加一个addOptionList函数，返回数组
        addOptionList:function(){
            return oldArray=[{
                label: "客户头像",
                noArrow: false,
                class: "li-icon",
                moveTo : "#",
                edit :{
                    type:"image",
                    field:"logo"
                }
            },{
                label: '姓名',
                noArrow: true,
                edit: {
                    type: 'text',
                    field: 'pName',
                    placeHolder: "必填"
                }
            },{
                label: '性别',
                moveTo: "#",
                edit: {
                    type: 'options',
                    field: 'sex',
                    options: {
                        0: "男",
                        1: "女",
                        2:"保密"
                    }
                }
            },{
                label: '电话',
                noArrow: true,
                edit: {
                    type: 'text',
                    field: 'phone',
                    placeHolder: "请输入电话"
                }
            },{
                label: '地址',
                noArrow: true,
                edit: {
                    type: 'text',
                    field: 'address',
                    placeHolder: "请输入地址"
                }
            },{
                label: '生日',
                moveTo: "#",
                edit: {
                    type: 'date',
                    field: 'birthday'
                }
            },{
                label: '余额',
                noArrow: true,
                edit: {
                    type: 'text',
                    field:'amount',
                    disabled: true
                }
            },{
                label:"星级",
                moveTo:'#',
                edit:{
                    type:'options',
                    field:'score',
                    options:{
                        5:'5',
                        4:'4',
                        3:'3',
                        2:'2',
                        1:'1'
                    }
                }
            },{
                label:"个人简介",
                moveTo:'#',
                edit:{
                    type:'textarea',
                    field:'userDesc'
                }
            },{
                label: '昵称',
                noArrow: true,
                edit: {
                    type: 'text',
                    field: 'nickName',
                    disabled: true
                }
            },{
                label: '来源客户',
                noArrow: true,
                edit: {
                    type: 'text',
                    field: 'srcUid',
                    disabled: true
                }
            },{
                label: '场景值',
                noArrow: true,
                edit: {
                    type: 'text',
                    field: 'wxSrcSid',
                    disabled: true
                }
            }];
        },
        onFirstShow: function () {			
            var option = {
                left: {
                    iconButton: ' ',
                    arrow: "left",
                    label: "返回",
                    onClick: function () {
                        //window.moveToView("userList");
                        history.back();
                        this.isEditing = false;
                    }
                },
                title: "客户管理",
                right: {
                    iconButton: ' ',
                    onClick: this.onSaveStore,
                    label: "完成"
                }
            };
            this.addHeader(option);
            //logo
            //li.set("clickable", false);
            //定义lists为addOptionList函数返回值
            option = {
                isEdge: true,
                class: "bottom-margin16",
                lists: this.addOptionList()
            };
            /*option = {
                isEdge: true,
                //class : "bottom-margin16",
                lists: [
                { label: '登录名', noArrow: true, edit: { type: 'text', field: 'userName', disabled: true } },
                //{label:'国家',noArrow:false,edit:{type:'text',field:'countryId'}},
                //{label:'省',noArrow:false,edit:{type:'text',field:'provinceId'}},
                //{label:'城市',noArrow:false,edit:{type:'text',field:'cityId'}},
                ]
            };
            this.addLists(option);*/
            /*option = {
                isEdge: true,
                //class : "bottom-margin16",
                lists: [
                //{label:'关注日期',noArrow:true,edit:{type:'text',field:'subscribeDate',disabled:true}},
                //{label:'取消关注日期',noArrow:true,edit:{type:'text',field:'cancelDate',disabled:true}},
                //{label:'来源',noArrow:true,edit:{type:'text',field:'source'}},
                ]
            };*/
             //执行this.addLists(option)
            this.addLists(option);
            this.onAfterShow();
        },
        // 保存数据
        onSaveStore: function () {
            //设置界面busy
            window.busy();
            // 当前节点失去焦点
            focusUtil.curNode && focusUtil.curNode.blur();
            var m = this.getData();
            var msg = this.checkData(m);
            if (msg) {
                //设置界面free
                window.free();
                alert(msg);
                return;
            }
            m.shopId = user.getShopId();
            user.save(m).then(lang.hitch(this, function (data) {
                //设置界面free
                window.free();
                if(data.data.ok == 1){
                    this.isEditing = false;
                    //window.moveToView("userList");
                    history.back();
                }else{
                    alert("保存失败");
                }
            }));
        },
        // 验证文本框内容
        checkData: function (data) {
            var msg = "";
            if(!data.pName){
                return "姓名不能为空";
            }
            if(!data.phone){
                return "电话不能为空";
            }
            /*
            for (var index = 0; index < this.textboxs.length; index++) {
                if ((!this.textboxs[index].node.value) && (!this.textboxs[index].node.disabled)) {
                    return msg = (this.textboxs[index].field + "为空!");
                }
            }*/
        }
    });
})