//变更人：张金鹏
//变更时间：20160628
//变更原因：1.没有填写摘要时显示的是undefined,修改为没有填写摘要时显示为空
//          2.动态的摘要应该控制显示两行，超出部分用...代替
// 变更人：周科吉
// 变更时间：2016-07-12
// 变更事项：头部添加显示资讯类别问题

define([
	"dojo/_base/declare",
	"dojo/_base/lang",
    "dojo/_base/array",
	"dojox/mobile/View",
	"dojox/mobile/EdgeToEdgeStoreList",
	"cq/ui/view/_ViewMixin",
	"dojo/query",
	"dijit/registry",
	"cq/biz/article/article",
    "cq/biz/article/articleGroup",
	"dojo/on",
	"dojo/when",
	"dojo/store/Memory",
	"dojo/store/JsonRest",
	"dojo/store/Observable",
	"dojo/topic",
	"cq/util/sys/date",
    "dojo/dom-class"
],function( declare, lang, array, View, EdgeToEdgeStoreList, _ViewMixin, query, registry, article, articleGroup, on, when, Memory, JsonRest, Observable, topic, date, domClass){
	return declare("cq.ui.c.a.NewsList",[View,_ViewMixin],{
		start:0,
        pageSize: 10,
        // 资讯类别
        groupData:[],
		//初始化相关接口
		//索引界面元素
		indexElement:function(){
            this.newsListScroll = this.centerPanel;
		},
		onAfterShow:function(){
            //articleGroup.load({isUse: true}).then(lang.hitch(this,function(data){
                //定义一个变量来获得所有类别
            //var groupData = data.data.items||[];
            //像类别中追加一个全局类别
            //groupData.push({
            //    groupName:"全部"
            //});
            //根据window.did来刷新页面
            if(window.did){
                for(var i=0;i<this.groupData.length;i++){
                    // 依据资讯名称来做匹配
                    if(window.did==this.groupData[i].groupName){
                        this.setGroupSelected(query('.tab-selector', this.domNode)[i]);
                        this.params.groupId = this.groupData[i]._id;
                        break;
                    }
                }
            }else{
                this.setGroupSelected(query(".tab-selector",this.groupHeader).pop());
            }
            if(this.storeList.store){
                this.setQuery(this.storeList.get("query"),{
                    start: 0,
                    count: this.pageSize
                });
            }else{
                this.storeList.setStore(this.store,this.params,{
                    start: 0,
                    count: this.pageSize
                });
            }
            //}));
		},
		onFirstShow:function(){
			// 加载当前商家的资讯类别
            articleGroup.load({isUse: true}).then(lang.hitch(this,function(data){
                this.storeList=new EdgeToEdgeStoreList({
                    append: true,
                    constraint: false,
                    query:{},
                    class:"icon-list-item",
                    variableHeight:true,
                    onComplete:lang.hitch(this,function(data){
                        for(var i=0;i<data.length;i++){
                            var time = data[i].createAt == "undefined" ? "" : date.formatISODate(data[i].createAt);
                            data[i]._label="<div class='mat-list-mname mat-list-margin'>"+data[i].title+"</div>";
                            data[i]._label+="<div class='mat-list-margin margin-topthis.pageSize' style='word-break: break-all;overflow: hidden;text-overflow: ellipsis;display:-webkit-box;-webkit-line-clamp: 2;-webkit-box-orient: vertical;'>"+
                            (data[i].brief||"")+"</div>";
                            data[i]._label+="<div class='mat-list-margin time-large-dark'>"+time+"</div>";
                        }
                        this.storeList.generateList(data);
                        this.end=this.start+data.length-1;
                        this.busy = false;
                    }),
                    queryOptions: {
                        count: this.pageSize,
                        start: this.start
                        },
                    itemMap:{_label:"label",logo:"icon"}
                });
                // 创建数据源
                //变更人:肖芳圆
                //变更时间:2016/5/26
                //原因:只显示使用的资讯
                this.params={isUse:true};
                this.store = new JsonRest({target:article.getArticleUrl()});
                // 将数据源赋值给StoreList
                //this.storeList.setStore(this.store,this.params);

                this.storeList.placeAt(this.newsListScroll.containerNode,"last");
                this.storeList.on("click",lang.hitch(this,this.onClickList));
                this.own(on(this.newsListScroll,"afterscroll",lang.hitch(this,this.onLoadMore)));
                
                //定义一个变量来获得所有类别
                this.groupData = data.data.items||[];
                //像类别中追加一个全局类别
                this.groupData.push({
                    groupName:"全部",
                    isUse: true
                });
                //var groupShowData = [];
                //依据类别生成addcolumns 的参数
                //定义一个能使用的资讯的数组
                //for(var i=0;i<this.groupData.length;i++){
                //  if(this.groupData[i].isUse){
                //    groupShowData.push(this.groupData[i]);
                //}
                //}
                //依据类别生成addcolumns 的参数
                var option = {
                    isHeader: true,
                    columns : array.map(this.groupData,function(item){
                        return{
                            label : item.groupName,
                            onClick : function(e){
                                this.setGroupSelected(e.target);
                                this.params.groupId = item._id||'';
                                this.refreshNewsList();
                            }
                        }
                    }),
                    labelClass : 'font-size1 tab-selector'
                };
                this.groupHeader = this.addColumns(option);
                //如果存在window.did，根据window.did的参数来判断类别并选中样式，否则选用默认方式
                //if(window.did){
                //    for(var i=0;i<groupData.length;i++){
                //        if(window.did==groupData[i]._id){
                //            this.setGroupSelected(query('.tab-selector', this.domNode)[i]);
                //            this.refreshNewsList(groupData[i]);
                //        }
                //    }
                //}else{
                //    this.setGroupSelected(query(".tab-selector",this.groupHeader).pop());
                //}
                //添加左右滑动功能
                var scrollHeader = this.addScrollablePane({scrollDir:"h", isHeader:true, className:"header_height full-width"});
                scrollHeader.containerNode.appendChild(this.groupHeader);
            
                var option = {
                    columns: [{

                        icon: '/static/images/mobile/main1.png',
                        iconClass: 'footer-tab-img',
                        className: 'footer-tab-col-normal',
                        label: '首页',
                        onClick: function() {
                            window.moveToView("main");
                        }
                    },
                     {
                        icon: '/static/images/mobile/contact.png',
                        iconClass: 'footer-tab-img',
                        //footer栏字幕显示
                        label: '动态',
                        className:'footer-tab-col-highlight',
                        onClick: function() {
                            //客户端以后都用window.moveToView来完成点击功能
                            window.moveToView("newsList");
                        }
                    },
                     {
                        icon: '/static/images/mobile/orderCar1.png',
                        //有点像样式的感觉，目前知道的三种大小分别为，把此句删掉、除了width-16之外的大小统统很大并且一样大、width-16的正常大小
                        iconClass: 'footer-tab-img',
                        label: '购物车',
                        isBadge:true,
                        badgeClass:'orderCarNum',
                        className:'footer-tab-col-normal',
                        onClick: function() {
                           window.moveToView("orderCar");
                        }
                    },
                    {
                        icon: '/static/images/mobile/user1.png',
                        iconClass: 'footer-tab-img',
                        label: '我的信息',
                        className:'footer-tab-col-normal',
                        onClick: function() {
                            window.moveToView("user");
                        }
                    }],
                    //
                    labelClass: 'font-size1',
                    className: 'fix-footer',
                    isFooter: true
                }
                // this.addColumns(option);
                this.addFooterColumns();
                //每次firstShow时侦听广播
                //topic.subscribe("cq/biz/ts/cart/numChanged", lang.hitch(this,function(num){
                //	this.matNumNode.innerHTML = num;
                //}));
                this.onAfterShow();
            }));
		},
		onClickList:function(evt){
			// 得到点击的ListItem
			var li = registry.getEnclosingWidget(evt.target);
			if(li.declaredClass!="dojox.mobile.ListItem") return;
			var _id = li.params._id;
			window.moveToView("newDetail",_id);
		},
		onLoadMore:function(evt){
			if(!this.busy&&evt.afterBottom){
				//设置本次加载内容的起始位置
                this.start = this.start + this.pageSize;
				//判断能否加载更多内容
				if(this.canLoadMore(this.start)){
					console.log("加载更多客户");
                    this.busy = true;
                    setTimeout(lang.hitch(this, function () {
						//执行加载内容操作
                        var queryResult = this.storeList.setQuery(this.storeList.get("query"), {
                            start : this.start,
                            count : this.pageSize
                        });
						//执行加载更多函数
                        this.onLoadListData(queryResult,this.start,this.pageSize);
                    }), 1000);
				}
            }
		},
		setQuery:function(query){
			this.start = 0;
			this.end = -1;
			this.storeList.destroyDescendants();
			var queryResult= this.storeList.setQuery(query,{
				start: this.start,
				count: this.pageSize
			});
            this.onLoadListData(queryResult,this.start,this.pageSize);
			
		},
        setGroupSelected:function(evt){
            //清空所有节点选中样式
            var items = query('.tab-selector', this.domNode);
            for (var i = 0; i < items.length; i++) {
                domClass.remove(items[i], "selected");
            }
            //为选中节点添加选中样式
            domClass.add(evt,"selected");
        },
        refreshNewsList:function(){
            this.start = 0;
            //查询条件改变，根据条件刷新页面显示
            this.setQuery(this.params,{
                start : this.start,
                count : this.pageSize
            });
            //if(item._id){
                
            //}else{
            //    this.setQuery(this.params,{
            //        start : this.start,
            //        count : this.pageSize
            //    });
            //}
        }
	});
});
