// 变更人员：母浚驰
// 变更时间：2016/5/18
// 变更内容：代码规范，添加注释

// 变更人员：母浚驰
// 变更时间：2016/6/20
// 变更内容：时间格式，页面样式修改

// 变更人员：周科吉
// 变更时间：2016/6/28
// 变更内容：处理列表，以及刷新显示问题,排序问题

// 变更人:徐阿雪
// 变更时间:2016/6/30
// 变更原因:设置标题，修改时间精确到时分秒,修改movetoview，重写一个函数，获取不同type的数据，加载显示出来

// 变更人:徐阿雪
// 变更时间:2016/7/01
// 变更原因:列表显示方式变更
// 变更人:冉伟
// 变更时间:2016/7/05
// 变更原因:1.修改返回按钮的window.moveToView()改为history.back() 2.修改商品名称的class为 shelf-mat-title
// 变更人:徐阿雪
// 变更时间:2016/7/06
// 变更原因:将orderStatus的状态按照优先级显示,已退款问题修复
// 变更人:徐阿雪
// 变更时间:2016/7/06
// 变更原因:添加运费信息，style.css新建tAmount样式，在

// 变更人:刘轩
// 变更时间:2016/7/13
// 变更原因:修改订单状态显示优先级
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-class",
    "dojo/query",
    "dojo/store/JsonRest",
    "dijit/registry",
    "dijit/_WidgetBase",
    "dojox/mobile/View",
    "dojox/mobile/EdgeToEdgeStoreList",
    "cq/ui/view/_ViewMixin",
    "cq/biz/ts/order",
    "cq/biz/user/user",
    "cq/widgets/item/OrderListItem"
],function(declare,lang,domClass,query,JsonRest,registry,_WidgetBase,View,EdgeToEdgeStoreList,_ViewMixin,order,user,OrderListItem){
    return declare("cq.ui.common.ts.OrderList",[View,_ViewMixin],{
        // 设置初始显示第0行
        start:0,
        //设置页面显示条数
        pageSize:20,

        // 设置页面内容的url
        url:"",
        // 加载数据,并显示到页面上
        onAfterShow:function(){
            user.hasLogin().then(lang.hitch(this,function(s){
                if(s){
                    this.type=window.did;
                    this.loadFirstPage();
                    this.busy=false;
                }else{
                    window.moveToView("login");
                    user.nextPage="orderList";
                }
            }));
        },
        // 创建列表
        onCreatList: function(){
            this.storeList=new EdgeToEdgeStoreList({
                append: true,
                constraint: false,
                query:{
                },
                className:"icon-list-item",
                variableHeight:true,
                //获取数据完成后调用的的处理方法
                onComplete:lang.hitch(this,function(data){
                    this.storeList.generateList(data);
                    this.busy = false;
                }),
                itemMap:{
                    _label:"label"
                },
                itemRenderer:OrderListItem
            });

            this.storeList.placeAt(this.centerPanel.containerNode,"last");
            this.storeList.on("click",lang.hitch(this,this.onClickList));
            this.centerPanel.on("afterscroll",lang.hitch(this,this.onLoadMore));
        },
        //初始化页面元素,绑定事件
        onFirstShow : function() {
            var option = {
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick : function() {
                         if(user.getCurrentUserRole() == 4){
                             history.back();
                         }else{
                            window.moveToView("buyerService");   
                         }
                    }
                },
                title:"我的订单"
            };
            this.addHeader(option);
            option = {
                isHeader: true,
                placeHolder: "按回车搜索所有订单查询",
                class: "cqSearchBox",
                type: "search",
                onInput: lang.hitch(this, function(evt) {
                    if (evt.keyCode == 13) {
                        this.search = evt.target.value;
                        var condition = this.storeList.get("query");
                        condition.search = this.search;
                        this.loadFirstPage(condition);
                        condition.search ='';
                        evt.target.value = "";
                    }
                })
            };
            this.addTextBox(option);
            option = {
                isHeader: true,
                columns:[{
                    label:'全部',
                    onClick:lang.hitch(this,function(e){
                        // 徐阿雪 修改movetoview，重写一个函数，获取不同type的数据，加载显示出来
                        this.type="";
                        this.loadFirstPage();
                    })
                },
                {
                    label:'待付款',
                    onClick:lang.hitch(this,function(e){
                        this.type = 0;
                        this.loadFirstPage();
                    })
                },
                {
                    label:'待发货',
                    className:'sale',
                    onClick:lang.hitch(this,function(e){
                        this.type = 1;
                        this.loadFirstPage();
                    })
                },
                {
                    label:'待收货',
                    onClick:lang.hitch(this,function(e){
                        this.type = 2;
                        this.loadFirstPage();
                    })
                },
                {
                    label:'待评价',
                    onClick:lang.hitch(this,function(e){
                        this.type = 3;
                        this.loadFirstPage();
                    })
                }],
                labelClass:'font-size1 tab-selector'
            };
            this.addColumns(option);
            this.onCreatList();
            //发生loadFirstPage函数时，调用changeOnall
            this.connect(this,"loadFirstPage",function(){
                this.changeOnAll(this.type);
            });
            this.onAfterShow();
        },
        // 订单查询时的属性
        getParse: function(type){
            type = type+"";
            if(type === "0"){
                //待付款：未支付、未取消
                return {
                    isPayed:false,
                    isCanceled:false,
                    orderBy:'-createAt'
                };
            } else if(type === "1"){
                //待发货：已支付、未取消、未发货
                return {
                    isPayed:true,
                    isCanceled:false,
                    isDelived:false,
                    orderBy:'-createAt'
                };
            } else if(type === "2"){
                //待收货：已支付、未取消、已发货、未收货
                return {
                    isPayed:true,
                    isCanceled:false,
                    isDelived:true,
                    isReceipted:false,
                    orderBy:'-createAt'
                };
            } else if(type === "3"){
                //待评价：已支付，未取消，已收货，未完成
                return {
                    isPayed:true,
                    isCanceled:false,
                    isReceipted:true,
                    isClosed:false,
                    orderBy:'-createAt'
                };
            }else{
                return {
                    orderBy:'-createAt'
                };
            }
        },
        //订单类型改变
        changeOnAll : function(type){
            if(""===type||4==type){
                type=-1;
            }else{
                type = type-0;
            }
            type = type+1;
            query(".tab-selector",this.domNode).forEach(function(node,index){
                domClass[type===index?"add":"remove"](node, "selected");
            });
        },
        // 订单列表点击
        onClickList:function(evt){
            // 得到点击的ListItem
            var li = registry.getEnclosingWidget(evt.target);
            if(li.declaredClass===OrderListItem.prototype.declaredClass){
                window.moveToView("orderDetail",li.params._id);
            }
        },
        // 下拉列表加载更多
        // 重写加载方法
        onLoadMore:function(evt){
            if(!this.busy&&evt.afterBottom){
                this.start = this.start+this.pageSize;
                //使用canLoadMore判断加载更多的条件
                if(this.canLoadMore(this.start)){
                    this.busy = true;
                    var queryResult = this.storeList.setQuery(this.storeList.get("query"), {
                        start: this.start,
                        count: this.pageSize
                    });
                    this.onLoadListData(queryResult,this.start,this.pageSize);
                }
            }
        },
        //依据当前页面状态，加载第一页订单数据
        loadFirstPage:function(condition){
            this.start = 0;
            this.busy=true;
            this.storeList.destroyDescendants();
            var queryResult = null;
            var query = null;
            //若取订单的地址发生了变化，重新setStore，否则setQuery
            //徐阿雪 2016/6/30
            if(this.store){
                this.busy = true;
                query = lang.mixin(this.getParse(this.type),condition);
                queryResult = this.storeList.setQuery(query, {
                    start: this.start,
                    count: this.pageSize
                });
            }else{
                // 创建数据源
                this.store = new JsonRest({
                    target:this.getOrderListTarget()
                });
                // 将数据源赋值给storeList
                queryResult = this.storeList.setStore(this.store,this.getParse(this.type),{
                    start: this.start,
                    count: this.pageSize
                });
            }
            this.onLoadListData(queryResult,this.start,this.pageSize);
        },
        //读取订单的目标数据库可能不同，抽取接口供重写
        getOrderListTarget:function(){
            return order.getWithDetailsUrl();
        }
    });
});
