define([
    "dojo/_base/declare",
    "dojo/dom-attr",
    "dijit/registry",
    "dojo/query",
    "dojo/_base/lang",
    "dojo/_base/array",
    "cq/biz/user/user",
    "cq/biz/shop/shop",
    "cq/biz/im/msg"
], function(declare, domAttr, registry, query, lang, array, user, shop, msg) {
    return declare("cq.ui.w.im.MsgDtl", null, {
        indexMsgElement: function() {
            this.shopName = query(".shopName", this.domNode)[0];
            this.shopName.innerHTML = window.shopName;
            this.talkList = registry.byNode(query(".talkList", this.domNode)[0]);
            this.talkList.target = msg.getSvcMsgUrl();
        },
        initMsgEvent: function(){},
        refreshAllList: function(){
            // 加载消息清单
            user.getUserInfo().then(lang.hitch(this, function(data){
                this.talkList.query = {
                    shopId: window.shopId,
                    userId1: data.data.item._id, // 发送人
                    userId2: this.targetUserId // 接收人
                };
            }));
        }
    });
});
