//创建人：周超
//创建时间：2016-6-22
//创建事务：带小时，分钟的时间滚轮
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/dom-style",
    "dojo/query",
    "dojox/mobile/SpinWheelDatePicker",
    "dojox/mobile/SpinWheelTimePicker",
    "cq/ui/view/EditorBase",
    "cq/ui/view/ViewUtil"
],function(declare,lang,array,domStyle,query,SpinWheelDatePicker,SpinWheelTimePicker,EditorBase,ViewUtil){
    //新建对象：日期滚轮+时分秒滚轮
    var DateTimePicker = declare("",EditorBase,{
        //获取选择滚轮之后的值
        getValue:function(){
            //前者日期滚轮值+“ ”+时间滚轮值
            //得到时间字符串
            var vt = this.spinMinWheel&&this.spinMinWheel.get("values");
            return this.spinWheel&&this.spinWheel.get("value")+" "+vt[0]+":"+vt[1]+":00";
        },
        //设置数据值类似setData
        // 输入格式“yyyy-mm-dd hh:mm”
        setOrigin:function(text){
            var ddd= query;
            if(text){
                //分割日期和时间
                var dateText=text.split(" ")[0];
                var timeText=text.split(" ")[1];
                //日期滚轮赋值
                if(this.spinWheel){
                    this.spinWheel.set("values",array.map(dateText.split("-"),function(value){
                        return value-0;
                    }));
                }
                //时间滚轮，给数组的2个元素赋值
                var h = timeText.split(":")[0];
                var m = (timeText.split(":")[1].length==1?"0":"") + timeText.split(":")[1];
                if(this.spinMinWheel){
                    this.spinMinWheel.set("values",[h,m]);
                }
            }
        },
        //获取文本，创建滚轮
        startEdit:function(text){
            if(text&&-1<text.indexOf("T")){
                var dateObj = (new Date(text));
                var dateString = dateObj.toLocaleDateString().split("/").join("-");
                var timeString = dateObj.getHours()+":"+dateObj.getMinutes();
                arguments[0] = dateString+" "+timeString;
            }
            var def = this.inherited(arguments);
            //创建时分秒滚轮
            if(!this.spinMinWheel){
                this.spinMinWheel = new SpinWheelTimePicker({
                    style:"width:82px;border:0;vertical-align:top;display:inline-block;",
                    "slotProps":[{
                        zeroPad:2,
                        "labelFrom":00,
                        "labelTo":23,
                        "style":{
                            "width":"37px",
                            "textAlign":"right"
                        }
                    },{
                        zeroPad:2,
                        "labelFrom":0,
                        "labelTo":59,
                        //step:15,
                        "zeroPad":2,
                        "style":{
                            "width":"37px",
                            "textAlign":"right"
                        }
                    }]
                });
                this.spinMinWheel.placeAt(this.contentPane.domNode,"first");
                this.spinMinWheel.startup();
                domStyle.set(this.spinMinWheel.domNode.parentNode, {
                    "text-align":"center"
                });
            }
            //创建日期滚轮
            if(!this.spinWheel){
                this.spinWheel = new SpinWheelDatePicker({
                    style:"width:156px;border:0;display:inline-block;",
                    "monthPattern":"MM",
                    "slotProps":[{
                        "labelFrom":1990,
                        "labelTo":2049,
                        "style":{
                            "width":"70px",
                            "textAlign":"center"
                        }
                    },{
                        "labelFrom":1,
                        "labelTo":12,
                        zeroPad:2,
                        "style":{
                            "width":"37px",
                            "textAlign":"right"
                        }
                    },{
                        zeroPad:2,
                        "labelFrom":1,
                        "labelTo":31,
                        "style":{
                            "width":"37px",
                            "textAlign":"right"
                        }
                    }]
                });
                this.spinWheel.placeAt(this.contentPane.domNode,"first");
                this.spinWheel.startup();
            }
            //显示原始值
            this.setOrigin(this.orginValue);
            return def;
        }
    });
    var editor = new ViewUtil({
        EditorClass:DateTimePicker
    });
    lang.setObject("cq.util.edit.dateTimePick",editor);
    return editor;
});