﻿define([
    "dojo/_base/lang",
    "cq/ui/view/JsonStoreListView"
],function(lang,JsonStoreList){
    //引用差别太大，用一个List做参数切换不合算，直接切换当前的list更好
    return lang.mixin(lang.getObject("cq.util.edit.jsonRef",true),{
        jsonStoreListHash:{},
        //调用方法与其他的类似，第三个参数为jsonRestList的属性信息
        startEdit:function(param,refView,options){
            var view = this.jsonStoreListHash[options.target];
            if(!view){
                this.jsonStoreListHash[options.target] = view = new JsonStoreList(options);
                view.placeAt(refView.domNode, "after");
                view.startup();
            }else{
                view.placeAt(refView.domNode, "after");
            }
            var def = view.startEdit.apply(view,arguments);
            def.then(function(){
                if(view.domNode.parentNode){
                    view.domNode.parentNode.removeChild(view.domNode);
                }
            });
            return def;
        }
    });
});