﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "cq/ui/view/ListView",
    "cq/ui/view/ViewUtil"
],function(declare,lang,array,ListView,ViewUtil){
    var OptionsList = declare("",ListView,{
        getValue:function(){
            return this.selectedItem&&this.selectedItem.params.key||"";
        },
        initList:function(options){
            var data = [];
            for(var k in options){
                data.push({
                    key:k,label:options[k]
                });
            }
            this.optionList.set("append",false);
            this.store.setData({
                items:data
            });
            this.optionList.setQuery();
        }
    });
    var optionsList = new ViewUtil({
        EditorClass:OptionsList
    });
    lang.setObject("cq.utl.edit.optionsList",optionsList);
    return optionsList;
});