﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-construct",
    "cq/ui/view/EditorBase",
    "cq/ui/view/ViewUtil"
],function(declare,lang,domConstruct,EditorBase,ViewUtil){
    var TextArea = declare("",EditorBase,{
        createContent:function(){
            this.contentNode = domConstruct.create("textarea", {
                style : "height:50%;width:98%;margin:auto;display:block"
            },
            this.contentPane.domNode, "last");
        },
        getValue:function(){
            return this.contentNode.value;
        },
        setOrigin:function(text){
          this.contentNode.innerHTML = this.contentNode.value = text;
        }
    });
    var editor = new ViewUtil({
        EditorClass:TextArea
    });
    lang.setObject("cq.util.edit.textArea",editor);
    return editor;
});