// 创建时间: 2016/10/17
// 创建人: 杜飞军
// 用途: 用于处理加载提供商的评价
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/store/JsonRest",
    "cq/biz/article/ss/comment",
    "cq/ui/b/m/MatEvalList"
], function(declare, lang, JsonRest, comment, MatEvalList) {
    return declare('whz.view.MatEvalList', [MatEvalList], {
        // 提供用于修改url请求的接口
        getHeader: function() {
            if (window.did) {
                var shopId = window.did.split('_')[1];
                return new JsonRest({ target: comment.getLoadUrlById(shopId) });
            }
        },
        // 修改查询接口
        getQuery: function() {
            var query = {};
            if (window.did) {
                var id = window.did.split('_')[0];
                query.commentId = id;
            }
            query.commentType = "mat";
            return query;
        },
    });
});
