// 修改人： 杜飞军
// 修改时间：2016/7/27
// 修内容容:
// 			继承cq/ui/common/t下的OderList 并查询当前平台数据库

// 变更人 ：母浚驰
// 变更时间:2016/10/26
// 变更内容:点击商品跳转到商品详情的调整

// 变更人员：母浚驰
// 变更时间：2016/10/31
// 变更内容：找人代付
define([
    'dojo/_base/declare',
    "dojo/_base/lang",
    "dojo/dom-attr",
    "dojo/dom-construct",
    'cq/ui/common/t/OrderDetail',
    "cq/biz/ts/order",
    "cq/biz/shop/shop",
    "./PayByOther"
], function(declare, lang, domAttr, domConstruct, orderDetail, order, shop, PayByOther) {
    return declare('whz.view.OrderDetail', [orderDetail], {
        //支付按钮
        postButtom:function(){
            var option = {
                columns: [{
                    label: "<div><span class='count'><div class='yfNode'><div><span class='mon_font'>" + "应付:￥</span><font class='yf_font_detail'>0.00</font></div><div class='jfdk_div'>" + "(余额(优惠券)抵扣<font class='jf_font_detail'>0</font>)</div></div></span></div>",
                    className: "edit-car-count flex1"
                },{
                    label: "<span class='payAli'>支付宝支付</span>",
                    className: "edit-car-submit none",
                    onClick: lang.hitch(this, function() {
                        this.onPayOrder("aliwap");
                    })
                },{
                    label: "<span class='payWeiXin'>微信支付</span>",
                    className: "edit-car-submit none",
                    onClick: function() {
                        this.onPayOrder("weixin");
                    }
                },{
                    label: "<span class='payDeposit'>余额支付</span>",
                    className: "edit-car-submit none",
                    onClick: function() {
                        this.onPayOrder("point");
                    }
                },{
                    label: "<span class='payByOther'>找人代付</span>",
                    className: "edit-car-submit none",
                    onClick: function() {
                        this.onPayOrder("payByOther");
                    }
                },{
                    label: "<span class='payBocB2C'>银联支付</span>",
                    className: "edit-car-submit none",
                    onClick: function() {
                        this.onPayOrder("bocB2CMobile");
                    }
                }],
                splitter: '../../images/mobile/splitter.png',
                className: 'fix-footer edit-car-footer',
                forceWidth: false,
                isFooter: true
            };
            this.bottDom = this.addColumns(option);
        },
        //跳转到商品详情
        moveToMat: function(dom){
            var id = domAttr.get(dom, "mId");
            var fromShopId = domAttr.get(dom, "fromShopId");
            window.moveToView("matDetail", id+"_"+fromShopId);
        },
        
        // 可能存在加载平台数据不同
        getLoadDetailById: function() {
            return order.loadB2BDetailById(window.did);
        },

        // 获得用户内容
        getLoadById: function() {
            return order.loadB2BById(window.did);
        },

        // 重写取消订单
        getCancelOrder: function() {
            return order.onCancelB2BAll(window.did);
        },

        // 重写获得运费接口
        getB2BTAmount: function() {
            return order.getB2BTAmount({ mids: [{ mid: window.did, qty: "" }] });
        },
        setReceiptededById:function(id){
            return order.setB2BReceipteded(id);
        },

        // 重写提交订单接口
        getPayByIds: function(params) {
            params.ids = [params._id];
            delete params._id;
            return order.onB2BPayByIds(params);
        },

        // 重写获得支付接口
        getPayTypeInfos: function() {
            return shop.getB2BPayType();
        },

        // 重写确认收货接口
        getDetailReceipteded: function(id){
        	return order.setB2BDetailReceipteded(id);
        },

        // 评价订单接口
        getEvaluedByDetailId:function(params){
        	return order.evaluedB2BByDetailId(params);
        },
        
        // 找人代付,客户列表
		userToPay : function () {
			this.payByOtherUser = new PayByOther();
			this.payByOtherDiv = domConstruct.create("div", {
				style : "height:400px;"
			});
			this.payByOtherDiv.appendChild(this.payByOtherUser.domNode);
			this.showInOverlay(this.payByOtherDiv);
			return this.payByOtherUser.showPayUser();
		}
    });
});
