// 变更人员：母浚驰
// 变更时间：2016/10/31
// 变更内容：找人代付，选择客户
define([
    'dojo/_base/declare',
    "dojo/_base/lang",
    "dojo/dom-attr",
    "dojo/dom-construct",
    "dojo/Deferred",
    "dojo/query",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "cq/biz/user/user"
], function(declare, lang, domAttr, domConstruct, Deferred, query, View, _ViewMixin, user) {
    return declare('whz.view.PayByOther', [View,_ViewMixin], {
        indexElement: function(){
            // 确定和取消
			option = {
				columns : [{
                    label: "确认",
                    onClick: lang.hitch(this, function() {
                        if(this.userData){
                            this.currentDef.resolve(this.userData);
                            this.hideOverlay();
                            domConstruct.destroy(query(".order-type")[0]);
                            window.moveToView("orderList");
                        }else{
                            alert("用户不存在，请重新输入");
                            this.search = "";
                        }
                    }),
                    className: "footer-tab-highlight"
                },{
					label : "取消",
					onClick : lang.hitch(this, function () {
                        this.currentDef.resolve();
						this.hideOverlay();
					}),
					className : "footer-tab-dark"
				}],
				labelClass : 'font-size2',
				className : 'fix-footer',
				isFooter : true
			}
			this.addColumns(option);

			// 查询客户
			option = {
				isEdge : true,
                isHeader : true,
				lists : [{
                        label : '电话号码',
                        noArrow : true,
                        edit : {
                            type : 'text',
                            field: "cqsearch",
                            placeHolder : "请输入代付人电话"
                        }
                        }]
			};
			this.addLists(option);
            domAttr.set(query(".mblListItemLabel",this.domNode)[0],"style","inline-block;float:left");
            this.connectElement();
        },
        connectElement:function(){
            this.connect(query(".right-textbox",this.domNode)[0],"oninput",lang.hitch(this,function(){
                this.search = query(".right-textbox",this.domNode)[0].value;
                if(this.userData){
                    this.userData == "";
                }
                if(this.search.length == 11){
                    this.queryUser(this.search);
                }
            }))
        },
        queryUser: function(search){
            user.checkPlatformUser(search).then(lang.hitch(this,function(data){
                if(data && data.data && data.data.item){
                    this.userData = data.data.item;
                }
            }));
        },
        showPayUser : function () {
			this.currentDef = new Deferred();
			
			this.startup();
			this.refreshData();
			
			return this.currentDef;
		}
    });
});