define([
	"dojo/_base/declare",
	"dojo/_base/lang",
	"dojox/mobile/View",
	"cq/ui/view/_ViewMixin",
	"./_MainViewMixin",
	"dojo/_base/xhr",
	"dojo/query",
	"dijit/registry"
],function(declare,lang,View,_ViewMixin,_MainViewMixin,xhr,query,registry){
	return declare("whz.view.Production",[View,_ViewMixin,_MainViewMixin],{
		onFirstShow:function(){
			var option = {left:{icon:__shop.logo?__shop.logo:'/a.png', onClick:function(){} , crop: true}, title:__shop.shopName};
			this.addHeader(option);
			option = {src:'images/home.png', onClick:function(){}}
			this.addImage(option);
			this.addIoInfoArea();
			option = {
				columns:[{
					icon:'images/icon/order.png',
					iconClass:'width-32',
					label:'数量增加',
					onClick:function(){
						window.moveToView("stock",1);
					}
				},{
					icon:'images/icon/order.png',
					iconClass:'width-32',
					label:'数量减少',
					onClick:function(){
						window.moveToView("stock",0);
					}
				},{
					icon:'images/icon/user.png',
					iconClass:'width-32',
					label:'疾病记录',
					onClick:function(){
						window.moveToView("desease");
					}
				},
				{
					icon:'images/icon/order.png',
					iconClass:'width-32',
					label:'免疫记录',
					onClick:function(){
						window.moveToView("immune");
					}
				}],
				valueClass:'font-size3',
				labelClass:'font-size1',
				className:'bottom-margin8 padding-top-bottom16'
			}
			this.addColumns(option);
			option = {
				columns:[{
					icon:'images/icon/shop_footer_highlight.png',
					iconClass:'width-16',
					label:'店铺',
					onClick:function(){
						window.moveToView("home");					}
				},
				{
					icon:'images/icon/member_footer_highlight.png',
					//icon1:'images/icon/member_footer_highlight.png',
					iconClass:'width-16',
					label:'生产',
					onClick:function(){
						window.moveToView("production");
					}
				},
				{
					icon:'images/icon/sale_footer.png',
					iconClass:'width-16',
					label:'动态',
					onClick:function(){
						window.moveToView("trends");
					}
				},
				{
					icon:'images/icon/more_footer.png',
					iconClass:'width-16',
					label:'更多',
					onClick:function(){
						window.moveToView("other");					}
				}],
				valueClass:'font-size3',
				labelClass:'font-size1',
				className:'fix-footer',
				isFooter:true
			}
			this.addColumns(option);
		}
	});
});
