// 张松
// 2016-07-26
// 新建页面
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/topic",
    "dojox/mobile/View",
    "dojo/dom-construct",
    "cq/ui/view/_ViewMixin",
    "cq/ui/b/a/_share",
    "cq/biz/shop/shop",
    "cq/biz/user/user"
],function(declare, lang, topic, View, domConstruct, _ViewMixin,_share, shop, user) {
    return declare("cq.ui.b.s.ShopConfig", [ View, _ViewMixin , _share], {
        onAfterShow:function(){
            shop.loadCurrentShop().then(lang.hitch(this, function(data) {
                //data.data.verficationStatusText = this.getVerStatusText(data.data.isVerified,data.data.isVerifySubmit);
                //data.data.isTrustedPayText = data.data.isTrustedPay?"已加入":"未加入";
                //data.data.isBailText = data.data.isBail?"已开通":"未开通";
                var sumAmount = data.data.availableAmount+data.data.pendingAmount?data.data.availableAmount+data.data.pendingAmount:0;
                data.data.sumAmount = window.fixedTo(sumAmount,3);
                this.setData(data.data);
                this.refreshData();
            }));
        },
        getVerStatusText : function (isVerified,isVerifySubmit) {
            var statusText = "";
            if (isVerifySubmit === 0  && !isVerified) {
                statusText = "未认证";
            }
            if (isVerifySubmit === -1 && !isVerified){
                statusText = "已驳回";
            }
            if (isVerifySubmit === 1 && !isVerified){
                statusText = "待审核";
            }
            if (isVerified && isVerifySubmit === 2){
                statusText = "已认证";
            }
            return statusText;
        },
        onFirstShow : function() {
            var option = {
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick:function(){
                        history.back();
                    }
                },
                title : "卖家服务"
            };
            this.addHeader(option);
            option = {
                isEdge : true,
                class : "top-bottom-margin16",
                lists : [{
                    rightIcon2 : "{{logo}}",
                    label:"{{shopName}}",
                    class : "li-icon",
                    onClick:function(){window.moveToView("shopBase");},
                    moveTo:"#"
                }]
            };
            this.addLists(option);
            option = {
                isEdge : true,
                class : "bottom-margin16",
                lists : [{
                    label:"店铺认证",
                    rightText:"{{verficationStatusText}}",
                    onClick:function(){
                    window.moveToView("shopVerification");
                    },
                    moveTo : "#"
                },/*{
                    label:"店铺余额",
                    rightText:"{{sumAmount}}",
                    onClick:function(){window.moveToView("shopBalance");},
                    moveTo : "#"
                },{
                    label:"店铺管理员",
                    onClick:function(){
                        window.moveToView("shopAdmin");
                    },
                    moveTo : "#"
                }*/]
            };
            //this.addLists(option);
            option = {
                isEdge : true,
                class : "bottom-margin16",
                lists : [{
                    label:"订单与客服通知",
                    onClick:function(){
                        window.moveToView("shopCustomerMsg");
                    },
                    moveTo : "#"
                }]
            };
            this.addLists(option);
            this.onAfterShow();
        }
    });
});