﻿// 变更人:徐阿雪
// 变更时间:2016/7/12
// 变更原因:点击查看农户详细信息
define([
    "dojo/_base/declare",
	"dojo/_base/lang",
    "dojo/dom-construct",
    "dojo/dom-class",
    "dojo/query",
    "dojo/store/JsonRest",
    "dijit/registry",
    "dijit/_WidgetBase",
    "dojox/mobile/EdgeToEdgeStoreList",
    "dojox/mobile/View",
    "dojox/mobile/Rating",
    "cq/ui/view/_ViewMixin",
    "cq/biz/user/userFarmer",
    "cq/biz/mat/mat",
    "cq/biz/article/ss/comment",
    "cq/widgets/item/itemProp"
],function(declare,lang,domConstruct,domClass,query,JsonRest,registry,_WidgetBase,EdgeToEdgeStoreList,View,Rating,_ViewMixin,userFarmer,mat,comment,itemProp){
   //创建新的ui组件 商品列表显示
    var OrderListItem = declare("", [_WidgetBase], {
        params:null,
        mName:"",
        retailPrice:0,
        qty:0,
        totalSale:0,
        logo:"",
        _id:"",
        baseClass:"mat-list-item",
        buildRendering:function(){
            this.inherited(arguments);
            //列表项的htmlStr
            var itemHtmlStr = ''
                  +'<div class="mat-list-imgpart"><img src="' + this.logo + '" /></div>'
			   	  + "<div class='shelf-mat-title'>"+this.mName+"</div>"
				  + "<div class='shelf-mat-price-normal'>"+"¥"+window.fixedTo(this.retailPrice,3)+"</div>"
                  + "<div class='shelf-mat-title'>"+"规格:"+this.sizeType+"</div>";
            this.domNode.appendChild(domConstruct.toDom(itemHtmlStr));
        }
    });
   return declare("whz.view.FarmerMsg",[View,_ViewMixin],{
       //创建农户信息   "mat"是农户商品状态,"matEva"是农户评价状态
       //当前显示的模式，显示商品列表还是评价列表
        selectedType:"mat",//"mat","matEva"
        //商品列表的start
        matStart:0,
        //评价列表的start
        matEvaStart:0,
        end:-1,
        pageSize:5,
        //不处理背景样式
        loadingBgClass:"farmer",
        //不处理没有列表的样式
        nothingBgClass:"farmerNothing",
        //刷新商品列表
       onFirstShow :function(){
           //导航显示
           var option = {
               isHeader:true,
               left : {
                   iconButton : ' ',
                   arrow : "left",
                   label : "返回",
                   onClick : function(){
                       this.isEditing = false;
                       history.back();
                   }
               },
               title : "农户详情"
           };
           this.addHeader(option);
           //显示logo/农户名称/电话/星级/地址/介绍
           option = {
               isEdge:true,
               lists: [{
                   label: "<div style='float:left;' class='farmerLogo'>"+
                   "<img style='width:100px' src='{{logo}}'/>"+
                   "</div>"+
                   "<div class='farmerMsg'>"+
                   "<p style='font-size:16px;'>姓名：{{pName}}</p>"+
                   "<p class='farmerName'>电话：{{phone}}</p>"+
                   "<div style='float:left' class='farmerName'>星级：</div><div style='float:left' class='ratingDivv'>{{score}}</div>"+
                   "</br><p class='farmerName'>地址：{{address}}</p>"+
                   "</div>",
                   variableHeight: true,
               },{
                   label: "<div class='farmerRmk'>{{userDesc}}</div>",
                   variableHeight: true,
               }]
           };
           this.farmerAllMsg=this.addLists(option);
           //创建公共区域
           option ={
               idHeader:true,
               class:"allMsg",
               columns : [{
                   label : '他的商品',
                   onClick : this.changeOnMatList
               },{
                   label : '他的评价',
                   onClick: this.changeOnMatEvaList
               }],
               labelClass : 'font-size1 tab-selector'
           };
           this.addColumns(option);
           //创建商品列表  
           this.matList=new EdgeToEdgeStoreList({
                append: true,
                constraint: false,
                query:{
                },
                className:"mat-list-verticalList2 matLists",
                variableHeight:true,
                onComplete:lang.hitch(this,function(data1){
                    this.matList.generateList(data1);
                    this.busy = false;
                }),
                itemRenderer:OrderListItem,
                itemMap:{
                    mName:"mName",
                    retailPrice:"retailPrice",
                    qty:"qty",
                    totalSale:"totalSale",
                    logo:"logo",
                    _id:"_id",
                }
           });
           //将列表添加到内容后面   this.centerPanel.containerNode直接添加当前节点到接下来的内容中
           this.matList.placeAt(this.centerPanel.containerNode,"last");
           //处理商品列表的点击事件
           this.matList.on("click",lang.hitch(this,this.onClickList));
           //创建评价详情
           this.matEvaList=new EdgeToEdgeStoreList({
               //参考评价列表
                append: true,
                constraint: false,
                query:{
                },
                className:"icon-list-item matEvaLists none",
                variableHeight:true,
                onComplete:lang.hitch(this,function(data2){
                    if(data2&&data2.length){
                        itemProp.initMatEvaData(data2);
                    }else{
                        data2 = [{
                            _label:"<div>暂无评价</div>"
                        }];
                    }
                    this.matEvaList.generateList(data2);
                    itemProp.initEvalistRating(this.matEvaList);
                    this.busy = false;
                }),
                itemMap:{_label:"label", logo:"logo",moveTo:"moveTo"}
              });
           this.matEvaList.placeAt(this.centerPanel.containerNode,"last");
           //添加滚动事件,拖动时加载更多
           this.centerPanel.on("afterscroll",lang.hitch(this,this.onLoadMore));
           this.onAfterShow();
       },
       onAfterShow : function(){
            //加载农户信息
            //刷新农户显示
            userFarmer.loadById(window.did).then(lang.hitch(this,function(data){
                //处理商品的评分
                if(data&&data.data&&data.data.item&&data.data.item.score){
                    data.data.item.score = window.fixedTo(data.data.item.score,2);
                }
                data.data.item.logo=data.data.item.logo||"/static/images/mobile/user_userIcon.png";
                data.data.item.userDesc=data.data.item.userDesc||"暂无简介";
                this.setData(data.data.item);
                this.refreshData();
                //星级评论
                if(!this.scoreWidget){
                    // 添加星级评论
                    this.createRating();
                }
                this.addRatingNode();
                if(data&&data.data&&data.data.item&&data.data.item.score){
                    this.scoreWidget.set("value",Math.round(data.data.item.score));
                }else{
                    this.scoreWidget.set("value",0);
                }
            }));
            //默认显示商品列表
            this.changeOnMatList({
                target:query(".tab-selector",this.domNode)[0]
            });
        },
        //刷新商品列表数据
        refreshMatList:function(){
            //销毁原来列表数据
            //从第一列开始加载，设置matStart=0
            this.matStart=0;
            this.matList.destroyDescendants();
            //若store没有初始化  创建new的srote  否则直接setQuery
            if(!this.matList.store){
                var url = mat.getLoadByFarmerUrl(window.did);
                //创建new的store
                var store = new JsonRest({target:url});
                // 将数据源赋值给StoreList
                var queryResult=this.matList.setStore(store,{farmer:window.did},{
                    start:this.matStart,
                    count:this.pageSize
                });
                this.onLoadListData(queryResult,this.matStart,this.pageSize);
            }else{
                var queryResult=this.matList.setQuery({farmer:window.did},{
                    start:this.matStart,
                    count:this.pageSize
                });
                this.onLoadListData(queryResult,this.matStart,this.pageSize);
            }
            
        },
        //刷新商品评价数据 跟刷新商品列表相同
        refreshMatEvaList:function(){
            this.matEvaStart=0;
            this.matEvaList.destroyDescendants();
            if(!this.matEvaList.store){
                var url = comment.getLoadByFarmerUrl();
                var store = new JsonRest({target:url});
                var queryResult=this.matEvaList.setStore(store,{farmer:window.did},{
                    start:this.matEvaStart,
                    count:this.pageSize
                });
                this.onLoadListData(queryResult,this.matEvaStart,this.pageSize);
            }else{
                var queryResult=this.matEvaList.setQuery({farmer:window.did},{
                    start:this.matEvaStart,
                    count:this.pageSize
                });
                this.onLoadListData(queryResult,this.matEvaStart,this.pageSize);
            }
        },
        //选中查看商品列表
        changeOnMatList:function(e){
            //清空样式
            this.clearSelected();
            //事件发生触发添加selected样式
            domClass.add(e.target, "selected");
            //设置当前选中的是商品还是评价
            this.selectedType = "mat";
            //设置显示隐藏
            this.setSelected();
            this.refreshMatList();
        },
        //选中查看评价列表  与商品详情相同
        changeOnMatEvaList:function(e){
            this.clearSelected();
            domClass.add(e.target, "selected");
            this.selectedType = "matEVa";
            this.setSelected();
            this.refreshMatEvaList();
        },
        //处理选中和显示隐藏，   滚动到最上边
        setSelected:function(){
            if(this.selectedType=="mat"){
                domClass.add(query(".matEvaLists")[0],"none");
                domClass.remove(query(".matLists")[0],"none");
            }
            if(this.selectedType=="matEVa"){
                domClass.remove(query(".matEvaLists")[0],"none");
                domClass.add(query(".matLists")[0],"none");
            }
        },
        //点击图片跳转商品详情
        onClickList:function(e){
            var li = registry.getEnclosingWidget(e.target);
            if(li.declaredClass!="dijit._WidgetBase") return;
            var _id = li.params._id;
            window.moveToView("matDetail", _id);
        },
        //拖动加载更多
        onLoadMore:function(e){
            //当滚动加载更多的时候，通过e的事件来判断是setQuer哪一个列表
            if(!this.busy&&e.afterBottom){
                if(this.selectedType=="mat"){
                    this.matStart = this.matStart+this.pageSize;
                    if(this.canLoadMore(this.matStart)){
                        console.log("加载更多商品");
                        this.busy = true;
                        setTimeout(lang.hitch(this, function () {
                            var queryResult = this.matList.setQuery(this.matList.get("query"), {
                                start : this.matStart,
                                count : this.pageSize
                            });
                            this.onLoadListData(queryResult,this.matStart,this.pageSize);
                        }), 1000);
                    }
                }
                if(this.selectedType=="matEVa"){
                    this.matEvaStart = this.matEvaStart+this.pageSize;
                    if(this.canLoadMore(this.matEvaStart)){
                        console.log("加载更多商品");
                        this.busy = true;
                        setTimeout(lang.hitch(this, function () {
                            var queryResult = this.matEvaList.setQuery(this.matEvaList.get("query"), {
                                start : this.matEvaStart,
                                count : this.pageSize
                            });
                            this.onLoadListData(queryResult,this.matEvaStart,this.pageSize);
                        }), 1000);
                    }
                }
                
            }
        },
       //清空所有状态
        clearSelected : function () {
            var items = query('.tab-selector', this.domNode);
            for (var i = 0; i < items.length; i++) {
                //移除每个节点的selected类
                domClass.remove(items[i], "selected");
            }
        },
        // 创建星级评论对象
        createRating : function(){
            this.scoreWidget = new Rating({
                image: "/static/common/images/star-orange.png",
                numStars: 5,
                value: 5
            });
        },
        // 添加农户星级评论对象
        addRatingNode: function() {
            var li = query("li", this.farmerAllMsg.domNode)[0];
            var ratingDiv = query(".ratingDivv",li)[0];
			ratingDiv.appendChild(this.scoreWidget.domNode);
        }
   }); 
});