// 创建人：潘云
// 创建时间： 2016-05-23
// 功能：抽奖活动
define([
    "dojo/_base/declare",
	"dojo/_base/array",
    "dojo/query",
    "dojo/sniff",
    "dojo/Deferred",
    "dojo/dom-class",
	"dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "dojo/_base/connect",
    "dojo/dom-style",
    "dojo/_base/lang",
    "dojo/dom-construct",
	"cq/biz/user/user",
	"cq/biz/article/mk/prize"
], function(declare,array, query, has, Deferred, domClass, View,_ViewMixin,connect, domStyle, lang,domConstruct,user,prize) {
	// module:
	//		widgets/mobile/PrizeBigWheel
    return declare("widgets.mobile.PrizeBigWheel", [View,_ViewMixin], {

        //正在加载抽奖结果. ture 为加载中...
        fetchingResult:false,
        //剩余抽奖次数
        remainChance:0,
        //指针旋转对应位置
        prizeLevAngles:[15, 45, 75, 105, 135, 165, 195, 225, 255, 285, 315, 345],
        //奖项的位置
        prizeLabelAngles:[105,135,165,195,225,255,285,315,345,15,45,75],
        //奖项
        awardLabels:["一等奖","二等奖","三等奖","四等奖","五等奖","六等奖","七等奖","八等奖"],
        //奖项分布,根据奖项的数量来确定分布情况
        awardsShow:["000000000000","100000000000","100000100000","100010001000","100100100100","101010101000","101010101010","101011101010","110110110110"],
        getTransformStyle:function () {
            return has("webkit")?"WebkitTransform":has("mozilla")?"MozTransform":"Transform"
        },
		// 初始化页面显示元素
		indexElement:function(){
            var prizeBg = this.prizeBg = domConstruct.create("div",{ class:"prizeBg" },this.centerPanel.containerNode);
			//我的奖品列表
            var myWineInfosDiv = '<img src="/static/common/images/prize.png"><span class="my_font_color">我的奖品：</span>'
                +'<div class="my_font_color my_prizeList" style="width:90%">'
                +   '<div class="my_prize_list">'
                +        '<marquee class="myWineInfosDiv" style="width:auto;height:32px;display:block;" scrollamount="2" direction="up" behaviour="Scroll">'
                +        '</marquee>'
                +  '</div>'
                +'</div>'
			this.myWineInfosDiv =query(".myWineInfosDiv",domConstruct.create("div", { class:"my_prize_background",innerHTML: myWineInfosDiv },prizeBg))[0] ;

			//我的抽奖次数
			this.remainChanceDiv = domConstruct.create("div", { class:"remainChanceDiv",innerHTML: "你目前还有<span class='remainChance'>0</span>次抽奖机会" },prizeBg);
			//提示可用积分兑换抽奖次数
			this.addNumberParset = domConstruct.create("div", { class:"addNumberParset",innerHTML: "使用5积分抽奖" },prizeBg);
			//奖项显示区域
			this.indexPrize();

			//活动中奖列表
            var winning_list = domConstruct.create("div",{class:"winning_list",innerHTML:'<img src="/static/common/images/winning_list.png">'},prizeBg);
			this.prizeWineInfosDiv = domConstruct.create("div", { class:"prizeWineInfosDiv"},winning_list);
			//活动说明
            var prizeStataDiv = domConstruct.toDom(
                '<div><div class="CommentTitle">'
                    +'<img class="img_turntable_explan" src="/static/common/images/activity_description.png">'
                +'</div>'
                +'<div>'
                    +'<div class="div_li_build prize_posi">'
                        +'<img src="/static/common/images/input_prize.png">'
                        +'<div class="prizeRemark">'
                            +'<textarea class="prizeStataDiv" readonly="readonly"></textarea>'
                        +'</div>'
                    +'</div>'
                +'</div></div>');
            prizeBg.appendChild(prizeStataDiv);
			this.prizeStataDiv = query('.prizeStataDiv',prizeStataDiv)[0];
			//活动时间
			this.prizeDate=domConstruct.create("div", { class:"prizeDate activ_background",innerHTML: '<img src="/static/common/images/activity_time.png"><div><span class="startTime">0</span> 至 <span class="endTime">0</span></div>' },prizeBg);
		},

		// 绑定页面事件
		initEvent:function(){
			// 抽奖指针绑定点击事件
			this.connect(query(".pointer", this.centerPanel.containerNode)[0], "onclick",this.onPrize);
		},
        createWhellHtml:function () {
            var htmlStr = '<div class="wheel"><ul class="wheel-light">';
            for (var i = 0; i < 6; i++) {
                htmlStr += "<li> <i></i><i></i><i></i><i></i> </li>";
            }
            htmlStr += "</ul></div>";
            return domConstruct.toDom(htmlStr);
        },
        createHoldHtml:function () {
            var htmlStr = '<div>';
            for (var i = 0; i < 12; i++) {
                htmlStr +=  '<div class="hold" id="hold'+(i+1)+'">'
                                +'<div class="pie pie'+(i%2?'2':"1")+'"></div>'
                            +'</div>'
            }
            htmlStr += '</div>';
            return domConstruct.toDom(htmlStr);
        },
        createPrizeHtml:function () {
            var htmlStr = ''
            +'<div class="noprize noprize1 prizeBox10">谢谢参与</div>'
            +'<div class="noprize noprize2 prizeBox1">再接再厉</div>'
            +'<div class="noprize noprize3 prizeBox4">继续努力</div>'
            +'<div class="noprize noprize4 prizeBox7">谢谢参与</div>'
            +'<div class="noprize noprize5 prizeBox9">再接再厉</div>'
            +'<div class="noprize noprize6 prizeBox0">继续努力</div>'
            +'<div class="noprize noprize7 prizeBox3">谢谢参与</div>'
            +'<div class="noprize noprize8 prizeBox6">再接再厉</div>'
            +'<div class="noprize noprize9 prizeBox5">继续努力</div>'
            +'<div class="noprize noprize10 prizeBox11">谢谢参与</div>'
            +'<div class="noprize noprize11 prizeBox2">再接再厉</div>'
            +'<div class="noprize noprize12 prizeBox8">继续努力</div>'
            return htmlStr;
        },
        indexPrize:function () {
            // 大转盘
            var bgDiv=domConstruct.toDom('<div class="pointerDiv bg"><div class="prizeAll"></div></div>');
            this.pointerDiv = query(".prizeAll",bgDiv)[0];
            this.prizeBg.appendChild(bgDiv);
            this.pointerDiv.appendChild(this.createWhellHtml());
            this.pointerDiv.appendChild(this.createHoldHtml());
            //奖项
            this.awardsDiv = domConstruct.create("div", { class:"awardsDiv" ,innerHTML:this.createPrizeHtml()},this.pointerDiv);
            //开始按钮
			this.pointer = domConstruct.toDom('<div class="pointer" stlye="z-index:15;"><div class="juzhong"><img class="cenImg" src="/static/common/images/start.png"></div></div>');
            this.cenImg = query(".cenImg",this.pointer)[0];
            this.pointerDiv.appendChild(this.pointer);
        },
		// 点击抽奖时的响应事件
		onPrize:function(){
			// 判断当前是否正在加载抽奖结果信息
			if(this.fetchingResult){
				alert("亲,点太快了,让我转一会儿~0.0~")
			}else{
				// 判断当前时间是否在活动时间之内
				if(this.endTime&&(Date.parse(new Date()) > Date.parse(this.endTime))){
					alert("活动已结束,下次记得赶早哟,亲~");
				}else if(this.startTime&&(Date.parse(new Date()) < Date.parse(this.startTime))){
					alert("活动未开始,请耐心等待哟,亲~");
				}else{
					user.hasLogin().then(lang.hitch(this,function(s){
						if(1){
							// 判断当前用户的是否有抽奖次数
                            //this.remainChance = 100;
							if(this.remainChance&&this.remainChance>0){
								// 让抽奖指针开始旋转
								this.startRotate();
								// 调用接口开始抽奖
								prize.onPrize().then(lang.hitch(this,function(data){
									this.handResult(data);
								}));
							}else{
								// 显示出积分兑换抽奖次数的对话框
								this.toggleMask('block');
								return;
							}
						}else{
							window.moveToView("login");
							user.nextPage="prizeBigWheel";
						}
					}));

				}
			}
		},
        //将指针重置到起始位置
        resetAngle:function(){
            this.resetToStartFlag = false;
            domStyle.set(this.cenImg,this.getTransformStyle(),"rotate("+0+"deg)");
        },
		// 抽奖时指针的处理 run表示运转 stop表示停止
		startRotate:function(){
			// 加载奖项的状态设置为真
			this.fetchingResult = true;
            //开始旋转
            domClass.add(this.cenImg ,"animationStyle");
            //开始旋转时,重置到起始位置
            domStyle.set(this.cenImg,this.getTransformStyle(),"rotate("+0+"deg)");
			console.log("抽奖的指针开始运转了");

		},
        stopRotate:function () {
            domClass.remove(this.cenImg ,"animationStyle");
            this.animate().then(lang.hitch(this,function () {
                this.fetchingResult = false;
                if(this.handled){
                    alert(this.message);
                }
                console.log("抽奖的指针停止运转了");
            }));
        },
        animate:function(){
            var stopAngle = (this.error?0:this.prizeLevAngles[this.endIndex]) + 1080,
                angle = 0, speed,def;
            def = new Deferred();
            window.clearInterval(this.d);
            this.d = setInterval(lang.hitch(this,function(){
                speed = (stopAngle - angle)/15;
                angle += speed;
                if(angle > stopAngle || speed < 0.01){
                    domStyle.set(this.cenImg,this.getTransformStyle(),"rotate("+stopAngle+"deg)");
                    window.clearInterval(this.d);
                    def.resolve();
                    return def;
                }
                domStyle.set(this.cenImg,this.getTransformStyle(),"rotate("+angle+"deg)");
            }),30);
            return def;
        },
		// 处理抽奖结果
		handResult:function(data){
            var handled;
            var message;
            var endIndex = 0;
            var remainChance = 0;
            var result;
			if(data.data.ok == 1){
                result = data.data.item;
				// 抽奖失败
				if(result.status == 0){
                    this.error = result.errMessage;
				}else{
					//alert("恭喜你，抽奖成功");
                    var prizeLev = result.PrizeLev||0,
                        awardShow = this.awardsShow[this.prizeCount];
                    if (prizeLev > 0) {
                        handled = true;
                        //需要指针有角度的情况
                        message = "恭喜您中了" + this.awardLabels[prizeLev-1] + ",奖品是:" + result.PrizeName;
                        endIndex = 0;
                        for(endIndex=0;endIndex<12;endIndex++){
                            if("1"==awardShow[endIndex]){
                                prizeLev--;
                            }
                            if(0===prizeLev){
                                break;
                            }
                        }
                    }else {
                        //没中奖
                        message = "很遗憾，您没有中奖，";
                        endIndex = 0;
                        prizeLev = Math.floor(Math.random()*10+2);
                        while(prizeLev){
                            endIndex++;
                            if(endIndex>11){
                                endIndex = endIndex-12;
                            }
                            if("0"===awardShow[endIndex]){
                                prizeLev--;
                            }
                        }
                    }
					// 刷新页面信息
					this.upDataUserInfo();
					this.upDataPrizeInfo();
				}
			}else {
			    this.error = data.data.msg;
			}
            this.handled = handled||'';
            this.message = message||'';
            this.endIndex  = endIndex;
            this.remainChance -= remainChance;
			this.stopRotate();
            this.showPrompt();
		},
		// 控制积分兑换抽奖次数的对话框 str = block 时显示，str = none 是隐藏
		toggleMask:function(str){
			if(str == "none" || str == "block"){
                if(this.addLotteryDiv){
                    domStyle.set(this.addLotteryDiv,"display",str);
                }else{
                    this.createMaskDiv();
                }
            }
		},
        //创建积分兑换框
        createMaskDiv:function () {
            var maskDivHtmlStr =
                '<div class="centerDiv">'
                    +'<img src="/static/common/images/prompt.png">'
                    +'<div class="contentDiv">'
                       +'<p><span>尊敬的客户，</span>您的抽奖次数已用完，是否使用<strong>积分抽奖</strong></p>'
                    +'</div>'
                    +'<div class="btnStyle integralBtn leftBtn">兑换抽奖</div>'
                    +'<div class="btnStyle shareBtn rightBtn">分享活动</div>'
                +'</div>'
                +'<div class="wires"></div>'
                +'<div class="close closeBtn"></div>'
            //积分兑换抽奖区域
			this.addLotteryDiv = domConstruct.create("div", { class:"addLotteryDiv",innerHTML:maskDivHtmlStr},this.prizeBg,"first");
            // 积分对话框中的兑换绑定点击事件
            this.connect(query(".integralBtn", this.addLotteryDiv)[0], "onclick",this.buyPrizeChance);
            // 积分对话框中的分享按钮点击事件
            this.connect(query(".shareBtn", this.addLotteryDiv)[0], "onclick",function(){
                this.toggleMask('none');
            });
            // 积分对话框的关闭按钮点击事件
            this.connect(query(".closeBtn", this.addLotteryDiv)[0], "onclick",function(){
                this.toggleMask('none');
            });
        },
		// 积分兑换抽奖次数的点击事件
		buyPrizeChance:function(){
			this.toggleMask('none');
			prize.buyPrizeChance("1411111").then(lang.hitch(this,function(data){
				if(data.data.ok == 1){
					alert("你获得了一次抽奖机会");
					// 刷新页面信息
                    this.upDataPrizeInfo();
                    //刷新用户信息
                    this.upDataUserInfo();
				}
			}));
		},
		// 提示积分兑换抽奖次数的显示隐藏
		showPrompt:function(){
            if(this.remainChance == 0){
                domStyle.set(query('.addNumberParset',this.centerPanel.containerNode)[0],"display","block");
            }else{
                domStyle.set(query('.addNumberParset',this.centerPanel.containerNode)[0],"display","none");
            }
        },
		onAfterShow:function(){
			this.prizeId = window.did||"1222222";
			// 判断用户是否登录
			user.hasLogin().then(lang.hitch(this,function(s){
				if(s){
					this.upDataUserInfo();
				}else{
					//处理提示积分兑换抽奖的显示问题
					this.showPrompt();
				}
			}));
            this.upDataPrizeInfo(true);
		},
        upAwards:function (awards) {
            var curIndex = 0;
            //奖项数量
            var len = awards.length;
            //显示方案
            var awardShow = this.awardsShow[len];
            for(var i = 0 ; awardShow.length > i; i++){
                node = query(".prizeBox" + i, this.domNode)[0];
                if(awardShow[i] == "1"){
                    node.innerHTML = this.awardLabels[curIndex];
                    curIndex ++;
                }
            }
        },
		// 更新奖项其他信息
		upDataPrizeInfo:function(isShow){
			prize.getPrizeInfo(this.prizeId).then(lang.hitch(this,function(data){
				var prizeData = data.data.item;
                //记录奖项信息到对象属性
				this.startTime = prizeData.startTime;
				this.endTime = prizeData.endTime;
                this.prizeCount = prizeData.awards.length;
				// 更新活动的时间
				query('.startTime',this.prizeDate)[0].innerHTML = this.startTime;
				query('.endTime',this.prizeDate)[0].innerHTML = this.endTime;
				this.prizeStataDiv.value = prizeData.content;
				// 刷新活动的奖品列表
				domConstruct.empty(this.prizeWineInfosDiv);
				if(prizeData.wineInfos){
					var prizestr = '<marquee class="marquee" scrollamount="2" direction="up" behaviour="Scroll">';
					array.forEach(prizeData.wineInfos,function(items){
						prizestr += "<div><span>"+items.wineTime+"</span><span>"+items.awardName+"</span><span>"+items.user.pName+"</span></div>";
					});
                    prizestr += "</marquee>";
					this.prizeWineInfosDiv.innerHTML = prizestr;
				}
                if(isShow){
                    this.upAwards(prizeData.awards);
                }
			}));
		},

		// 更新用户的信息
		upDataUserInfo:function(){
			prize.getCurrentUserPrizeInfo(this.prizeId).then(lang.hitch(this,function(data){
				this.userData = data.data.item;
				this.remainChance = this.userData.availableNum;
				// 更新用户的可抽奖次数
				query('.remainChance',this.remainChanceDiv)[0].innerHTML = this.remainChance;
				// 刷新我的奖品列表
				domConstruct.empty(this.myWineInfosDiv);
				if(this.userData.wineInfos){
					var userstr = "";
					array.forEach(this.userData.wineInfos,function(items){
						userstr += "<div><span>"+items.wineTime+"</span><span>"+items.awardName+"</span><span>"+items.user.pName+"</span></div>";
					});
					this.myWineInfosDiv.innerHTML = userstr;
				}
				this.showPrompt();
			}));
		},

		onFirstShow:function(){
			this.onAfterShow();
		},

    });
});
