// 变更人:徐阿雪
// 变更时间:2016/6/28
// 变更原因:修改编辑个人信息页面;修改到同一个ul中；修改默认时间为1990/01/01;地址和生日，头像，姓名；修改头像裁剪；
define(
    [
      "dojo/_base/declare",
      "dojo/_base/lang",
      "dojox/mobile/View",
      "cq/ui/view/_ViewMixin",
      "dojo/query",
      "cq/biz/user/user",
      "dojo/dom-construct",
      "dojo/on",
      "dojo/request/xhr"
  ],function(declare, lang,  View , _ViewMixin, query ,user, domConstruct, on, xhr){
       return declare("widgets.mobile.UserData",[ View, _ViewMixin ],{
       isEditing:false,
        onAfterShow : function(){
            //徐阿雪 修改默认时间为1990/01/01
            if(!this.isEditing){
                this.isEditing=true;
                user.loadById(user.getCurrentUserId()).then(lang.hitch(this,function(data){
                    data.data.item.birthday=data.data.item.birthday||"1990-01-01";
                    this.setData(data.data.item);
                    this.refreshData();
                }));
            }
        },
        onFirstShow : function(){
            // 头部设置
            var  options = {
              left : {
                  iconButton : ' ',
                  arrow : "left",
                  label : "返回",
                  onClick : lang.hitch(this,function() {
                    //history.back();
                    this.isEditing=false;
                    window.moveToView("user");
                  })
              },
              title : "个人信息",
              right :
                {iconButton : ' ', onClick : this.onSaveStore, label : "完成"}
             };
            this.addHeader(options);
            //徐阿雪 修改所有li到一个ul中 2016/6/28
            option = {
            isEdge : true,
            title:"",
            lists : [ {
                label : "头像",
                noArrow : false,
                imgSize:{width:128,height:128},
                edit :{
                    type:"image",
                    field:"logo"
                },
                class : "li-icon",
                moveTo : "#"
            },{
                    label : '姓名',
                    noArrow : true,
                    edit : {type : 'text', field : 'pName', placeHolder : '必填'}
            },{
                    label : '地址',
                    noArrow : true,
                    edit : {type : 'text', field : 'address', placeHolder : '必填'}
            },{
                    label : '生日',
                    noArrow : false,
                    moveTo:"#",
                    edit : {type : 'date', field : 'birthday', placeHolder : '必填'}
            }],
          };
          var list = this.addLists(option);
          this.onAfterShow();
        },
        onSaveStore:function(){
            //徐阿雪 2016/6/28
            if(this.isEditing){
                //设置界面busy
                window.busy();
                var save = this.getData();
                delete save.userName;
                //var saveDate；
                //savaDate._id=sava._id;
                user.save(save).then(function() {
                    //console.log("保存成功");
                    this.isEditing = false;
                    window.free();
                    window.moveToView("user");
                });
            }
        },
       });
     });
