/* 
修改人：张金鹏
修改内容：增加我关注的商品、已购买的商品、我的收货地址的入口
修改时间：2016/09/21 
*/

require([
	"cq/util/config/config",
    "cq/biz/user/user",
    "dojo/_base/lang"
],function(config, user, lang){
	config.platformShopId = g_sys_info.platformShopId;
    config.dataOrigin = location.origin;
    window.moveToTargetView = function(view){
        user.hasLogin().then(lang.hitch(this,function(s){
            if(s){
                window.moveToView(view);
            }else{
                user.nextPage = view;
                window.moveToView("login");
            }
        }));
    };
    require(["widgets/mobile/app"]);
});
window.viewParam = {
	//首页
	main : {
        //android设备APP中点击两次退出
        noBack:true,
		headClass : "nothing",
		dojoType : "widgets/mobile/Main"
	},
	matList : {
		headClass : "nothing",
		dojoType : "widgets/mobile/MatList"
	},
	matDetail : {
		dojoType : "cq/ui/common/m/MatDetail"
	},
    
	//订单添加
	orderInfo : {
		dojoType : "widgets/mobile/OrderInfo"
	},
	//订单详情
	orderDetail : {
		dojoType : "widgets/mobile/OrderDetail"
	},
	//所有订单
	orderList : {
		dojoType : "cq/ui/common/ts/OrderList"
	},
	//地址填写
	chooseAddr: {
		dojoType : "widgets/mobile/ChooseAddr"
	},
	orderCar : {
		dojoType : "widgets/mobile/OrderCar"
	},
	// 资讯列表
	newsList : {
		dojoType : "cq/ui/c/a/NewsList"
	},
	// 资讯详情
	newDetail : {
		dojoType : "widgets/mobile/NewDetail"
	},
	// 我
	user : {
		dojoType : "widgets/mobile/User"
	},
	// 用户信息
	userData : {
		dojoType : "widgets/mobile/UserData"
	},
	//用户设置
	userSetting : {
		dojoType:"widgets/mobile/UserSetting"
	},
    // 用户地址编辑
    userAddDetail: {
        dojoType: "cq/ui/common/u/UserAddDetail"
    },
	//客户分销
	clientDistribute : {
		dojoType:"widgets/mobile/ClientDistribute"
	},
    //榜单
    dstbtList : {
       dojoType:"widgets/mobile/DstbtList"
    },
	//货架预览页面
    shelfPreview:{
		dojoType:"widgets/mobile/ShelfPreview"
    },
	//抽奖活动
	prizeBigWheel:{
		dojoType:"widgets/mobile/PrizeBigWheel"
	},
	// 服务机构
	agencyList:{
		dojoType:"widgets/mobile/AgencyList"
	},
	//商铺详情
	shopDetail:{
		dojoType:"widgets/mobile/ShopDetail"
	},
	// 商品评论列表
	matEvalList:{
		dojoType:"cq/ui/b/m/MatEvalList"
	},
	expertList:{
		dojoType:"widgets/mobile/ExpertList"
	},
    expertDetail:{
		dojoType:"widgets/mobile/ExpertDetail"
	},
    //直播间列表
    channelList:{
		dojoType:'cq/ui/c/im/ChannelList'
	},
    //直播详情
    channelDetail:{
        dojoType:'cq/ui/c/im/ChannelDetail'
    },
    //客服列表详情
    svcDetail:{
        dojoType:'cq/ui/common/im/SvcDetail'
    },
    // 商家列表
    shopList:{
        dojoType:"widgets/mobile/ShopList"
    },
    // 畜牧商品列表
    xmMatList:{
    	dojoType:"widgets/mobile/XmMatList"
    },
    // 畜牧商品详情
    xmMatDetail:{
    	dojoType:"widgets/mobile/XmMatDetail"
    },
    //讲堂详情
	classRoomDtl:{
		dojoType:"widgets/mobile/ClassRoomDtl"
	},
    // 讲堂列表
    classRoomList : {
        dojoType:"widgets/mobile/ClassRoomList"
    },
    supplyDemandList : {
        dojoType:"widgets/mobile/SupplyDemandList"
    },
    supplyDemandDetail:{
        dojoType:"widgets/mobile/SupplyDemandDetail"
    },
    //农户详细信息
    farmerMsg:{
        dojoType: "widgets/mobile/FarmerMsg"
    },
    //供货店铺
    supplyBus:{
        dojoType: "cq/ui/c/s/SupplyBus"
    },
    // 我的卡劵
    userCountSer : {
        dojoType : "cq/ui/common/t/UserCountSer"
    },
	// 消费者端的关注商品列表
    attentionMatList: {
        dojoType: "cq/ui/common/u/AttentionMatList"
    },
    // 消费者端的已购买商品列表
    boughtMatList: {
        dojoType: "cq/ui/common/u/BoughtMatList"
		 //dojoType: "whz/view/BoughtMatList"
    },
	// 消费者端的评价列表
    evaList: {
        dojoType: "cq/ui/c/s/EvaList"
    },
    // 消费者端的评价
    eva: {
        dojoType: "cq/ui/c/s/Eva"
    },
	// 消费者端的我的收货地址
    userAddList: {
        dojoType: "cq/ui/common/u/UserAddList"
    },
    //  乡村详情
    reVillager : {
        dojoType: "widgets/mobile/ReVillager"
    },
    saleBuyCenter:{
        dojoType:"widgets/mobile/SaleBuyCenter"
    },
    //拼团编辑
    pacBuyDetail : {
        dojoType: 'widgets/mobile/PacBuyDetail'
    },
    //拼团列表
    pacBuyList : {
        dojoType: 'widgets/mobile/PacBuyList'
    },
    //拼团玩法
    pacBuyIntroduces : {
        dojoType: 'widgets/mobile/PacBuyIntroduces'
    },
    //我的拼团
    pacTeamList : {
        dojoType: 'widgets/mobile/PacTeamList'
    },
    //所有拼团
    pacAllTeamList : {
        dojoType: 'widgets/mobile/PacAllTeamList'
    },
    //团队详情
    pacTeamDetail : {
        dojoType: 'widgets/mobile/PacTeamDetail'
    }
};
