﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-class",
    "dijit/_WidgetBase"
],function(declare,lang,domClass,_WidgetBase){
    return declare("",[_WidgetBase],{
        baseClass:"list-item",
        label:"",
        checked:false,
        buildRendering:function(){
            this.inherited(arguments);
            this.domNode.innerHTML = "<img class='list-icon-mini' src='"+this.icon+"'><div class='list-label'>"+this.label+"</div>";
            this.connect(this.domNode,"onclick",this.onClick);
        },
        _setCheckedAttr:function(checked){
            this.inherited(arguments);
            this.checked = !!checked;
            domClass[this.checked?"add":"remove"](this.domNode,"list-checked");
        },
        onClick:function(e){
            return this.getParent().onItemClick(this,e);
        }
    });
});