﻿define([
    "dojo/_base/declare",
    "dojo/dom-class",
    "dijit/_WidgetBase"
],function(declare,domClass,_WidgetBase){
    return declare("",[_WidgetBase],{
        baseClass:"list-label-item",
        logo:"",
        label:"",
        checked:false,
        buildRendering:function(){
            this.inherited(arguments);
            this.domNode.innerHTML = this.label;
            this.connect(this.domNode,"onclick",this.onClick);
        },
        _setCheckedAttr:function(checked){
            this.inherited(arguments);
            this.checked = !!checked;
            domClass[this.checked?"add":"remove"](this.domNode,"label-checked");
        },
        onClick:function(e){
            return this.getParent().onItemClick(this,e);
        }
    });
});