define([
    "dojo/_base/declare",
    "dojo/_base/array",
    "dojo/_base/lang",
    "cq/util/config/config",
    "cq/biz/object"
],function(declare, array, lang, config, object){
    var O = declare("", object.Schema, {
        modalName:"article/article_group",
        //加载指定类别
        loadById:function(id){
            return this.execInCurrentShop("load_by_id",{
                _id:id
            });
        },
        //保存类别
        save:function(item){
            return this.execInCurrentShop("save",item);
        },
        load:function(condition){
            return this.execInCurrentShop("load",condition);
        },
        getLoadUrl:function(){
            return this.getBaseUrl()+"/load?shopId="+this.getShopId();
        },
        getPlatformUrl:function(){
            //从config中读取platformID
            return this.getBaseUrl()+"/load?shopId="+config.getPlatformShopId();
        },
        getPlatformGroups:function(params){
            return this.exec("load",{
                shopId : config.getPlatformShopId(),
                isUse : params.isUse
            });
        }
    });
    var o = new O();
    lang.setObject("cq.biz.article.articleGroup", o);
    o.Schema = O;
    return o;
});