define([
    "dojo/_base/declare",
    "dojo/_base/array",
    "dojo/_base/json",
    "dojo/_base/lang",
    "cq/biz/object"
],function(declare, array, json, lang, object){
    var O = declare("", object.Schema, {
        modalName:"article/article",
        //资讯详情
        loadById:function(id){
            return this.execInCurrentShop("load_by_id",{_id:id}).then(function(result){
                return result;
            });
			
        },
		save:function(item){
            return this.execInCurrentShop("save",item).then(function(result){
                return result;
            })
        },
		delete:function(id){
            return this.execInCurrentShop("delete_by_id",{_id:id}).then(function(result){
                return result;
            })
        },
		load:function(condition){
            return this.execInCurrentShop("load",condition).then(function(result){
                return result;
            })
        },
        //通栏目取资讯
        loadByType:function(type,page){
            var hash={
                type:type?type:"",
            };
            if(page){
                hash.pageSize=page.pageSize?page.pageSize:"";
                hash.pageIndex=page.pageIndex?page.pageIndex:"";
                hash.orderBy=page.orderBy?page.orderBy:"";
            }
            return this.execInCurrentShop("load_by_type",hash).then(function(result){
                return result;
            });
			/* return this.defTest([{_id:"1234",TITLE:"测试数据",SUMMARY:"二级hi发七台河io儿人",
									LARGEURL:"接电话业务iofc",MAKEDATE:"2014-1-3"},{
									_id:"3333",TITLE:"孙悟空",SUMMARY:"阿斯钢哈克龙韩国回来",
									LARGEURL:"环境司机大哥",MAKEDATE:"2015-1-3"
									}]); */
        },
        getArticleUrl:function(){            
            return this.getBaseUrl()+"/load?shopId="+this.getShopId();            
            
        },
		getXMShopUrl:function(){
			return this.getBaseUrl()+"/load?shopId=5703ca7d0ccae34b2b40ab8c";
		}
    });
    var o = new O();
    lang.setObject("cq.biz.article.article", o);
    o.Schema = O;
    return o;
});