﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "cq/biz/object"
],function(declare,lang,object){
    var Award = declare("",object.Schema,{
        modalName:"article/mk/award",
        save:function(awards,prizeId){
            return this.execInCurrentShop("save",{
                data:JSON.stringify({
                    prizeId:prizeId,
					awards:awards
                })
            });
        },
        loadByPrizeId:function(prizeId){
            return this.execInCurrentShop("load_by_prize",{
                prizeId:prizeId
            });
        }
    });
    var award = new Award();
    award.Schema = Award;
    lang.setObject("cq.biz.article.mk.award",award);
    return award;
});