/**
* Writer 杜飞军
* Create Time 2016/05/20
**/
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "cq/biz/object"
],function(declare,lang,object){
    var disCount = declare("",object.Schema,{
        modalName:"article/mk/dis_count",
        save:function(params){
            return this.execInCurrentShop("save",params);
        },
        getLoadUrl:function(){
            return this.getBaseUrl()+"/load?shopId="+this.getShopId();
        },
        loadById:function(id){
            return this.execInCurrentShop("load_by_id",{
                _id:id
            });
        },
        verifyById:function(id){
            return this.execInCurrentShop("verify_by_id",{
                _id:id
            });
        },
        stopById:function(id){
            return this.execInCurrentShop("stop_by_id",{
                _id:id
            });
        },
        generateSeries:function(id){
            return this.execInCurrentShop("generate_series",{
                _id:id
            });
        },
        distribute:function(params){
            return this.execInCurrentShop("distribute_by_id_and_user",{
                _id:params.id,
                userId:params.userId
            });
        }
    });
    var disCount = new disCount();
    disCount.Schema = disCount;
    lang.setObject("cq.biz.article.mk.disCount",disCount);
    return disCount;
});