define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "cq/biz/object"
],function(declare,lang,object){
    var disCountSer = declare("",object.Schema,{
        modalName:"article/mk/dis_count_ser",
        //依据活动Id和类型state查询优惠券，上述两个参数必传
        getLoadUrl:function(){
            return this.getBaseUrl()+"/load?shopId="+this.getShopId();
        },
        loadById:function(id){
            return this.execInCurrentShop("load_by_id",{
                _id:id
            });
        },
        getValidDisSer:function(amount){
            return this.defTest({
                data:{
                    ok:0,
                    items:[{
                        _id:"57406d8bd9f2d3cb69bf0fa8",
                        disSer:"123456789",
                        disId:{
                            _id:"57406d8bd9f2d3cb69bf0fa8",
                            disName:"1st优惠券--满10减1",
                            validDate:"2016-12-31T00:00:00",
                            amount:50,
                            preferentFee:10,
                            limitAmount:100
                        }
                    },{
                        _id:"5703ca7d0ccae34b2b40ab8c",
                        disSer:"123456789",
                        disId:{
                            _id:"5703ca7d0ccae34b2b40ab8c",
                            disName:"2st优惠券--免费券",
                            validDate:"2016-12-01T00:00:00",
                            amount:50,
                            preferentFee:2,
                            limitAmount:100
                        }
                    }]
                }
            });
        }
    });
    var disCountSer = new disCountSer();
    disCountSer.Schema = disCountSer;
    lang.setObject("cq.biz.article.mk.disCountSer",disCountSer);
    return disCountSer;
});