define(
    [
      "dojo/_base/declare", "dojo/_base/array", "dojo/_base/json",
      "dojo/_base/lang", "cq/biz/object"
    ],
    function(declare, array, json, lang, object) {
      var O = declare("", object.Schema, {
        modalName : "article/section",
        //根据id取一条数据
        loadById : function(id) {
          return this.execInCurrentShop("load_by_id", {_id : id});
        },
        save : function(item) { return this.execInCurrentShop("save", item); },
        delete : function(id) {
          return this.execInCurrentShop("delete_by_id", {_id : id});
        },
        load : function(condition) {
            return this.execInCurrentShop("load",condition);
        },
        getSectionUrl : function() {
          return this.getBaseUrl() + "/load?shopId=" + this.getShopId();
        },
        publish : function(button) {
          var data = json.toJson({button : button});
          return this.execInCurrentShop("create_wx_menu", {data : data});
        }
      });
      var o = new O();
      lang.setObject("cq.biz.article.section", o);
      o.Schema = O;
      return o;
    });