define([
    "dojo/_base/declare",
    "dojo/_base/array",
    "dojo/_base/json",
    "dojo/_base/lang",
    "cq/biz/object"
],function(declare, array, json, lang, object){
    var O = declare("", object.Schema, {
        modalName:"mat/mat",
        //商品详情
        loadById:function(id){
            return this.execInCurrentShop("load_by_id", {_id : id});
            /* return this.execInCurrentShop("load_by_id",{_id:id}).then(function(result){
               return result.item;
            }); */
            /* return this.defTest({_id:'57089a3e01bbccd1211dffc8',code:30022,mName:"酉州乌羊",group:"30036",sizeType:"2213",
                retailPrice:"580.00",settlePrice:"10080.00",marketPrice:"41585.00",content:"按时打算的 大扫荡   la",
                logo:"30401",deliveryTimes:"7",qty:"500",totalSale:"500",images:'dgh'
            }); */
        },
        //商品详情
        loadPublicById:function(id,shopId){
            return this.exec("load_by_id", {_id : id,shopId});
            /* return this.execInCurrentShop("load_by_id",{_id:id}).then(function(result){
               return result.item;
            }); */
            /* return this.defTest({_id:'57089a3e01bbccd1211dffc8',code:30022,mName:"酉州乌羊",group:"30036",sizeType:"2213",
                retailPrice:"580.00",settlePrice:"10080.00",marketPrice:"41585.00",content:"按时打算的 大扫荡   la",
                logo:"30401",deliveryTimes:"7",qty:"500",totalSale:"500",images:'dgh'
            }); */
        },
        //通过品类取商品
        loadByType:function(type,page){
            var hash={
             type:type?type:"",
             };
             if(page){
             hash.pageSize=page.pageSize?page.pageSize:"";
             hash.pageIndex=page.pageIndex?page.pageIndex:"";
             hash.orderBy=page.orderBy?page.orderBy:"";
             }
             return this.exec("load_by_type",hash).then(function(result){
             return result;
             });
            /* return this.defTest([{_id:30001,code:30002,mName:"haodongxi",group:"30001",sizeType:"1221",
                retailPrice:"500.00",settlePrice:"1000.00",marketPrice:"4155.00",content:"henhaode dongxi la la",
                logo:"30001",deliveryTimes:"5",qty:"500",totalSale:"500",images:'sdfef'
            },{_id:30031,code:30022,mName:"阿嘎",group:"30036",sizeType:"2213",
                retailPrice:"580.00",settlePrice:"10080.00",marketPrice:"41585.00",content:"按时打算的 大扫荡   la",
                logo:"30401",deliveryTimes:"7",qty:"500",totalSale:"500",images:'dgh'
            }]); */
        },
        loadOnSale:function(pageSize,pageIndex){
            return this.defTest([{
                logo:"images/icons/mat.png",
                mName:"酉州乌羊",
                totalSale:1250,
                qty:60
            },{
                logo:"images/icons/mat.png",
                mName:"酉州乌羊",
                totalSale:1250,
                qty:60
            }]);
        },
        add:function(item){
            return this.exec("add",item).then(function(result){
                return result;
            });
        },
        save : function(data) { return this.execInCurrentShop("save", data); },
        getOnSaleUrl:function(){
            return this.getBaseUrl()+"/load_mat?shopId="+this.getShopId();
        },
        getRecMat:function(){
            return this.getBaseUrl()+"/load_rec_mat?shopId="+this.getShopId();
        },
        getOnSaleByShop:function(condition){
            return this.exec("load_mat",condition);
        }
    });
    var o = new O();
    lang.setObject("cq.biz.mat.mat", o);
    o.Schema = O;
    return o;
});