﻿//创建人：冉伟
//创建时间：2016/7/18
//创建内容：标准分类后台代理接口
define([
    "dojo/_base/declare",
    "dojo/_base/array",
    "dojo/Deferred",
    "dojo/_base/lang",
    "cq/biz/object",
    "cq/util/config/config"
],function(declare, array,Deferred, lang, object, config){
    var O = declare("", object.Schema, {
        //后台模块路径
        modalName:"mat/std/mat_std_sort",
        //依据id加载指定一行数据接口
        loadById:function(id){
            return this.exec("load_by_id", {
                _id : id,
                shopId:config.getPlatformShopId()
            });
        },
        //保存数据接口
        save:function(data){
            return this.exec("save", {
                //将对象转化为字符串
                data : data,
                shopId : config.getPlatformShopId()
            });
        },
        //为查询界面准备数据源，获取执行操作的地址
        getSortUrl:function(){
            return this.getBaseUrl()+"/load?shopId="+config.getPlatformShopId();
        },
        //查询接口
        load : function(param){
            param.shopId = config.getPlatformShopId();
           //param obj
           return this.exec("load",param);
        },
        //查询接口
        loadNoSub : function(){
            return this.getBaseUrl()+"/load?shopId="+config.getPlatformShopId()+"&isUse=true&noSub=true";
        },
        // 查询下级分类
        loadSubSorts: function(upSort, orderBy){
            var params = {
                shopId: config.getPlatformShopId(),
                upSort: upSort
            };
            if(orderBy){
                params.orderBy = orderBy;
            }
            return this.exec("load_sub_sorts",params);
        },
        // 获取查询下级分类url
        getLoadSubSortsUrl: function(upSort, orderBy){
            return this.getBaseUrl()+"/load_sub_sorts?shopId="+config.getPlatformShopId()+("&upSort="+(upSort?upSort:""))+(orderBy?"&orderBy="+orderBy:"");
        },
        updateCodeByIds : function(ids){
            return this.exec("update_code_by_ids", {ids : ids, shopId : config.getPlatformShopId()});
        },
        deleteById : function(id){
            return this.exec("delete_by_id", {_id : id, shopId : config.getPlatformShopId()});
        }
    });
    var o = new O();
        lang.setObject("cq.biz.mat.sort", o);
        o.Schema = O;
        return o;
});