﻿//创建人：潘云
//创建时间：2016/7/13
//创建内容：畜栏后台代理接口
define([
    "dojo/_base/declare",
    "dojo/_base/array",
    "dojo/_base/json",
    "dojo/Deferred",
    "dojo/_base/lang",
    "cq/biz/object"
],function(declare, array, json,Deferred, lang, object){
    var O = declare("", object.Schema, {
        modalName:"mat/stall",
        //加载
        loadById:function(id){
            return this.execInCurrentShop("load_by_id", {_id : id});
        },
        //保存
        save:function(data){
            return this.execInCurrentShop("save", data);
        },
        //为查询界面准备数据源
        getStallUrl:function(){
            return this.getBaseUrl()+"/load?shopId="+this.getShopId();
        },
        //加载
        load : function(param){
           //param obj
           return this.execInCurrentShop("load",param);
        },
        //参数格式：
        //{stallDatas:[{bamId:"fsdafds",bamCode:"fsdaf",capacity:10},...]}
        //返回值：同正常查询的结果
        create : function (param) {
            return this.execInCurrentShop("batch_create",{
                stallDatas : param.stallDatas
            });
        }
    });
    var o = new O();
    lang.setObject("cq.biz.mat.stall", o);
    o.Schema = O;
    return o;
});