﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "cq/biz/object",
    "cq/util/config/config"
],function(declare,lang,object,config){
    var DiscountCoupon = declare("",object.Schema,{
        modalName:"mk/discount_coupon",
        //获取自己的优惠券列表、状态、人、分页
        getLoadUrl:function(){
            return this.getBaseUrl()+"/load?shopId="+this.getShopId();
        },
        // 获取平台下的优惠劵
        getPlatformLoadUrl : function () {
            return this.getBaseUrl()+"/load?shopId="+config.getPlatformShopId();
        },
        getCoupons : function(){
            return this.execInCurrentShop("load",{});
        },
        // 加载指定的id内容
        loadById: function(id) {
            return this.execInCurrentShop("load_by_id", {_id: id});
        }
    });
    var discountCoupon = new DiscountCoupon();
    lang.setObject("cq.biz.mk.discountCoupon",discountCoupon);
    return discountCoupon;
});
