﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "cq/biz/object"
],function(declare,lang,object){
    var Price = declare("",object.Schema,{
        modalName:"mk/group_buy",
        save:function(params){
            //params.rebateRule = JSON.stringify(params.rebateRule);
            return this.execInCurrentShop("save",this.filterSaveData(params));
        },
        loadById:function(id){
            return this.execInCurrentShop("load_by_id",{_id:id});
        },
        getLoadUrl:function(){
            return this.getBaseUrl()+"/load?shopId="+this.getShopId();
        },
        //缓存的商品的促销活动
        //_groupBuyInfo:{},
        loadGroupBuys:function(shopMatInfo){
            var mids = null,midLen = 0,handledGroupInfo = {};
            //从缓存中查找团购信息
            for(var shopId in shopMatInfo){
                mids = shopMatInfo[shopId];
                midLen = mids.length;
                // while(midLen--){
                //     if(this._groupBuyInfo[mids[midLen]]){
                //         handledGroupInfo[mids[midLen]] = lang.clone(this._groupBuyInfo[mids[midLen]]);
                //         mids.splice(midLen,1);
                //     }
                // }
                if(0===midLen){
                    delete shopMatInfo[shopId];
                }
            }
            midLen = 0;
            for(var shopId in shopMatInfo){
                midLen++;
            }
            if(midLen){
                //有些信息还是要从服务器读取
                // return this.exec("load_group_buys",{
                    // data:JSON.stringify(shopMatInfo)
                // });
                return this.exec("load_group_buys",{
                    data:shopMatInfo
                });
                
                // .then(lang.hitch(this,function(data){
                //     // data.data.item = data.data.item||{};
                //     // for(var mid in data.data.item){
                //     //     this._groupBuyInfo[mid] = lang.clone(data.data.item[mid]);
                //     // }
                //     // lang.mixin(data.data.item,handledGroupInfo);
                //     return data;
                // }));
            }else{
                return this.defTest({
                    data:{
                        item:{}//handledGroupInfo
                    },
                    ok:1
                });
            }
        }
    });
    var price = new Price();
    lang.setObject("cq.biz.mk.groupBuy",price);
    return price;
});
