﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "cq/biz/object"
],function(declare,lang,object){
    var Price = declare("",object.Schema,{
        modalName:"mk/group_buy",
        save:function(params){
            params.rebateRule = JSON.stringify(params.rebateRule);
            return this.execInCurrentShop("save",this.filterSaveData(params));
        },
        loadById:function(id){
            return this.execInCurrentShop("load_by_id",{_id:id});
        },
        getLoadUrl:function(){
            return this.getBaseUrl()+"/load?shopId="+this.getShopId();
        }
        //{mName,销量, retailPrice , price ,sDate,eDate,返现金额}
    });
    var price = new Price();
    lang.setObject("cq.biz.mk.groupBuy",price);
    return price;
});
