﻿// 创建人 : 潘云
// 创建时间 : 2016-7-19
// 创建内容 : 出场记录后台代理接口
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/_base/json",
    "dojo/Deferred",
    "cq/biz/object"
],function(declare, lang, array, json, Deferred, object){
    var O = declare("",object.Schema,{
        modalName:"pr/leaving_record",
        //加载
        loadById : function(id){
            return this.execInCurrentShop("load_by_id", {_id : id});
        },
        //保存
        save : function(data){
            //data = this.filterSaveData(data);
            return this.execInCurrentShop("save", data);
        },
        //为查询界面准备数据源
        getLoadUrl : function(){
            return this.getBaseUrl()+"/load?shopId="+this.getShopId();
        },
        //加载
        load : function(param){
           //param obj
           return this.execInCurrentShop("load",param);
        },
        // 批量生成出场记录
        // 参数格式
        // cattles : 要出场的畜只 数组【_id,_id】
        // 其他参数与save方法一样
        batchCreateLeaving : function (params) {
            //params.cattles = JSON.stringify(params.cattles);
            return this.execInCurrentShop("batch_create_leaving", params);
        }
    });
    var o = new O();
        lang.setObject("cq.biz.pr.leavingRecord", o);
        o.Schema = O;
        return o;
})