﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "cq/biz/object"
],function(declare, lang, array, object){
    var O = declare("",object.Schema,{
        modalName:"shop/freight_template",
        //加载
        loadById : function(id){
            return this.execInCurrentShop("load_by_id", {_id : id});
        },
        //保存
        save : function(data){
            if(data.expections){
                data.expections = array.map(data.expections,function(item){
                    return this.fileCreatedDate(item);
                },this);
            }
            data = this.filterSaveData(data);
            return this.execInCurrentShop("save", {
                //data:JSON.stringify(data)
                data : data
            });
        },
        //为查询界面准备数据源
        getLoadUrl : function(){
            return this.getBaseUrl()+"/load?shopId=" + this.getShopId();
        },
        //加载
        load : function(params){
           return this.execInCurrentShop("load", params);
        },
        //根据_id来加载模板
        loadById : function(id){
            return this.exec("load_by_id", {
                shopId : this.getShopId(),
                _id : id
            });
        },
        //根据_id来删除模板
        deleteById : function(id){
            return this.exec("delete_by_id", {
                shopId : this.getShopId(),
                _id : id
            });
        },
        //查看哪些商品引用了本模板
        getLoadRefMatUrl : function(id){
            return this.getBaseUrl()+"/load_ref_mat?shopId=" + this.getShopId() + "&_id=" + id;
        }
    });
    var o = new O();
        lang.setObject("cq.biz.shop.freightTemplate", o);
        o.Schema = O;
        return o;
});