define([
    "dojo/_base/declare",
    "dojo/_base/array",
    "dojo/_base/json",
    "dojo/_base/lang",
    "cq/biz/object",
    "cq/util/config/config",
    "dojo/Deferred"
],function(declare, array, json, lang, object,config,Deferred){
    var O = declare("", object.Schema, {
        modalName:"shop/goat_quater_summary",
        //保存
        save:function(param){
            param.shopId=config.getPlatformShopId();
            return this.exec("save",param);
        },
        loadById:function(id){
            return this.exec("load_by_id",{_id:id,shopId:config.getPlatformShopId()});
            //return this.defTest([{APP_TITLE:"测试shangjia",M_BUSS:"aioghraohrqoihrhqoighi",PHONE:123456478,ADDR:"只能乖乖",LOGO:"30014",shopId:"45555",appendClass:"ok"}]);
        },
        saveAll:function(data){
          return this.exec("save_some", {shopId:config.getPlatformShopId(),data : json.toJson(data)});
        },
        delete:function(id){
            return this.exec("delete_by_id",{_id:id,shopId:config.getPlatformShopId(),formShopId:this.shopId});
        },
        load:function(){
            return this.getBaseUrl()+"/load?shopId="+config.getPlatformShopId()+"&fromShopId="+this.getShopId();
        }
    });
    var o = new O();
    lang.setObject("cq.biz.shop.goat_quater_summary", o);
    o.Schema = O;
    return o;
});