﻿//创建人：周超
//创建时间：2016/9/6
//创建内容：合作伙伴后台代理接口
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "cq/biz/object",
    "cq/util/config/config"
], function(declare, lang, object, config) {
    var O = declare("", object.Schema, {
        modalName: "shop/shop",
        //加载
        loadById: function(id) {
            return this.execInCurrentShop("load_by_id", { _id: id });
        },
        loadByIdAndShopId: function(shopId, id) {
            return this.exec("load_by_id", { shopId: shopId, _id: id });
        },
        checkSupplierById: function(param) {
            return this.execInCurrentShop("load_by_id", param);
        },
        //添加供应商
        addSupplier: function(supplierShopId) {
            return this.execInCurrentShop("b2b_add_supplier", { supplierShopId: supplierShopId });
        },
        //删除供应商
        removeSupplier: function(supplierShopId) {
            return this.execInCurrentShop("remove_supplier", { supplierShopId: supplierShopId });
        },
        //删除分销商
        removeCustomer: function(params) {
            return this.execInCurrentShop("remove_customer", {
                shopId: this.getShopId(),
                customerShopId: params
            });
        },
        //保存
        //save : function(data){
        //data = this.filterSaveData(data);
        //    return this.execInCurrentShop("save",data);
        //},
        //为查询界面准备数据源
        getLoadUrl: function() {
            return this.getBaseUrl() + "/load_partner?shopId=" + this.getShopId();
        },
        //加载
        load: function(param) {
            return this.execInCurrentShop("load_partner", param);
        },
        loadByShopId: function(param) {
            return this.exec("load_partner", param);
        },
        // 验证区域
        verifyArea: function(param) {
            return this.execInCurrentShop("verify_area", param);
        },
        //农村处。
        //  标记认证
        businessVerify: function(param) {
            return this.exec("business_verify", param);
        },
        //取消认证
        businessCancel: function(param) {
            return this.exec("business_cancel", param);
        },
        //驳回认证
        businessReject: function(param) {
            return this.exec("business_reject", param);
        },
        //删除服务商
        removeServiceShop: function(param) {
            return this.exec("remove_service_shop", param);
        }
    });
    var o = new O();
    lang.setObject("cq.biz.shop.partner", o);
    o.Schema = O;
    return o;
});
