define([
    "dojo/_base/declare",
    "dojo/_base/array",
    "dojo/_base/json",
    "dojo/_base/lang",
    "cq/biz/object",
    "cq/util/config/config"
],function(declare, array, json, lang, object, config){
    var O = declare("", object.Schema, {
        modalName:"shop/shelf",
        loadById:function(id){
            return this.execInCurrentShop("load_by_id",{
                _id:id
            });
        },
        save:function(item){
            return this.execInCurrentShop("save",item);
        },
        load:function(condition){
            return this.getBaseUrl()+"/load";
        },
        //设置主页的方法
        setMain:function (id) {
            return this.execInCurrentShop("set_main_shelf",{
                _id:id
            });
        },
        //获取主页货架
        getMainShelf:function () {
            return this.execInCurrentShop("load_main_shelf",{});
        }
    });
    var o = new O();
    lang.setObject("cq.biz.shop.shelf", o);
    o.Schema = O;
    return o;
});