define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "cq/biz/object"
],function(declare, lang, object){
    var O = declare("", object.Schema, {
        modalName : "shop/ui_config",
        save : function(item){
            return this.execInCurrentShop("save", item);
        },
        load : function(){
            return this.execInCurrentShop("load", {shopId : this.getShopId()});
        },
        getLoadUrl : function(condition){
            return this.getBaseUrl()+"/load?shopId=" + this.getShopId();
        }
    });
    var o = new O();
    lang.setObject("cq.biz.shop.ui_config", o);
    o.Schema = O;
    return o;
});