define([
    "dojo/_base/declare",
    "dojo/_base/array",
    "dojo/_base/json",
    "dojo/_base/lang",
    "cq/biz/object",
    "dojo/Deferred",
    "cq/util/config/config"
],function(declare, array, json, lang, object,Deferred,config){
    var O = declare("", object.Schema, {
        modalName:"sms/sms",
        //获取验证码
        sendVcode:function(tel){
            var params={};
            params.shopId = config.getPlatformShopId();
            params.tel=tel;
            return this.exec("send_vcode",params);
        },
        //检验验证码是否正确
        isValid:function(params){
            params.shopId = config.getPlatformShopId();
            return this.exec("is_valid_vcode",params);
        }
    });
    var o = new O();
    lang.setObject("cq.biz.sms.sms", o);
    o.Schema = O;
    return o;
});