define([
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/_base/json"
], function(lang, array, json){
    return lang.mixin(lang.getObject("cq.biz.ts.orderCar", true),{
        add:function(mid, qty){
            var orderCar = this.get();
            orderCar[mid] = (orderCar[mid]||0) + parseInt(qty)||1;
            this.set(orderCar);
        },
        set:function(car){
            localStorage.setItem(window.code + "order", json.toJson(car));
        },
        get:function(){
             return json.fromJson(localStorage.getItem(window.code + "order") || "{}");
        },
        clear:function(mids){
            var car = this.get();
            if(mids){
                array.forEach(mids, function(mid){
                    delete car[mid];
                });
            }else{
                car = {};
            }
            this.set(car);
        }/*,
        //立即购买和加入购物车判断在销售区域内的相关处理
        addCartAndBuy:function(data){
            
        }*/
    });
});