﻿// 创建人 : 潘云
// 创建时间 : 2016-9-30
// 创建内容 : 任务提醒定义对象的后台代理接口
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/_base/json",
    "dojo/Deferred",
    "cq/biz/object"
], function(declare, lang, array, json, Deferred, object) {
    var O = declare("", object.Schema, {
        modalName: "ts/task",
        //加载
        loadById: function(id) {
            return this.execInCurrentShop("load_by_id", { _id: id });
        },
        //保存
        save: function(data) {
            //data = this.filterSaveData(data);
            return this.execInCurrentShop("save", data);
        },
        //为查询界面准备数据源
        getLoadUrl: function() {
            return this.getBaseUrl() + "/load?shopId=" + this.getShopId();
        },
        //加载
        load: function(param) {
            //param obj
            return this.execInCurrentShop("load", param);
        },
        // 初始化
        initData : function (param) {
            return this.execInCurrentShop("init_data", param);
        },
        // 修改任务的启用状态
        updataUsingById : function (param) {
            return this.execInCurrentShop("updata_using_by_id", param);
        } 
    });
    var o = new O();
    lang.setObject("cq.biz.ts.task", o);
    o.Schema = O;
    return o;
})
