define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "cq/biz/object"
], function (declare, lang, object) {
    var O = declare("", object.Schema, {
        modalName: "ts/transaction_log",
        loadById: function (id) {
            return this.execInCurrentShop("load_by_id", {_id: id});
        },
        load: function (param) {
			if(!param){
				var param={};
				param.shopId=this.getShopId();
			}
			if(param&&!param.shopId){
				param.shopId=this.getShopId();
			}
            return this.getBaseUrl() + "/load?";
        },
        loadTransactionLog : function(){
            return this.getBaseUrl() + "/load?shopId="+this.getShopId();;    
        },
        loadTshop: function () {
            return this.getBaseUrl() + "/load?";
        }
    });
    var o = new O();
    lang.setObject("cq.biz.ts.transaction_log", o);
    o.Schema = O;
    return o;
});