define([
    "dojo/topic",
    "cq/biz/shop/shop",
    "cq/biz/ts/pm/shopPayLog"
], function(topic, shop, shopPayLog) {
    var shopBo = {
        // 添加商品
        matDetail: [{
            type: "form",
            contents: [{
                type: "formItem",
                field: "logo",
                contents: [{
                    type: "formLabel",
                    label: "店铺图标"
                }, {
                    type: "formItem",
                    field: "logo",
                    contents: [{
                        dojoType: "cq/app/widget/web/edit/ImagePicker",
                        field: "logo",
                        mode: "singular"
                    }]
                }]
            }, {
                type: "formItem",
                field: "shopName",
                contents: [{
                    type: "formLabel",
                    label: "商品编码"
                }, {
                    type: "formInput",
                    inputType: "text",
                    field: "code"
                }]
            }, {
                type: "formItem",
                field: "address",
                contents: [{
                    type: "formLabel",
                    label: "商品名称"
                }, {
                    type: "formInput",
                    inputType: "text",
                    field: "mName"
                }]
            }, {
                type: "formItem",
                field: "svcPhone",
                contents: [{
                    type: "formLabel",
                    label: "标准分类"
                }, {
                    type: "formInput",
                    inputType: "text",
                    field: "sortName"
                }]
            }, {
                type: "formItem",
                field: "",
                contents: [{
                    type: "formLabel",
                    label: "参数"
                }, {
                    type: "formInput",
                    inputType: "text",
                    field: ""
                }]
            }, {
                type: "formItem",
                field: "groupId",
                contents: [{
                    type: "formLabel",
                    label: "品类"
                }, {
                    type: "formInput",
                    inputType: "text",
                    field: "groupId"
                }]
            }, {
                type: "formItem",
                field: "retailPrice",
                contents: [{
                    type: "formLabel",
                    label: "规格"
                }, {
                    type: "formInput",
                    inputType: "text",
                    field: "retailPrice"
                }]
            }, {
                type: "formItem",
                field: "retailPrice",
                contents: [{
                    type: "formLabel",
                    label: "价格"
                }, {
                    type: "formInput",
                    inputType: "text",
                    field: "retailPrice"
                }]
            }, {
                type: "formItem",
                field: "marketPrice",
                contents: [{
                    type: "formLabel",
                    label: "市场价"
                }, {
                    type: "formInput",
                    inputType: "text",
                    field: "marketPrice"
                }]
            }, {
                type: "formItem",
                field: "content",
                contents: [{
                    type: "formLabel",
                    label: "详细信息"
                }, {
                    type: "formInput",
                    inputType: "text",
                    field: "content"
                }]
            }, {
                type: "formItem",
                field: "qty",
                contents: [{
                    type: "formLabel",
                    label: "库存"
                }, {
                    type: "formInput",
                    inputType: "text",
                    field: "qty"
                }]
            }, {
                type: "formItem",
                field: "totalSale",
                contents: [{
                    type: "formLabel",
                    label: "销量"
                }, {
                    type: "formInput",
                    inputType: "text",
                    field: "totalSale"
                }]
            }]
        }],
    };
    topic.subscribe("cqthink/svc/svcChanged", function() {
        shopBo.onShopChanged();
    });
    return shopBo;
});
