define([
	"dojo/_base/declare",
	"dojo/_base/lang",
	"dojox/mobile/View",
	"dojo/dom-construct",
	"cq/ui/view/_ViewMixin",
	"cq/biz/article/article"
],function(declare,lang,View,domConstruct,_ViewMixin,article){
	return declare("cq.ui.b.a.About",[View,_ViewMixin],{
		onFirstShow:function(){
			var option = null;
			//添加头部
			option = {
				left : {
					iconButton: ' ',
                    arrow: "left",
                    label: "返回",
					onClick: function(){
						history.back();
					}
				},
				title: "关于我们"
			};
			this.addHeader(option);
			//图片
			domConstruct.create("div",{
				style:"",
				width:"100%",
				innerHTML:"<img src='images/gywm.jpg' style='height:200px;width:100%;'/>"
			},this.centerPanel.containerNode)
			//列表
			option = {
				isEdge:true,
				class: "bottom-margin16",
				lists:[{
                    label:"重盐云商官网",
                    rightText:"http://go.cqsalt.com/",
                    noArrow:false,
                    moveTo:"#",
                    onClick:function(){
                        localStorage.setItem("from","about");
                        window.moveToView("iframe","http://go.cqsalt.com/");
                    }
                },{
                    label : "关于重盐云商",
                    noArrow:false,
                    onClick : this.moveToAbout,
                    moveTo : "#"
                }]
			};
			this.addLists(option)
			//版权相关
			domConstruct.create("div",{
				style:"text-align:center",
				width:"100%",
				innerHTML:"<p style='font-size:8px'>Copyright © 2016 go.cqsalt.cn All Rights Reserved </p><p style='font-size:8px'>重盐云商版权所有</p>"
			},this._bottomPane.domNode)
			this.resize();
		},
		moveToAbout:function(){
			article.loadPlatformByTitle("关于重盐云商").then(lang.hitch(this,function(data){
				if(data.data.ok===1){
					moveToView("helpVerification","关于重盐云商");
				}else{
					alert("暂无介绍");
				}
			}))
		}
	})
})