// 变更人：潘云
// 变更时间：2016-05-17
// 变更事项：代码规范、注释、迁移
// 变更人：周超
// 变更时间：2016-06-17
// 变更事项：摘要显示问题
// 变更人：张金鹏
// 变更时间：2016-06-22
// 变更事项：资讯未录入时摘要显示undfined的问题
/*  变更人:冉伟
    变更时间:2016/6/22
    变更原因:设置客户端底部图标的高度使其与农企宝底部高度保持一致
 */
 /*  变更人:徐阿雪
     变更时间:2016/6/27
     变更原因:加载更多的和加载中代码
 */
// 变更人：周科吉
// 变更时间：2016-07-11
// 变更事项：头部添加显示资讯类别问题

// 变更人：周科吉
// 变更时间：2016-08-03
// 变更事项：点击进入畜牧类别中的某资讯编辑状态返回资讯列表，显示的资讯为畜牧类别的，但是红色的下划线却在“全部”处。类别过多头部标签显示不全且“全部”不见了。
// 变更人：肖芳圆
// 变更时间：2016-08-09
// 变更:当选中除“全部”外的资讯类别时，点击该类别中的任何一条资讯详情后再返回时，已经返回到“全部”类别了

// 变更人：潘云
// 变更时间：2016-08-15
// 变更:处理头部标签页的样式，以及选中后返回，删除某一类别时的显示问题
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/Deferred",
    "dojo/store/JsonRest",
    "dojo/on",
    "dojo/when",
    "dojo/query",
    "dijit/registry",
    "dojox/mobile/View",
    "dojox/mobile/EdgeToEdgeStoreList",
    "dojox/mobile/ScrollablePane",
    "cq/ui/view/_ViewMixin",
    "cq/biz/article/article",
    "cq/biz/article/articleGroup",
    "cq/biz/mat/mat",
    "dojo/dom-class",
    "dojo/dom-style",
    "dojo/dom-construct"
],function( declare, lang,array, Deferred, JsonRest, on, when, query, registry, View, EdgeToEdgeStoreList, ScrollablePane,
 _ViewMixin, article, articleGroup, mat, domClass,domStyle, domConstruct){
    // module:
    //      cq/ui/b/a/NewsList
    return declare("cq.ui.b.a.NewsList",[View,_ViewMixin],{
        // 加载数据的下标，默认从0开始
        start : 0,
        // 每次加载数据的条数
        pageSize : 20,
        // 创建头部标签页
        createHeaderTab : function () {
            var def = new Deferred();
            if(this.scrollHeader){
                this.scrollHeader.destroyRecursive();
            }
            //加载平台资讯类别添加头部显示
            articleGroup.load({isUse:true}).then(lang.hitch(this,function(data){
                //定义一个变量获取所有类别
                var groupData = data.data.items||[];
                //像所有资讯类别中追加一个全部的类别
                groupData.splice(0,0,{
                    groupName:"全部"
                });
                //依据类别生成addcolumns 的参数
                var option = {
                    isHeader : true,
                    columns : array.map(groupData,function(item){
                        return{
                            label:item.groupName,
                            'className' : "flex1 "+item._id,
                            onClick:function(e){
                                this.setGroupSelected(e.target);
                                this.refreshNewsList(item);
                            }
                        };
                    }),
                    labelClass : 'font-size1 tab-selector tab-min-width',
                    forceWidth : false
                };
                this.groupHeader = this.addColumns(option);
                // 处理头部标签的选中样式
                this.setGroupSelected(this.getSelectNode());
                //添加左右滑动功能
                this.scrollHeader = this.addScrollablePane({scrollDir:"h", isHeader:true, className:"header_height full-width"});
                this.scrollHeader.containerNode.appendChild(this.groupHeader);
                domStyle.set(this.scrollHeader.containerNode,"min-width","100%");
                def.resolve();
            }));
            return def;
        },
        // 获取要选中的节点
        getSelectNode : function () {
            var node = "";
            if (this.groupId) {
                var parantNode = query("."+this.groupId, this.groupHeader)[0];
                if (parantNode) {
                    node = query(".tab-selector", parantNode)[0];
                } else {
                    node = query(".tab-selector",this.groupHeader)[0];
                    this.groupId = "";
                }
            } else {
                node = query(".tab-selector",this.groupHeader)[0];
            }
            return node;
        },
        // 每次进入页面重新加载数据
        onAfterShow:function(){
            // 创建头部标签页
            this.createHeaderTab().then(lang.hitch(this, function () {
                if(!this.store){
                    this.store = new JsonRest({
                        target : article.getArticleUrl()
                    });
                    // 将数据源赋值给storeList
                    var queryResult = this.storeList.setStore(this.store, this.getQuery(),{
                        start:this.start,
                        count:this.pageSize
                    });
                    this.onLoadListData(queryResult,this.start,this.pageSize);
                } else {
                    this.setQuery();
                }
            }));
        },
        // 第一次进入页面加载页面显示组件
        onFirstShow:function(){
            // 页面头部
            var option = {
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick : function() {
                        localStorage.removeItem("fromTrends");
                        //window.moveToView("home");
                        history.back();
                    }
                },
                title:"资讯管理"
            };
            this.addHeader(option);
            // 搜索框
            option = {
                placeHolder:"请输入要查询条件，按回车查询",
                type:"search",
                class:"cqSearchBox",
                isHeader:true,
                onInput:lang.hitch(this,function(evt){
                    if(evt.keyCode==13){
                        this.search = evt.target.value;
                        this.title = evt.target.value;
                        this.setQuery();
                        evt.target.value = "";
                    }
                })
            };
            this.searchBox = this.addTextBox(option);
            

            // 页面尾部按钮
            option = {
                columns:[{
                    label:'添加资讯',
                    icon:'images/icon/addnews.png',
                    /*iconClass:'width-16',*/
                    iconClass:'footer-tab-img',
                    onClick:function(){
                        window.moveToView("news");
                    }
                },{
                    //新增资讯类别按钮
                    label:'资讯类别',
                    icon:'images/icon/addnews.png',
                    iconClass:'footer-tab-img',
                    onClick:function(){
                        window.moveToView("newsGroupList");
                    }
                }],
                valueClass:'font-size3',
                labelClass:'font-size1',
                className:'fix-footer',
                isFooter:true
            };
            this.addColumns(option);
            // 资讯显示列表
            this.storeList=new EdgeToEdgeStoreList({
                append: true,
                constraint: false,
                query:{},
                class:"icon-list-item",
                variableHeight:true,
                onComplete:lang.hitch(this,function(data){
                    for(var i=0;i<data.length;i++){
                        data[i]._label="<div class='mat-list-mname mat-list-margin'>"+data[i].title+"</div>";
                        data[i]._label+="<div class='mat-list-margin margin-top10' style='word-break: break-all;overflow: hidden;text-overflow: ellipsis;display:-webkit-box;-webkit-line-clamp: 2;-webkit-box-orient: vertical;'>"+
                       (data[i].brief||"")+"</div>";
                        data[i].moveTo="#";
                    }
                    this.storeList.generateList(data);
                    this.end=this.start+data.length-1;
                    this.busy = false;
                }),
                queryOptions: {
                    count: this.pageSize,
                    start: this.start
                },
                itemMap:{_label:"label",logo:"icon", moveTo:"moveTo"}
            });
            // 徐阿雪 修改加载问题 20160623
            this.storeList.placeAt(this.centerPanel.containerNode, "last");
            this.storeList.on("click", lang.hitch(this, this.onClickList));
            this.centerPanel.on("afterscroll", lang.hitch(this, this.onLoadMore));
            this.onAfterShow();
        },
        // 资讯列表项的点击响应事件
        onClickList:function(evt){
            // 得到点击的ListItem
            var li = registry.getEnclosingWidget(evt.target);
            if(li.declaredClass!="dojox.mobile.ListItem") return;
            var _id = li.params._id;
            window.moveToView("news",_id);
        },
        // 获取查询条件
        getQuery : function () {
            var query = {};
            if (this.groupId) {
                query.groupId = this.groupId;
            }
            if (this.search) {
                query.search = this.search;
                this.search = "";
            }
            if (this.title) {
                query.title = this.title;
                this.title = "";
            }
            return query;
        },
        // 重新赋值列表并刷新显示
        setQuery:function () {
            this.start = 0;
            this.end = -1;
            this.storeList.destroyDescendants();
            // 徐阿雪 修改加载问题 20160623
            var queryResult = this.storeList.setQuery(this.getQuery(), {
                start : this.start,
                count : this.pageSize
            });
            this.onLoadListData(queryResult,this.start,this.pageSize);
        },
        //判断简介长度
        showBrief:function(data){
            if(data){
                if(data.length>80){
                    var dataT=data.substring(0,80)+"...";
                    return dataT;
                }else{
                    return data;
                }
            }else{
                return "";
            }
        },
        // 列表拖动的响应事件，拖动加载更多
        onLoadMore:function(evt){
            //徐阿雪 修改加载中问题 2016/6/27
            if(!this.busy&&evt.afterBottom){
                this.start = this.start+this.pageSize;
                if(this.canLoadMore(this.start)){
                    //console.log("加载更多资讯");
                    this.busy = true;
                    setTimeout(lang.hitch(this,function(){
                        // 徐阿雪 修改加载问题 20160623
                        var queryResult = this.storeList.setQuery(this.storeList.get("query"), {
                            start : this.start,
                            count : this.pageSize
                        });
                        this.onLoadListData(queryResult,this.start,this.pageSize);
                    }), 1000);
                }
            }
        },
        setGroupSelected:function(evt){
            //清空所有节点选中样式
            var items = query('.tab-selector', this.domNode);
            for (var i = 0; i < items.length; i++) {
                domClass.remove(items[i], "selected");
            }
            //为选中节点添加选中样式
            domClass.add(evt,"selected");
        },
        refreshNewsList:function(item){
            //查询条件改变，根据条件刷新页面显示
            this.groupId = item._id;
            this.setQuery();
        }
    });
});
