// 变更日期：2016-5-17
// 变更人：周超
// 变更原因：代码规范
// 变更日期：2016-5-19
// 变更人：母浚驰
// 变更原因：左上角logo，点击进入预览页面
// 变更人：张金鹏
// 变更时间：2016-06-22
// 变更事项：动态未录入时摘要显示undfined的问题
//变更人:周科吉
//变更时间:2016/6/22
//变更原因:更改底部标签样式问题
/*  变更人:徐阿雪
     变更时间:2016/6/27
     变更原因:加载更多的和加载中代码
 */
// 变更人：周科吉
// 变更时间：2016-07-12
// 变更事项：头部添加显示资讯类别问题
/*
    变更人：潘云
    变更时间：2016-8-5
    变更内容：头部标签页的滑动和最小宽度的设置
*/
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "dojo/query",
    "dijit/registry",
    "cq/biz/article/article",
    "cq/biz/article/articleGroup",
    "cq/biz/shop/shop",
    "dojox/mobile/EdgeToEdgeStoreList",
    "dojo/store/JsonRest",
    "cq/biz/mat/mat",
    "dojo/dom-class",
    "dojo/dom-style",
    "dojo/on"
],function(declare, lang, array, View, _ViewMixin, query, registry, article, articleGroup, shop, EdgeToEdgeStoreList, JsonRest,mat,domClass,domStyle,on){
    return declare("cq.ui.b.a.Trends",[View,_ViewMixin],{
        //为列表设置的数据开始默认值
        start:0,
        pageSize:10,
        // 创建头部标签页
        createHeaderTab : function () {
            //加载平台资讯类别添加头部显示
            articleGroup.getPlatformGroups({isUse:true}).then(lang.hitch(this,function(data){
                //定义一个变量获取所有类别
                var groupData = data.data.items||[];
                //像所有资讯类别中追加一个全部的类别
                groupData.splice(0,0,{
                    groupName:"全部"
                });
                //依据类别生成addcolumns 的参数
                var option = {
                    isHeader : true,
                    columns : array.map(groupData,function(item){
                        return{
                            label:item.groupName,
                            onClick:function(e){
                                this.setGroupSelected(e.target);
                                this.refreshNewsList(item);
                            }
                        };
                    }),
                    labelClass : 'font-size1 tab-selector tab-min-width'
                };
                this.groupHeader = this.addColumns(option);
                // 处理头部标签的选中样式
                this.setGroupSelected(query(".tab-selector",this.groupHeader)[0]);
                //添加左右滑动功能
                this.scrollHeader = this.addScrollablePane({scrollDir:"h", isHeader:true, className:"header_height full-width"});
                this.scrollHeader.containerNode.appendChild(this.groupHeader);
                domStyle.set(this.scrollHeader.containerNode,"min-width","100%");
            }));
        },
        // 每次进入页面重新加载数据
        onAfterShow:function(){
            if(!this.store){				
                this.store = new JsonRest({
                    target : article.getPlatformUrl()
                });
                // 将数据源赋值给storeList
                var queryResult = this.storeList.setStore(this.store, this.getQuery(),{
                    start:this.start,
                    count:this.pageSize
                });
                this.onLoadListData(queryResult,this.start,this.pageSize);
            } else {
                this.setQuery();
            }
        },
        //添加底部导航工具栏，不同项目的可能不同
        addBottomColumn:function(){},
        // 初始化界面元素
        onFirstShow:function(){
            this.addTrendHeader();
            // 加载头部标签页
            this.createHeaderTab();
            //添加底部栏目
            this.addBottomColumn();
            //创建列表对象，参数append，constraint，query，class，variableHeight，onComplete，queryOptions，itemMap
            //返回值：下拉列表
            this.storeList=new EdgeToEdgeStoreList({
                append: true,
                constraint: false,
                query:{},
                class:"icon-list-item",
                variableHeight:true,
                onComplete:lang.hitch(this,function(data){
                    for(var i=0;i<data.length;i++){
                        data[i]._label="<div class='mat-list-mname mat-list-margin'>"+data[i].title+"</div>";
                        data[i]._label+="<div class='mat-list-margin margin-top10' style='word-break: break-all;overflow: hidden;text-overflow: ellipsis;display:-webkit-box;-webkit-line-clamp: 2;-webkit-box-orient: vertical;'>"+
                        (data[i].brief||"")+"</div>";
                        data[i].moveTo="#";
                    }
                    this.storeList.generateList(data);
                    this.end=this.start+data.length-1;
                    this.busy = false;
                }),
                queryOptions: {
                    count: this.pageSize,
                    start: this.start
                    },
                itemMap:{_label:"label",logo:"icon", moveTo:"moveTo"}
            });
            //置于地点
            this.storeList.placeAt(this.centerPanel.containerNode, "last");
            //绑定点击事件
            this.storeList.on("click", lang.hitch(this, this.onClickList));
            //绑定事件--加载更多
            this.centerPanel.on("afterscroll", lang.hitch(this, this.onLoadMore));
            this.onAfterShow();
        },
        //点击事件，点击下拉列表节点项所触发事件触发函数，参数evt，返回值：无
        onClickList:function(evt){
            // 得到点击的ListItem
            var li = registry.getEnclosingWidget(evt.target);
            if(li.declaredClass!="dojox.mobile.ListItem")
                return;
            window.moveToView("trendDetail",li.params._id);
        },
        // 获取查询条件
        getQuery : function () {
            var query = {};
            if (this.groupId) {
                query.groupId = this.groupId;
            }
			query.isUse = true;
            return query;
        },
        // 重新赋值列表并刷新显示
        setQuery:function(){
            this.start = 0;
            this.end = -1;
            this.storeList.destroyDescendants();
            var queryResult = this.storeList.setQuery(this.getQuery(), {
                start : this.start,
                count : this.pageSize
            });
            this.onLoadListData(queryResult,this.start,this.pageSize);
        },
        //加载更多，参数evt，返回值：无
        onLoadMore:function(evt){
            //修改加载中问题 2016/6/27
            if(!this.busy&&evt.afterBottom){
                this.start = this.start+this.pageSize;
                if(this.canLoadMore(this.start)){
                //console.log("加载更多资讯");
                this.busy = true;
                setTimeout(lang.hitch(this,function(){
                    var queryResult = this.storeList.setQuery(this.storeList.get("query"), {
                        start : this.start,
                        count : this.pageSize
                    });
                    this.onLoadListData(queryResult,this.start,this.pageSize);
                }), 1000);
                }
            }
        },
        setGroupSelected:function(evt){
            //清空所有节点选中样式
            var items = query('.tab-selector', this.domNode);
            for (var i = 0; i < items.length; i++) {
                domClass.remove(items[i], "selected");
            }
            //为选中节点添加选中样式
            domClass.add(evt,"selected");
        },
        refreshNewsList:function(item){
            this.groupId = item._id;
            this.setQuery();
        },
        addTrendHeader: function(){
			var option = {
                left: {
                    iconButton: ' ',
                    arrow: 'left',
                    label: '返回',
                    onClick: function(){
                        history.back();
                    }
                },
                title:window.__shop.shopName
            };
            //添加头部栏
            this.addHeader(option);
        }
    });
});