﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-style",
    "cq/ui/common/im/Channel"
],function( declare, lang, domStyle, Channel){
    return declare("cq.ui.b.im.ChannelDetail",[Channel],{
        //onFirstShow，
        onFirstShow : function(){
            //侦听事件，toLive时显示发送消息区域，toDiscuss时隐藏
            this.connect(this,"toLiveView",function(){
                domStyle.set(this.footerColumn,"display","");
                this.resize();
            });
            this.connect(this,"toDiscussView",function(){
                domStyle.set(this.footerColumn,"display","none");
                this.resize();
            });
            this.inherited(arguments);
        },
        //getSendMsg，得到基类结果，将是主持人发送的标志设置为true
        getMsg: function(){
            var msg=this.inherited(arguments);
            msg.isHost= true;
            return msg;
        }
    });
});