//变更人:肖芳圆
//变更时间:2016-06-03
//变更原因:留出通过辅助资料筛选商品的接口
//变更人: 杜飞军
//变更时间: 2016-06-07
//变更原因: 没有预留按钮对象
//变更人: 杜飞军
//变更时间: 2016-06-07
//变更原因:
//        条件查询后离开页面 再进入时没有刷新页面
//        查询后没有内容提示
//变更人:冉伟
//变更时间:2016/6/22
//变更原因:设置客户端底部图标的高度使其与农企宝底部高度保持一致
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-attr",
    "dojo/dom-class",
    "dojo/dom-construct",
    "dojo/dom-style",
    "dojo/query",
    "dojo/on",
    "dojo/when",
    "dojo/store/JsonRest",
    "dijit/registry",
    "dojox/mobile/View",
    "dojox/mobile/EdgeToEdgeStoreList",
    "cq/ui/view/_ViewMixin",
    "cq/biz/mat/mat",
    "dijit/_WidgetBase"
], function(declare, lang, domAttr, domClass, domConstruct, domStyle, query, on, when, JsonRest, registry, View, EdgeToEdgeStoreList, _ViewMixin, mat, _WidgetBase) {
    return declare("cq.ui.b.m.MatList1", [View, _ViewMixin], {
        //筛选条件
        params: null,
        start: 0,
        pageSize: 10,
        hideBottom: false,
        totalCount: 0,
        // 控制选项的显示隐藏
        displaySelect: false,
        onAfterShow: function() {
            //创建数据源
            if (!this.store) {
                this.params = {
                    isUse: true,
                    //fromShopId:mat.getShopId(),
                    qty: 1
                };
                this.store = new JsonRest({
                    target: this.getMatUrl()
                });
                var queryResult = this.storeList.setStore(this.store, this.params, {
                    start: this.start,
                    count: this.pageSize
                });
                // 将数据源赋值给storeList
                this.onLoadListData(queryResult, this.start, this.pageSize);
            } else {
                // 重置筛选
                //var condition = this.storeList.get("query");
                //condition.mName = "";
                //this.setQuery(condition);
                query(".selected", this.conditMenus)[0].click();
            }
        },
        //获取头部option的函数,可重载
        getHeadOption: function() {
            return {
                left: {
                    iconButton: ' ',
                    arrow: "left",
                    label: "返回",
                    onClick: function() {
                        //window.moveToView("home");
                        history.back();
                    }
                },
                title: "商品管理"/*,
                right: {
                    iconButton: ' ',
                    onClick: function() {
                        this.selectOption();
                    },
                    label: "+",
                }*/
            };
        },
        // 创建选项盒子
        selectOption: function() {
            if (this.displaySelect) {
                domClass.add(this.selectObject, 'none');
                this.displaySelect = false;
            } else {
                domClass.remove(this.selectObject, 'none');
                this.displaySelect = true;
            }
        },
        //获取商品链接可重载
        getMatUrl: function() {
            return mat.getOnSaleUrl();
        },
        onFirstShow: function() {
            var option = this.getHeadOption();
            this.addHeader(option);            
            option = {
                isHeader: true,
                placeHolder: "请输入要查询的条件，按回车查询",
                class: "cqSearchBox",
                type: "search",
                onInput: lang.hitch(this, function(evt) {
                    if (evt.keyCode == 13) {
                        // this.search = evt.target.value;
                        // var condition = this.storeList.get("query");
                        // condition.mName = evt.target.value;
                        // this.setQuery(condition);
                        // condition.mName='';
                        this.params.mName = evt.target.value;
                        this.setQuery(this.params);
                        this.params.mName = '';
                        evt.target.value = "";
                    }
                })
            };
            this.addTextBox(option);
			 option = {
                isHeader: true,
                columns: [{
                        label: '出售中',
                        onClick: this.changeOnSale
                    }, {
                        label: '已售罄',
                        onClick: this.changeSaleOut
                    }, {
                        label: '已下架',
                        onClick: this.changeNoSale
                    }
                    /*,{
                    label:'分类'
                    }*/
                ],
                labelClass: 'font-size1 tab-selector'
            };
            this.conditMenus = this.addColumns(option);
            option = {
                columns: [{
                        className: 'flex2 footer-tab-highlight',
                        label: '添加商品',
                        onClick: function() {
                            window.moveToView("mat");
                        }
                    },
                     {
						 className: 'flex2 footer-tab-dark',
                         label : '管理品类',
                         onClick : function () {
                             window.moveToView("matGroupList");
                         }
                     }
                ],
                isFooter: true
            };
            this.footerButton = this.addColumns(option);            
            this.storeList = new EdgeToEdgeStoreList({
                append: true,
                constraint: false,
                query: {},
                class: "icon-list-item imgSize64",
                variableHeight: true,
                //获取数据完成后调用的的处理方法
                onComplete: lang.hitch(this, function(data) {
                    /*if(!data.length){
                        this.promptMessage();
                    }*/
                    for (var i = 0; i < data.length; i++) {
                        data[i]._label = "<div class='mat-list-mname mat-list-margin margin-top5'>" + data[i].mName +
                            "</div><div class='mat-list-price mat-list-margin margin-top5'>￥" + window.fixedTo(data[i].retailPrice, 3) +
                            "</div><div class='mat-list-qty mat-list-margin margin-top5'><div class='halfwidth'>库存：" + window.fixedTo(data[i].qty, 1) +
                            "</div><div class='margin-top5 halfwidth'>销量：" + window.fixedTo(data[i].totalSale, 1) +
                            "</div></div>";
                        data[i].moveTo = "#";
                        data[i]._logo = data[i].logo ? data[i].logo : 'images/nomat.png';
                        //data[i]._logo='images/nomat.png';
                    }
                    this.storeList.generateList(data);
                    this.busy = false;
                }),
                queryOptions: {
                    count: this.pageSize,
                    start: this.start
                },
                itemMap: {
                    _label: "label",
                    _logo: "icon",
                    moveTo: "moveTo"
                }
            });
            domClass.add(query('.tab-selector', this.domNode)[0], "selected");
            this.storeList.placeAt(this.centerPanel.containerNode, "last");
            this.storeList.on("click", lang.hitch(this, this.onClickList));
            this.centerPanel.on("afterscroll", lang.hitch(this, this.onLoadMore));
            this.onAfterShow();
        },
        onClickList: function(evt) {
            // 得到点击的ListItem
            var li = registry.getEnclosingWidget(evt.target);
            if (li.declaredClass != "dojox.mobile.ListItem")
                return;
            var _id = li.params._id;
            window.moveToView("matDetailB", _id);
        },
        // 提示信息
        promptMessage: function() {
            alert("没有查到内容");
        },
        onLoadMore: function(evt) {
            if (!this.busy && evt.afterBottom) {
                this.start = this.start + this.pageSize;
                if (this.canLoadMore(this.start)) {
                    console.log("加载更多商品");
                    this.busy = true;
                    setTimeout(lang.hitch(this, function() {
                        var queryResult = this.storeList.setQuery(this.storeList.get("query"), {
                            start: this.start,
                            count: this.pageSize
                        });
                        this.onLoadListData(queryResult, this.start, this.pageSize);
                    }), 1000);
                }
            }
        },
        // 新增隐藏底部按钮接口
        hideFooterButton: function() {
            domStyle.set(this.footerButton, "display", "none");
        },
        clearSelected: function() {
            var items = query('.tab-selector', this.domNode);
            for (var i = 0; i < items.length; i++) {
                domClass.remove(items[i], "selected");
            }
        },
        //在售
        changeOnSale: function(evt) {
            this.clearSelected();
            domClass.add(evt.target, "selected");
            this.params.isUse = true;
            this.params.qty = 1;
            this.setQuery(this.params);
        },
        //售罄
        changeSaleOut: function(evt) {
            this.clearSelected();
            domClass.add(evt.target, "selected");
            this.params.isUse = true;
            this.params.qty = 0;
            this.setQuery(this.params);
        },
        //下架
        changeNoSale: function(evt) {
            this.clearSelected();
            domClass.add(evt.target, "selected");
            this.params.isUse = false;
            delete this.params.qty;
            this.setQuery(this.params);
        },
        setQuery: function(query) {
            this.start = 0;
            this.end = -1;
            this.totalCount = 0;
            this.storeList.destroyDescendants();
            // 依据查询条件加载数据
            var queryResult = this.storeList.setQuery(query, {
                start: this.start,
                count: this.pageSize
            });
            //依据加载数据得结果处理界面显示
            this.onLoadListData(queryResult, this.start, this.pageSize);
        }
    });
});
