//  创建人:曹桂捷
//  创建时间:2016.08.03
//  创建原因:爱在龙乡标准分类列表界面
define([
	"dojo/_base/declare",
	"dojo/_base/lang",
	"dojo/_base/connect",
	"dojo/_base/array",
	"dojo/store/JsonRest",
	"dojo/query",
	"dojo/ready",
	"dojo/dom-style",
    "dojo/dom-attr",
	"dojo/Deferred",
	"dojo/dom-class",
	"dojo/dom-construct",
	"dojox/mobile/EdgeToEdgeStoreList",
	"dojox/mobile/View",
    "dojox/mobile/ScrollablePane",
	"dijit/registry",
	"cq/biz/mat/sort",
	"cq/ui/view/_ViewMixin",
	"dojox/mobile/_EditableListMixin",
    "dojox/mobile/parser",
    "dojox/mobile"
	],function(declare,lang,connect,array,JsonRest,query,ready,domStyle,domAttr,Deferred,domClass,domConstruct,EdgeToEdgeStoreList,View,ScrollablePane,registry,sort,_ViewMixin, _EditableListMixin){
		var MoveSortView = declare("",[View,_ViewMixin],{
			currentDef : null,
			start : 0,
			pageSize : 100,
  			//开始编辑
            //  异步返回值，若确定，完整路径[{_id:分类id,sortName:标签}]
		    startEdit : function(data){
			    this.startup();
                //记录要更改的分类id
				this.hideListItemId = data;
                //返回异步对象
			    this.currentDef = new Deferred();
			    // this.refreshData();
			    return this.currentDef;
		    },
		  	//初始化选择器
		    indexElement : function(){
                //顶部导航区域
                //处理点击切换
                var option = {
					isHeader : true,
					scrollDir : "h"
				};
				this.scrollNavDiv = this.addScrollablePane(option);
                this.scrollNavDivNode = this.scrollNavDiv.containerNode;
                domStyle.set(this.scrollNavDivNode,"white-space","nowrap");
				this.moveSortAll = domConstruct.create("a",{
					onclick:lang.hitch(this,this.onClickSortList),
					class:"moveSortAll",
					innerHTML:"类别 > ",
					style:"min-width:120px;display:inline-block;border-right:1px solid #C8C7CC;padding:10px 0;text-align:center"
				},this.scrollNavDiv.containerNode);
            	this.moveSortNavWrap = domConstruct.create("div",{style:"display:inline-block"},this.scrollNavDiv.containerNode);
                //中间列表区域
                //列表点击之后展开
                this.storeList = new EdgeToEdgeStoreList({
						append : true,
		                constraint : false,
		                query : {},
		                class : "icon-list-item",
		                variableHeight : true,
		                onComplete : lang.hitch(this,function(data){
		                	for(var i = data.length - 1;i >= 0;i--){
		                		if((data[i]._id == this.hideListItemId) || (data[i].props&&data[i].props.length)){
		                			data.splice(i,1);
                                    continue;
		                		}
		                		data[i]._label = "<div class='namesort mat-list-mname mat-list-margin float-left'>" + data[i].sortName + "</div>"
	                            data[i]._logo = data[i].logo?data[i].logo:"images/nopic.png";
		                	}
		                	this.storeList.generateList(data);
		                    this.busy = false;
		                }),
		                queryOptions : {
		                	start : this.start,
		                	count : this.pageSize
		                },
		                itemMap : {
		                	_label : "label",
		                	_logo : "icon"
		                }
					});
				//创建数据源
	            this.params = {
	            	//排序条件，依据编码排序
                    orderBy : "code"
	            };
	            this.store = new JsonRest({
	            	target : sort.getLoadSubSortsUrl()
	            });
	            //将数据源赋值给storeList
	            this.onLoadListData(this.storeList.setStore(this.store,this.params));
	            this.storeList.placeAt(this.centerPanel.containerNode,"first");
	            this.storeList.on("click",lang.hitch(this,this.onClickList));
                //底部按钮
                //完成和取消
                option = {
			    	columns : [{
					    label : "确认",
					    className : "footer-tab-highlight",
					    onClick : this.onFinished
					},{
					    label : "取消",
					    className : "footer-tab-dark",
					    onClick : this.onCanceled
					}],
                    className : "fix-footer",
                    labelClass : "font-size2",
                    isFooter : true
				};
				this.addColumns(option);
                //this.connect(this, "onAfterTransitionOut", lang.hitch(this, function(){
                //    query(".moveSortAll", this.domNode)[0].click();
                //}));
		    },
		    //列表点击事件
		    onClickList : function(evt){
		    	var li = this._li = registry.getEnclosingWidget(evt.target);
            	if (li.declaredClass != "dojox.mobile.ListItem"){
            		return;
            	}
                var dom = evt.target;
            	var _id = li.params._id;
            	//导航区显示选中的分类
        		this.sortNav = domConstruct.create("a",{
                    onclick:lang.hitch(this,this.onClickSortList),
                    class:"sortNav",
                    innerHTML:"",
                    style:"min-width:120px;display:inline-block;border-right:1px solid #C8C7CC;padding:10px 0;text-align:center"
                },this.moveSortNavWrap);
        		this.sortNav.innerHTML = li.sortName + " > ";
        		domAttr.set(this.sortNav,"shopId",_id);
            	//显示选中的分类列表
            	this.showSelectSort(_id);
		    },
		    //导航点击事件
			onClickSortList : function(evt){
				var dom = evt.target;
				//所有分类
				if(dom&&domClass.contains(dom,"moveSortAll")){
					//展开所有分类
					array.forEach(query(".sortNav",this.moveSortNavWrap),function(item){
	            		domConstruct.destroy(item);
	            	})
					this.showSelectSort();
				}
				//下级分类
				if(dom&&domClass.contains(dom,"sortNav")){
					var navIndex = array.indexOf(query("a",this.moveSortNavWrap),dom);
					for(var i = query("a",this.moveSortNavWrap).length;i > navIndex; i --){
						domConstruct.destroy(query("a",this.moveSortNavWrap)[i]);
					}
					//展开当前点击分类
					var _id = domAttr.get(dom,"shopId");
					this.showSelectSort(_id);
				}
			},
		    showSelectSort : function(id){
	    		//清空当前列表
            	// array.forEach(query(".namesort",this.centerPanel.containerNode),function(item){
            	//	domConstruct.destroy(item.parentNode.parentNode);
            	//})
                this.storeList.destroyDescendants();
            	//列表显示选中分类
            	this.store.target = sort.getLoadSubSortsUrl(id);
            	this.onLoadListData(this.storeList.setStore(this.store,this.params,{
					start:this.start,
					count:this.pageSize
				}),this.start,this.pageSize);
		    },
		    //确定按钮响应
		    onFinished : function(){
                var tabs = query(".sortNav", this.domNode);
                // var id = null;
                // if(tabs.length){
                //    id = domAttr.get(tabs.pop(), "shopId");
                //}
                var data = array.map(tabs, function(item){
                    return {id:domAttr.get(item, "shopId"), label:item.innerText};
                });
		    	this.currentDef.resolve(data);
		    },
		    //取消按钮响应
		    onCanceled : function(){
		    	this.currentDef.resolve();
		    }
		});
		return declare("cq.ui.b.m.SortTList",[View,_ViewMixin],{
			start : 0,
			pageSize : 100,
			//初始化相关接口
			onAfterShow : function(){
				if(this.storeList.setStore){
					this.setQuery(this.storeList.get("query"));
				}else{
					var queryResult = this.storeList.setQuery(this.storeList.get("query"), {
                        start : this.start,
                        count : this.pageSize
                    });
                    this.onLoadListData(queryResult,this.start,this.pageSize);
					this.centerPanel.resize();
				}
				this.refreshData();
			},
			//初始化页面元素，绑定事件
			onFirstShow : function(){
				var option = null;
				//添加头部信息
				option = {
					left : {
						iconButton : ' ',
						arrow : "left",
						label : "返回",
						onClick : function(){
							history.back();
						}
					},
					title : "标准分类",
					right : {
						iconButton : ' ',
						label : "添加",
						//添加新的分类
						onClick : function(){
							//u_id：在当前分类下面添加下级分类时，获取到当前分类的_id，作为添加的下级分类的上级分类upSort
							var u_id = "";
							//判断是否有展开的分类，如果有则获取到当前分类
							if(query(".sortNav",this.sortNavWrap)[0]){
								//获取当前分类的_id
								u_id = domAttr.get(query(".sortNav",this.sortNavWrap).pop(),"shopId");
							}
							//如果是在所有分类下，不添加u_id，如果不是，则添加u_id
							//if(u_id == ""){
							//	window.moveToView("sortTDetail");
							//}else{
								window.moveToView("sortTDetail","u_id"+u_id);
							//}
						}
					}
				};
				this.addHeader(option);
                option = {
                	isHeader : true,
                	scrollDir : "h"
                };
                this.scrollNavDiv = this.addScrollablePane(option);
                this.scrollNavDivNode = this.scrollNavDiv.containerNode;
                domStyle.set(this.scrollNavDiv.domNode,"white-space","nowrap");
                this.resize();
                //添加可左右滑动的导航区域
                this.sortAll = domConstruct.create("a",{
                    onclick:lang.hitch(this,this.onClickSortList),
                    "class":"sortAll",
                    innerHTML:"类别 > ",
                    style:"background:white;min-width:120px;display:inline-block;border-right:1px solid #C8C7CC;padding:10px 0;text-align:center"
                },this.scrollNavDivNode,"first");
            	this.sortNavWrap = domConstruct.create("div",{
                    onclick:lang.hitch(this,this.onClickSortList),
                    style:"display:inline-block",
                    innerHTML:""
                },this.scrollNavDivNode);
				//添加中间区域,EdgeToEdgeStoreList列表
				this.storeList = new EdgeToEdgeStoreList({
					append : true,
	                constraint : false,
	                query : {},
	                class : "icon-list-item",
	                variableHeight : true,
		            editable : true,
	                onComplete : lang.hitch(this,function(data){
	                	for(var i = 0;i < data.length;i++){
	                		data[i]._label = this.getSortLabel(data[i]);
                            data[i]._logo = data[i].logo ? data[i].logo : '../../common/images/nopic.png';
                        }
	                	this.storeList.generateList(data);
	                    this.busy = false;
	                }),
	                queryOptions : {
	                	start : this.start,
	                	count : this.pageSize
	                },
	                itemMap : {
	                	_label : "label",
	                	_logo : "icon"
	                }
				});
                // list加载完成后，startEdit
                this.connect(this.storeList, "onComplete", lang.hitch(this, function(data){
                    this.storeList.startEdit();
                }));
	            //创建数据源
	            this.params = {
	            	//排序条件，依据编码排序
                    orderBy : "code"
	            };
	            this.store = new JsonRest({
	            	target : sort.getLoadSubSortsUrl()
	            });
	            //将数据源赋值给storeList
	            this.onLoadListData(this.storeList.setStore(this.store,this.params));
	            this.storeList.placeAt(this.centerPanel.containerNode,"last");
                this.connect(this.storeList, "onClick", this.onClickList);
                this.connect(this.storeList,"onMoveItem",this.updateItemSort);
                this.connect(this.storeList,"onDeleteItem",this.onDeleteItem);
			},
            updateItemSort:function(){
                var sorts = this.storeList.getChildren();
                var ids = array.map(sorts, function(item){
                    return item.get("params")._id;
                });
                sort.updateCodeByIds(ids).then(lang.hitch(this, function(data){
                    this.setQuery();
                }));
            },
            //列表删除
            onDeleteItem : function(sortData){
                if(window.confirm("是否删除该标准分类?")){
                    sort.deleteById(sortData._id).then(lang.hitch(this, function(data){
                        if(data&&data.data&&data.data.ok){
                            this.setQuery();
                        }
                    }));
                }
            },
			//列表点击事件
			onClickList : function(evt){
				var li = registry.getEnclosingWidget(evt.target);
            	if (li.declaredClass != "dojox.mobile.ListItem"){
            		return;
            	}
                var dom = evt.target;
                //编辑按钮
                if(dom&&domClass.contains(dom,"editsort")){
                   var _id = li.params._id;
                   window.moveToView("sortTDetail",_id);
                }
                //弹窗按钮
                else if(dom&&domClass.contains(dom,"movesort")){
                	//显示弹窗
                	if(!this.moveSortViewDiv){
						this.moveSortView = new MoveSortView();
						this.moveSortViewDiv = domConstruct.create("div",{
							style : "height:500px;",
							class : "moveSortViewDiv"
						});
						this.moveSortView.placeAt(this.moveSortViewDiv);
					}
					this.showInOverlay(this.moveSortViewDiv);
					this.moveSortView.startEdit(li.params._id).then(lang.hitch(this,function(data){
						this.hideOverlay();
                        // query(".moveSortAll", this.moveSortView.domNode)[0].click();
                        if(data){
                            //完整初始化顶部导航栏
                            this.showSortNav(data);
                            li.params.upSort = data[data.length - 1]&&data[data.length - 1].id || null;
                            //修改上级，打开上级
                            sort.save(li.params).then(lang.hitch(this,function(){
                                this.showSelectSort(li.params.upSort);
                            }));
                        }
				    }));
                }else if(query(".mblListItemRightIcon", li.domNode)[0].contains(dom)){// 点击拖拽按钮，返回false
                    return false;
                }else if(query(".mblListItemDeleteIcon", li.domNode)[0].contains(dom)){// 点击删除按钮，do nothing
                    
                }
                //非按钮区域，展开当前分类
                else{
                    var _id = li.params._id;
                    //导航区显示选中的分类
                    this.sortNav = domConstruct.create("a",{
                        class:"sortNav",
                        innerHTML:"",
                        style:"background:white;min-width:120px;display:inline-block;border-right:1px solid #C8C7CC;padding:10px 0;text-align:center"
                    },this.sortNavWrap);
                    this.sortNav.innerHTML = li.sortName + " > ";
                    domAttr.set(this.sortNav,"shopId",_id);
                    //显示选中的分类列表
                    this.showSelectSort(_id);
                    return false;
                }
			},
            showSortNav:function(data){
                this.sortNavWrap.innerHTML = "";
                array.forEach(data, lang.hitch(this, function(item){
                    domConstruct.create("a",{
                        class:"sortNav",
                        innerHTML:item.label,
                        style:"min-width:120px;display:inline-block;border-right:2px solid #ccc;padding:10px 0;text-align:center"
                    }, this.sortNavWrap);
                }));
            },
			//导航点击事件
			onClickSortList : function(evt){
				var dom = evt.target;
                var navNodes = query(".sortNav",this.sortNavWrap);
				//所有分类
				if(dom&&domClass.contains(dom,"sortAll")){
					//展开所有分类
					array.forEach(navNodes,function(item){
	            		domConstruct.destroy(item);
	            	});
					this.showSelectSort();
				}
				//下级分类
				if(dom&&domClass.contains(dom,"sortNav")){
					var count = navNodes.length-1,navIndex = array.indexOf(navNodes,dom);
                    while(navIndex<count){
                        domConstruct.destroy(navNodes[count]);
                        count = count-1;
                    }
					//展开当前点击分类
					var _id = domAttr.get(dom,"shopId");
					this.showSelectSort(_id);
				}
			},
			//展开显示选中的分类列表
			showSelectSort : function(id){
            	//清空当前列表
                this.storeList.destroyDescendants();
	            this.store.target = sort.getLoadSubSortsUrl(id);
                this.setQuery();
			},
			//设置查询条件
			setQuery : function(){
				this.start = 0;
	            this.storeList.destroyDescendants();
	            var queryResult = this.storeList.setQuery(this.storeList.get("query"), {
                    start : this.start,
                    count : this.pageSize
                });
                this.onLoadListData(queryResult,this.start,this.pageSize);
	            this.centerPanel.resize();
			},
			//列表html片段
			getSortLabel : function(data){
				return  "<div class='float-left' style='width:100%'><div class='namesort mat-list-mname mat-list-margin'>" + data.sortName + "</div>"
                    +"<div class='forth-btn'>"
                        +"<span class='movesort float-right'>移动</span>"
                        +"<span class='editsort float-right'>编辑</span>"
                    +"</div></div>";
			}
		});
	});