//创建人：周超   创建时间：2016-5-28  创建事项：项目申请--浏览/详情
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "cq/ui/b/p/_PrjMixin",
    "cq/biz/ts/pm/project",
    "cq/util/sys/date"
],function(declare,lang,View,_ViewMixin,_PrjMixin,project,date){
    return declare("cq.ui.b.p.PriDefDtl",[View,_ViewMixin,_PrjMixin],{
        dtlOpers:{
            //0:"等待审核"    编辑 废除 审核
            //1:"审核通过"    查看 废除
            //4:"审核作废"    查看
            0:[false,true,true,true,false],
            1:[true,false,true,false,false],
			4:[true,false,false,false,false],
			//当前日期小于申报开始日期的撤销审核的按钮设置
			111:[true,false,true,false,true],
        },
        getDtlState:function(){
            var data = this.getData();
            if((data&&data.startDate&&date.formatISODate(date.nowISOString()) < data.startDate) && (data.state === 1)){
                return 111;
            }else{
				return this.inherited(arguments);
            }
        },
		
        //onAfterShow：
        //        参数：无
        //        返回值：无
        //        给界面赋值数据
        onAfterShow:function() {
            this.refreshProjectData();
        },
        //onFirstShow：
        //        参数:无
        //        返回值:无
        //        初始化界面元素
        onFirstShow:function(){
            this.addListTitleHeader("项目浏览");
            option = {
                isEdge:true,
                lists:[{
                    label:'项目名称',
                    noArrow:true,
                    rightText:"{{title}}"
                },{
                    label:'申报开始日期',
                    noArrow:true,
                    rightText:'{{startDate}}'
                },{
                    label:'申报结束日期',
                    noArrow:true,
                    rightText:'{{endDate}}'
                },{
                    label:'项目申请指南',
                    noArrow:true,
                    variableHeight:true,
                    rightText:'{{content}}'
                },{
                    label:'公示开始日期',
                    noArrow:true,
                    rightText:'{{startReviewDate}}'
                },{
                    label:'公示结束日期',
                    noArrow:true,
                    rightText:'{{endReviewDate}}'
                },{
                    label:'建设单位',
                    noArrow:true,
                    rightText:'{{company}}'
                },{
                    label:'建设性质',
                    noArrow:true,
                    rightText:'{{property}}'
                },{
                    label:'建设年限',
                    noArrow:true,
                    rightText:'{{term}}'
                },{
                    label:'计划总投入',
                    noArrow:true,
                    rightText:'{{investments}}'
                },{
                    label:'联系人',
                    noArrow:true,
                    rightText:'{{newContactPerson}}'
                },{
                    label:'联系电话',
                    noArrow:true,
                    rightText:'{{newContactPhone}}'
                }],
                data:this.getData()
            };
            this.addLists(option);
            //附件lists
            this.createDtlAttachList();
            option = {
                className: "showNone",
                columns : [{
                    label : '查看申请',
                    className : 'flex2 footer-tab-dark projectOperator',
                    onClick : function () {
                        window.moveToView("prjCheckList",window.did);
                    }
                },
                {
                    label : '编辑',
                    className : 'flex2 footer-tab-dark projectOperator',
                    onClick : function () {
                        window.moveToView("prjDefEdt",window.did);
                    }
                },
                {
                    label : '作废',
                    className : 'flex2 footer-tab-highlight projectOperator',
                    onClick : function () {
                        //调用接口设置作废
                        project.stopById(window.did).then(lang.hitch(this,function(){
                            alert("作废成功");
                            this.onAfterShow();
                        }));
                    }
                },
                {
                    label : '审核',
                    className : 'flex2 footer-tab-dark projectOperator',
                    onClick : function () {
                        //调用接口设置审核
                        project.verifyById(window.did).then(lang.hitch(this,function(){
                            alert("审核成功！");
                            this.onAfterShow();
                        }));
                    }
                },
                {
                    label : '撤销审核',
                    className : 'flex2 footer-tab-dark projectOperator',
                    onClick : function () {
                        project.cancelById(window.did).then(lang.hitch(this,function(){
                            alert("撤销审核成功！");
                            this.onAfterShow();
                        }));
                    }
                }],
                forceWidth : false,
                isFooter : true
            };
            this.createDtlOperColunm(option);
            this.onAfterShow();
        }
    });
});