//创建人：周超   创建时间：2016-5-28  创建事项：项目申请--浏览/详情
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "cq/ui/b/p/_PrjMixin",
    "cq/biz/ts/pm/project"
],function(declare,lang,View,_ViewMixin,_PrjMixin,project){
    return declare("cq.ui.b.p.PrjCheckDtl",[View,_ViewMixin,_PrjMixin],{
        dtlOpers:{
            0:[true,true,true,false,false,false],
			11:[false,false,false,true,true,true],
        },
        hasBlank:false,
        //onAfterShow：
        //        参数：无
        //        返回值：无
        //        给界面赋值数据
        onAfterShow:function() {
            this.refreshProjectData();
        },
        //onFirstShow：
        //        参数:无
        //        返回值:无
        //        初始化界面元素
        onFirstShow:function(){
            this.addListTitleHeader("项目申请");
            option = {
                isEdge:true,
                lists:[{
                    label:'项目名称',
                    noArrow:true,
                    rightText:"{{title}}"
                },{
                    label:'业主单位',
                    noArrow:true,
                    rightText:"{{fromShopName}}"
                },{
                    label:'申报开始日期',
                    noArrow:true,
                    rightText:'{{startDate}}'
                },{
                    label:'申报日期',
                    noArrow:true,
                    rightText:'{{createAt}}'
                },{
                    label:'申请项目',
                    noArrow:true,
                    rightText:'{{srcProjectName}}'
                },{
                    label:'公示开始日期',
                    noArrow:true,
                    rightText:'{{startReviewDate}}'
                },{
                    label:'公示结束日期',
                    noArrow:true,
                    rightText:'{{endReviewDate}}'
                }],
                data:this.getData()
            };
            this.addLists(option);
            //附件lists
            this.createDtlAttachList();
            option = {
                className: "showNone",
                columns : [
                    {
                        label : '审核通过',
                        className : 'flex2 footer-tab-dark audit',
                        onClick : function () {
                            //调用接口设置审核
                            project.verifyApplyById(window.did).then(lang.hitch(this,function(){
                                alert("审核成功！");
                                this.onAfterShow();
                            }));
                        }
                    },
                    {
                        label : '审核驳回',
                        className : 'flex2 footer-tab-highlight rejected',
                        onClick : function () {
                            this.startEditAsHtml("").then(lang.hitch(this,function(reason){
                                //驳回
                                project.rejectApplyById(window.did,reason).then(lang.hitch(this,function(){
                                    this.onAfterShow();
                                }));
                            }));
                        }
                    },
                    {
                        label : '审核拒绝',
                        className : 'flex2 footer-tab-dark refuse',
                        onClick : function () {
                            project.refuseApplyById(window.did).then(lang.hitch(this,function(){
                                this.onAfterShow();
                            }));
                        }
                    },
					//添加验收相关操作
					{
                        label : '验收通过',
                        className : 'flex2 footer-tab-dark audit',
                        onClick : function () {
                            //调用接口设置审核
                            project.examinePass(window.did).then(lang.hitch(this,function(){
                                alert("验收成功！");
                                this.onAfterShow();
                            }));
                        }
                    },
                    {
                        label : '验收驳回',
                        className : 'flex2 footer-tab-highlight rejected',
                        onClick : function () {
                            this.startEditAsHtml("").then(lang.hitch(this,function(reason){
                                //驳回
								project.rejectApplyById(window.did,reason).then(lang.hitch(this,function(){
									project.examineReject(window.did,reason);
                                    this.onAfterShow();
                                }));
                            }));
                        }
                    },
                    {
                        label : '验收拒绝',
                        className : 'flex2 footer-tab-dark refuse',
                        onClick : function () {
                            project.examineNopass(window.did).then(lang.hitch(this,function(){
                                this.onAfterShow();
                            }));
                        }
                    }
                ],
                forceWidth : false,
                isFooter : true
            };
            this.createDtlOperColunm(option);
            this.onAfterShow();
        }
    });
});