// 变更人员：母浚驰
// 变更时间：2016/5/19
// 变更原因：代码规范，从哪里来返回哪里
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "dojo/query",
    "cq/util/sys/userAgent"
],function(declare, lang, View, _ViewMixin, query, userAgent){
    return declare("cq.ui.b.s.IFrame",[View,_ViewMixin],{
        // 初始化页面元素,绑定事件
        onFirstShow:function(){
            // 创建头部信息
            var option={
                left:{
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick:lang.hitch(this,function(){
                        query('iframe',this.domNode)[0].parentNode.removeChild(query('iframe')[0]);
                        window.moveToView(localStorage.getItem("from"));
                        localStorage.removeItem("from");
                    })
                },
                title:"正在加载...",
            }
            this.header = this.addHeader(option);
            this.onAfterShow();
        },
        // 加载数据,并显示到页面上
        onAfterShow:function(){
            var option = {
                height:document.body.clientHeight-this.header.domNode.clientHeight
            },src = decodeURIComponent(window.did).split(","),title = "";
            
            title = src[1]||"";
            src = src[0];
            
            this.iframe = this.addIFrame(option);
            if(userAgent.isDesktop()||(userAgent.isIPad()&&(!userAgent.isWeixin())&&(!userAgent.isApp()))){
                window.open(src,"_blank");
                history.back();
            }else{
                this.header.set("label",title);
                this.iframe.src=src;
            }
        }
    });
});