define([
        "dojo/_base/declare",
        "dojo/_base/lang",
        "dojox/mobile/View",
        "cq/ui/view/_ViewMixin",
        "dojo/_base/xhr",
        "dojo/query",
        "cq/biz/shop/shop"
    ], function (declare, lang, View, _ViewMixin, xhr, query, shop) {
    return declare("cq.ui.b.s.PersonalInformation", [View, _ViewMixin], {
        onAfterShow : function () {
            var data = {};
            data.shopName = __shop.shopName;
            data.userName = "";
            this.setData(data);
            this.refreshData();
        },
        onFirstShow : function () {
            var option = {
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick : function () {
                        history.back(-1);
                    }
                },
                title : "个人资料"
            };
            this.addHeader(option);/*
            option = {
                isEdge : true,
                lists : [{
                    label : '手机号',
                    noArrow : true,
                    edit : {
                        type : 'text',
                        field : 'userName',
                        disabled : true
                    }
                }]
            };
            this.addLists(option);*/
            option = {
                isEdge : true,
                lists : [{
                        label : '{{shopName}}',
                        rightText : '切换店铺',
                        onClick : function () {
                            window.moveToView("shopList");
                        },
                        moveTo : "#"
                    }
                ]
            };
            this.addLists(option);
            option = {
                columns : [{
                    label : '修改密码',
                    className : 'flex2 footer-tab-dark',
                    onClick : function () {
                        window.moveToView("changePassword");
                    }
                },{ /*
                    label:'找回密码',
                    className:'flex2 footer-tab-highlight',
                    onClick : function(){
                    window.moveToView("RetrievePassword");
                }
                },{*/
                    label : '注销',
                    className : 'flex2 footer-tab-highlight',
                    onClick : function () {
                        shop.logout().then(lang.hitch(this, function () {
                                window.moveToView("login");
                            }));
                    }
                }],
                forceWidth : false,
                isFooter : true
            };
            this.addColumns(option);
            this.onAfterShow();
        }
    });
});