// 变更人：   周科吉
// 变更时间： 2016-06-24
// 变更内容： 为完成按钮添加busy事件
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/topic",
    "dojox/mobile/View",
    "dojo/store/Memory",
    "dojox/mobile/EdgeToEdgeStoreList",
    "cq/ui/view/_ViewMixin",
    "dojo/request/xhr",
    "dojo/query", "dijit/registry",
    "cq/biz/shop/shop",
    "cq/biz/user/user",
    "dojo/on"
],function(declare, lang, topic, View, Memory, EdgeToEdgeStoreList, _ViewMixin, xhr,
    query, registry, shop, user,on) {
    return declare("cq.ui.b.s.ShopPay", [ View, _ViewMixin ], {
        onAfterShow:function(){
            shop.loadCurrentShop().then(lang.hitch(this, function(data) {
                // 显示信息
                this.setData(data.data);
                this.refreshData();
            }));
        },
        onFirstShow : function() {
            var option = {
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick:function(){
                        //window.moveToView("shopConfig");
                        history.back();
                    }
                },
                right :{iconButton : ' ', onClick : this.onSaveStore, label : "完成"},
                title : "支付方式"
            };
            this.addHeader(option);
            this.onAfterShow();
            option = {
                isEdge:true,
                lists: [{
                    label: '微信支付',
                    edit : {
                        type : 'checkbox',
                        field : 'payWeiXin'
                    }
                },{
                    label: '支付宝支付',
                    edit : {
                        type : 'checkbox',
                        field : 'payAli'
                    }
                },{
                    label: '中国银行B2C',
                    edit : {
                        type : 'checkbox',
                        field : 'payBocB2C'
                    }
                },{
                    label: '中国银行B2B',
                    edit : {
                        type : 'checkbox',
                        field : 'payBocB2B'
                    }
                },{
                    label: '余额支付',
                    edit : {
                        type : 'checkbox',
                        field : 'payDeposit'
                    }
                }/*,{
                    label: '货到付款',
                    edit : {
                        type : 'checkbox',
                        field : 'payCredit'
                    }
                }*/]
            };
            this.addLists(option);
        },
        onSaveStore : function() {
            window.busy();
            var shopData = this.getData();
            if(shopData.payWeiXin==false&&shopData.payAli==false&&shopData.payDeposit==false&&shopData.payCredit==false){
                window.free();
                alert ("请至少选择一种支付方式");
            }else{
                shop.save(shopData).then(function() {
                    window.free();
                    history.back();
                });
            }
        }
    });
});