//变更人:肖爱玲，变更时间:2016/5/21，变更原因:页面布局修改，是否可启用某些功能控制
//变更人：王龙， 变更时间:2016/6/21，变更原因:店铺管理的标签和页面名称需保持一致，需要将快速登录和自动注册合并为一栏，复制微信Url和微信Token
//变更人：王龙，变更时间:2016/6/22，变更原因:隐藏自动注册按钮;添加订单状态模板字段
// 变更人:徐阿雪
// 变更时间:2016/6/24
// 变更原因:页面处理时候的busy和Free,防止重复提交
//变更人：王龙，
//变更时间:2016/6/27
//变更原因，没有判断微信栏目和自动回复是否已设置，已经加上判断
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/topic",
    "dojo/query",
    "dojo/DeferredList",
    "dojox/mobile/View",
    "dojox/mobile/EdgeToEdgeStoreList",
    "dijit/registry",
    "cq/ui/view/_ViewMixin",
    "cq/biz/shop/shop",
    "cq/biz/user/user",
    "cq/util/config/config",
    "cq/biz/article/section",
    "cq/biz/article/autoReply"
],function(declare, lang, topic, query, DeferredList, View, EdgeToEdgeStoreList, registry, _ViewMixin, shop, user,config,section,autoReply) {
    return declare("cq.ui.b.s.ShopWeiXin", [ View, _ViewMixin], {
        onAfterShow:function(){
            new DeferredList([
               shop.loadCurrentShop(),
               section.load({pageSize:1,pageIndex:0}),
               autoReply.loadData({pageSize:1,pageIndex:0})
            ]).then(lang.hitch(this,function(results){
                //results:三个异步请求返回值，是一个数组
                //返回当前页面的数据
                var shopData = results[0][1].data;
                //返回栏目的数据
                var sectionData = results[1][1].data;
                //返回自动回复的数据
                var autoReplyData = results[2][1].data;
                //判断微信栏目是否设置
                if(sectionData.items.length>0){
                   shopData.isSectionData = "已设置";
                }else{
                   shopData.isSectionData = "未设置";
                }
                //判断自动回复是否设置
                if(autoReplyData.items.length>0){
                   shopData.isAutoReplyData = "已设置";
                }else{
                   shopData.isAutoReplyData = "未设置";
                }
                shopData.wxUrl = config.getDataOrigin()+"/w/wx/"+shopData._id;
                this.setData(shopData);
                this.refreshData();
            }));
            // shop.loadCurrentShop().then(lang.hitch(this, function(data) {
                // 显示信息
                // data.data.wxUrl = config.getDataOrigin()+"/w/wx/"+data.data._id;
                // this.setData(data.data);
                // this.refreshData();
             // }));
        },
        onFirstShow : function() {
            var option = {
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick : function() {
                        history.back();
                    }
                },
                right :{
                    iconButton : ' ',
                    onClick : this.onSaveStore,
                    label : "完成"
                },
                title : "微信公众号集成" //店铺管理的标签和页面名称需保持一致，已改为"微信公共号集成"
            };
            this.addHeader(option);
            //微信信息
            option = {
                isEdge : true,
                title:"微信信息",
                class : "bottom-margin16",
                lists : [{
                    label : "公众号二维码",
                    noArrow : false,
                    imgSize:{width:256,height:256},
                    edit :{
                        type:"image",
                        field:"wxLogo"
                    },
                    class : "li-icon",
                    moveTo : "#"
                },{
                    label : '微信APPID',
                    noArrow : true,
                    edit : {type : 'text', field : 'wxAppId', placeHolder: "未设置"}
                },{
                    label : '微信APPSEC',
                    noArrow : true,
                    edit : {
                        type : 'text',
                        field : 'wxAppSec',
                        placeHolder: "未设置"
                    }
                },{
                    label : '微信配置Url',
                    noArrow : true,
                    edit : {
                        type : 'text',
                        field : 'wxUrl',
                        placeHolder: '未设置',
                        disabled:"true"
                    }
                },{
                    label : '微信Token',
                    noArrow : true,
                    edit : {
                        type : 'text',
                        field : 'wxCqToken'
                    }
                },{
                    label : '微信wxAesk',
                    noArrow : true,
                    edit : {
                        type : 'text',
                        field : 'wxHash',
                        placeHolder: "消息加解密密钥"
                    }
                },{
                    //添加订单状态模板字段
                    label : '订单状态模板',
                    noArrow : true,
                    edit : {
                        type : 'text',
                        field : 'wxMsgTemplate',
                        placeHolder: "未设置"
                    }
                },{
                    label : '微信认证',
                    noArrow : true,
                    edit : {
                        type : 'checkbox',
                        field : 'wxVerification'
                    }
                },{
                    label : '快速登陆',
                    noArrow : true,
                    edit : {
                        type : 'checkbox',
                        field : 'wxAutoLogin'
                    }
                },
                //{
                //  label : '自动注册',
                //  noArrow : true,
                // edit : {type : 'checkbox', field : 'wxAutoRegister'}
                // },
                {
                    iconPos: '0,0,29,29',
                    label: '微信栏目',
                    rightText: '{{isSectionData}}',
                    noArrow: false,
                    moveTo: "#",
                    onClick: lang.hitch(this, function(evt){
                        window.moveToView('section');
                    })
                },{
                    iconPos: '0,0,29,29',
                    label: '自动回复',
                    //右边图
                    rightText: '{{isAutoReplyData}}',
                    noArrow: false,
                    moveTo: "#",
                    onClick: lang.hitch(this, function(evt){
                        window.moveToView('autoReply');
                    })
                }]
            };
            this.addLists(option);
            
            //添加一个option，用来复制微信Url和微信Token
            option = {
                columns:[{
                    label:'复制微信Url',
                    onClick:function(){
                        var wxUrl = this.getData().wxUrl;
                        this.copyToClipboard(wxUrl,function(){
                            alert("微信Url复制成功!");
                        },function () {
                            prompt("",wxUrl);
                        });
                    }
                },{
                    label:'复制微信Token',
                    onClick:function(){
                        var wxToken = this.getData().wxCqToken;
                        this.copyToClipboard(wxToken,function(){
                            alert("微信Token复制成功!");
                        },function () {
                            prompt("",wxToken);
                        });
                    }
                }],
                labelClass:'font-size1',
                className:'padding-top-bottom16',
                isFooter:true
            };
            this.addColumns(option);
            this.onAfterShow();
        },
        onDataChange:function(field, oldValue, newValue){
            var shopWeiXinData=this.getData();
            // 没有填写微信接口参数，微信认证、自动登录、自动注册不允许启用
            if(field=="wxVerification"||field=="wxAutoLogin"||field=="wxAutoRegister"){
                if((!shopWeiXinData.wxAppId||!shopWeiXinData.wxAppSec)&&newValue){
                    alert("微信接口参数(微信APPID、微信配置Url)没有填写，不允许启用！");
                    return false;
                }
            }
            // 若微信未认证，自动登陆和自动注册不允许启用
            if((field=="wxAutoLogin"||field=="wxAutoRegister")&&newValue){
                if(!shopWeiXinData.wxVerification){
                    alert("微信未认证，不允许启用此项！");
                    return false;
                }
            }
        },
        onSaveStore : function() {
            // 徐阿雪  页面处理时候的busy和Free,防止重复提交， 2016/6/24
            window.busy();
            var shopData = this.getData();
            //将快速登录的值赋值给自动注册
            shopData.wxAutoRegister = shopData.wxAutoLogin;
            shop.save(shopData).then(function() {
                // 徐阿雪  页面处理时候的busy和Free,防止重复提交， 2016/6/24
                window.free();
                history.back();
            });
        }
    });
});