// 变更内容： 代码规范，添加注释，文件迁移
// 变更时间： 2016/5/17
// 变更人员：母浚驰
// 变更时间：2016/6/20
// 变更内容：时间格式，页面样式修改
// 变更人员：肖芳圆
// 变更时间：2016/6/24
// 变更内容：
//  1.addColumns的分隔线图片显示找不到
//  2.隐藏所有底部按钮后底部高度不正常的bug
//  3.发送修改数据请求的时候给出busy,在请求完成的时候free

// 变更人员：徐阿雪
// 变更时间：2016/8/3
// 变更内容：订单详细页面订单状态修改  

// 变更人:母浚驰
// 变更时间:2016/9/22
// 变更内容:订单详情新增修改价格

// 变更人:母浚驰
// 变更时间:2016/10/26
// 变更内容:订单详情修改价格更改
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/dom-attr",
    "dojo/dom-class",
    "dojo/dom-style",
    "dojo/dom-construct",
    "dojo/query",
    "dojo/Deferred",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "dojox/mobile/ListItem",
    "cq/biz/ts/order",
    "cq/util/sys/date"
],function(declare, lang, array, domAttr, domClass, domStyle, domConstruct, query, Deferred, View, _ViewMixin, ListItem, order, date){
    //订单优惠金额/修改价格
    var UpdateOrderCode = declare("", [View,_ViewMixin], {
        indexElement : function () {
			option={isEdge:true,lists:[],'class':"bottom-margin16"};
            this.matList=this.addLists(option);

			// 确定和取消
			option = {
				columns : [{
					label : "确认",
					onClick : lang.hitch(this, function () {
                        var price = [];
                        var items = [];
                        for(var i=0; i<this.datas.length; i++){
                            price.push(parseFloat(query(".discountAmount",this.domNode)[i].value));
                        };
                        array.forEach(this.datas,function(item,index){
                            items.push({_id:item._id,discountAmount:price[index]});
                        },this);
                        
						this.currentDef.resolve(items);
						this.hideOverlay();
					}),
					className : "footer-tab-highlight"
				}, {
					label : "取消",
					onClick : lang.hitch(this, function () {
						this.currentDef.resolve();
						this.hideOverlay();
					}),
					className : "footer-tab-dark"
				}],
				labelClass : 'font-size2',
				className : 'fix-footer',
				isFooter : true
			}
			this.addColumns(option);
		},
        
        refreshData:function(){
            this.inherited(arguments);
            for (var i = 0; i<this.datas.length; i++) {
                var listitem=new ListItem({
                    label:this.getDetailLabel(this.datas[i]),
                    variableHeight:true
                });
                this.matList.addChild(listitem);
            }
            var items = query(".discountAmount",this.domNode);
            array.forEach(items,function(item,index){
                this.connect(item,"onblur",function(){
                    if(!item.value){
                        item.value = 0;
                    }
                    if(query(".realPic",this.domNode)[index].innerHTML){
                        if(parseFloat(query(".realPic",this.domNode)[index].innerHTML)+parseFloat(item.value) < 0){
                            alert("优惠金额不能大于商品实际支付价格");
                        }else {
                            query(".realPic",this.domNode)[index].innerHTML = parseFloat(query(".realPic",this.domNode)[index].innerHTML)+parseFloat(item.value);
                        }
                    }else {
                        if(parseFloat(query(".pricePay",this.domNode)[index].innerHTML)+parseFloat(item.value) < 0){
                            alert("优惠金额不能大于商品原价");
                        }else {
                            query(".realPic",this.domNode)[index].innerHTML = parseFloat(query(".pricePay",this.domNode)[index].innerHTML)+parseFloat(item.value);
                        }
                    }
                });
            },this);
        },
        
        // 订单详细信息赋值
        getDetailLabel:function(item){
            var label = "<div style='float:left;'><div class='orderIcon'><img class='discountIcon' src='"
                +item.mId.logo+"' />"
                +"</div></div>"
                +"<div style='float:right;'><div class='updateOrder matname'>"+item.mId.mName+"</div>"
                +"<div class='updateOrder priceAll'>小计：￥"
                +"<span class='pricePay'>"
                +window.fixedTo(item.price*item.qty,3)
                +"</span></div><div class='updateOrder benefit'>优惠：￥"
                +"<input class='discountAmount' type='text'></div>"
                +"<div class='updateOrder'>（请使用“-”号表示减少费用）</div></div>"
                +"<div class='border-top'>"
                +"<div class='realPay'>买家实付：￥<span class='realPic'>"
                +window.fixedTo(item.discountAmount?(item.amount):(item.price*item.qty),3)
                +"</span></div>";
            return label;
        },
		
		// 得到数据
		showUpdateOption : function (datas) {
			this.currentDef = new Deferred();
			
			this.datas = datas;
			this.startup();
			this.refreshData();

			return this.currentDef;
		}
    });
    return declare("cq.ui.b.t.OrderDetail",[View,_ViewMixin],{
        // 初始化页面元素,绑定事件
        onFirstShow:function(){
            // 创建头部信息
            var option = {
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick : function() {
                        history.back();
                    }
                },
                title:"订单详情"
            };
            this.addHeader(option);
            //收货相关信息
            // 添加class 使
            option={isEdge:true,lists:[],'class':"bottom-margin16"};
            this.orderList=this.addLists(option);
            this.orderStateItem = new ListItem({
                variableHeight:true
            });
            this.orderList.addChild(this.orderStateItem);
            //商品信息
            option={isEdge:true,lists:[],'class':"bottom-margin16"};
            this.matList=this.addLists(option);
            //费用信息
            option={isEdge:true,lists:[],'class':"bottom-margin16"};
            this.expenseList=this.addLists(option);
            this.expenseItem = new ListItem({
                variableHeight:true
            });
            this.expenseList.addChild(this.expenseItem);
            
            this.addBottomMenus();
            //this.addColumns(option);
            this.connectEvent();
            this.onClickCertificate();
            this.onAfterShow();
        },
        //整单审核
        setAccepted:function(){
            //系统busy状态,待请求完成后free
            window.busy();
            order.setAccepted(window.did).then(lang.hitch(this, function () {
                window.free();
                this.onAfterShow();
            }));
        },
        setDelivered:function(){
            //系统busy状态,待请求完成后fre
            window.busy();
            order.setDelivered(window.did).then(lang.hitch(this, function () {
                window.free();
                this.onAfterShow();
            }));
        },
        setCanceled:function(){
            //系统busy状态,待请求完成后fre
            window.busy();
            order.setCanceled(window.did).then(lang.hitch(this, function () {
                window.free();
                this.onAfterShow();
            }));
        },
        //修改价格
        setUpdate : function(){
            this.toUpdateOrder().then(lang.hitch(this,function(datas){
                var tag = true;
                array.forEach(datas,function(data,index){
                    var price = this.orderItems[index].amount + data.discountAmount;
                    if(price<0){
                        tag = false;
                        return;
                    }
                },this);
                if(tag){
                    var params = {};
                    params.detail = JSON.stringify(datas);
                    params.tsId = window.did;
                    order.updateDetailDiscountAmount(params).then(lang.hitch(this,function(result){
                        this.onAfterShow();
                    }));
                }else {
                    alert("优惠价格不能大于商品实际支付价格");
                }
            }));
        },
        toUpdateOrder : function(){
            this.updateOrder = new UpdateOrderCode();
			this.orderEditDiv = domConstruct.create("div", {
				style : "height:400px;"
			});
			this.orderEditDiv.appendChild(this.updateOrder.domNode);
			this.showInOverlay(this.orderEditDiv);
			return this.updateOrder.showUpdateOption(this.orderItems);
        },
        // 绑定订单审核/退款/发货点击事件
        connectEvent:function(){
            this.connect(this.matList.domNode,"onclick",function(e){
                var dom = e.target;
                if(dom&&dom.tagName=== "SPAN"){
                    var id=domAttr.get(dom.parentNode,"detailId");
                    if(domClass.contains(dom,"edit-car-revieweds")){
                        order.setDetailAccepted(id).then(lang.hitch(this,function(){
                            this.onAfterShow();
                        }));
                    }else if(domClass.contains(dom,"edit-car-send")){
                        order.setDetailDelivered(id).then(lang.hitch(this,function(){
                            this.onAfterShow();
                        }));
                    }else if(domClass.contains(dom,"edit-car-refunds")){
                        order.setDetailRefounded(id).then(lang.hitch(this,function(){
                            this.onAfterShow();
                        }));
                    }
                }
            });
        },
        //订单详情的状态显示 2016/8/3 徐阿雪
        getOrderDetailStatus : function(items){
            var status=null;
            if(items.isPayed){
                if(items.isCanceled){
                    status = "已退款";
                }else if(items.isDelived){
                    if(items.isClosed){
                        status = "已完成";
                    }else if(!items.isReceipted){
                        status = "待收货";
                    }else{
                        status = "待评价";
                    }
                }else if(items.isAccepted){
                    status = "待发货";
                }else{
                    status = "待审核";
                }
            }else{
                if(items.isCanceled){
                    status = "已取消";
                }else{
                    status = "待付款";
                }
            }
            return status;
        },
        onClickCertificate:function(){
            this.connect(this.expenseItem.domNode,"onclick",function(e){
                var dom = e.target;
                if(dom&&dom.tagName == "IMG"){
                    this.showImg(dom.src)
                }
            })
        },
        // 加载数据,并显示到页面上
        onAfterShow:function () {
            this.inherited(arguments);
            this.orderStateItem.set({label:"",rightText:""});
            this.matList.destroyDescendants();
            this.expenseItem.set({label:"",rightText:""});
            // 收货人信息列表赋值
            order.loadDetailById(window.did).then(lang.hitch(this,function (data) {
                var items=data&&data.data&&data.data.items||[];
                this.orderItems = items;
                if(items.length){
                    //更新收货人信息
                    var status=this.getOrderDetailStatus(items[0]);
                    this.orderStateItem.set({
                        label:"<div class='webkit-list'><div class='edit-car-dName'>收货人:"+(items[0].dName?items[0].dName:"未知")+"</div><div class='edit-car-dTel'>"+(items[0].dTel?items[0].dTel:"未知")+"</div></div>"
                            +"<div class='immune-list'><div class='edit-car-dAddress'>收货地址："+(items[0].dAddress?items[0].dAddress:"未知")+"</div></div>",
                        rightText:status
                        //订单状态修改
                    });
                    //添加商品列表项
                    for (var i = items.length - 1; i >= 0; i--) {
                        var listitem=new ListItem({
                            label:this.getDetailLabel(items[i]),
                            rightText:"<span class='edit-car-qty'>x"+items[i].qty+"</span>",
                            variableHeight:true
                            });
                        this.matList.addChild(listitem);
                    }
                    var discountItems = [];
                    items.reverse();
                    for (var i = items.length - 1; i >= 0; i--) {
                        if(items[i].discountAmount!=0){
                            domClass.remove(query(".edit-car-discountAmount",this.matList.containerNode)[i],"none");
                            domClass.add(query(".edit-car-priceAll",this.matList.containerNode)[i],"line-through");
                        }
                    }
                }
            }));
            // 订单详细信息赋值
            order.loadById(window.did).then(lang.hitch(this,function (data) {
                if(data&&data.data&&data.data.item){
                    var item = this.orderItem = data.data.item;
                    this.setImages(item);
                    var certificateText = "";
                    var certificateLabel = "";
                    if(item.certificate.length){
                        var certificateImg = "";
                        for(var i = 0;i < item.certificate.length; i ++){
                            certificateImg += "<img src="+ item.certificate[i] +" style='margin-right:5px;width:30%;height:30%' class='certificate-img'>";
                        }
                        certificateText = "<div style='margin-top:8px'>"+ certificateImg +"</div>";
                        certificateLabel = "<div class='edit-car-certificate' style='margin-top:8px'>签收凭证:</div>";
                    }
                    if(item.isReceipted){
                        domClass.add(query(".cancel",this.bottomMenus)[0],"none");
                    }
                    //费用明细
                    // 更改时间格式
                    var dates = date.formatISODateMinutes(data.data.item.createAt);
                    this.expenseItem.set({
                        label:"<div class='edit-car-amount'>运费:</div>"
                        +"<div class='edit-car-amount'>交易金额（含运费）:</div>"
                        +"<div class='edit-car-createAt'>创建时间:</div>"
                        +certificateLabel+certificateText,
                        rightText:"<div class='edit-car-amount'>￥"+ window.fixedTo(item.tAmount,3) +"</div>"
                        +"<div class='edit-car-amount'>￥"+ window.fixedTo(item.amount,3) +"</div>"
                        +"<div class='edit-car-createAt'>"+ dates +"</div>"
                    });
                    this.changeBottomStatus(item);
                }
            }));
        },
        // 订单详细信息赋值
        getDetailLabel:function(item){
            var label = "<img class='edit-car-matimg' src='"+item.mId.logo+"' /><span class='edit-car-matname'>"+item.mId.mName+"</span><span class='edit-car-matprice'>￥"+window.fixedTo(item.price,3)+"</span>"
                +"<span class='edit-car-priceAll'>小计:￥"
                +window.fixedTo(item.price*item.qty,3)
                +"</span><span class='edit-car-discountAmount none'>修改价:￥"
                +window.fixedTo(item.amount,3)+"</span>"
                +"<div class='forth-btn ' detailId='" + item._id +"'>";
            label += "</div>";
            return label;
        },
        //上传凭证
        makeCertificate:function(){},
        changeBottomStatus: function(item){
            domClass.add(query(".accept",this.bottomMenus)[0],"none");
            domClass.add(query(".deliver",this.bottomMenus)[0],"none");
            domClass.add(query(".cancel",this.bottomMenus)[0],"none");
            domClass.add(query(".update",this.bottomMenus)[0],"none");
            
            //依据订单主表显示订单按钮
            if(!item.isPayed){
                domClass.remove(query(".update",this.bottomMenus)[0],"none");
            }
            if(item.isPayed&&false===item.isAccepted&&false===item.isCanceled){
                domClass.remove(query(".accept",this.bottomMenus)[0],"none");
            }
            if(item.isAccepted&&false===item.isDelived&&false===item.isCanceled){
                domClass.remove(query(".deliver",this.bottomMenus)[0],"none");
            }
            if(item.payType === "point"){
                if(item.isPayed && false===item.isCanceled){
                    domClass.remove(query(".cancel",this.bottomMenus)[0],"none");
                }
            }else{
                if(item.isPayed && false===item.isCanceled && false===item.isReceipted){
                    domClass.remove(query(".cancel",this.bottomMenus)[0],"none");
                }
            }
            
            //有可能底部全部被隐藏,所以需要重算高度
            this.resize();
        },
        addBottomMenus:function(){
            var option = {
                columns:[{
                    label:'审核',
                    className:'flex2 footer-tab-highlight none accept',
                    onClick : lang.hitch(this,this.setAccepted)
                },
                {
                    label:'发货',
                    className:'flex2 footer-tab-highlight none deliver',
                    onClick:lang.hitch(this,this.setDelivered)
                },
                {
                    label:'退款',
                    className:'flex2 footer-tab-dark none cancel',
                    onClick:lang.hitch(this,this.setCanceled)
                },{
                    label:'修改价格',
                    className:'flex2 footer-tab-dark none update',
                    onClick:lang.hitch(this,this.setUpdate)
                }],
                forceWidth:false,
                isFooter:true
            };
            this.bottomMenus = this.addColumns(option);
        },
        //为上传凭证赋值
        setImages:function(item){}
    });
});