﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-style",
    "cq/ui/common/im/Channel"
],function( declare, lang, domStyle, Channel){
    return declare("cq.ui.c.im.ChannelDetail",[Channel],{
        onFirstShow : function(){
            //侦听事件，toDiscuss时显示发送消息区域，toLive时隐藏
            this.connect(this,"toLiveView",function(){
                domStyle.set(this.footerColumn,"display","none");
                this.resize();
            });
            this.connect(this,"toDiscussView",function(){
                domStyle.set(this.footerColumn,"display","");
                this.resize();
            });
            this.inherited(arguments);
        },
        getMsg:function(){
            var msg = this.inherited(arguments);
            msg.isHost = false;
            return msg;
        }
    });
});