//变更人:母浚驰
//变更时间:2016-07-20
//变更原因:供货商页面
//变更人:肖芳圆
//变更时间:2016-08-02
//变更原因:第二次进入页面的时候加载商家商品有问题
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/Deferred",
    "dojo/dom-attr",
    "dojo/dom-class",
    "dojo/dom-style",
    "dojox/mobile/View",
    "dojo/query",
    "dojo/dom-construct",
    "dijit/registry",
    "dijit/_WidgetBase",
    "dojox/mobile/ListItem",
    "dojox/mobile/EdgeToEdgeStoreList",
    "dojox/mobile/ScrollablePane",
    "dojo/when",
    "dojo/store/JsonRest",
    "cq/ui/view/_ViewMixin",
    "cq/biz/mat/mat",
    "cq/biz/mat/xmMat",
    "cq/biz/mat/group",
    "cq/biz/shop/shop",
    "cq/biz/shop/bs/parameter"
], function (declare, lang, array, Deferred, domAttr, domClass, domStyle, View, query, domConstruct, registry, _WidgetBase, ListItem, EdgeToEdgeStoreList, ScrollablePane, when, JsonRest, _ViewMixin, mat, xmMat, matGroup, shop, parameter){
    var OrderListItem = declare("", [_WidgetBase], {
        params:null,
        mName:"",
        retailPrice:0,
        qty:0,
        totalSale:0,
        logo:"",
        baseClass:"mat-list-item",
        buildRendering:function(){
            this.inherited(arguments);
            //列表项的htmlStr
            var itemHtmlStr = ''
                +      '<div class="mat-list-imgpart"><img src="' + this.logo + '" /></div>'
				//'<div class="mat-list-imgpart"><img src="' + this.logo + '" /></div>'
               // +       '<div class="mat-list-infopart">'
               // +           '<h5 class="mname">' + this.mName + '</h5>'
               // +           '<p><span class="size">规格：' + this.sizeType + '</span><span class="price">￥' + window.fixedTo(this.retailPrice,3) + '</span></p>'
               // +       '</div>';
			   	  + "<div class='shelf-mat-title'>"+this.mName+"</div>"
				  + "<div class='shelf-mat-price-normal'>"+"¥"+window.fixedTo(this.retailPrice,3)+"</div>"
                  + "<div class='shelf-mat-title'>"+"规格:"+this.sizeType+"</div>"
            this.domNode.appendChild(domConstruct.toDom(itemHtmlStr));
        }
    });
    return declare("widgets.mobile.MatList",[View,_ViewMixin],{
        start:0,
        //页面分页大小
        pageSize:10,
        //加载数据的参数
        matParams:{},
        appNavItems:[],
        setMatGroup : function () {
            var groupUl = query("ul", this.appNavItems[0])[0];
            groupUl.innerHTML = "";
            // 获取商家的分类数据
            var li = domConstruct.create("li", {
                tabType : "matType",
                tabValue : ""
            });
            li.innerHTML = "全部分类";
            groupUl.appendChild(li);
            var queryGroup = {
                isUse : true
            };
            if (window.did) {
                queryGroup.shopId = window.did;
            }
            matGroup.load(queryGroup).then(lang.hitch(this, function (data) {
                if (data && data.data.ok) {
                    for (var i = data.data.items.length - 1; i >= 0; i--) {
                        li = domConstruct.create("li", {
                            tabType : "matType",
                            tabValue : data.data.items[i]._id
                        });
                        li.innerHTML = data.data.items[i].gName;
                        groupUl.appendChild(li);
                    };
                };
                this.inintTabNav();
            }));
        },
        onAfterShow:function(){
            // 处理下拉列表的分类问题
            this.setMatGroup();
            
            //创建数据源
            shop.loadById(window.did).then(lang.hitch(this,function(data){
                var bannerTitle = query(".banner-title", this.domNode)[0];
                var bannerIcon = query(".banner-icon", this.domNode)[0];
                bannerTitle.innerHTML = data.data.shopName;
                data.data.logo = data.data.logo||"/static/images/mobile/user_userIcon.png";
                bannerIcon.src = data.data.logo;
                domStyle.set(bannerIcon, "background-color", "white");
            }));
            this.matParams = {fromShopId:window.did,isUse:true,qty:1};
            if(!this.store){
                // 创建数据源
                var  url ="";
                //根据平台方来确定加载数据的接口连接
                if(g_sys_info.platformShopId === "5703ca7d0ccae34b2b40ab8c"){
                    url = xmMat.getOnSaleUrl(g_sys_info.platformShopId);
                }else{
                    url = mat.getOnSaleUrl(g_sys_info.platformShopId);
                }
                this.store = new JsonRest({target:url});
                // 将数据源赋值给StoreList
                var queryResult=this.storeList.setStore(this.store,this.matParams,{
                    start:this.start,
                    count:this.pageSize
                });
                //判断加载更多的显示隐藏
                this.onLoadListData(queryResult,this.start,this.pageSize);
            }else{
                this.setQuery(this.matParams);
                this.inintTabNav();
            }
        },
        onFirstShow:function(){
            var option = {
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick : function() {
                        history.back();
                    //window.moveToView("main");
                    }
                },
                title:"全部商品"
            };
            //判断商家的平台方是否属于酉阳畜牧，如果是显示标题右边的筛选按钮
            if (g_sys_info.platformShopId === "5703ca7d0ccae34b2b40ab8c") {
                option.right = {
                    iconButton : ' ',
                    label : "筛选",
                    onClick:lang.hitch(this.showFilterOverlay)
                }
            }
            this.addHeader(option);
            option = {
                isHeader:true,
                columns : [{
                    label : "<div style='text-align: left;'><img src='/static/images/mobile/user_header.jpg' style='height:94px;display:block;'/>"
                    +"<img class='banner-icon'/><span class='banner-title'></span></div>",
                }],
                className : 'banner'
            };
            this.addColumns(option);
            option = {
                isHeader: true,
                placeHolder:"请输入要查询条件，按回车查询",
                class:"cqSearchBox",
                type:"search",
                onInput:lang.hitch(this,function(evt){
                    if(evt.keyCode==13){
                         //this.search = evt.target.value;
                         //var condition = this.storeList.get("query");
                         //condition.mName = evt.target.value;
                         //this.setQuery(condition);
                        this.matParams.mName = evt.target.value;
                        this.matParams.isUse=true;
                        this.setQuery(this.matParams);
                        this.matParams.mName = '';
                        evt.target.value = "";
                    }
                })
            };
            this.searchBox = this.addTextBox(option);

            //this.addSearchInput();
            option = {
                isHeader: true,
                className:"tabBox",
                columns:[{
                    label:'全部分类',
                    className:'flex2',
                    onClick:lang.hitch(this,function(e){
                        this.tabNav(e,"0");
                    })
                },
                {
                    label:'默认排序',
                    className:'flex2',
                    onClick:lang.hitch(this,function(e){
                        this.tabNav(e,"1");
                    })
                },{
                    'className':'verticalList2 flex1 changestyle',
                    onClick:lang.hitch(this,function(e){
                        this.tabNav(e,"2");
                    })
                }],
                labelClass:'font-size1 tab-selector',
                forceWidth: false
            }
            this.addColumns(option);
            
            this.createTabNavDropdowm("matType",[{title : "全部分类", value : ""}]);
            this.createTabNavDropdowm("matOrder",[{title:"默认排序",value:"-createAt"},{title:"销量优先",value:"-totalSale"},{title:"价格优先",value:"retailPrice"}]);
            this.storeList=new EdgeToEdgeStoreList({
                append: true,
                constraint: false,
                query:{
                },
                className:"mat-list-verticalList2",
                variableHeight:true,
                //获取数据完成后调用的的处理方法
                onComplete:lang.hitch(this,function(data){
                    this.storeList.generateList(data);
                    this.end=this.start+data.length-1;
                    this.busy = false;
                }),
                itemRenderer:OrderListItem,
                itemMap:{
                    mName:"mName",
                    retailPrice:"retailPrice",
                    qty:"qty",
                    totalSale:"totalSale",
                    logo:"logo",
                    //moveTo:"moveTo",
                }
            });
            this.storeList.placeAt(this.centerPanel.containerNode,"last");
            this.storeList.on("click",lang.hitch(this,this.onClickList));
            this.centerPanel.on("afterscroll",lang.hitch(this,this.onLoadMore));
            this.onAfterShow();
        },
        //解析筛选条件参数,删除没有值的参数,避免出错
        parseParams:function(params){
            for(var item in params){
                if(params[item]==''){
                    delete params[item];
                }
            }
            return params;
        },

        //创建导航的下拉
        createTabNavDropdowm:function(tab,options){
            if(!this.dropdowm){
                this.dropdowm=domConstruct.create("div",{
                    className:"nav_dropdowm none"
                });
                this.appNavDropDownBg=domConstruct.create("div",{
                    className:"nav_dropdownbg none"
                });
                var tabBox=query(".tabBox",this.domNode)[0];
                tabBox.appendChild(this.dropdowm);
                tabBox.appendChild(this.appNavDropDownBg);
                this.connect(this.dropdowm,"onclick",this.onDropdowmClick);
                this.connect(this.appNavDropDownBg,"onclick",this.dropUp);
            }
            var item=domConstruct.create("div",{
                className:"nav_dropdowm_item"
            });
            this.dropdowm.appendChild(item);

            this.appNavItems.push(item);
            var ul=domConstruct.create("ul");
            var scrollablePane = new ScrollablePane({},item);
            scrollablePane.containerNode.appendChild(ul);
            scrollablePane.startup();
            var li="";
            for (var i = 0; i < options.length; i++) {
                li=domConstruct.create("li",{
                    tabType:tab,
                    tabValue:options[i].value
                });
                li.innerHTML=options[i].title;
                ul.appendChild(li);
            };
        },
        //初始化导航默认
        inintTabNav:function(){
            var current=query("li[tabValue='"+window.did+"']",this.dropdowm)[0]
            if(current){
                this.tabStyle(current,current.parentNode.children,"selected");
                query(".tabBox .tab-selector",this.domNode)[0].innerHTML=current.innerHTML;
            }
        },
        onDropdowmClick:function(e){
            var dom=e.target;
            if (dom&&dom.tagName=="LI") {
                if(domAttr.get(dom,"tabType")==="matType"){
                    this.chooseTabType(dom);
                }else if (domAttr.get(dom,"tabType")==="matOrder") {
                    this.matParams.orderBy=domAttr.get(dom,"tabValue");
                    this.chooseTabType(dom);
                };
            };
        },
        chooseTabType:function(dom){
            var params = this.matParams;
            if(dom.getAttribute("tabvalue")){
                params.groupId = dom.getAttribute("tabvalue");
            }else{
                params.groupId = "";
            }
            this.setQuery(params);
            this.tabStyle(dom,dom.parentNode.children,"selected");
            query(".selected.tab-selector",this.appNav)[0].innerHTML=dom.innerHTML;
            this.dropUp();
        },
        onClickList:function(evt){
            // 得到点击的ListItem
            var li = registry.getEnclosingWidget(evt.target);
            if(li.declaredClass!="dijit._WidgetBase") return;
            var _id = li.params._id;
            window.moveToView("matDetail",_id);

        },
        onLoadMore:function(evt){
            if(!this.busy&&evt.afterBottom){
                this.start = this.start+this.pageSize;
                if(this.canLoadMore(this.start)){
                    console.log("加载更多商品");
                    this.busy = true;
                    setTimeout(lang.hitch(this, function () {
                        var queryResult = this.storeList.setQuery(this.storeList.get("query"), {
                            start : this.start,
                            count : this.pageSize
                        });
                        this.onLoadListData(queryResult,this.start,this.pageSize);
                    }), 1000);
                }
            }
        },
        clearSelected:function(){
            var items = query('.tab-selector',this.domNode);
            for(var i=0;i<items.length;i++){
                domClass.remove(items[i],"selected");
            }
        },
        tabNav:function(e,type){
            var dom=e.target;
            //是否是切换列表显示
            if(dom && type != 2){
                array.forEach(this.appNavItems,function(index){
                    domClass.add(index,"none");
                },this);
                if(domClass.contains(dom,"selected")){
                    this.dropUp();
                }else{
                    this.clearSelected();
                    domClass.add(e.target,"selected");
                    domClass.remove(this.appNavItems[type],"none");
                    this.dropDown();
                }
            } else {
                var dom = query(".changestyle", this.domNode)[0];
                if (domClass.contains(dom, "verticalList2")) {
                    domClass.replace(dom, "levelList", "verticalList2");
                    domClass.replace(this.storeList.domNode, "mat-list-levelList", "mat-list-verticalList2");
                }else {
                    domClass.replace(dom, "verticalList2", "levelList");
                    domClass.replace(this.storeList.domNode, "mat-list-verticalList2", "mat-list-levelList");
                }
            }
        },
         //收起框
        dropUp:function(isFresh){
            this.clearSelected();
            domClass.add(this.dropdowm,"none");
            domClass.add(this.appNavDropDownBg,"none");
        },
        //打开框
        dropDown:function(){
           domClass.remove(this.dropdowm,"none");
           domClass.remove(this.appNavDropDownBg,"none");
        },
        setQuery:function(query){
            this.start = 0;
            this.end = -1;
            query=this.parseParams(query);
            this.storeList.destroyDescendants();
            var queryResult = this.storeList.setQuery(query,{
                start: this.start,
                count: this.pageSize
            });
            //判断加载更多的显示隐藏
            this.onLoadListData(queryResult,this.start,this.pageSize);
            this.centerPanel.resize();
        },
        //切换样式
        tabStyle:function(dom,domArray,className){//切换样式的操作
            array.forEach(domArray,function(index){
                domClass.remove(index,className);
            });
            if(dom){
                domClass.add(dom,className);
            }
        },
        onAfterTransitionOut:function(){
            this.inherited(arguments);
            if(this.appNavDropDownBg){
                this.dropUp();
            }
        },
        showFilterOverlay:function () {
            var assistData = null;
            var assistGroupTitle = {
                "xmColor" : "颜色",
                "xmUsage" : "用途",
                "xmSex" : "性别",
                "xmVariety" : "品种"
            };
            if(!this.assistFilterDiv){
                //设置筛选页面高度为body的60%
                this.assistFilterDiv = domConstruct.create("div",{style:"height:" + domStyle.get(document.body,"height")*0.6+"px",className:"assistFilterDiv"});
                this.getXmAssistData().then(lang.hitch(this,function (data) {
                    if(data.data.ok === 1){
                        var scrollablePane = new ScrollablePane({height:domStyle.get(document.body,"height")*0.6-49+"px"});
                        scrollablePane.placeAt(this.assistFilterDiv);
                        scrollablePane.startup();
                        assistData = this.parserAssistData(data.data.items);
                        for(var type in assistData){
                            domConstruct.create("div",{className:"mat-list-margin padding-top-bottom16",innerHTML:assistGroupTitle[type]},scrollablePane.containerNode)
                            scrollablePane.containerNode.appendChild(this.createAssistList(assistData[type]));
                        }
                        this.assistFilterDiv.appendChild(this.addColumns({
                            columns : [{
                                    label : '确认',
                                    onClick : lang.hitch(this,function () {
                                        this.setQueryParams();
                                    }),
                                    className: "footer-tab-highlight"
                                }, {
                                    label : '取消',
                                    onClick : lang.hitch(this,function () {
                                        this.hideOverlay();
                                    }),
                                    className: "footer-tab-dark"
                                }
                            ],
                            labelClass : 'font-size3',
                            className : 'hflex'
                        }));
                        this.showInOverlay(this.assistFilterDiv);
                    }
                }));
            }else {
                this.showInOverlay(this.assistFilterDiv);
            }
        },
        getXmAssistData:function () {
            var def = new Deferred();
            parameter.loadPlatform().then(function (result) {
                def.resolve(result);
            });
            return def;
        },
        parserAssistData:function (items) {
            //items : [{title:"用来吃",purpose:"xmUsage",isUser:true}]
            // assistData : {
            //                 xmUsage:[{title:"用途",purpose:"xmUsage",isUser:true}]
            //                 xmVariety:[{title:"品种",purpose:"xmVariety",isUser:true}]
            //                 xmColor:[{title:"颜色",purpose:"xmColor",isUser:true}]
            //                 xmSex:[{title:"性别",purpose:"xmSex",isUser:true}]
            //             }
            var assistData = {
                xmVariety : [],
                xmColor : [],
                xmSex : [],
                xmUsage : []
            };
            array.forEach(items, function (item) {
                item.purpose = item.purpose
                if(!assistData[item.purpose]){
                    assistData[item.purpose] = [];
                }
                assistData[item.purpose].push(item);
            });
            return assistData;
        },
        createAssistList:function (assists) {
            var option = { isEdge : true ,lists : [] ,class : "padding-top8 " + (assists[0]&&assists[0].purpose)};
            var edgeList = null;
            array.forEach(assists,function (assist) {
                option.lists.push({
                    label : assist.title,
                    rightText : "<input class='assist' value='"+assist._id+"' type='"+assist.purpose+"' style='display:none'>",
                    className : 'mblListItem h-four-pane bottom-margin8'
                });
            });
            edgeList = this.addLists(option);
            this.connect(edgeList.containerNode,"onclick",function (e) {
                var dom = e.target;
                var listItems = null;
                while (dom&&!domClass.contains(dom,"mblListItem")) {
                    dom = dom.parentNode;
                }
                if(dom&&domClass.contains(dom,"selected")){
                    domClass.remove(dom,"selected");
                }else if(dom){
                    listItems = query(".mblListItem",dom.parentNode);
                    array.forEach(listItems,function (listItem) {
                        domClass.remove(listItem,"selected");
                    });
                    domClass.add(dom,"selected");
                }
            });
            return edgeList.containerNode;
        },
        setQueryParams:function () {
            var selecteds = query(".selected input",this.assistFilterDiv);
            var assistParams = {
                'xmUsage' : 'purposes',
                'xmSex' : 'sex',
                'xmColor' : 'color',
                'xmVariety' : 'variety'
            }
            //删除原有的属性
            for (var type in assistParams) {
                delete this.matParams[assistParams[type]];
            }
            //重新获取属性
            array.forEach(selecteds,function (selected) {
                this.matParams[assistParams[domAttr.get(selected,"type")]] = domAttr.get(selected,"value");
            },this);
            console.log(this.matParams);
            this.setQuery(this.matParams);
            this.hideOverlay();
        }
    });
});
