﻿define([
    "dojo/_base/declare",
    "dojo/_base/array",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin"
],function( declare, array, View, _ViewMixin){
    return declare("cq.ui.common.icons.IconEdit",[View,_ViewMixin],{
        isEditing: false,
        //初始化界面元素
        onFirstShow: function(){
            //添加头部
            var option={
                left:{
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick:function(){
                        this.isEditing = false;
                        history.back();
                    }
                },
                title:"添加",
                right:{
                    iconButton:' ',
                    onClick:this.onSaveStore,
                    label:"完成"
                }
            };
            this.addHeader(option);
            //加载页面中
            option={
                isEdge:true,
                lists:[{
                    label : "上传图片",
                    noArrow : false,
                    imgSize:{width:900,height:500},
                    edit :{
                        type:"image",
                        field:"logo"
                    },
                    class : "li-icon",
                    moveTo : "#"
                },{
                    label :"使用途径",
                    moveTo:"#",
                    rightText:'',
                    edit:{
                        type:'ref',
                        field:'groupId',
                        moveTo:"#",
                        params:{
                            target:null,
                            query:{},
                            searchField:"groupName",
                            labelField:"groupName",
                            addPageId:"iconGroup"
                        }
                    }
                },{
                   label:'标签',
                    noArrow:true,
                    edit:{
                        type:'text',
                        field:'title',
                        placeHolder:"必填"
                    } 
                }],
                data:this.getData()
            };
            this.addLists(option);
            this.onAfterShow();
        },
        onAfterShow:function(){
            //如果isEditing 为false
            if(!this.isEditing){
                this.isEditing = true;
                //如果存在window.did，则按window.did加载页面，否则当第一次进入该页面处理
                if(!window.did){
                    this.setData({
                    });
                    this.refreshData();
                }else{
                    
                }
            }
        },
        onSaveStore:function(){
            if(this.isEditing){
                //设置界面busy
                window.busy();
                this.isEditing = false;
                var m = this.getData();
                //如果没有shopId，则获取shopId
                if(!m.shopId){
                    //m.shopId=?
                }
                var checkMsg=this.checkFiled(m);
                if(checkMsg){
                    //设置界面free
                    window.free();
                    alert(checkMsg);
                    this.isEditing = true;
                    return;
                }
                console.log(m);
                window.moveToView("iconStorage");
                // icon.save(m).then(lang.hitch(this,function(data){
                    // //设置界面free
                    // window.free();
                    // // 保存成功则跳转到资讯列表页面
                    // if(data.data.ok === 1){
                        // //history.back();
                        // window.moveToView("iconStorage",data.data.item.groupId);
                    // }else{
                        // alert("保存失败");
                        // this.isEditing = true;
                    // }
                // }));
            }
            
        },
        // 验证必填项是否有值
        checkFiled:function(data){
            var msg="";
            if(!data.title){
                msg="编码不能为空!";
                return msg;
            }else if(!data.logo){
                msg="图片没有选择!";
                return msg;
            }
            // }else if(!data.groupId){
                // msg="请选择使用类别";
                // return msg;
            // }
        }
    });
});