//变更人:母浚驰
//变更时间:2016-07-20
//变更原因:供货商页面
//变更人:张金鹏
//变更时间:2016-07-28
//变更原因:供货商页面增加粉丝数，关注和取消关注，及其联系商家按钮
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/Deferred",
    "dojo/dom-attr",
    "dojo/dom-class",
    "dojo/dom-style",
    "dojox/mobile/View",
    "dojo/query",
    "dojo/dom-construct",
    "dijit/registry",
    "dijit/_WidgetBase",
    "dojox/mobile/ListItem",
    "dojox/mobile/EdgeToEdgeStoreList",
    "dojox/mobile/ScrollablePane",
    "dojo/when",
    "dojo/store/JsonRest",
    "cq/ui/view/_ViewMixin",
    "cq/biz/mat/mat",
    "cq/biz/mat/xmMat",
    "cq/biz/mat/group",
    "cq/biz/shop/partner",
    "cq/biz/shop/shop",
    "cq/biz/shop/bs/parameter",
    "cq/util/config/config",
    "cq/biz/user/user",
    "cq/biz/im/msg_p",
    "cq/biz/shop/cm/shopStore"
], function (declare, lang, array, Deferred, domAttr, domClass, domStyle, View, query, domConstruct, registry, _WidgetBase, ListItem, EdgeToEdgeStoreList, ScrollablePane, when, JsonRest, _ViewMixin, mat, xmMat, matGroup, partner, shop, parameter,config, user, msg_p, shopStore){
    return declare("widgets.mobile.MatList",[View,_ViewMixin],{
        start:0,
        //页面分页大小
        pageSize:10,
        //加载数据的参数
        //matparam:{},
        appNavItems:[],
        //第一次载入页面时
        onFirstShow:function(){
            //设置节点样式
            domStyle.set(this._headerPane.containerNode, "overflow", "hidden");
			//头部区域的option设置
            var option = {
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick : function() {
                        history.back();
                    }
                },
                title:"商家详情"
            };
            //判断商家的平台方是否属于酉阳畜牧，如果是显示标题右边的筛选按钮
            if (g_sys_info.platformShopId === "5703ca7d0ccae34b2b40ab8c") {
                option.right = {
                    iconButton : ' ',
                    label : "筛选",
                    onClick:lang.hitch(this.showFilterOverlay)//showFilterOverlay函数未声明    2016-08-03
                };
            }
            this.addHeader(option);
            //背景图片的设置
            option = {
                isHeader:true,
                columns : [{
                    //图片地址改为images/userBanner.jpg
                    label : "<div class='banner' style='text-align: left;'><img src='images/userBanner.jpg' class='bannerImg' style='height:70px;display:block;'/>"
                        +"<img class='banner-icon'/><span class='banner-title'></span></div>",
                }],
                className : 'banner'
            };
            this.addColumns(option);
			//头部的联系商家按钮    张金鹏，2016/07/28
            this.banner = query(".banner", this.domNode)[0];
            domStyle.set(this.banner,"height","90px");
            this.banner.appendChild(domConstruct.toDom("<div class = 'banner_header_div'><span class = 'fans-num supplybud-num'>粉丝数:0</span><span class = 'notAttentioned attention-btn'>关注</span><span class = 'mat-num supplybud-num none'>商品数:0</span><span class = 'sale-num supplybud-num none'>销量</span></div>"));
            //关注和取消关注按钮
            this.attendStateNode = query(".attention-btn", this.banner)[0];
            //关注和取消关注的消息响应
            this.connect(this.attendStateNode, "onclick", this.toggleAttendState);
            //商家粉丝数
            this.fansNumNode = query(".fans-num", this.banner)[0];                     
            //头部的查询输入框
            option = {
                isHeader: true,
                placeHolder:"请输入要查询条件，按回车查询",
                class:"cqSearchBox",
                type:"search",
                onInput:lang.hitch(this,function(evt){
                    if(evt.keyCode==13){
                        this.param.mName = evt.target.value;
                        this.param.isUse=true;
						//刷新显示
                        this.setQuery(this.param);
                        this.param.mName = '';
                        evt.target.value = "";
                    }
                })
            };
            this.addTextBox(option);
            //增加页面中两种排序方式和显示方式
            option = {
                isHeader: true,
                className:"tabBox",
                columns:[{
                    label:'全部分类',
                    className:'flex2',
                    onClick:lang.hitch(this,function(e){
                        //点击之后弹出分类列表
                        this.showMatGroupDropdown();
                    })
                },
                {
                    label:'默认排序',
                    className:'flex2',
                    onClick:lang.hitch(this,function(e){
                        //点击之后弹出排序方式列表
                        this.showMatOrderDropdown();
                    })
                },{
                    'className':'verticalList2 flex1 changestyle',
                    onClick:lang.hitch(this,function(e){
                        //点击之后切换排列方式，横向一个还是两个(列表模式还是卡片模式)
                        this.alterListLayout();
                    })
                }],
                labelClass:'font-size1 tab-selector',
                forceWidth: false
            };
            this.optionColumnNode = this.addColumns(option);
            this.initDropdownToolBar();
            //添加商品详情列表
            this.storeList=new EdgeToEdgeStoreList({
                append: true,
                constraint: false,
                query:{},
                className:"mblEdgeToEdgeList icon-list-item",
                variableHeight:true,
                //获取数据完成后调用的的处理方法
                onComplete:lang.hitch(this,function(data){
                    this.processMatData(data);
                    //添加html片段
                    for (var i = 0; i < data.length; i++) {
                        data[i]._label = "<div class='mat-list-mname mat-list-margin'>" + data[i].mName +
                            "</div><div class='mat-list-price mat-list-margin showRetailPrice'>￥<span class='showPrice'>" + (data[i].retailPrice||0)+
                            "</span></div><div class='mat-list-qty mat-list-margin'><span>库存：" + window.fixedTo(data[i].qty ,1)+
                            "</span><span class='mat-list-totalSale'>规格：" + data[i].sizeType +
                            "</span></div>";
                        data[i].moveTo = "#";
                        //data[i]._logo = data[i].logo ? data[i].logo : 'images/nomat.png';
                    }
                    //传入参数并生成一个列表项
                    this.storeList.generateList(data);
                    this.end=this.start+data.length-1;
                    this.busy = false;
                    //this.showRealPric();
                }),
                itemMap:{
                    _label:"label",
                    logo:"icon"
                }
            });
            //将this.storeList放到this.centerPanel.containerNode的最后
            this.storeList.placeAt(this.centerPanel.containerNode,"last");
            //添加一个监听click，执行onClickList方法
            this.storeList.on("click",lang.hitch(this,this.onClickList));
            //添加一个监听afterscroll，执行onLoadMore方法
            this.centerPanel.on("afterscroll",lang.hitch(this,this.onLoadMore));
			// 提供添加底部按钮的接口
			this.addFooterButton();
            this.onAfterShow();
        },
		addFooterButton:function(){
			option = {
                columns:[{
                    className:'flex2 footer-tab-highlight',
                    label:'联系客服',
                    onClick:function(){
                        this.toTalk();
                    }
                }],
                isFooter:true
            };
            this.footerButton = this.addColumns(option);  
		},
        //判断是否为供应商
        processMatData : function(){
        },
        //联系客服的程序
        toTalk:function(evt){
            //调用msg_p对象的getSvcInfo()方法，获取和指定商家客服对话的信息的结果取名叫msgInfo
            msg_p.getSvcInfo(window.did).then(lang.hitch(this,function(msgInfo){
                if(msgInfo&&msgInfo.data&&msgInfo.data.item){
                    var item = msgInfo.data.item;
                    var senderId = item.senderId,receiverId = item.receiverId;
                    senderId = senderId._id||senderId;
                    receiverId = receiverId._id||receiverId;
                    var svcId = senderId===user.getCurrentUserId()?receiverId:senderId;
                    window.moveToView("svcDetail",window.did+","+svcId);
                } else {
                    alert (msgInfo.data.msg);
                }
            }));
        },        
        //切换当前人对当前商家的关注状态
        toggleAttendState:function(evt){
            var target = evt.target;
            shopStore[domClass.contains(target, "notAttentioned")?"shopStore":"shopStoreCancel"]({
                targetShopId:window.did
            }).then(lang.hitch(this,this.updateFansAndFocus));
        },
        moveTo : function(){
            window.moveToView("supplyBusDetail",window.did);
        },
        onAfterShow:function(){
            //创建数据源
            //在平台库中获取指定ID的商家信息
            shop.loadShopByPlatform(window.did).then(lang.hitch(this,function(data){
            	//找出.banner-title和.banner-icon的节点
                var bannerTitle = query(".banner-title", this.domNode)[0];
                var bannerIcon = query(".banner-icon", this.domNode)[0];
                //设置节点的内容显示为商家的名字
                bannerTitle.innerHTML = data.data.shopName;
				query(".mat-num", this.domNode)[0].innerHTML = "商品数:" + data.data.shopMatNum||0;
				query(".sale-num", this.domNode)[0].innerHTML ="销量:" +  data.data.saleAmount||0;
                data.data.logo = data.data.logo||"../../images/mobile/user_userIcon.png";
                bannerIcon.src = data.data.logo;
                //设置bannerIcon的样式
                domStyle.set(bannerIcon, "background-color", "white");
            }));
            //初始化当前人是否关注商家、商家粉丝数信息
            this.updateFansAndFocus();
            //加载当前商家的品类信息，并刷新品类区域内容
            this.initMatGroupContent();
            
			this.loadMatDef().then(lang.hitch(this, this.updateStoreList));
			// 控制添加供应商、删除供应商的显示与隐藏
			this.showButton();
        },
		showButton:function(){			         
        },
        loadMatDef:function(){
            var def = new Deferred();
            def.resolve();
            return def;
        },
		updateStoreList:function(){
            //初始化查询条件
            var shopId = window.did;
			this.param = this.param||{};
            this.param.isUse = true;
            this.param.shopId = window.did;
            this.param.qty = 1;
            delete this.param.groupId;
            if(!this.store){
                // 创建数据源
                var url ="";
                //根据平台方来确定加载数据的接口连接
                if(g_sys_info.platformShopId === "5703ca7d0ccae34b2b40ab8c"){	
                    this.param = {};
                    url = xmMat.getLoadUrl();
                }else{
                    //var platformId = config.getPlatformShopId();
                    url=mat.getUrlByShop(shopId);
                }
                this.store = new JsonRest({target:url});
                // 将数据源赋值给StoreList
                var queryResult=this.storeList.setStore(this.store,this.param,{
                    start:this.start,
                    count:this.pageSize
                });
                //判断加载更多的显示隐藏
                this.onLoadListData(queryResult,this.start,this.pageSize);
            }else{
                //传入参数并刷新显示
                this.setQuery(this.param);
                //商品分类的默认值显示
                query(".tab-selector",this.optionColumnNode)[0].innerHTML = "全部分类";
            }
		},
		//查询是否关注并刷新商家的粉丝数据    张金鹏，2016/07/28
		updateFansAndFocus:function(){
            //查询当前商家的ID=window.did    张金鹏，2016/07/28
            //更新它的粉丝数    张金鹏，2016/07/28
            shop.loadFansNum(window.did).then(lang.hitch(this,function(data){
                var item=data&&data.data&&data.data.item;
                var fansNum=item.fansNum;
                this.fansNumNode.innerHTML = "粉丝数:" + fansNum;
            }));
            //关注和取消关注的样式设置
            shopStore.hasStored(window.did).then(lang.hitch(this,function(result){
				//用户假如关注了该商家 result: true/false
                if(result){
                    domClass.remove(this.attendStateNode, "notAttentioned");
                    domClass.add(this.attendStateNode, "attentioned");
                    this.attendStateNode.innerHTML = "取消关注";
                }else{
				//用户假如未关注该商家
                    domClass.add(this.attendStateNode, "notAttentioned");
                    domClass.remove(this.attendStateNode, "attentioned");
                    this.attendStateNode.innerHTML = "关注";
                }
            }));
        },
        //选择分类的区域的根节点
        matGroupPane:null,
        //选择排序方式区域的根节点
        matOrderPane:null,
        //向界面上添加点击下拉区域
        initDropdownToolBar:function(){
            //添加弹出分类区域，点击之后切换当前分类并重新加载数据
            this.matGroupPane = this.addDropdownArea({
				//点击商品分类之后的响应事件
                onClick:lang.hitch(this,this.onMatGroupClick)
            });
            //添加弹出排序区域，点击之后是刷新排序方式并重新加载数据
            this.matOrderPane = this.addDropdownArea({
				//点击商品排序之后的响应事件
                onClick:lang.hitch(this,this.onMatOrderClick)
            });
            //向商品排序区域添加内容
            this.addMatOrderContent();
        },
        //向界面上添加下拉区域，参数暂时只支持onClick——内容点击事件，返回值为该区域的根节点
        addDropdownArea:function(param){
            //判断是否已有半透明背景，若没有，创建，处理点击事件
            if(!this.dropdowm){
                //domConstruct.create()创建一个元素
                this.dropdowm=domConstruct.create("div",{
                    className:"nav_dropdowm none"
                });
                this.dropdownItem = domConstruct.create("div",{
                    "class":"nav_dropdowm_item"
                },this.dropdowm);
				//创建一个背景元素
                this.appNavDropDownBg=domConstruct.create("div",{
                    className:"nav_dropdownbg none"
                });
                var tabBox=query(".tabBox",this.domNode)[0];
                tabBox.appendChild(this.dropdowm);
                tabBox.appendChild(this.appNavDropDownBg);
				//监听事件，隐藏下拉区域
                this.connect(this.appNavDropDownBg,"onclick",this.hideDropDown);
            }
            //向根节点添加scrollbalePane
            var scrollablePane = new ScrollablePane({
                height:"100%"
            });
			//把scrollablePane放到this.dropdowm的最后
            scrollablePane.placeAt(this.dropdownItem,"last");
            scrollablePane.startup();
            var ulNode = domConstruct.create("ul",{
            //向scrollablePane的containerNode中添加内容div——有特殊的class，用于添加内容
            },scrollablePane.containerNode,"last");
            //侦听内容节点的点击事件，事件处理函数为参数中的onClick
            this.connect(ulNode,"onclick",param.onClick);
            return scrollablePane;
        },
        //商品分类点击之后的响应事件，获取被选中的商品分类、处理选中样式、刷新数据、将选中的内容显示到分类column中
        onMatGroupClick:function(e){
			var id = domAttr.get(e.target,"name");
            if(id){
                this.param.groupId = id;
            }else{
                delete this.param.groupId;
            }
            //刷新显示
            this.setQuery(this.param);
            //处理选中样式
            this.setItemSelected(e.target);
            //处理分类column中的显示
            query(".tab-selector",this.optionColumnNode)[0].innerHTML = e.target.innerHTML;
            //隐藏下拉区域
            this.hideDropDown();
        },
		//设置选中的样式
        setItemSelected:function(node){
            var selectedNode = query(".selected",node.parentNode)[0];
            if(selectedNode){
                domClass.remove(selectedNode,"selected");
            }
            domClass.add(node,"selected");
        },
        //商品排序区域的点击事件，获取被选中的排序方式、处理选中样式、刷新数据、将选中的内容显示到排序column中
        onMatOrderClick:function(e){
			var id = domAttr.get(e.target,"name");
            this.param.orderBy = id;
            //刷新显示
            this.setQuery(this.param);
            //处理选中样式
            this.setItemSelected(e.target);
            //处理分类column中的显示
            query(".tab-selector",this.optionColumnNode)[1].innerHTML = e.target.innerHTML;
            //隐藏下拉区域
            this.hideDropDown();
        },
        //添加商品排序规则区域的内容
        addMatOrderContent:function(){
			this.addScrollContent([{
                title:"默认排序",
                _id:"-createAt"
            },{
                title:"销量优先",
                _id:"-totalSale"
            },{
                title:"价格优先",
                _id:"retailPrice"
            }],this.matOrderPane);
        },
        addScrollContent:function(contents,scrollablePane){
            var ulNode = query("ul",scrollablePane.containerNode)[0];
			//map() 方法返回一个新数组，数组中的元素为调用函数按照原始数组元素顺序依次处理后的值。
            ulNode.innerHTML = array.map(contents,function(content){
                return "<li tabtype='matType' name='"+content._id+"'>"+content.title+"</li>";
            }).join("");
        },

        //隐藏弹出的选择分类或者排序的下拉区域
        hideDropDown:function(){
            var items = query('.tab-selector',this.domNode);
            for(var i=0;i<items.length;i++){
                domClass.remove(items[i],"selected");
            }
            domClass.add(this.dropdowm,"none");
            domClass.add(this.appNavDropDownBg,"none");
        },
        //加载当前商家的所有商品分类，并依据结果初始化分类区域内容
        initMatGroupContent:function(){
			matGroup.load({
                isUse:true,
                shopId:window.did
            }).then(lang.hitch(this,function(data){
                var items = data&&data.data&&data.data.items||[];
                this.addScrollContent([{
                    _id:"",
                    title:"全部分类"
                }].concat(array.map(items,function(item){
                    return {
                        _id:item._id,
                        title:item.gName
                    };
                })),this.matGroupPane);
            }));
        },
		//弹出商品分类下拉框
        showMatGroupDropdown:function(){
            domClass.add(query(".tab-selector",this.optionColumnNode)[0],"selected");
            domClass.add(this.matOrderPane.domNode,"none");
            domClass.remove(this.dropdowm,"none");
            domClass.remove(this.appNavDropDownBg,"none");
            domClass.remove(this.matGroupPane.domNode,"none");
            this.matGroupPane.resize();
        },
		//弹出商品排序下拉框
        showMatOrderDropdown:function(){
            domClass.add(query(".tab-selector",this.optionColumnNode)[1],"selected");
            domClass.add(this.matGroupPane.domNode,"none");
            domClass.remove(this.dropdowm,"none");
            domClass.remove(this.appNavDropDownBg,"none");
            domClass.remove(this.matOrderPane.domNode,"none");
            this.matOrderPane.resize();
        },
        //切换商品列表显示模式，是列表模式还是卡片模式
        alterListLayout:function(){
            var dom = query(".changestyle", this.domNode)[0];
            if (domClass.contains(dom, "verticalList2")) {
                domClass.replace(dom, "levelList", "verticalList2");
                domClass.replace(this.storeList.domNode, "mat-list-levelList", "mat-list-verticalList2");
            }else {
                domClass.replace(dom, "verticalList2", "levelList");
                domClass.replace(this.storeList.domNode, "mat-list-verticalList2", "mat-list-levelList");
            }
        },
        onClickList:function(evt){
            // 得到点击的ListItem
            //registry.getEnclosingWidget()函数返回包含指定节点的组件，不包含则为空
            var li = registry.getEnclosingWidget(evt.target);
            //属性declaredClass看不懂
            if(li.declaredClass!="dojox.mobile.ListItem") {
                return;
            }
            var _id = li.params._id+"_"+window.did;
            window.moveToView("matDetail",_id);
        },
        //查找操作，看不懂
        setQuery:function(query){
            this.start = 0;
            this.end = -1;
            //query=this.parseparam(query);
            this.storeList.destroyDescendants();
            var queryResult = this.storeList.setQuery(query,{
                start: this.start,
                count: this.pageSize
            });
            //判断加载更多的显示和隐藏
            this.onLoadListData(queryResult,this.start,this.pageSize);
            this.centerPanel.resize();
        },
        //载入更多
        onLoadMore:function(evt){
            if(!this.busy&&evt.afterBottom){
                this.start = this.start+this.pageSize;
                //函数canLoadMore()看不懂
                if(this.canLoadMore(this.start)){
                    console.log("加载更多商品");
                    this.busy = true;
                    setTimeout(lang.hitch(this, function () {
                        //获取storeList的属性
                        var queryResult = this.storeList.setQuery(this.storeList.get("query"), {
                            start : this.start,
                            count : this.pageSize
                        });
                        //onLoadListData()看不懂
                        this.onLoadListData(queryResult,this.start,this.pageSize);
                    }), 1000);
                }
            }
        }
    });
});
