// 变更人员：母浚驰
// 变更时间：2016/5/18
// 变更内容：代码规范，添加注释
// 变更人：潘云
// 变更时间：2016/5/31
// 变更内容：商品评价

// 变更人员：母浚驰
// 变更时间：2016/6/20
// 变更内容：时间格式，页面样式修改

// 变更人员：胡飞
// 变更时间：2016/6/22
// 变更内容：增加收货人/商品信息/订单信息三个ul之间的间隔

// 变更人：潘云
// 变更时间：2016/6/28
// 变更内容：评价的样式,提交成功后刷新评论的内容，最多可以提交5张图片

//变更人:王龙
//变更时间:2016/6/30
//变更内容:支付之前，将底部的“余额/代金券/优惠券抵扣”修改为余额“抵扣”(代金券和优惠券未启用);

//变更人:周科吉
//变更时间:2016/7/5
//变更内容:订单详情余额显示按钮问题；取消订单后不能评论的问题

// 变更人:刘轩
// 变更时间:2016/7/13
// 变更内容:订单取消也可以收货的BUG修复

// 变更人 ：徐阿雪
// 变更时间:2016/8/3
// 变更内容:1、修改显示支付方式问题2订单不能提交问题3、支付出现错误问题（参数不对）

// 变更人 ：张金鹏
// 变更时间:2016/9/6
// 变更内容:1、修改评价的打分选项2订单不能提交问题3、支付出现错误问题（参数不对）

// 变更人 ：母浚驰
// 变更时间:2016/10/26
// 变更内容:点击商品跳转到商品详情的调整
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojox/mobile/Rating",
    "dojo/DeferredList",
    "dojo/dom-attr",
    "dojo/dom-style",
    "dojo/dom-class",
    "dojo/dom-construct",
    "dojo/query",
    "dojo/Deferred",
    "dijit/registry",
    "dijit/_WidgetBase",
    "dojox/mobile/View",
    "dojox/mobile/ListItem",
    "cq/biz/ts/order",
    "cq/util/sys/date",
    "cq/biz/user/user",
    "cq/ui/view/_ViewMixin",
    "cq/biz/shop/shop"
], function(declare, lang, array, Rating, DeferredList, domAttr, domStyle, domClass, domConstruct, query, Deferred, registry, _WidgetBase, View, ListItem, order, date, user, _ViewMixin, shop) {
    //评价
    var MatEva = declare("", [View, _ViewMixin], {
        // 默认分数为5
        score: 5,
        matEvaluation: 5,
        serviceEvaluation: 5,
        deliveryEvaluation: 5,
        logisticsEvaluation: 5,
        // 初始化fromShopId
        fromShopId:'',
        // 评论等级的HTML
        getevalHtml: function() {
            var htl = "";
            /*htl += "<div class = 'scorediv'>商品评价:</div>"; */
            htl += "<div class = 'scorediv'>描述相符:</div>";
            htl += "<div class = 'scorediv'>服务态度:</div>";
            htl += "<div class = 'scorediv'>发货速度:</div>";
            htl += "<div class = 'scorediv'>物流速度:</div>";
            htl += "<div class = 'evaltext'><textarea maxlength='512' rows='5' placeholder='亲，请填写评价详情'></textarea></div>";
            return htl;
        },
        // 添加评价等级
        indexMatRating: function() {
            var scoreWidget = this.scoreWidget = new Rating({
                className: "rating",
                image: "../../../static/common/images/xin2.png",
                numStars: 5,
                value: 5,
            });
            query(".scorediv", this.evalList.domNode)[0].appendChild(this.scoreWidget.domNode);

            var scoreWidget1 = this.scoreWidget1 = new Rating({
                className: "rating",
                image: "../../../static/common/images/xin2.png",
                numStars: 5,
                value: 5,
            });
            query(".scorediv", this.evalList.domNode)[1].appendChild(this.scoreWidget1.domNode);

            var scoreWidget2 = this.scoreWidget2 = new Rating({
                className: "rating",
                image: "../../../static/common/images/xin2.png",
                numStars: 5,
                value: 5,
            });
            query(".scorediv", this.evalList.domNode)[2].appendChild(this.scoreWidget2.domNode);

            var scoreWidget3 = this.scoreWidget3 = new Rating({
                className: "rating",
                image: "../../../static/common/images/xin2.png",
                numStars: 5,
                value: 5,
            });
            query(".scorediv", this.evalList.domNode)[3].appendChild(this.scoreWidget3.domNode);
        },
        // 初始化页面元素
        indexElement: function() {
            // 评价的等级
            var option = {
                isEdge: true,
                class: 'top-bottom-margin16',
                lists: [{
                    label: this.getevalHtml(),
                    variableHeight: true
                }]
            };
            this.evalList = this.addLists(option);
            this.indexMatRating();
            // 上传图片
            option = {
                maxImages: 5,
                mainLabel: "",
                detailLabel: "",
                canAdd: true,
                icons: [],
                editable: true,
                class: "no-shake",
                size: {
                    width: 640,
                    height: 640
                }
            };
            this.images = this.addImagePicker(option);
            // 底部按钮 提交 取消
            option = {
                columns: [{
                    label: "取消",
                    onClick: lang.hitch(this, function() {
                        this.currentDef.resolve();
                        this.hideOverlay();
                    }),
                    className: "flex2 footer-tab-dark"
                }, {
                    label: "提交",
                    onClick: lang.hitch(this, function() {
                        window.busy();
                        var data = this.getEvalData();
                        data.score = data.matEvaluation;
                        var msg = this.checkFlied(data);
                        if (msg) {
                            window.free();
                            alert(msg);
                            return;
                        }
                        this.currentDef.resolve(data);
                    }),
                    className: "flex2 footer-tab-highlight"
                }],
                forceWidth: false,
                isFooter: true
            };
            this.addColumns(option);
        },
        // 验证必填字段是否为空
        checkFlied: function(data) {
            var msg = "";
            /* if (!data.score) {
                
            } */
            if ((!data.matEvaluation) && (!data.serviceEvaluation) && (!data.deliveryEvaluation) && (!data.logisticsEvaluation)) {
                msg = "必须给出评价分数";
            } else if (!data.content) {
                msg = "评价内容不能为空";
            }
            return msg;
        },
        // 保存时获取用户的评价信息
        getEvalData: function() {
            var data = {};
            // 用户评价的分数
            data.score = this.score;
            data.matEvaluation = this.matEvaluation;
            data.serviceEvaluation = this.serviceEvaluation;
            data.deliveryEvaluation = this.deliveryEvaluation;
            data.logisticsEvaluation = this.logisticsEvaluation;
            // 获取用户输入的内容
            data.content = query(".evaltext>textarea", this.evalList.domNode)[0].value;
            // 获取图片
            var iconItems = this.images.getChildren();
            if (iconItems.length > 1) {
                var images = [];
                for (var i = 0; i < iconItems.length; i++) {
                    // 如果icon存在则为用户上传的图片
                    if (iconItems[i].icon) {
                        images.push(iconItems[i].icon);
                    }
                }
                data.images = images;
            }

            return data;
        },

        // 初始化事件
        initEvent: function() {
            // 处理用户点击的等级事件
            this.scoreWidget.on("click", lang.hitch(this, function(e) {
                var node = e.target;
                var domNode = this.scoreWidget.domNode;
                while (node && node.parentNode !== domNode) {
                    node = node.parentNode;
                }
                // 设置评价的分数
                this.matEvaluation = array.indexOf(domNode.childNodes, node) + 1;
                // 改变样式
                this.scoreWidget.set("value", this.matEvaluation);
            }));

            this.scoreWidget1.on("click", lang.hitch(this, function(e) {
                var node = e.target;
                var domNode = this.scoreWidget1.domNode;
                while (node && node.parentNode !== domNode) {
                    node = node.parentNode;
                }
                this.serviceEvaluation = array.indexOf(domNode.childNodes, node) + 1;
                this.scoreWidget1.set("value", this.serviceEvaluation);
            }));
            this.scoreWidget2.on("click", lang.hitch(this, function(e) {
                var node = e.target;
                var domNode = this.scoreWidget2.domNode;
                while (node && node.parentNode !== domNode) {
                    node = node.parentNode;
                }
                this.deliveryEvaluation = array.indexOf(domNode.childNodes, node) + 1;
                this.scoreWidget2.set("value", this.deliveryEvaluation);
            }));
            this.scoreWidget3.on("click", lang.hitch(this, function(e) {
                var node = e.target;
                var domNode = this.scoreWidget3.domNode;
                while (node && node.parentNode !== domNode) {
                    node = node.parentNode;
                }
                this.logisticsEvaluation = array.indexOf(domNode.childNodes, node) + 1;
                this.scoreWidget3.set("value", this.logisticsEvaluation);
            }));
        },
        showAuditOption: function() {
            // 初始化一个异步操作
            this.currentDef = new Deferred();
            this.startup();
            //this.initData();
            return this.currentDef;
        },
        initData: function() {
            query(".evaltext>textarea", this.evalList.domNode)[0].value = "";
            this.scoreWidget.set("value", 5);
            this.scoreWidget1.set("value", 5);
            this.scoreWidget2.set("value", 5);
            this.scoreWidget3.set("value", 5);
            this.images.refreshItems([]);
        },
    });

    return declare("widgets.mobile.OrderDetail", [View, _ViewMixin], {
        pacTeamId: null,
        // 初始化页面元素,绑定事件
        onFirstShow: function() {
            // 创建头部信息
            var option = {
                left: {
                    iconButton: ' ',
                    arrow: "left",
                    label: "返回",
                    onClick: function() {
                        history.back();
                    }
                },
                title: "订单详情"
            };
            this.addHeader(option);
            //收货相关信息
            option = {
                isEdge: true,
                lists: [],
                class: "bottom-margin16"
            };
            this.orderList = this.addLists(option);
            this.orderStateItem = new ListItem({
                variableHeight: true
            });
            this.orderList.addChild(this.orderStateItem);

            //商品信息
            option = {
                isEdge: true,
                lists: [],
                class: "bottom-margin16"
            };
            this.matList = this.addLists(option);

            //费用信息
            option = {
                isEdge: true,
                lists: [],
                class: "bottom-margin16"
            };
            this.expenseList = this.addLists(option);
            this.expenseItem = new ListItem({
                variableHeight: true
            });
            this.expenseList.addChild(this.expenseItem);
            this.postButtom();

            this.connectEvent();
            option = {
                columns: [{
                    label: '确认收货',
                    className: 'flex2 footer-tab-highlight',
                    onClick: lang.hitch(this, this.setReceipteded)
                }],
                forceWidth: false,
                isFooter: true
            };
            this.receiptNode = this.addColumns(option);
            this.onAfterShow();
        },
        onPayOrder: function(payType) {
            window.busy(); //JSON.stringify([window.did]
            if(payType == "payByOther"){
                window.free();
                this.userToPay().then(lang.hitch(this,function(data){
                    if(data){
						alert("发送成功！");
                        var param = {};
                        param.receiverId = data._id;
                        param.content = (user.getUserData().pName||user.getUserData().pName || "未知")+"请求您帮其付款，付款金额" 
                        +this.payAmount+"元";
                        param.moveTo = "payToAnother";
                        param._id = window.did;
                        param.userName = data.userName;
                        param.taskType = 2;
                        order.findAnotherToPay(param);
                    } else {
						alert("发送失败！");
					}
                }));
            }else {
                this.getPayByIds({
                    _id: window.did,
                    payType: payType
                }).then(lang.hitch(this, function(data) {
                    window.free();
                    if (data && data.data && data.data.ok == 1) {
                        this.updatePacTeam(this.pacTeamId);
                        this.onAfterShow();
                    } else {
                        alert(data && data.data && data.data.msg);
                    }
                }));
            }
        },

        setReceipteded: function() {
            order.setReceipteded(window.did).then(lang.hitch(this, this.onAfterShow));
        },
        // 创建评价
        createMatEva: function() {
            if (!this.matEvaDiv) {
                // 创建一个商品评价对象
                this.matEva = new MatEva();
                this.matEvaDiv = domConstruct.create("div", {
                    style: "height:400px;"
                });
                this.matEvaDiv.appendChild(this.matEva.domNode);
            }
            this.showInOverlay(this.matEvaDiv);
            return this.matEva.showAuditOption();
        },

        // 提供支付接口
        getPayByIds: function(params) {
            return order.onPayed(params);
        },

        // 获得支付接口
        getPayTypeInfos: function() {
            return shop.getPayType();
        },

        // 提供收获接口
        getDetailReceipteded: function(id) {
            return order.setDetailReceipteded(id);
        },

        // 提供评价接口
        getEvaluedByDetailId: function(params) {
            return order.evaluedByDetailId(params);
        },
        // 绑定订单点击事件
        connectEvent: function() {
            this.connect(this.orderStateItem.domNode, "onclick", function(e) {
                var domCancel = e.target;
                if (domCancel && domClass.contains(domCancel, "edit-car-cancel")) {
                    this.cancelOrder();
                }
            });
            this.connect(this.matList.domNode, "onclick", lang.hitch(this, function(e) {
                var dom = e.target;
                if (dom && dom.tagName === "SPAN") {
                    var id = domAttr.get(dom.parentNode, "detailId");
                    if (domClass.contains(dom, "edit-car-delivery")) {
                        //收货
                        this.getDetailReceipteded(id).then(lang.hitch(this, function() {
                            this.onAfterShow();
                        }));
                    } else if (domClass.contains(dom, "edit-car-comment")) {
                        this.createMatEva().then(lang.hitch(this, function(evaldata) {
                            window.free();
                            if (evaldata) {
                                // 保存评价信息
                                if (id) {
                                    evaldata._id = id;                                    
                                    this.getEvaluedByDetailId(evaldata).then(lang.hitch(this, function(data) {
                                        if (data.data.ok === 1) {
                                            this.matEva.hideOverlay();
                                            this.onAfterShow();
                                        } else {
                                            alert("保存失败  " + data.data.msg);
                                        }
                                    }));
                                } else {
                                    alert("订单详情id不能为空");
                                }
                            }
                        }));
                    }
                } else if (dom && dom.tagName === "IMG") {
                    this.moveToMat(dom);
                    
                }
            }));
        },
        //跳转到商品详情
        moveToMat: function(dom){
            var id = domAttr.get(dom, "mId");
            window.moveToView("matDetail", id);
        },
        // 加载收获人信息
        getLoadDetailById: function() {
            return order.loadDetailById(window.did);
        },

        // 依据Id获得信息
        getLoadById: function() {
            return order.loadById(window.did);
        },
        // 加载数据,并显示到页面上
        onAfterShow: function() {
            if (this.matEva) {
                this.matEva.initData();
            }
            this.inherited(arguments);
            this.orderStateItem.set({
                label: "",
                rightText: ""
            });
            this.matList.destroyDescendants();
            this.expenseItem.set({
                label: "",
                rightText: ""
            });
            // 隐藏支付按钮
            domClass.add(this.bottDom, "none");
            domClass.add(this.receiptNode, "none");

            this.getLoadDetailById().then(lang.hitch(this, function(data) {
                var items = data && data.data && data.data.items || [];
                if (items.length) {
                    //更新收货人信息
                    this.orderStateItem.set({
                        label: "<div class='webkit-list'><div class='edit-car-dName'>收货人:" + (items[0].dName ? items[0].dName : "未知") + "</div><div class='edit-car-dTel'>" + (items[0].dTel ? items[0].dTel : "未知") + "</div></div>" + "<div class='immune-list'><div class='edit-car-dAddress'>收货地址：" + (items[0].dAddress ? items[0].dAddress : "未知") + "</div></div>"
                    });                    
                    for (var i = items.length - 1; i >= 0; i--) {
                        var listitem = new ListItem({
                            label: this.getDetailLabel(items[i]),
                            rightText: "<div class='edit-car-qtys'>x" + items[i].qty + "</div><div class='edit-car-subtotal'>小计:<span class='line-through'>￥" + window.fixedTo(items[i].price * items[i].qty, 3) + "</span>" + "<div style='text-align:right;'>￥" + window.fixedTo(items[i].amount, 3) + "</div></div>",
                            variableHeight: true
                        });
                        this.matList.addChild(listitem);
                    }
                }
            }));

            //加载订单信息
            this.getLoadById().then(lang.hitch(this, function(data) {
                if (data && data.data && data.data.ok == 1) {
                    this.pacTeamId = data.data.item.pacTeamId;
                    //若订单未支付且未取消
                    if (data.data.item.isPayed === false && data.data.item.isCanceled === false) {
                        //重算订单支付方案
                        order.generatePaymentSchemeById(window.did).then(lang.hitch(this, function(data) {
                            //加载订单信息
                            this.getLoadById().then(lang.hitch(this, function(data) {
                                //刷新订单显示
                                this.refreshView(data);
                            }));
                        }));
                    } else {
                        //刷新订单显示
                        this.refreshView(data);
                    }
                }
            }));
        },
        //收货和交易完成后时间转化
        checkNowDate: function(date, numDay) {
            var nowDate = new Date();
            date = new Date(date);
            return (nowDate.getTime() <= date.getTime() + numDay * 24 * 60 * 60 * 1000) ? true : false;
        },

        getDetailLabel: function(item) {
            var label = "<img class='edit-car-matimg' src='" + item.mId.logo + "' mId='" + item.mId._id + "' fromShopId='"+item.mId.fromShopId+"'/><span class='edit-car-matname'>" + item.mId.mName + "</span><span class='edit-car-matprice'>￥" + window.fixedTo(item.price, 3) + "</span>" + "<div class='forth-btn ' detailId='" + item._id + "'>";
            // 修复订单取消后也可以收货的问题
            // 收货已经调整为整单收货,隐藏明细中的收货按钮
            //if(item.isDelived===true&&item.isRefounded===false&&item.isCanceled==false&&item.isReceipted===false){
            //    label += "<span class='edit-car-delivery'>收货</span>";
            //} else
            if (item.isReceipted && !item.isCanceled) {
                label += "<span>已收货</span>";
            }
            if (item.isReceipted && !item.isCanceled && !item.isRefounded && !item.isEvaluated) {
                label += "<span class='edit-car-comment'>评论</span>";
            }
            if (item.isReceipted && !item.isCanceled && !item.isRefounded && item.isEvaluated) {
                label += "<span class=''>已评论</span>";
            }
            label += "</div>";
            return label;
        },
        //取消订单
        //提供取消订单接口
        getCancelOrder: function() {
            return order.onCancelAll(window.did);
        },
        cancelOrder: function() {
            this.getCancelOrder().then(lang.hitch(this, function(data) {
                if(this.pacTeamId){
                    this.changeTeamState(window.did).then(lang.hitch(this,function(){
                        this.onAfterShow();
                    }));
                }else {
                    this.onAfterShow();
                }
            }));
        },
        //刷新订单显示
        refreshView: function(data) {
            var item = this.orderItem = data.data.item;
            // 保留fromShopId   杜飞军 2016/10/17
            this.fromShopId = item.fromShopId;
            this.orderStateItem.set(
                "rightText", item.isCanceled ? "已取消" : item.isPayed ? "已支付" : "<div class='edit-car-cancel'>取消订单</div>"
            );
            //费用明细
            var dates = date.formatISODateMinutes(data.data.item.createAt);
            this.expenseItem.set({
                label: "<div class='edit-car-amount'>运费:</div>" + "<div class='edit-car-amount'>交易金额（含运费）:</div>" + "<div class='edit-car-amount'>积分/优惠券抵扣:</div>" + "<div class='edit-car-createAt'>创建时间:</div>",
                rightText: "<div class='edit-car-amount'>￥" + data.data.item.tAmount.toFixed(2) + "</div>" + "<div class='edit-car-amount'>￥" + data.data.item.amount.toFixed(2) + "</div>" + "<div class='edit-car-amount'>￥" + (data.data.item.couponAmount + data.data.item.point).toFixed(2) + "</div>" + "<div class='edit-car-createAt'>" + dates + "</div>"
            });
            // 更新应收金额，积分金额等
            query(".yf_font_detail", this.bottDom)[0].innerHTML = (data.data.item.amount - ((data.data.item.point + data.data.item.couponAmount) || 0)).toFixed(2);
            query(".jf_font_detail", this.bottDom)[0].innerHTML = (data.data.item.point + data.data.item.couponAmount).toFixed(2);

            this.getPayTypeInfos().then(lang.hitch(this, function(payTypes) {
                var payNodes = query(".edit-car-submit", this.bottDom);
                var payModes = [false, false, false];
                if (item.isPayed === false && item.isCanceled === false) {
                    this.payAmount = data.data.item.amount;
                    if ((data.data.item.amount - ((data.data.item.point + data.data.item.couponAmount) || 0)) <= 0) {
                        payModes[2] = true;
                    } else {
                        if (payTypes.payAli) {
                            payModes[0] = true;
                        }
                        if (payTypes.payWeiXin) {
                            payModes[1] = true;
                        }
						if (payTypes.payBocB2C) {
                            payModes[4] = true;
                        }
                    }
                    payNodes.forEach(function(node, index) {
                        //找人代付
                        if(index == 3){
                            domClass.remove(node,"none");
                        }else {
                            domClass[payModes[index] ? "remove" : "add"](node, "none");
                        }
                    });
                    domClass.remove(this.bottDom, "none");
                    this.resize();
                }
            }));

            // 状态都为false显示提交
            if (item.isPayed === true && item.isCanceled === false && item.isReceipted === false && item.isDelived === true) {
                domClass.remove(this.receiptNode, "none");
                this.resize();
            }
        },
        //支付按钮
        postButtom: function() {},
        //支付后修改拼团团队的状态
        updatePacTeam: function(data) {},
        changeTeamState: function(data){}
    });
});
