// 变更人员：母浚驰
// 变更时间：2016/5/18
// 变更内容：代码规范，添加注释，提交订单支付超时的提示
//--变更人：周超    变更时间2016-5-26  变更内容：消费者端优惠券的使用，部分提交代码的提出

// 变更人员：肖芳圆
// 变更时间：2016/6/28
// 变更内容：提交订单判断登陆

// 变更人员：徐阿雪
// 变更时间：2016/7/15
// 变更内容：验证是否已经下架，给出提示;有就显示运费，否则就无

// 变更人员：母浚驰
// 变更时间：2016/7/27
// 变更内容：换地址

// 变更人员：母浚驰
// 变更时间：2016/8/10
// 变更内容：换地址

// 变更人员：肖芳圆
// 变更时间：2016/8/10
// 变更内容：提供盐业重载的方法

// 变更人员：母浚驰
// 变更时间：2016/8/17
// 变更内容：优惠券信息

// 变更人员：母浚驰
// 变更时间：2016/10/26
// 变更内容：提交订单后不再弹出框 而是新的View
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/dom-attr",
    "dojo/Deferred",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "dojo/query",
    "dijit/focus",
    "dijit/_WidgetBase",
    "dojo/dom-construct",
    "dojox/mobile/ListItem",
    "cq/biz/article/mk/disCountSer",
    "cq/biz/mk/discount",
    "dojo/dom-style",
    "dijit/registry",
    "dojo/dom-class",
    "cq/util/sys/date",
    "cq/biz/shop/shop",
    "cq/biz/mat/mat",
    "cq/biz/ts/order",
    "cq/biz/ts/cart",
    "cq/biz/user/user"
],function(declare, lang, array, domAttr, Deferred, View, _ViewMixin, query,  focusUtil, _WidgetBase, domConstruct, ListItem, disCountSer, disCount, domStyle, registry, domClass, date, shopParam, mat, order, cart, user){
    var showInOverlay = null;
    //路径：
    //    widgets.mobile.OrderInfo
    //创建优惠券对象
    //创建优惠券对象
    var CouponListClass=declare("",[View,_ViewMixin],{
        //简介：
        //    优惠券对象：用于创建优惠券对象

        //coupName：String
        //    --用于获取coupName
        coupName:null,
        //coupId：String
        //    用于订单提交
        coupId:null,
        //getLists:
        //    --参数：data，类型：array
        //    --返回值:无
        //    --获取优惠券列表
        getLists:function(data){
            //销毁原优惠券列表
            this.couponsLists.destroyDescendants();
            //创建新优惠券列表
            var items=data.data.items;
            for (var i = 0; i<items.length; i++) {
                var startDate = items[i].startDate?date.formatISODate(items[i].startDate):"";
                var stopDate = items[i].stopDate?date.formatISODate(items[i].stopDate):"";
                var listitem=new ListItem({
                    label:"<div class='coupsSelected'>"
                    +"<div class='coupName couponShowList' style='display:none;'>"+items[i].title+"</div>"
                    +"<div class='couponShowList'><font class='price'>"+items[i].amount+"</font>元</div>"
                    +"<div class='couponShowList'>订单满"+items[i].reachAmount+"元使用</div>"
                    +'<div class="getCouponId" style="display: none;">'+items[i]._id+'</div>'
                    +"<div class='couponDtl-date couponShowList'>使用期限 "+startDate+"~"+stopDate+"</div>"
                    +"<button class='couponsBtn'>领用</button></div>",
                    variableHeight:true
                });
                this.couponsLists.addChild(listitem);
            }
        },
        //creatCoupons：
        //    --参数:无
        //    --返回值:无
        //    --初始化页面页面元素
        creatCoupons:function(){
            var option={
                class:'couponsLists',
                variableHeight:true,
                //宽度拉伸
                isEdge:true,
                lists:[]
            };
            //参数option：元素属性
            this.couponsLists=this.addLists(option);
        },
        //setCoupInfo：
        //    --参数：data，类型:Object
        //    --返回值:this.currentDef,等待释放,类型：Deferred
        //    --为优惠券列表附上数据
        setCoupInfo:function(data){
            this.currentDef = new Deferred();
            this.shopId = data.data.shopId;
            if(!this.couponsLists){
                //this.startup();
                //初始化界面元素
                this.creatCoupons();
                this.domNode.appendChild(this.couponsLists.domNode);
                this.connectEve();
            }
            //创建优惠券列表
            this.getLists(data);
            this.resize();
            return this.currentDef;
        },
        //connectEve:
        //    --参数：无
        //    --返回值:无
        //    --为优惠券列表添加点击事件
        connectEve:function(){
            this.connect(this.couponsLists.containerNode,"onclick",this.couponsListClick);
        },
        //getSuccess：
        //    --参数：无
        //    --返回值:无
        //    --点击确定，使用优惠券
        getSuccess:function(){
            var id=this.coupId;
            var name=this.coupName;
            var partInfo={id:id,name:name};
            disCount.getCouponByUserSelf({_id:id,shopId:this.shopId}).then(lang.hitch(this,function(data){
                if(data&&data.data.ok == 1){
                    alert("您领取了"+name+"的优惠券");
                    this.couponFinished();
                }else{
                    var msg = data.data.message||"优惠券完了";
                    alert(msg);
                }
            }));
            //释放defer
            this.currentDef.resolve(partInfo);
        },
        couponFinished:function(){},
        //couponsListClick：
        //    --参数：e，类型
        //    --返回值
        //    --点击列表：改变样式，获取id
        couponsListClick:function(e){
            if(e.target.className.indexOf("couponsBtn")>=0){
                //设置选中
                domClass.add(e.target.parentNode, "selected");
                array.forEach(query(".couponsBtn",this.domNode),function(node){
                    domStyle.set(node, 'backgroundColor', 'rgba(255, 255, 255, 0.2)');
                },this);
                //变更样式
                domStyle.set(e.target, 'backgroundColor', '#FF2100');
                //获取选中Id，Name
                this.getCoupInfo(e);
                this.getSuccess();
            }
        },
        //获取数据
        //    参数：e，鼠标点击事件，类型：MouseEvent
        //    返回值：无
        //    获取当前选中的节点的部分信息
        getCoupInfo:function(e){
            //获取名称/类型
            this.coupName=query(".coupName",e.target.parentNode)[0].innerText;
            //获取ID
            this.coupId=query(".getCouponId",e.target.parentNode)[0].innerText;
        },
        //clearState：
        //    参数:无
        //    返回值：无
        //    清除选中状态
        clearState : function () {
            var items = query('.couponsBtn', this.domNode);
            array.forEach(items,function(node){
                domStyle.set(node, 'backgroundColor', 'rgba(255, 255, 255, 0.2)');
            },this);
        }
    });

    var CouponOrderListClass=declare("",[View,_ViewMixin],{
        //简介：
        //    优惠券对象：用于创建优惠券对象

        //coupName：String
        //    --用于获取coupName
        coupName:null,
        //coupId：String
        //    用于订单提交
        coupId:null,
        //getLists:
        //    --参数：data，类型：array
        //    --返回值:无
        //    --获取优惠券列表
        getLists:function(data){
            //销毁原优惠券列表
            this.couponsOrderLists.destroyDescendants();
            //创建新优惠券列表
            var items=data;
            for (var i = 0; i<items.length; i++) {
                var startDate = items[i].startDate?date.formatISODate(items[i].startDate):"";
                var stopDate = items[i].stopDate?date.formatISODate(items[i].stopDate):"";
                var listitem=new ListItem({
                    label:"<div class='coupsSelected'>"
                    +"<div class='coupName couponShowList' style='display:none;'>"+items[i].title+"</div>"
                    +"<div class='couponShowList'><font class='price'>"+items[i].amount+"</font>元</div>"
                    +"<div class='couponShowList'>订单满"+items[i].reachAmount+"元使用</div>"
                    +'<div class="getCouponId" style="display: none;">'+items[i]._id+'</div>'
                    +"<div class='couponDtl-date couponShowList'>使用期限 "+startDate+"~"+stopDate+"</div>"
                    +"<button class='couponsOrderBtn'>使用</button></div>",
                    variableHeight:true
                });
                this.couponsOrderLists.addChild(listitem);
            }
        },
        //creatCoupons：
        //    --参数:无
        //    --返回值:无
        //    --初始化页面页面元素
        creatCoupons:function(){
            var option={
                class:'couponsOrderLists',
                variableHeight:true,
                //宽度拉伸
                isEdge:true,
                lists:[]
            };
            //参数option：元素属性
            this.couponsOrderLists=this.addLists(option);
            option = {
                columns : [{
                    label : '不选择',
                    className : 'flex2 footer-tab-dark getCancel',
                    onClick :lang.hitch(this,function () {
                        this.currentOrderDef.resolve({});
                        this.clearState();
                        this.hideOverlay();
                    })
                }],
                className:"bottom-margin8 downButton",
                labelClass:'',
                valueClass:'',
                isFooter : true
            };
            this.downButton = this.addColumns(option);
            this.setWidth();
        },
        setWidth:function(domNodeInfo){
            var target=query(".getCancel",this.domNode)[0];
            domStyle.set(target,'width',"100%");
        },
        //setCoupInfo：
        //    --参数：data，类型:Object
        //    --返回值:this.currentDef,等待释放,类型：Deferred
        //    --为优惠券列表附上数据
        setCoupInfo:function(data,shopId){
            this.currentOrderDef = new Deferred();
            if(!this.couponsOrderLists){
                this.startup();
                //初始化界面元素
                this.creatCoupons();

                this.connectEve();
            }
            this.getLists(data);
            return this.currentOrderDef;
        },
        //connectEve:
        //    --参数：无
        //    --返回值:无
        //    --为优惠券列表添加点击事件
        connectEve:function(){
            this.connect(this.couponsOrderLists.containerNode,"onclick",this.couponsOrderListClick);
        },
        //getSuccess：
        //    --参数：无
        //    --返回值:无
        //    --点击确定，使用优惠券
        getSuccess:function(){
            var id=this.coupId;
            var name=this.coupName;
            var price = this.coupPrice;
            var partInfo={id:id,name:name,price:price};
            //释放defer
            this.currentOrderDef.resolve(partInfo);
            //清除选中
            this.clearState();
            this.hideOverlay();
        },
        //couponsListClick：
        //    --参数：e，类型
        //    --返回值
        //    --点击列表：改变样式，获取id
        couponsOrderListClick:function(e){
            if(e.target.className.indexOf("couponsOrderBtn")>=0){
                //设置选中
                domClass.add(e.target.parentNode, "selected");
                array.forEach(query(".couponsOrderBtn",this.domNode),function(node){
                    domStyle.set(node, 'backgroundColor', 'rgba(255, 255, 255, 0.2)');
                },this);
                //变更样式
                domStyle.set(e.target, 'backgroundColor', '#FF2100');
                //获取选中Id，Name
                this.getCoupInfo(e);
                this.getSuccess();
            }
        },
        //获取数据
        //    参数：e，鼠标点击事件，类型：MouseEvent
        //    返回值：无
        //    获取当前选中的节点的部分信息
        getCoupInfo:function(e){
            //获取名称/类型
            this.coupName=query(".coupName",e.target.parentNode)[0].innerText;
            //获取抵用金额
            this.coupPrice=query(".price",e.target.parentNode)[0].innerText;
            //获取ID
            this.coupId=query(".getCouponId",e.target.parentNode)[0].innerText;
        },
        //clearState：
        //    参数:无
        //    返回值：无
        //    清除选中状态
        clearState : function () {
            var items = query('.couponsOrderBtn', this.domNode);
            //var items=this.getData().coupsSelected;
            array.forEach(items,function(node){
                domStyle.set(node, 'backgroundColor', 'rgba(255, 255, 255, 0.2)');
            },this);
        }
    });
    // 定义显示列表对象
    var OrderListItem = declare("", [_WidgetBase], {
        details:[],
        orderStatus:"",
        params:null,
        mAmount:0,
        amount:0,
        tAmount:0,
        shopName:"",
        shopId:"",
        coupons:[],
        buildRendering:function(){
            this.inherited(arguments);
            var countQty = 0,couponsDiv="";
            domClass.add(this.domNode,"order-list-item");
            //创建订单状态栏
            domConstruct.create("div",{
                "class": "order-list-status",
                innerHTML: "<span class='date'>"+this.shopName+"</span>"
                + "<span class='date getCouponsList' style='float:right;margin-right: 2%;'>领券</span>"
                +"<span class='date shopId' style='display:none;'>"+this.shopId+"</span>"
            },this.domNode);
            this.detailList = domConstruct.create("div",{
                "class":"order-detail-list"
            },this.domNode);
            array.forEach(this.details,function (detail){
                countQty += detail.qty;
                this.detailList.appendChild(this.createDetails(detail));
            },this);
            domConstruct.create("div",{
                "class":"order-list-count",
                innerHTML:"<span class='qty'>共"+countQty+"件商品</span>"+
                    "<span class='count'>合计:<i>￥"+window.fixedTo(this.amount,3)+"</i></span>"+
                    "<span class='tAmount'>（运费：￥"+window.fixedTo(this.tAmount,3)+"）</span>"
            },this.domNode);
            if(this.coupons.length>0){
                this.coupons = this.getCouponsAmount(this.coupons);
                var startDate = this.coupons[0].startDate?date.formatISODate(this.coupons[0].startDate):"";
                var stopDate = this.coupons[0].stopDate?date.formatISODate(this.coupons[0].stopDate):"";
                domConstruct.create("div",{
                    "class":"coupon-detail-list couponOrder",
                    innerHTML:"<span style='float:left;margin-top: 6px;'>店铺优惠</span>"
                    +"<div class='couponOrder coupsSelected' style='text-align:right;line-height: 29px;'>"
                    +"<span class='couponOrderShow'>省<span class='couponsAmount' style='color: #D35D13!important;'>"
                    + this.coupons[0].amount +"</span>元："
                    +"<span class='couponsTitle'>"+this.coupons[0].title+"</span></span>"
                    +"<div class='mblListItemRightIcon' style='margin:0;'>"
                    +"<div title='' class='mblDomButtonArrow mblDomButton'>"
                    +"<div class='moveToColor'></div></div></div></div>"
                    +"<span class='coupsId' style='display:none;'>"+this.coupons[0]._id+"</span>"
                    +"<span class='coupsShopId' style='display:none;'>"+this.shopId+"</span>"
                },this.domNode);
                if(!this.couponsListClick){
                    this.couponsListClick = this.connect(query(".couponOrder",this.domNode)[0],"onclick",this.createCouponsOrderList);
                }
            }
        },//添加运费信息，style.css新建tAmount样式   2016/7/8 徐阿雪
        //创建订单详情的列表
        createDetails:function(data){
            var htmlStr = "";
            htmlStr+='<li class="order-detail-item">';
            htmlStr+=    '<img alt="" src="'+data.mId.logo+'" class="icon" style="margin-top: 1px;">';
            htmlStr+=    '<div class="right" style="display: block;">';
            htmlStr+=       '<div class="shelf-mat-title">'+data.mId.mName+'</div>';  //'<div class="mname">'+data.mId.mName+'</div>'
            htmlStr+=        '<div><span class="price">￥'+window.fixedTo(data.price,3)+'</span>'+(data.price==data.retailPrice?'':'<del style="margin-left:5px;">￥'+window.fixedTo(data.retailPrice,3)+'</del>')+'<span class="qty">x'+data.qty+'</span></div>';
            htmlStr+=    '</div>';
            htmlStr+='</li>';
            return domConstruct.toDom(htmlStr);
        },
        getCouponsAmount:function(datas){
            var i = datas.length, j;
            var tempExchangVal;
            while (i > 0) {
                for (j = 0; j < i - 1; j++) {
                    if (datas[j].amount < datas[j + 1].amount) {
                        tempExchangVal = datas[j];
                        datas[j] = datas[j + 1];
                        datas[j + 1] = tempExchangVal;
                    }
                }
                i--;
            }
            return datas;
        },
        showOrderCoupons:function(data){
            //创建对象
            if(!this.couponsOrder){
                this.couponsOrder =domConstruct.create("div", {
                    className : "shareAll",
                    style : "height:584px"
                });
                var obj = this.couponsOrderObj = new CouponOrderListClass();
                this.couponsOrder.appendChild(obj.domNode);
            }
            var def = this.couponsOrderObj.setCoupInfo(data);
            //显示弹出框
            showInOverlay(this.couponsOrder);
            return def;
        },
        createCouponsOrderList:function(e){
            var dom = e.target;
            this.showOrderCoupons(this.coupons).then(lang.hitch(this,function(data){
                if(data&&data.id){
                    domStyle.set(query(".couponOrderShow",this.domNode)[0],"display","inline-block");
                    query(".coupsId",this.domNode)[0].innerHTML = data.id;
                    query(".coupsShopId",this.domNode)[0].innerHTML = this.shopId;
                    query(".couponsAmount",this.domNode)[0].innerHTML = data.price;
                    query(".couponsTitle",this.domNode)[0].innerHTML = data.name;
                    // localStorage.set("couponsAmount",JSON.stringify({
                        // couponsAmount:data.price,
                        // couponsTitle:data.name,
                        // coupsId:data.id
                    // }));
                }else{
                    query(".coupsId",this.domNode)[0].innerHTML = null;
                    domStyle.set(query(".couponOrderShow",this.domNode)[0],"display","none");
                    query(".coupsShopId",this.domNode)[0].innerHTML = this.shopId;
                }
            }));
        },
    });

    return declare("cq.ui.common.t.OrderInfo",[View,_ViewMixin],{
        // isEditing：Boolean
        //    --设置编辑状态
        isEditing : false,
        //优惠券可以使用
        couponsListOk : true,
        coupsId:null,
        coupsName:null,
        couponsId:{},
        payTypes : {
            payDeposit : "point",
            payCredit : "credit",
            payWeiXin : "weixin",
            payAli : "aliwap"
        },
        // 选中的商品
        mats:{},
        // 加载数据
        loading : true,
        //showCoupons：
        //    --参数：data，类型：array
        //    --返回值：obj.setCoupInfo(data)，类型：Deferred
        //    --点击选择优惠券，弹出优惠券弹列表框
        showCoupons:function(data){
            //创建对象
            if(!this.coupons){
                this.coupons = new CouponListClass();
                this.connect(this.coupons,"couponFinished",this.loadMatsInfo);
            }

            var obj = this.coupons;
            var div = domConstruct.create("div", {
                className : "shareAll",
                style : "min-height:100px"
            });
            div.appendChild(obj.domNode);

            var def = obj.setCoupInfo(data);
            //显示弹出框
            this.showInOverlay(div);
            return def;

        },
        //refreshByAddrAndCoupon:
        //    --参数：data，数据储源，类型：object
        //    --返回值:无
        //    --刷新优惠券和编辑信息
        refreshByAddrAndCoupon:function(data){
            //赋值数据
            this.setData(data);
            //刷新数据
            this.refreshData();
        },
        // 加载数据,并显示到页面上
        onAfterShow:function(){
            if(!this.isEditing){
                this.isEditing = true;
                this.refreshOrderInfo();
            }
        },
        refreshOrderInfo:function(){
            this.getDefaultAddr();
            this.loadMatsInfo();
        },
        /*//没有上架的cart加载
        getmids:function(){
            var mids = [],
            selectedCart = cart.getSelectedChart();
            for (var mid in selectedCart) {
                if (selectedCart.hasOwnProperty(mid)) {
                    if(window.did){
                        mids.push({
                            mid : mid,
                            qty : selectedCart[mid],
                            pacTeamId : window.did
                        });
                    }else {
                        mids.push({
                            mid : mid,
                            qty : selectedCart[mid]
                        });
                    }
                    
                }
            }
            return mids;
        },*/
        // 加载数据
        loadMatsInfo:function(){
            this.carIds=cart.getSelected();
            //储存计算合计的商品信息{mid:matInfo}
            this.mats={};
            //储存计算合计的运费信息{shopid:tranFees}
            this.tranFees = {};
            var mids = [],
            selectedCart = cart.getSelectedChart();
            for (var mid in selectedCart) {
                if (selectedCart.hasOwnProperty(mid)) {
                    if(window.did){
                        mids.push({
                            mid : mid,
                            qty : selectedCart[mid],
                            pacTeamId : window.did
                        });
                    }else {
                        mids.push({
                            mid : mid,
                            qty : selectedCart[mid]
                        });
                    }
                    
                }
            }
            this.selectedMatArray = mids;
            //商品
            this.matList.destroyDescendants();
            if(this.carIds.length>0){
                this.loadMatsByIds(this.carIds).then(lang.hitch(this,function(data){
                    var items=data.data.items;
                    //获取商铺数据
                    this.orderCouponsMids = mids;
                    var params = {};
                    params.mids = mids;
                    this.loadTranFee(params).then(lang.hitch(this,function(tData){
                        if(tData && tData.data&&tData.data.ok){
                            var shopMatHash = {};
                            var shopHash = this.shopHash = tData.data.item,shop = null;
                            array.forEach(items, function (item,index) {
                                if(!shopMatHash[item.fromShopId]){
                                    shopMatHash[item.fromShopId] = [];
                                }
                                shopMatHash[item.fromShopId].push({
                                    retailPrice:item.retailPrice,
                                    //取服务器返回的价格
                                    price : shopHash[item.fromShopId].matInfo[item._id].price,
                                    qty:selectedCart[item._id],
                                    mId:item
                                });
                                this.mats[item._id] = {
                                    retailPrice:shopHash[item.fromShopId].matInfo[item._id].price||item.retailPrice,
                                    qty:selectedCart[item._id]
                                };
                            }, this);
                            for(var shopId in shopHash){
                                shop = shopHash[shopId];
                                this.tranFees[shopId] = shop.tAmount||0;

                                if(tData.data.item[shopId].coupons&&tData.data.item[shopId].coupons.length>0){
                                    this.makeOrderList(shopMatHash,shop,shopId,tData.data.item[shopId].coupons);
                                    //this.addCouponsList(tData.data.item[shopId].coupons,shopId);
                                }else{
                                    this.makeOrderList(shopMatHash,shop,shopId);
                                }
                            }
                        }else{
                            alert(tData.data.msg||"商品未找到");
                            history.back();
                            this.isEditing = false;
                        }
                        this.refreshFooter(this.countCart());
                    }));
                }));
            }
        },
        // 初始化页面元素,绑定事件
        onFirstShow : function() {
            showInOverlay = lang.hitch(this.showInOverlay);
            this.setData({});
            var option = {
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick : function() {
                        history.back();
                        this.isEditing=false;
                    }
                },
                title:"订单提交"
            };
            this.addHeader(option);
            option = {
                class: "defaultAddr",
                isEdge : true,
                lists : []
            };
            this.defaultAddr = this.addLists(option);

            /* option = {
                class: "bottom-margin16",
                isEdge : true,
                lists : [{
                    label:'收货人',
                    noArrow:true,
                    edit:{
                        type:'text',
                        field:'pName'
                    }
                },{
                    label:'联系电话',
                    noArrow:true,
                    edit:{
                        type:'text',
                        field:'phone'
                    }
                },{
                    label:'收货地址',
                    noArrow:true,
                    edit:{
                        type:'text',
                        field:'address'
                    }
                }]
            };
            this.defaultBuyer = this.addLists(option); */

            option = {
                class: "defaultAddr",
                isEdge : true,
                lists : [{
                    label:'买家留言',
                    noArrow:true,
                    edit:{
                        type:'text',
                        placeHolder:'请填写您的详细要求',
                        field:'remark'
                    }
                }]
            };
            this.defaultRemark = this.addLists(option);

            option={
                variableHeight:true,
                isEdge:true/*宽度拉伸*/,
                lists:[]
            };
            this.matList=this.addLists(option);

            option={
                columns:[{
                    label:"<div class='countBox'>合计:<span class='footerAmt count'>￥0.00</span></div><span class='edit-car-alert footerTranFees'>含运费</span>",
                    className:"edit-car-count flex1"
                },{
                    label:"<span class='amout'>提交订单</span>",
                    className:"edit-car-submit",
                    onClick: function(){
                        user.hasLogin().then(lang.hitch(this, function (s) {
                            if (s) {
                                this.onSaveStore();
                            } else {
                                window.moveToView("login");
                                user.nextPage="orderInfo";
                            }
                        }));
                    }
                }],
                className:'fix-footer edit-car-footer',
                forceWidth:false,
                isFooter:true
            };
            this.addColumns(option);
            this.connectAddrEve();
            this.onAfterShow();
        },
        // 收货信息
        addDefaultAddr:function(data){
            this.defaultAddr.destroyDescendants();
        },
        //创建订单的商品信息
        makeOrderList:function(shopMatHash,shop,shopId,coupons){
            if(coupons){
                this.matList.addChild(new OrderListItem({
                    details:shopMatHash[shopId],
                    amount:shop.totalPrice+shop.tAmount,
                    tAmount:shop.tAmount,
                    shopName:shop.shopInfo&&shop.shopInfo.shopName||"",
                    shopId:shopId,
                    coupons:coupons
                }));
            }else {
                this.matList.addChild(new OrderListItem({
                    details:shopMatHash[shopId],
                    amount:shop.totalPrice+shop.tAmount,
                    tAmount:shop.tAmount,
                    shopName:shop.shopInfo&&shop.shopInfo.shopName||"",
                    shopId:shopId
                }));
            }
            if(window.did){
                domStyle.set(query(".getCouponsList",this.domNode)[0],"display","none");
            }
        },
        // 计算合计
        countCart:function(mats){
            mats = mats||this.mats;
            var qty = 0;
            var totalPrice = 0;
            var tranFees = 0
            //商品价格合计
            for(var item in mats){
                qty+=mats[item].qty;
                totalPrice+=mats[item].retailPrice*mats[item].qty;
            }
            //运费合计
            for(var shopId in this.tranFees){
                tranFees += this.tranFees[shopId]||0;
            }
            totalPrice += tranFees;
            return {
                qty : qty,
                totalPrice : window.fixedTo(totalPrice,3),
                tranFeesTotal :  window.fixedTo(tranFees,3)
            };
        },
        connectAddrEve:function(){},
        // 刷新底部
        refreshFooter:function(info){
            var count=query(".footerAmt",this.domNode)[0];
            var tranFeesTotal = query(".footerTranFees", this.domNode)[0];
            count.innerHTML="￥"+info.totalPrice;
            tranFeesTotal.innerHTML = "含运费￥" + info.tranFeesTotal;
        },
        //orders = {shopId:{order}};
        showPayType : function (orders) {
            this.payTypeSelectors();
            
            this.payTypeSelector.startSelecte(orders);
        },

        //获取商家优惠券
        getValidDisSer:function(params){
            var def = new Deferred();

            return def.resolve({});;
        },
        
        getPayTypeInfos:function(){
            return shopParam.getPayType();
        },
        
        //将分钟数转换为时间格式
        //    输入：80——分钟数
        //    输出：1小时20分钟
        minuteToTimeString:function(minutes){
            var minute = minutes%60;
            minutes = parseInt(minutes/60);
            var hour = minutes%24;
            var day = parseInt(minutes/24);
            var timeStr = "";
            if(day){
                timeStr += ""+day+"天";
            }
            if(hour){
                timeStr += ""+hour+"小时";
            }
            if(minute){
                timeStr += ""+minute+"分钟";
            }
            return timeStr;
        },
        //加载购物车中商品
        loadMatsByIds:function(mids){
            return mat.loadByIds(mids);
        },
        //加载本次的运费
        loadTranFee:function(mids){
            return order.getTAmount(mids);
        },
        //提交订单
        postOrder:function(orderInfo){
            return order.createDistributionOrder(orderInfo);
        },
        //支付订单——一组订单
        onPayOrder:function(orderInfo){
            return order.onPayedByIds(orderInfo);
        },
        //获取地址
        getDefaultAddr:function(){
            user.getDefaultAddr().then(lang.hitch(this,function(data){
                this.coupsId=null;
                this.coupsName=null;
                this.refreshByAddrAndCoupon(data);
            }));
        },
        //设置默认地址
        setDefaultAddr:function(data){
            user.setDefaultAddr({
                pName:data.pName,
                phone:data.phone,
                address:data.address
            });
        },
        // 创建订单
        onSaveStore : function() {
            window.busy();
            var userInfo = this.getData(),
            m = {
                dName : userInfo.pName,
                dTel : userInfo.phone,
                dAddress : userInfo.address
            };
            //保存地址
            this.setDefaultAddr(userInfo);
            //添加优惠券ID
            var coupsIds = query(".coupsId",this.domNode);
            m.coupon = {};
            array.forEach(coupsIds,function(node){
                this.coupsId = node.innerHTML;
                var shopId = node.nextSibling.innerHTML;
                this.couponsId[shopId] = this.coupsId;
                if(this.coupsId){
                    m.coupon[shopId] = this.couponsId[shopId];
                }
            },this);
            if(window.did){
                m.pacTeamId = window.did;
            }
            m.userId = user.userId;
            m.mids = this.selectedMatArray;
            var msg=this.verify(m);
            if(msg){
                alert(msg);
                window.free();
                return;
            }
            this.postOrder(m).then(lang.hitch(this,function(result){
                window.free();
                //判断是否下架
                if(result.data.ok == 0){
                    alert(result.data.msg);
                }else{
                    var shopIds = [];
                    for (var shop in result.data.item) {
                        shopIds.push(shop);
                    }
                    this.shopsIds = 0;
                    this.couponsListMsg(shopIds,result);
                    var shopId = shopIds[0];
                    this.updatePacMember(result.data.item[shopId]);
                    
                }
            }));
        },
        //拼团团队
        updatePacMember:function(result){},
        updatePacTeam:function(did){},

        couponsListMsg:function(shop,result){
            shopParam.loadById(shop[this.shopsIds]).then(lang.hitch(this,function(data){
                var msg = "";
                if(data&&data.data&&data.data.shopName){
                    var shopId = data.data._id;
                    if (result.data.item.hasOwnProperty(shopId)) {
                        if(result.data.item[shopId]&&result.data.item[shopId].msg){
                            msg = data.data.shopName + result.data.item[shopId].msg.message|| "优惠券已锁定";
                            delete(result.data.item[shopId]);
                            alert(msg);
                            window.moveToView("orderList-4");
                        }else{
                            cart.clear(cart.getSelected());
                            cart.setSelected([]);
                            this.shopsIds++;
                            if(this.shopsIds<shop.length){
                                this.couponsListMsg(shop,result);
                            }else{//订单创建成功后弹出支付选择框
                                this.showPayType(result.data.item);
                            }
                        }
                    }
                }
            }));
        },

        verify:function(data){
            var msg="";
            if(!data.dName){
                msg="收货人还没有填写";
            }
            if(!data.dTel){
                msg="联系电话还没有填写";
            }
            if(!data.dAddress){
                msg="收货地址还没有填写";
            }
            return msg;
        }
    });
});
