﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang"
],function(declare,lang,View,FixedSplitter,Pane){
    return declare("cq.ui.view.ViewUtil",null,{
        constructor:function(param){
            this.EditorClass = param.EditorClass;
        },
        EditorClass:null,
        startEdit : function(param, refView) {
          if (!this.editorView) {
            this.editorView = new this.EditorClass();
            this.editorView.placeAt(refView.domNode, "after");
            this.editorView.startup();
          } else {
            this.editorView.placeAt(refView.domNode, "after");
          }
          var def = this.editorView.startEdit.apply(this.editorView,arguments);
          def.then(lang.hitch(this,function(){
              if(this.editorView.domNode.parentNode){
                  this.editorView.domNode.parentNode.removeChild(this.editorView.domNode);
              }
          }));
          return def;
        }
    });
});