﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/dom-style",
    "dojo/dom-construct",
    "dojox/mobile/SpinWheelDatePicker",
    "cq/ui/view/EditorBase",
    "cq/ui/view/ViewUtil"
],function(declare,lang,array,domStyle,domConstruct,SpinWheelDatePicker,EditorBase,ViewUtil){
    var DatePicker = declare("",EditorBase,{
        getValue:function(){
            return this.spinWheel&&this.spinWheel.get("value");
        },
        setOrigin:function(text){
            if(text&&this.spinWheel){
                this.spinWheel.set("values",array.map(text.split("-"),function(value){
                    return value-0;
                }));
            }
        },
        startEdit:function(text){
            if(text&&-1<text.indexOf("T")){
                arguments[0] = (new Date(text)).toLocaleDateString().split("/").join("-");
            }
            var def = this.inherited(arguments);
            if(!this.spinWheel){
                this.spinWheel = new SpinWheelDatePicker();
                this.spinWheel.placeAt(this.contentPane.domNode,"first");
                this.spinWheel.startup();
                domStyle.set(this.spinWheel.domNode, {"margin-left":"auto","margin-right":"auto"});
                //domStyle.set(this.spinWheel.domNode.parentNode, {"background-color":"white"});
                this.setOrigin(this.orginValue);
            }
            return def;
        }
    });
    var editor = new ViewUtil({
        EditorClass:DatePicker
    });
    lang.setObject("cq.util.edit.datePick",editor);
    return editor;
});