﻿//创建人：张金鹏
//创建时间：2016/07/13
//创建功能：直播和讨论中的一条信息
define([
    "dojo/_base/declare",
	"dojo/dom-construct",
    "dijit/_Widget",
    "cq/util/sys/date"
],function(declare,domConstruct,_Widget,date){
	//消息组件的功能
    return declare("cq.widgets.item.LiveListItem",_Widget,{
        baseClass:"liveMsg",
		//讨论区和直播室中消息数据项
		params:null,
		//初始化界面元素
        buildRendering:function(){
			this.inherited(arguments);
			this.domNode.innerHTML = "<div class='authorHeader hflex "+ (this.params.isHost?"reverse":"") + "'>" +
				//发布日期
				"<span class='sendTime'>"+ date.formatISODateMinutes(this.params.sendTime) + "</span>" +
				//昵称
                "<span class='authorNick'>" + (
					this.params.sendNick||(
						this.params.isHost?"主持人":"游客"
					)
				) + "</span>"+
                //头像
                "<img class='authorLogo' src='" + (
					this.params.sendLogo?this.params.sendLogo:"http://www.cqthink.com/image/defaultUser.jpg"
				) + "'/>" +
                "</div>" +
                //消息的内容
                "<div class='richText'>" + (
					this.params.msgType ? "<img src='" + this.params.msgImage + "'>" : this.params.msgText
				) + "</div>";
        }
    });
});
/*
define([
    "dojo/_base/declare",
    "dojox/mobile/ListItem",
    "../../util/sys/date"
],function(declare,ListItem,date){
    return declare("cq.widgets.item.LiveListItem",ListItem,{
        variableHeight:true,
        buildRendering:function(){
            this.inherited(arguments);
            if(this.params.isHost){
                this.label = "<div class='authorHeader'>" +
                    "<img class='authorLogo' src='" + (this.params.sendLogo || "images/userIcon.png") + "'/>" +
                    "<span class='authorNick'>" + (this.params.sendNick || "主持人" ) + "</span>" +
                    "<span class='sendTime'>" + date.formatISODateMinutes(this.params.sendTime) + "</span>" +
                    "</div>" +
                    "<div class='richText'>" +
                    (this.params.msgImage ? "<img src='" + this.params.msgImage + "'>" : "") +
                    (this.params.msgText || "") +
                    "</div>";
            }else{
                this.label = "<div class='authorHeader'>" +
                    //日期在左侧
                    "<span class='sendTime' style='float:left;'>" + date.formatISODateMinutes(this.params.sendTime) + "</span>" +
                    "<img class='authorLogo' src='" + (this.params.sendLogo || "images/userIcon.png") + "' style='float:right;'/>" +
                    "<span class='authorNick' style='float:right;'>" + (this.params.sendNick || "匿名用户") + "</span>" +
                    "</div>" +
                    "<div class='richText' style='text-align:right;'>" +
                    (this.params.msgImage ? "<img src='" + this.params.msgImage + "'>" : "") +
                    (this.params.msgText || "") +
                    "</div>";
            }
        }
    });
});*/