//创建人：张金鹏
//创建时间：2016/07/13
//创建功能：客服一对一聊天时消息列表中的一条信息
define([
    "dojo/_base/declare",
	"dojo/dom-construct",
    "dijit/_Widget",
	"cq/util/sys/date"
],function(declare,domConstruct,_Widget,date){
	//消息组件的功能
    return declare("cq.widgets.item.TalkListItem",_Widget,{
		//客服一对一聊天时的消息数据项
        baseClass : 'talkItem liveMsg',
		params:null,
		//初始化界面元素
        buildRendering:function(){
			this.inherited(arguments);
            //按照文本和图片来分别来处理html片段
            
			this.domNode.innerHTML = 
				//发布日期
				"<div class='sendTime'>"+ date.formatISODateMinutes(this.params.createAt) + "</div>" +
                "<div class='msgNode hflex "+ (this.params.isHost?"reverse":"") + "'>" +
                "<div class='msgHeader'>"+
                //头像
                "<img class='senderLogo' src='" + (
					this.params.senderId.logo?this.params.senderId.logo:"http://www.cqthink.com/image/defaultUser.jpg"
				) + "'/>" +
				//昵称
                "<span class='senderNick'>" + (
					this.params.senderId.pName||this.params.senderId.nickName||this.params.senderId.wxNick||""
				) + "</span>"+
                "</div>" +
                //消息的内容
                "<div class='msgBody'><div class='msgContent'>" + (
					"image"==this.params.msgType ? "<img src='" + this.params.msgContent + "'>" : this.params.msgContent
				) + "</div></div>"+
                "</div>";
            
            /*if(this.params.isHost==this.params.senderId){
                this.domNode.innerHTML += "<div class='righttd'><div class='chartTime'><label class='chartTimeLabel'>"+this.params.createAt+"</label></div>"
                +"<div><div class='userRightPic'><div class='chartNameLabel'>"+"<img src='" + (this.params.sendLogo?this.params.sendLogo:'http://www.cqthink.com/image/defaultUser.jpg') + "'></div></div></div>"
                +"<div class='speech right'>"+(this.params.msgType=="image"?"<img src='" + this.params.msgContent + "'>":this.params.msgContent) +"</div>";
            }else{
                this.domNode.innerHTML += "<div class='lefttd'><div class='chartTime'><label class='chartTimeLabel'>"+this.params.createAt+"</label></div>"
                +"<div><div class='userLeftPic'><div class='chartNameLabel'>"+"<img src='"+ (this.params.sendLogo?this.params.sendLogo:'http://www.cqthink.com/image/defaultUser.jpg') + "'></div></div></div>"
                +"<div class='speech left'>"+(this.params.msgType=="image"?"<img src='" + this.params.msgContent + "'>":this.params.msgContent) +"</div>";
            }*/
        }
    });
});