﻿//特性：
//  view嵌套
//  view布局配置完全独立
//  无需为每个view写一个程序
//  支持view和内部widget联动
//  支持view内部widget之间联动
//  支持纯静态内容定义
//所有程序全部写到这个文件中，需要时将各个对象单独分离
require([
    "dojo/ready",
], function(ready) {
    require([
        "dojo/_base/lang",
        "cq/biz/user/user",
        "cq/app/config",
        "cq/app/builder/mobileBuilder",
        "cq/app/layout/loader/memoryLayoutLoader",
        "cq/app/view/view/FullScreenWeb",
        "cq/util/config/config",
        "cq/app/layout/mobile/layout",
        "cq/app/layout/mobile/programLayout",
        "cq/app/layout/mobile/testLayout",
        "dojo/dom-construct"
    ], function(lang, user, config, mobileBuilder, memoryLayoutLoader, View, config2,layout,programLayout,testLayout,domConstruct) {
        config2.dataOrigin = config2.dataOrigin||"http://192.168.0.2";
        config2.shopId = config2.platformShopId = config2.platformShopId||"573817a98f9ca8d447bfdff3";
        config2.defaltTranRegion = {
            provinceId:"57a936a0e026905d4c92f647",
            cityId:"57a936a0e026905d4c92f648"
        };
        //根view
        config.view = {
            //默认下级view为欢迎页
            defaultView: "widgetTest",
            subViews: {
                merchantDetail:{
                    mustLogin: true
                },
                merchantList:{
                    mustLogin: true
                },
                myPartnerList:{
                    mustLogin: true
                },
                myPartnerDetail:{
                    mustLogin: true
                },
                supplyList:{
                    mustLogin: true
                },
                widgetTest: {},
                login:{},
                personalInformation:{},
                changePassword:{},
                retrieve:{},
                registerB:{},
                userSetting2:{},
                shopVerification:{
                    mustLogin:true
                },
                saleStatisticList:{
                    mustLogin:true
                }
            }
        };
        config.layoutBuilder = mobileBuilder;
        config.ViewRender = View;
        config.loadLayout = function() {
            return memoryLayoutLoader.loadLayout.apply(memoryLayoutLoader, arguments);
        };
        config.nextPageOnLogin = "shopList";
        // user.getUserInfo().then(lang.hitch(this,function(data){
                // var item = data && data.data && data.data.item;
                // if(item.role == 2){
                    // layout.myPartnerList.splice(2,1);
                // }            
        // }));
        memoryLayoutLoader.layouts = {
            "": [{
                type: "viewContainer"
            }],
            widgetTest:testLayout.widgetTest,
            merchantList:layout.merchantList,
            supplyList:layout.supplyList,
            //myPartnerList在programLayouts中处理 10-14 程磊
            //myPartnerList:layout.myPartnerList,
            //合作伙伴详情
            myPartnerDetail:layout.myPartnerDetail,
            //登录
            login:layout.login,
            //个人资料
            personalInformation:layout.personalInformationC,
            //修改密码
            changePassword:layout.changePassword,
            //找回密码
            retrieve:layout.retrieve,
            //注册
            registerB:layout.registerB,
            //个人信息设置
            userSetting2:layout.userSetting,
            //店铺认证
            shopVerification:layout.shopSaltVerification,
            //商家管理/详情（平台）
            merchantDetail:layout.merchantDetail,
            //销售员统计
            saleStatisticList:layout.saleStatisticList
        };
        memoryLayoutLoader.programLayouts = programLayout.programLayouts;
    });
});
