// 变更日期：2016-7-26
// 变更人：干劲
// 变更原因：添加平台服务页面
// 变更日期：2016-09-06
// 变更人：张金鹏
// 变更原因：添加商家端的回复评论列表
/*
修改人：张金鹏
修改日期：2016/09/21
修改内容：我关注的商品、已购买的商品、我的收货地址移动到\\192.168.0.2\www\static\lib\dojo\cq\ui\common\u
 */
 require([
    "cq/util/config/config",
    "cq/ui/view/_ViewMixin"
], function(config, _ViewMixin) {
    config.platformShopId = "573817a98f9ca8d447bfdff3";
    config.shopLevel = {
        "1":"一级客户",
        "2":"二级客户",
        "3":"三级客户",
        "4":"四级客户",
        "5":"五级客户"
    };
    config.shopType = [{
        typeName: "未分类",
        typeCard: "9999"
    }];
    //是否可编辑新增地址的区划
    config.cannotSetProvince = true;
    config.dataOrigin = "http://go.cqsalt.com";
    config.notLoginViews = {
        main: true,
        login: true,
        register: true,
        retrieve: true,
        registerB: true,
        trendDetail:true
    };
    config.loginLevel = "hasUid";
    var addColumns = _ViewMixin.prototype.addColumns;
    _ViewMixin.prototype.addColumns = function(columns) {
        if (!columns.isFooter && false != columns.forceWidth && columns.columns.length > 1 && (!columns.columns[0].icon)) {
            for (var i = 0; i < columns.columns.length; i++) {
                var className = columns.columns[i].className || "";
                if (false != columns.forceWidth) {
                    className += " flex1";
                }
                if (i != 0) {
                    className = className + " borderLeft";
                }
                columns.columns[i].className = className;
            }
            columns.forceWidth = false;
        }
        return addColumns.apply(this, arguments);
    };
    //注入新的view的结构
    require(["whz/app"]);
});
window.viewParam = {
    main: {
        //android设备APP中点击两次退出
        noBack: true,
        dojoType: 'whz/view/Welcome'
    },
    register: {
        dojoType: 'cq/ui/b/s/Svcregist'
    },
    home: {
        //android设备APP中点击两次退出
        noBack: true,
        dojoType: 'whz/view/Home'
    },
    shop: {
        dojoType: "whz/view/Shop"
    },
    mat: {
        dojoType: "whz/view/Mat" //cq/ui/b/m/Mat
    },
    matList: {
        dojoType: 'whz/view/MatList'
    },
    // 供应商商品详情
    matDetailB: {
        // dojoType:'cq/ui/b/m/MatDetailB'
        dojoType: 'whz/view/MatDetailB'
    },
    // 采购商商品详情
    matDetail: {
        dojoType: 'whz/view/MatDetail'
    },
    // 商品评价详情
    matEvalList: {
        dojoType: 'whz/view/MatEvalList'
    },
    matGroup: {
        dojoType: 'cq/ui/b/m/MatGroup'
    },
    matGroupList: {
        dojoType: 'cq/ui/b/m/MatGroupList'
    },
    news: {
        dojoType: 'cq/ui/b/a/News'
    },
    newsList: {
        dojoType: 'cq/ui/b/a/NewsList'
    },
    newDetail: {
        dojoType: 'cq/ui/b/a/NewDetail'
    },
    //资讯管理列表
    newsGroupList: {
        dojoType: 'cq/ui/b/a/NewsGroupList'
    },
    newsGroup: {
        dojoType: "cq/ui/b/a/NewsGroup"
    },
    orderListB: {
        dojoType: 'cq/ui/b/t/OrderListB'
    },
    orderList: {
        dojoType: 'whz/view/OrderList'
    },
    orderDetailB: {
        dojoType: 'whz/view/OrderDetailB'
    },
    orderDetail: {
        dojoType: 'whz/view/OrderDetail'
    },
    //订单添加
    orderInfo: {
        dojoType: "whz/view/OrderInfo"
    },
    //订单添加
    orderInfoB2B: {
        dojoType: "whz/view/OrderInfoB2B"
    },
    //他人代付
    payToAnother:{
        dojoType: 'whz/view/PayToAnother'
    },
    taskTodo:{
        dojoType: 'whz/view/TaskTodo'
    },
    user: {
        dojoType: 'cq/ui/b/u/User'
    },
    userList: {
        dojoType: 'whz/view/UserList'
    },
    userDetail: {
        dojoType: 'whz/view/UserDetail'
    },
    userCredit: {
        dojoType: 'cq/ui/b/u/UserCredit'
    },
    pendingMsg: {
        dojoType: 'cq/ui/b/s/PendingMsg'
    },
    chat: {
        dojoType: 'cq/ui/b/s/Chat'
    },
    supplyDemandList: {
        dojoType: 'cq/ui/b/a/SupplyDemandList'
    },
    supplyDemandPost: {
        dojoType: 'cq/ui/b/a/SupplyDemandPost'
    },
    supplyDemandDetail: {
        dojoType: 'cq/ui/b/a/SupplyDemandDetail'
    },
    //动态
    trends: {
        dojoType: 'cq/ui/c/a/Trends'
    },
    //动态详情
    trendDetail: {
        dojoType: 'cq/ui/b/a/TrendDetail'
    },
    //其他
    others: {
        dojoType: 'whz/view/Others'
    },
    // 平台商品管理
    platMatList:{
        dojoType:'whz/view/PlatMatList'
    },
    iframe: {
        dojoType: 'cq/ui/b/s/IFrame'
    },
    cShop: {
        dojoType: 'cq/ui/b/s/CShop'
    },
    qrCode: {
        dojoType: 'cq/ui/b/s/QrCode'
    },
    qrCodeDetail: {
        dojoType: 'cq/ui/b/s/QrCodeDetail'
    },
    autoReply: {
        dojoType: 'cq/ui/b/a/AutoReply'
    },
    autoReplyDetail: {
        dojoType: 'cq/ui/b/a/AutoReplyDetail'
    },
    careNotice: {
        dojoType: "cq/ui/b/u/CareNotice"
    },
    //添加栏目和栏目编辑的view配置
    section: {
        dojoType: "cq/ui/b/a/Section"
    },
    //栏目编辑
    sectionDetail: {
        dojoType: "cq/ui/b/a/SectionDetail"
    },
    //店铺配置
    shopConfig: {
        dojoType: "cq/ui/b/s/ShopConfig"
    },
    //店铺基本信息
    shopBase: {
        dojoType: "cq/ui/b/s/ShopBase"
    },
    helpVerification: {
        dojoType: "cq/ui/b/s/HelpVerification"
    },
    //会员俱乐部
    shopClub: {
        dojoType: "cq/ui/b/s/ShopClub"
    },
    //店铺装修
    shopDecoration: {
        dojoType: "cq/ui/b/s/ShopDecoration"
    },
    /*
    //店铺认证
    shopVerification: {
        dojoType: "cq/ui/b/s/ShopVerification"
    },
    */
    //担保交易
    shopSecure: {
        dojoType: "cq/ui/b/s/ShopSecure"
    },
    //店铺余额
    shopBalance: {
        dojoType: "cq/ui/b/s/ShopBalance"
    },
    // 店铺余额充值
    shopBalanceTransaction: {
        dojoType: "cq/ui/b/s/ShopBalanceTransaction"
    },
    // 店铺余额提现
    shopBalanceDeposit: {
        dojoType: "cq/ui/b/s/ShopBalanceDeposit"
    },
    //保障金缴纳
    shopBail: {
        dojoType: "cq/ui/b/s/ShopBail"
    },
    //支付方式
    shopPay: {
        dojoType: "cq/ui/b/s/ShopPay"
    },
    //交易和物流通知
    shopCustomerMsg: {
        dojoType: "whz/view/ShopCustomerMsg"
    },
    //客服消息设置
    shopServiceMsg: {
        dojoType: "cq/ui/b/s/ShopServiceMsg"
    },
    //店铺二维码
    shopQrCode: {
        dojoType: "cq/ui/b/s/ShopQrCode"
    },
    //保证金缴纳
    shopBailTransaction: {
        dojoType: "cq/ui/b/s/ShopBailTransaction"
    },
    //店铺微信配置
    shopWeiXin: {
        dojoType: "cq/ui/b/s/ShopWeiXin"
    },
    //店铺装修设计
    shopDecDetail: {
        dojoType: "cq/ui/b/s/ShopDecDetail"
    },
    //平台商家列表，新写法的头部筛选还不能操作，如果要修改请告知肖爱玲，谢谢    
    //merchantList: {
    //    dojoType: 'cq/ui/b/s/MerchantList'
    //},    
    //平台商家详情，功能是没有完全弄好，暂时隐藏
    //merchantDetail: {
    //   dojoType: 'cq/ui/b/s/MerchantDetail'
    //},
    //平台方认证列表
    platVerificationList: {
        dojoType: "whz/view/PlatVerificationList"
    },
    //平台审核保证金
    platBail: {
        dojoType: "cq/ui/b/s/PlatBail"
    },
    //平台方查看店铺详情
    platShopDetail: {
        dojoType: "cq/ui/b/s/PlatShopDetail"
    },
    //店铺列表
    shopList: {
        dojoType: 'cq/ui/b/s/ShopList'
    },
    shopRegist: {
        dojoType: "cq/ui/b/s/ShopRegist"
    },
    //抽奖活动列表
    luckyDrawList: {
        dojoType: "whz/view/LuckyDrawList"
    },
    //抽奖活动详情设置
    luckyDrawDetail: {
        dojoType: "whz/view/LuckyDrawDetail"
    },
    //抽奖活动详情浏览/审核
    luckyDrawPost: {
        dojoType: "whz/view/LuckyDrawPost"
    },
    // 奖项设置
    awardsDetail: {
        dojoType: "whz/view/AwardsDetail"
    },
    // 优惠券活动
    coupon: {
        dojoType: "cq/ui/b/s/Coupon"
    },
    // 优惠券活动添加页面
    addCoupon: {
        dojoType: "cq/ui/b/s/AddCoupon"
    },
    // 查询优惠券页面
    selectCoupon: {
        dojoType: "cq/ui/b/s/SelectCoupon"
    },
    // 查询优惠券详情
    lookCountSer: {
        dojoType: "cq/ui/b/s/LookCountSer"
    },
    // 店铺余额管理
    shopBalanceList: {
        dojoType: "cq/ui/b/s/ShopBalanceList"
    },
    // 店铺余额详情
    shopBalanceDetail: {
        dojoType: "cq/ui/b/s/ShopBalanceDetail"
    },
    //平台设计
    setPlatform: {
        dojoType: 'cq/ui/b/s/SetPlatform'
    },
    //模版列表
    richTextTempList: {
        dojoType: 'cq/ui/b/p/RichTextTempList'
    },
    //模版编辑
    richTextTempDetail: {
        dojoType: 'cq/ui/b/p/RichTextTempDetail'
    },
    // 分销客户查询
    cShopUserList: {
        dojoType: 'cq/ui/b/s/CShopUserList'
    },
    // 交易明细列表
    transactionList: {
        dojoType: 'cq/ui/b/t/TransactionList'
    },
    refundRecordList: {
        dojoType: 'cq/ui/b/t/RefundRecordList'
    },
    refundRecordDetail: {
        dojoType: 'cq/ui/b/t/RefundRecordDetail'
    },
    // 店铺管理员
    shopAdmin: {
        dojoType: 'cq/ui/b/s/ShopAdmin'
    },
    // 添加店铺管理员
    addShopAdmin: {
        dojoType: 'cq/ui/b/s/AddShopAdmin'
    },
    businessRegist: {
        dojoType: 'cq/ui/b/s/BusinessRegist'
    },
    //标准分类
    stdSort: {
        dojoType: 'cq/ui/b/m/StdSort'
    },
    //标准分类列表
    stdSortList: {
        dojoType: 'cq/ui/b/m/StdSortList'
    },
    //买功能
    buy: {
        dojoType: 'whz/view/Buy'
    },
    //B2BBuy
    b2bBuy: {
        dojoType: 'whz/view/B2BBuy'
    },
    //卖家
    sale: {
        dojoType: 'whz/view/Sale'
    },
    //团购返利编辑
    groupBuy: {
        dojoType: 'whz/view/GroupBuy'
    },
    //团购返利列表
    groupBuyList: {
        dojoType: 'whz/view/GroupBuyList'
    },
    //平台服务
    platformService: {
        dojoType: 'whz/view/PlatformService'
    },
    // 卖家服务
    saleService: {
        dojoType: 'whz/view/SaleService'
    },
    // 买家服务
    buyerService: {
        dojoType: "whz/view/BuyerService"
    },
    //直播间列表
    channelListB: {
        dojoType: 'cq/ui/b/im/ChannelListB'
    },
    //直播频道
    channelB: {
        dojoType: 'cq/ui/b/im/ChannelB'
    },
    //直播详情
    channelDetailB: {
        dojoType: 'cq/ui/b/im/ChannelDetailB'
    },
    //直播间列表
    channelList: {
        dojoType: 'whz/view/ChannelList'
    },
    //直播详情
    channelDetail: {
        dojoType: 'whz/view/ChannelDetail'
    },
    //商家详情
    supplyBus: {
        dojoType: 'whz/view/SupplyBus'
    },
    supplyListB: {
        dojoType: 'whz/view/SupplyListB'
    },
    supplyListC: {
        dojoType: 'whz/view/SupplyListC'
    },
    // 关注供应商列表
    attentionShopList: {
        dojoType: "whz/view/AttentionShopList"
    },
    // 关注商品列表
    attentionMatList: {
        dojoType: "cq/ui/common/u/AttentionMatList"
    },
    // 已购买商品列表
    boughtMatList: {
        dojoType: "cq/ui/common/u/BoughtMatList"
    },
    // 消费者端的评价列表
    evaList: {
        dojoType: "cq/ui/c/s/EvaList"
    },
    // 消费者端的评价
    eva: {
        dojoType: "cq/ui/c/s/Eva"
    },
	//商家端的评价列表
	evaListb: {
        dojoType: "cq/ui/b/s/EvaListb"
    },
    // 商家端的评价回复
    evab: {
        dojoType: "cq/ui/b/s/Evab"
    },
    //客服列表详情
    svcDetail: {
        dojoType: 'cq/ui/common/im/SvcDetail'
    },
    iconStorage: {
        dojoType: "cq/ui/common/icons/IconStorage"
    },
    // 运费管理
    freightList: {
        dojoType: "cq/ui/b/s/FreightList"
    },
    // 用户地址管理
    userAddList: {
        dojoType: "cq/ui/common/u/UserAddList"
    },
    // 用户地址编辑
    userAddDetail: {
        dojoType: "cq/ui/common/u/UserAddDetail"
    },
    // 运费模板编辑
    freightDetail: {
        dojoType: "cq/ui/b/s/FreightDetail"
    },
    // 我的卡劵列表
    userCountSer: {
        dojoType: "whz/view/UserCountSer"
    },
    // 优惠券详情页面
    disCountSerDetail:{
        dojoType:"cq/ui/b/s/DisCountSerDetail"
    },
    sortList : {
        // dojoType : "whz/view/SortTList"
        dojoType: 'cq/ui/b/m/SortTList'
    },
    //编辑
    sortTDetail : {
        // dojoType : "whz/view/SortTDetail"
        dojoType:'cq/ui/b/m/SortTDetail'
    },
    //注册送
    registerGiftList:{
        dojoType:"whz/view/RegisterGiftList"
    },
    //注册送编辑
    registerGift:{
        dojoType:"whz/view/RegisterGift"
    },
    //商品送
    shopGiftList:{
        dojoType:"cq/ui/b/s/ShopGiftList"
    },
    //商品送编辑
    shopAwardEdit:{
        dojoType:"cq/ui/b/s/ShopAwardEdit"
    },
    //抽奖活动列表界面
    prizeList:{
        dojoType:"whz/view/PrizeList"
    },
    //抽奖活动详情页面
    prizeDetail:{
        dojoType:"whz/view/PrizeDetail"
    },
    //抽奖活动录入编辑界面
    prizeEdit:{
        dojoType:"whz/view/PrizeEdit"
    },

    //合作伙伴
    myPartner: {
        dojoType: 'cq/ui/common/s/MyPartner'
    },
    //销售区域
    positionList: {
        dojoType: 'cq/ui/b/s/PositionList'
    },
    //商家消息
    shopMsgList: {
        dojoType: 'whz/view/ShopMsgList'
    },
    //个人信息设置
    userSetting:{
        dojoType: 'whz/view/UserSetting'
    },
    //供应商详情
    supplyBusDetail: {
        dojoType: "cq/ui/b/s/SupplyBusDetail"
    },
    //财务信息
    treasurer : {
        dojoType : "whz/view/Treasurer"
    },
    //查询供货商商品
    b2bShopBuy : {
        dojoType : "whz/view/B2bShopBuy"
    },
    //商家统计
    trainProcess : {
        dojoType : "whz/view/TrainProcess"
    },
    //关于我们
    about : {
        dojoType: "cq/ui/b/a/About"
    }
};
