// 变更人：干劲
// 变更时间：20160910
// 变更内容：买页面的跳转
//
define([
        "dojo/_base/declare",
        "dojo/_base/lang",
        "dojox/mobile/View",
        "dojo/dom-construct",
        "dojo/dom-style",
        "dojo/dom-attr",
        "dojo/dom-class",
        "cq/ui/view/_ViewMixin",
        "dojo/query",
        "cq/biz/ts/order",
        "cq/biz/user/user",
        "cq/util/config/config"
    ], function (declare, lang, View, domConstruct, domStyle, domAttr, domClass, _ViewMixin, query, order, user, config) {
    return declare("whz.view.BuyerService", [View, _ViewMixin], {
        onFirstShow : function () {
            var option = {
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick : function () {
                        history.back();
                    }
                },
				title:"重盐云商"
			};
			//this.addHeader(option);
            var options = {
                boxes: [{
                    icon: g_sys_info.logo,
                    banner: "images/userBanner.jpg",
                    title: "未登录",
                    userSetting: true
                }]
			};
			this.banner = this.addIconBanner(options);
			option = {
				columns: [{
                    label: '待付款',
                    iconClass: 'width-24',
                    icon: 'images/icon/user_toeva.png',
                    isBadge: true,
                    badgeClass: "user_toeva_num",
                    onClick: lang.hitch(this, function (e) {
                        window.moveToView("orderList-0");
                    })
                }, {
                    label : '待发货',
                    badgeClass : "user_tostate_num",
                    iconClass : 'width-24',
                    isBadge : true,
                    icon : 'images/icon/user_tostate.png',
                    onClick : lang.hitch(this, function (e) {
                        window.moveToView("orderList-1");
                    })
                }, {
                    label : '待收货',
                    iconClass : 'width-24',
                    badgeClass : "user_todeli_num",
                    isBadge : true,
                    icon : 'images/icon/user_todeli.png',
                    onClick : lang.hitch(this, function (e) {
                        window.moveToView("orderList-2");
                    })
                }, {
                    label : '待评价',
                    iconClass : 'width-24',
                    badgeClass : "user_topay_num",
                    isBadge : true,
                    icon : 'images/icon/user_topay.png',
                    onClick : lang.hitch(this, function (e) {
                        window.moveToView("orderList-3");
                    })
                }],
				labelClass : 'font-size1 tab-selector',
				className : "orderNumList"
			};
			this.addColumns(option);
			option = {
				isEdge : true,
				lists : [{
                    icon : 'images/icon/user_allorder.png',
                    label : '我的订单',
                    noArrow : false,
                    moveTo : "#",
                    onClick : lang.hitch(this, function () {
                        window.moveToView("orderList-4");
                    })
                }, {
                    icon : 'images/icon/user_sale_verify.png',
                    label : '采购商认证',
                    noArrow : false,
                    moveTo : "#",
                    onClick : lang.hitch(this, function () {
                        window.moveToView("shopVerification");
                    })
                },/* {
                    icon : 'images/icon/user_attention_sale.png',
                    label : '我关注的供应商',
                    noArrow : false,
                    moveTo : "#",
                    onClick : lang.hitch(this, function () {
                        window.moveToView("attentionShopList");
                    })
                }, {
                    icon : 'images/icon/user_attention_mat.png',
                    label : '我关注的商品',
                    noArrow : false,
                    moveTo : "#",
                    onClick : lang.hitch(this, function () {
                        window.moveToView("attentionMatList");
                    })
                }, */{
                    icon : 'images/icon/user_clientDistribute.png',
                    label : '已购买商品',
                    noArrow : false,
                    moveTo : "#",
                    onClick : lang.hitch(this, function () {
                        window.moveToView("boughtMatList");
                    })
                }, {
                    icon : 'images/icon/eva_sale.png',
                    label : '我的评价',
                    noArrow : false,
                    moveTo : "#",
                    onClick : lang.hitch(this, function () {
                        window.moveToView("evaList");
                    })
                }, {
                    icon : 'images/icon/user_address.png',
                    label : '我的收货地址',
                    noArrow : false,
                    moveTo : "#",
                    onClick : lang.hitch(this, function () {
                        window.moveToView("userAddList");
                    })
                }, {
                    icon : 'images/icon/myCoupons.png',
                    label : '我的卡劵',
                    noArrow : false,
                    moveTo : "#",
                    onClick : lang.hitch(this, function () {
                        window.moveToView("userCountSer");
                    })
                }]
			};
			var viewList = this.addLists(option);
            
			option = {
				columns:[{
					icon:'images/icon/shop_footer_highlight.png',
					iconClass:'footer-tab-img',
					label:'首页',
					onClick:function(){
						window.moveToView("home");
					}
				},{
					icon:'images/icon/member_footer.png',
					iconClass:'footer-tab-img',
					label:'买',
					onClick:function(){
						window.moveToView("b2bBuy");
					}
				},{
					icon:'images/icon/sale_footer.png',
					iconClass:'footer-tab-img',
					label:'卖',
					onClick:function(){
						localStorage.setItem("fromTrends","ok");
						window.moveToView("sale");
					}
				},{
                    icon:'images/icon/news_footer.png',
                    iconClass:'footer-tab-img',
                    label:'资讯',
                    onClick:function(){
                        window.moveToView("trends");
                    }
                },{
					icon:'images/icon/more_footer_highlight.png',
					iconClass:'footer-tab-img',
					label:'更多',
					onClick:function(){
						window.moveToView("others");
					}
				}],
				valueClass:'font-size3',
				labelClass:'font-size1',
				className:'fix-footer',
				isFooter:true
			};
			user.getUserInfo().then(lang.hitch(this,function(data){
                var item = data && data.data && data.data.item;
                if(item.role == 2){
                    option.columns.splice(2,1);
                }
                this.addColumns(option);                
            }));
            
            this.objAmt="0.00";
            this.payDomNode = "<div class='getPayDom' style='position: relative;right: 12px;top: -73px;text-align: right'>余额：" + this.objAmt + "</div>";
            var target = domConstruct.toDom(this.payDomNode);
            this.banner = query(".banner", this.domNode)[0];
            this.banner.appendChild(target);
			this._topSplitter.resize();
			this.onAfterShow();
			this.queryDom();
			this.connect(query(".banner-title", this.banner.domNode)[0], "onclick", function (e) {
				window.moveToView("personalInformation");
			});
			this.connect(query(".user-setting", this.banner.domNode)[0], "onclick", function () {
				window.moveToView("user");
			});
        },
        queryDom : function () {
			this.orderNumList = query(".orderNumList", this.domNode)[0];
			this.user_toeva_num = query(".user_toeva_num", this.orderNumList)[0];
			this.user_tostate_num = query(".user_tostate_num", this.orderNumList)[0];
			this.user_todeli_num = query(".user_todeli_num", this.orderNumList)[0];
			this.user_topay_num = query(".user_topay_num", this.orderNumList)[0];
		},
		isLogin : false,
		onAfterShow : function () {
			this.inherited(arguments);
			var userDomNode = query(".banner", this.domNode)[0];
			domStyle.set(userDomNode, "background-color", "white");
			domStyle.set(query(".user-setting", this.banner.domNode)[0], "display", "none");
			user.hasLogin().then(lang.hitch(this, function (s) {
                var bannerTitle = query(".banner-title", this.domNode)[0];
                var bannerIcon = query(".banner-icon", this.domNode)[0];
                if (s) {
                    this.isLogin = true;
                    this.refreshOrderNum();
                    user.loadUseByIdAndShop(user.getCurrentUserId(), user.getShopId()).then(lang.hitch(this, function (data) {
                        var item = data && data.data && data.data.item;
                        if (data && data.data && data.data.ok == "1") {
                            domClass.add(bannerTitle, "isLogin");
                            bannerTitle.innerHTML = item.pName || "未填写";
                            bannerIcon.src = item.logo || "images/icon/userIcon.png";
                        }
                        if(data && data.data && data.data.ok == "1"){
                            this.objAmt = window.fixedTo((data.data.item.amount) || 0, 3);
                        }else{
                            this.objAmt = "0.00";
                        }
                        var payDom = query(".getPayDom", this.domNode)[0];
                        payDom.innerHTML = "余额：" + this.objAmt;
                        }));
                } else {
                    this.isLogin = false;
                    bannerTitle.innerHTML = "未登录";
                    domClass.remove(bannerTitle, "isLogin");
                    bannerIcon.src = "images/icon/userIcon.png";
                    this.objAmt = "0.00";
                    var payDom = query(".getPayDom", this.domNode)[0];
                    payDom.innerHTML = "余额：" + this.objAmt;
                }
            }));
		},
		refreshOrderNum : function () {
			order.getB2BDetailCount().then(lang.hitch(this, function (data) {
                data = data && data.data;
                this.user_toeva_num.innerHTML = data.toPayCount || 0;
                this.user_tostate_num.innerHTML = data.toDeliverCount || 0;
                this.user_todeli_num.innerHTML = data.toReceiptCount || 0;
                this.user_topay_num.innerHTML = data.toEvaluateCount || 0;
                domStyle.set(this.user_toeva_num, "display", (data.toPayCount || 0) ? "" : "none");
                domStyle.set(this.user_tostate_num, "display", (data.toDeliverCount || 0) ? "" : "none");
                domStyle.set(this.user_todeli_num, "display", (data.toReceiptCount || 0) ? "" : "none");
                domStyle.set(this.user_topay_num, "display", (data.toEvaluateCount || 0) ? "" : "none");
            }));
		}
    });
});