//变更人:肖芳圆
//变更时间:2016/5/18
//变更原因:微信分享使用公共基类_share
/**
 * 修改人: 杜飞军
 * 修改时间: 2016-06-08
 * 修改内容:
 * 			没有商家logo时url是的
 */
//变更人:周科吉
//变更时间:2016/6/22
//变更原因:更改底部标签样式问题
//变更人:张松
//变更时间:2016/07/25
//变更原因:首页布局修改
//变更人:周科吉
//变更时间:2016/07/29
//变更原因:平台商品数区域获取平台的平台商品数，并显示；供货商数量处，显示平台已认证供货商数量
//变更人：干劲
//变更时间：20160910
//变更原因：没有认证的商家提醒去做认证，上下游动态
define([
	"dojo/_base/declare",
	"dojo/_base/lang",
    "dojo/_base/array",
    "dojo/dom-style",
    "dojo/dom-class",
    "dojo/dom-attr",
    "dojo/dom-construct",
	"dojox/mobile/View",
	"cq/ui/view/_ViewMixin",
	"cq/biz/shop/shop",
	"dojo/query",
	"dojo/topic",
	"cq/ui/b/a/_share",
    "cq/biz/article/article",
    "cq/biz/user/user"
],function( declare, lang, array, domStyle, domClass, domAttr, domConstruct, View, _ViewMixin, shop, query, topic, _share, article, user){
	return declare("whz.view.Home",[View,_ViewMixin,_share],{
        addNoticeArea:function(){
            var option = {
                columns:[{
                    label:"<div class='noticeDiv' style='width:100%;'></div>"
                }],
                labelClass:'font-size3 notice',
                className:"padding-top-bottom16 notice-home"
            };
            this.notice = this.addColumns(option);
            this.moveNotice();
        },
        moveNotice:function(){
            var noticeDiv = query(".noticeDiv", this.notice)[0];
            this.movedHeight = this.movedHeight||0;
            setTimeout(lang.hitch(this, function(){
                this.movedHeight = (this.movedHeight + 18) >= domStyle.get(noticeDiv, "height") ? 0:(this.movedHeight + 18);
                domStyle.set(noticeDiv, {
                    transform:"translate3d(0px, -" + this.movedHeight + "px, 0px)",
                    animationDuration: "2s",
                    animationTimingFunction: "ease-out"
                });
                this.moveNotice();
            }), 5000);
        },
		updateIOInfo:function(){
			var shopIoInfoArea = query(".shopIoInfoArea",this.domNode)[0];
			if(shopIoInfoArea){
				var shopIoNodes = query('.font-size3',shopIoInfoArea);
				if(3===shopIoNodes.length){
					shop.summary().then(function(ioInfo){
						shopIoNodes[0].innerHTML = ioInfo.data.item.todaySale.toFixed(2);
						shopIoNodes[1].innerHTML = ioInfo.data.item.monthSale.toFixed(2);
						shopIoNodes[2].innerHTML = ioInfo.data.item.userCount.toFixed(0);
					});
				}
			}
		},
		addDisplayArea:function(){
            var option = {
                columns:[{
                    icon:'images/icon/shop.png',
					iconClass:'width-32',
					label:'买家1'
                },{
                    icon:'images/icon/shop.png',
					iconClass:'width-32',
					label:'买家2'
                },{
                    icon:'images/icon/shop.png',
					iconClass:'width-32',
					label:'卖家1'
                },{
                    icon:'images/icon/shop.png',
					iconClass:'width-32',
					label:'卖家2'
                }],
                valueClass:'font-size3',
				labelClass:'font-size1',
				className:'padding-top-bottom16'
            };
            this.displayArea = this.addColumns(option);
        },
        onAfterShow:function(){
			// 财务人员直接跳转到Treasurer
			user.getUserInfo().then(lang.hitch(this,function(data){
                var item = data && data.data && data.data.item;
                if(item.role == 4){
                    window.moveToView("treasurer");
                } else {
					//如果店铺没有认证，只有当店铺高级管理员登录时，才显示认证链接
					shop.loadCurrentShop().then(lang.hitch(this,function(shopData){
						if((!shopData.data.isVerified)){
							// 只有高级管理员进入时才能看到进行认证
							if(item.role == 1){
								domClass.remove(this.verificationLink.domNode,'none');
							}							
							domClass.add(this.buyerServiceImage,'none');
							domClass.add(this.saleServiceImage,'none');
							domClass.add(this.upstreamMsg.domNode,'none');
							domClass.add(this.downstreamMsg.domNode,'none');
						}else{
							domClass.add(this.verificationLink.domNode,'none');
							domClass.remove(this.buyerServiceImage,'none');
							domClass.remove(this.saleServiceImage,'none');
							domClass.remove(this.upstreamMsg.domNode,'none');
							domClass.remove(this.downstreamMsg.domNode,'none');
						}
					}));
					//获取某个数据，其实就是将onFirstShow中的接口获取数据移至onAfterShow
					shop.getVerifiedCount().then(lang.hitch(this,function(data){
						var item = data&&data.data&&data.data.item;
						//获取商品数的节点
						var nodes = query(".font-size3",this.summaryInfoNode);
						nodes[0].innerHTML = item.verifiedShopNum.toString();
					}));
					shop.getPlatformMatNum().then(lang.hitch(this,function(data){
						var item = data&&data.data&&data.data.item;
						//获取商品数的节点
						var nodes = query(".font-size3",this.summaryInfoNode);
						nodes[1].innerHTML = item.platformShopMatNum.toString();
					}));
					// 加载平台公告
					article.loadByGroupName("平台公告",10,true).then(lang.hitch(this, function(data){
						var items = [];
						array.forEach(data.data.items, function(item){
							items.push({icon:item.logo,articleId:item._id});
						});
						this.slideShow.items = items;
						this.slideShow.refresh();
					}));
					// 加载活动公告
					article.loadByGroupName("活动公告", 10, true).then(lang.hitch(this, function(data){
						var noticeStr = "";
						array.forEach(data.data.items, function(item){
							noticeStr += "<a style='width:100%;text-align:center;color:#666;display:block;overflow:hidden;height:18px;line-height:18px;' onclick='window.moveToView(\"trendDetail\", \"" + item._id + "\")'>";
							noticeStr += item.title + "</a>";
						});
						query(".noticeDiv", this.notice)[0].innerHTML = noticeStr;
					}));
					// 加载买家卖家公告
					article.loadByGroupName("买家公告", 3, true).then(lang.hitch(this, function(data){
						var buyStr = "";
						array.forEach(data.data.items, function(item){
							buyStr += "<a style='width:100%;height:30px;line-height:30px;text-align:left;color:#666;display:block;overflow:hidden;font-size:14px;' onclick='window.moveToView(\"trendDetail\", \"" + item._id + "\")'>";
							buyStr += item.title + "</a>";
						});
						this.buyerA.innerHTML = buyStr;
					}));
					article.loadByGroupName("卖家公告", 3, true).then(lang.hitch(this, function(data){
						var saleStr = "";
						array.forEach(data.data.items, function(item){
							saleStr += "<a style='width:100%;height:30px;line-height:30px;text-align:left;color:#666;display:block;overflow:hidden;font-size:14px;' onclick='window.moveToView(\"trendDetail\", \"" + item._id + "\")'>";
							saleStr += item.title + "</a>";
						});
						this.sellerA.innerHTML = saleStr;
					}));
				}                              
            }));			
		},
		onFirstShow:function(){
            var data = {
				boxes : [{}],
				options : {
					height:"160"
				},
                isShowBigImg :false
			};
			this.slideShow=this.addSlideShow(data);
            //第一步：将setTimeout放在addSlideShow之后
            var option = {
                columns:[{
                    value:0,
                    label:'品牌数',
                    onClick:function(){
                        window.moveToView('supplyList');
                    }
                },{
                    value:0,
                    label:'商品数',
                    onClick:function(){
                        window.moveToView("b2bBuy");
                    }
                },{
                    value:'0',
                    label:'买家数',
                    onClick:function(){
                    }
                },{
                    value:'0',
                    label:'交易额',
                    onClick:function(){
                    }
                }],
                splitter:'./splitter.jpg',
                valueClass:'font-size3',
                labelClass:'font-size1',
                className:'shopIoInfoArea padding-top-bottom16'
            };
            this.summaryInfoNode = this.addColumns(option);
            this.addNoticeArea();

            var node = domConstruct.create("div",{
                "class":"hflex"
            },this.centerPanel.containerNode);
            domConstruct.create("div",{
                style:"width:22%;",
                innerHTML:"<img src='images/buy01.png' style='width:100%;'/>",
                onclick:function(){
                    window.moveToView("b2bBuy");
                }
            },node);
            this.buyerA = domConstruct.create("div",{
                "class":"flex1",
				"style":"margin-left:5px;"
            },node);
            domConstruct.create("div",{
                style:"width:22%;",
                innerHTML:"<img src='images/buy02.png' style='width:100%;'/>",
                onclick:function(){
                    window.moveToView("sale");
                }
            },node);
            this.sellerA = domConstruct.create("div",{
                "class":"flex1",
				"style":"margin-left:5px;"
            },node);

            option = {
                src:'images/buyerservice.png',
				className:'none',
                onClick:function(){
                    window.moveToView("buyerService");
                },
                className:"margin-top10"
            };
            this.buyerServiceImage = this.addImage(option);

            option = {
                src:'images/sallerservice.png',
				className:'none',
                onClick:function(){
                    window.moveToView("saleService");
                }
            };
            this.saleServiceImage = this.addImage(option);
            option = {
                src:'images/yszj.png',
                onClick:function(){
                    window.moveToView("trends");
                }
            }
            //this.addImage(option);
            option = {
                src:'images/yszb.png',
                onClick:function(){
                    window.moveToView("channelList");
                }
            }
            //this.addImage(option);
			option = {
				isEdge : true,
				class : 'none',
				lists : [{
                    label : '商家认证',
					rightText: '完成认证后，才能购买和销售',
                    noArrow : false,
                    moveTo : "#",
                    onClick : lang.hitch(this, function () {
                        window.moveToView("shopVerification");
                    })
                }]
			};
			this.verificationLink = this.addLists(option);
			option = {
				isEdge : true,
				class : 'none',
				lists : [{
                    label : '上游动态',
					rightText: '',
                    noArrow : false,
                    moveTo : "#",
                    onClick : lang.hitch(this, function () {
                        window.moveToView("shopMsgList",1);
                    })
                }]
			};
			this.upstreamMsg = this.addLists(option);
			option = {
				isEdge : true,
				class : 'none',
				lists : [{
                    label : '下游动态',
					rightText: '',
                    noArrow : false,
                    moveTo : "#",
                    onClick : lang.hitch(this, function () {
                        window.moveToView("shopMsgList",2);
                    })
                }]
			};
			this.downstreamMsg = this.addLists(option);
			option = {
				isEdge : true,
				lists : [{
                    label : '入驻商家',
					rightText: '...',
                    noArrow : false,
                    moveTo : "#",
                    onClick : lang.hitch(this, function () {
                        window.moveToView("supplyList");
                    })
                }]
			};
			this.supplyListLink = this.addLists(option);

            option = {
                columns:[{
                    icon:'images/icon/shop_footer.png',
                    iconClass:'footer-tab-img',
                    label:'首页',
                    onClick:function(){
                        window.moveToView("home");
                    }
                },{
                    icon:'images/icon/member_footer.png',
                    iconClass:'footer-tab-img',
                    label:'买',
                    onClick:function(){
                        //修改买进入的view为b2bBuy-20160906-肖芳圆
                        window.moveToView("b2bBuy");
                    }
                },{
                    icon:'images/icon/sale_footer.png',
                    iconClass:'footer-tab-img',
                    label:'卖',
                    onClick:function(){
                        localStorage.setItem("fromTrends","ok");
                        window.moveToView("sale");
                    }
                },{
                    icon:'images/icon/news_footer.png',
                    iconClass:'footer-tab-img',
                    label:'资讯',
                    onClick:function(){
                        window.moveToView("trends");
                    }
                },{
                    icon:'images/icon/more_footer.png',
                    iconClass:'footer-tab-img',
                    label:'更多',
                    onClick:function(){
                        window.moveToView("others");
                    }
                }],
                valueClass:'font-size3',
                labelClass:'font-size1',
                className:'fix-footer hflex',
                isFooter:true
            };
            user.getUserInfo().then(lang.hitch(this,function(data){
                var item = data && data.data && data.data.item;
                if(item.role == 2){
                    option.columns.splice(2,1);
                }
                this.addColumns(option);                
            }));
            
            this.subscribe("whz/shop/changed",lang.hitch(this,this.updateHeader));
            // 添加图片点击事件，点击图片跳转到对应的咨询详情页面
            this.connect(this.slideShow.domNode, "onclick", lang.hitch(this, function(evt){
                var target = evt.target;
                if(target.tagName == "IMG" && domStyle.get(target, "width") == domStyle.get(this.domNode, "width")){
                    array.forEach(this.slideShow.items, function(item){
                        if(item.icon == domAttr.get(target, "src")){
                            window.moveToView("trendDetail", item.articleId);
                        }
                    });
                }
            }));

            this.onAfterShow();
		},
		updateHeader:function(shopData){
			if(this.header){
				var icon = query(".header-image.float-left",this.header.domNode)[0];
				if(icon){
					icon.src = shopData.logo||icon.src;
				}
				this.header.set("label",shopData.shopName);
			}
		}
	});
});
