//变更人: 肖爱玲
//变更时间: 2016-07-29
//变更原因: 继承公共基类
// 变更人:徐阿雪
// 变更时间:2016/8/10
// 变更原因:运费显示更改
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/query",
    "dojo/dom-construct",
    "dojo/dom-style",
    "dojo/dom-class",
    "cq/ui/common/m/MatDetail",
    "cq/biz/user/user",
    "cq/biz/im/msg_p",
    "cq/util/config/config",
    "dojo/Deferred",
    "cq/biz/mat/mat",
    "cq/biz/shop/partner",
    "cq/biz/shop/cm/matStore"
], function (declare, lang, query, domConstruct, domStyle, domClass, MatDetail, user, msg_p, config, Deferred, mat, partner, matStore) {
    return declare("whz.view.MatDetail", [MatDetail], {
        hideBottom: true,
        //重写点击加入购物车跳转view地址
        orderCarViewId: "buy",

        addAtttion: function () {
            // var column = this.inherited(arguments);
            // domClass.add(column,"none");
            var option = {
                columns: [{
                        label: '客服',
                        className: 'flex2 footer-tab-dark',
                        onClick: lang.hitch(this, this.toTalk)
                    }, {
                        label: '店铺',
                        className: 'flex2 footer-tab-highlight',
                        onClick: lang.hitch(this, function () {
                            window.moveToView("supplyBus", this.matShopId);
                        })
                    }, {
                        label: '加入采购清单',
                        className: 'flex2 footer-tab-dark',
                        onClick: lang.hitch(this, this.toState)
                    }
                    /*{
                                        label:'加入购物车',
                                        className:'flex2 footer-tab-highlight',
                                        onClick: lang.hitch(this, this.addOrderCar)
                                    }*/
                ],
                forceWidth: false,
                labelClass: "attion",
                isFooter: true
            };
            this.bottomMenus1 = this.addColumns(option);
            return this.bottomMenus1;
        },
        onAfterShow: function () {
            this.inherited(arguments);
            // 添加和修改商品库需要的数据
            this.matPurch = {
                _id: '',
                fromShopId: '',
                code: '',
                logo: '',
                mName: '',
                sortName: '',
                sizeType: '',
                purchaseQty: 'minQty',
                marketPrice: '',
                freight: '',
                purchasePrice: 'retailPrice',
                retailPrice: '',
                isUse: '',
                sortId: '',
                content: ''
            };
            var addShopDiv = query(".attion", this.domNode)[2];
            this.oldShopId = null;

            // 判断是否为供应商  不是隐藏价格
            partner.loadById(this.matShopId).then(lang.hitch(this, function (data) {
                var matRetail = query('.matRetail', this.domNode)[0];
                if (data && data.data) {
                    if (data.data.isSupplier === true) {
                        // 通过验证显示价格
                        domClass.remove(matRetail, 'none');
                    } else {
                        // 没有通过验证 不显示
                        domClass.add(matRetail, 'none');
                    }
                } else {
                    // 不是供货商 不显示
                    domClass.add(matRetail, 'none');
                }
                mat.loadById(this.matId).then(lang.hitch(this, function (data) {
                    var item = data.data.item;
                    if (data.data.ok === 1 && item) {
                        this.oldShopId = item.fromShopId;
                        // 只对定义过的赋值
                        if (item.fromShopId === this.matShopId) {
                            if (item.isPurchase) {
                                addShopDiv.innerHTML = '停止采购';
                            } else {
                                addShopDiv.innerHTML = '加入采购清单';
                            }

                        } else {
                            addShopDiv.innerHTML = '修改供货商';
                        }
                        // 用于处理 可能存在没有填写价格 不显示或者显示undefined问题
                        if (!data.data.item.retailPrice) {
                            data.data.item.retailPrice = window.fixedTo(0, 3);
                            this.setData(data.data.item);
                            this.refreshData();
                        }
                    } else {
                        addShopDiv.innerHTML = '加入采购清单';
                    }

                }));
            }));
        },
        // toTalk: function() {
        //     msg_p.getSvcInfo(this.matShopId).then(lang.hitch(this, function(msgInfo) {
        //         if (msgInfo && msgInfo.data && msgInfo.data.item) {
        //             var item = msgInfo.data.item;
        //             var senderId = item.senderId,
        //                 receiverId = item.receiverId;
        //             senderId = senderId._id || senderId;
        //             receiverId = receiverId._id || receiverId;
        //             var svcId = senderId === user.getCurrentUserId() ? receiverId : senderId;
        //             window.moveToView("svcDetail", this.matShopId + "," + svcId);
        //         } else if (msgInfo && msgInfo.data && msgInfo.data.msg && msgInfo.data.msg == "没有客服人员") {
        //             alert("没有客服人员");
        //         }
        //     }));
        // },
        toState: function (evt) {
            var target = evt.target;
            var matData = this.getData();
            // 如果已经下架不能加入采购清单
            if (!matData.isUse) {
                alert('商品已下架不能添加');
                return;
            }
            if (target.innerHTML.trim() == "加入采购清单") {
                //只有加为供应商后才能加入采购清单
                //partner.checkSupplierById({ _id: this.matShopId, isSupplier: true }).then(lang.hitch(this, function(pData) {
                // if (pData && pData.data && pData.data.isSupplier) {
                mat.b2bAdd({
                    fromShopId: this.matShopId,
                    mId: this.matId
                }).then(lang.hitch(this, function (data) {
                    if (data.data.ok === 1) {
                        this.onAfterShow();
                        alert('加入采购清单成功');
                    } else {
                        alert('加入采购清单失败   ' + data.data.msg);
                    }
                }));
                //     } else {
                //         alert("只有加入了合作伙伴才能加入产品库");
                //         return;
                //     }
                // }));

            } else if (target.innerHTML.trim() == "修改供货商") {
                //只有加为供应商后才能加入采购清单
                // partner.checkSupplierById({ _id: this.matShopId, isSupplier: true }).then(lang.hitch(this, function(pData) {
                //     if (pData && pData.data && pData.data.isSupplier) {
                var reData = confirm('是否确认将供应商修改为当前供应商');
                if (reData) {
                    //取消从老供应商那里供应
                    mat.b2bRemove({
                        fromShopId: this.oldShopId,
                        mId: this.matId
                    }).then(lang.hitch(this, function (data) {
                        //添加新的供应商s
                        mat.b2bAdd({
                            fromShopId: this.matShopId,
                            mId: this.matId
                        }).then(lang.hitch(this, function (data) {
                            if (data.data.ok === 1) {
                                alert('修改供货商成功');
                                this.onAfterShow();
                            } else {
                                alert('修改供货商失败  ' + data.data.msg);
                            }
                        }));
                    }));
                }
                //     } else {
                //         alert("只有加入了合作伙伴才能加入产品库");
                //         return;
                //     }
                // }));
            } else if (target.innerHTML.trim() == "停止采购") {
                mat.b2bRemove({
                    fromShopId: this.matShopId,
                    mId: this.matId
                }).then(lang.hitch(this, function (data) {
                    if (data.data.ok === 1) {
                        alert('停止采购成功');
                        this.onAfterShow();
                    } else {
                        alert('停止采购失败  ' + data.data.msg);
                    }
                }));
            }
        },
        toAttentioned: function (evt) {
            var target = evt.target;
            if (target.innerHTML.trim() == "收藏") {
                matStore.matStore({
                    mId: window.did
                }).then(lang.hitch(this, function (data) {
                    if (data.data.ok) {
                        target.innerHTML = "取消收藏";
                    }
                }));
            } else if (target.innerHTML.trim() == "取消收藏") {
                matStore.matStoreCancel({
                    mId: window.did
                }).then(lang.hitch(this, function (data) {
                    if (data.data.ok) {
                        target.innerHTML = "收藏";
                    }
                }));
            }
        },
        //重写运费方法
        getTranFee: function () {
            var tranFee = "运费:" + this.freight + "元";
            return tranFee;
        }
    });
});