// 变更人员：母浚驰
// 变更时间：2016/7/27
// 变更内容：订单
// 变更人员：母浚驰
// 变更时间：2016/08/11
// 变更内容：收货地址选择,刷新邮费

// 变更人员：母浚驰
// 变更时间：2016/8/17
// 变更内容：优惠券信息

// 变更人员：母浚驰
// 变更时间：2016/9/9
// 变更内容：修改为B2B

// 变更人员：母浚驰
// 变更时间：2016/10/31
// 变更内容：找人代付
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/query",
    "dojo/dom-class",
    "dojo/dom-style",
    "dojo/dom-construct",
    "dojo/Deferred",
    "dojox/mobile/EdgeToEdgeList",
    "dojox/mobile/ListItem",
    "dijit/registry",
    "dijit/_WidgetBase",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "cq/biz/mat/mat",
    "cq/biz/ts/order",
    "cq/biz/shop/shop",
    "cq/biz/mk/discount",
    "cq/biz/user/userAddress",
	"cq/biz/user/user",
    "cq/ui/util/addrPick",
    "cq/util/sys/date",
    "cq/util/config/config",
    "cq/ui/common/t/OrderInfo",
    "./PayByOther"
],function(declare, lang, array, query, domClass, domStyle, domConstruct, Deferred, EdgeToEdgeList, ListItem, registry, _WidgetBase, View, _ViewMixin, mat, order, shop, disCount, userAddress, user, addrPick, date, config, OrderInfo, PayByOther){
    // 定义显示列表对象
    var OrderListItem = declare("", [_WidgetBase], {
        details:[],
        orderStatus:"",
        params:null,
        mAmount:0,
        amount:0,
        tAmount:0,
        shopName:"",
        shopId:"",
        coupons:[],
        buildRendering:function(){
            this.inherited(arguments);
            var countQty = 0,couponsDiv="";
            domClass.add(this.domNode,"order-list-item");			
            //创建订单状态栏
            domConstruct.create("div",{
                "class": "order-list-status",
                innerHTML: "<span class='date'>"+this.shopName+"</span>"
            },this.domNode);
            this.detailList = domConstruct.create("div",{
                "class":"order-detail-list"
            },this.domNode);
            array.forEach(this.details,function (detail){
                countQty += detail.qty;
                this.detailList.appendChild(this.createDetails(detail));
            },this);
            domConstruct.create("div",{
                "class":"order-list-count",
                innerHTML:"<span class='qty'>共"+countQty+"件商品</span>"+
                    "<span class='count'>合计:<i>￥"+window.fixedTo(this.amount,3)+"</i></span>"+
                    "<span class='tAmount'>（运费：￥"+window.fixedTo(this.tAmount,3)+"）</span>"
            },this.domNode);
        },
        //创建订单详情的列表
        createDetails:function(data){
            var htmlStr = "";
            htmlStr+='<li class="order-detail-item">';
            htmlStr+=    '<img alt="" src="'+data.mId.logo+'" class="icon" style="margin-top: 1px;">';
            htmlStr+=    '<div class="right" style="display: block;">';
            htmlStr+=       '<div class="shelf-mat-title">'+data.mId.mName+'</div>';  //'<div class="mname">'+data.mId.mName+'</div>'
            htmlStr+=        '<div><span class="price">￥'+window.fixedTo(data.price,3)+'</span>'+(data.price==data.retailPrice?'':'<del style="margin-left:5px;">￥'+window.fixedTo(data.retailPrice,3)+'</del>')+'<span class="qty">x'+data.qty+'</span></div>';
            htmlStr+=    '</div>';
            htmlStr+='</li>';
            return domConstruct.toDom(htmlStr);
        }
    });
    
    //支付方式选择对象
    var PayTypeSelector = declare("", [View, _ViewMixin], {
        payTypes : {
            payDeposit : "point",
            payCredit : "credit",
            payWeiXin : "weixin",
            payAli : "aliwap",
            payByOther : "byother",
            payBocB2C: "bocB2CMobile"
        },
        startSelecte : function (orders) {
            this.orders = orders;
            this.currentDef = new Deferred();
            this.startup();
            this.onAfterShow(this.orders);
            return this.currentDef;
        },
        indexElement : function () {
            //总金额
            this.countDiv = domConstruct.create("div", {
                "class": "order-count",
                style :"height:100%;",
                innerHTML: '<div class="countBox margin-top24 bottom-margin16">应付金额：<span class="footerAmt count">￥0.00</span><span class="footerTranFees none">（余额抵扣：￥0.00）</span></div>'
            }, this.centerPanel.containerNode);
            this.footerAmt = query(".footerAmt", this.countDiv)[0];
            this.footerTranFees = query(".footerTranFees", this.countDiv)[0];
            //初始化平台支持的支付方式
            this.payTypeList = new EdgeToEdgeList({
                "class": "payTypeList padding-top8",
                style :"border:none;"
            });
            this.payTypeList.placeAt(this.centerPanel.containerNode,"last");
            this.payTypeList.on("click",lang.hitch(this, this.choosePayType));
            this.loadPayType();
        },
        loadPayType: function () {
            var htmlStr = "";
            var listItem = null;
            //支付宝
            //htmlStr += "<li class='h-four-pane none payAli' paytype='payAli'>支付宝支付</li>";
            listItem = new ListItem({
                "class" : "h-four-pane none payAli",
                paytype : 'payAli',
                label : "支付宝支付",
                style : "width:auto; padding: 0 15px;"
            });
            this.payTypeList.addChild(listItem);

            //微信
            //htmlStr += "<li class='h-four-pane none payWeiXin' paytype='payWeiXin'>微信支付</li>";
            listItem = new ListItem({
                "class" : "h-four-pane none payWeiXin",
                paytype : 'payWeiXin',
                label : "微信支付",
                style : "width:auto; padding: 0 15px;"
            });
            this.payTypeList.addChild(listItem);
            
            // 中行支付
            listItem = new ListItem({
                "class" : "h-four-pane none payBocB2C",
                paytype : 'payBocB2C',
                label : "银联支付",
                style : "width:auto; padding: 0 15px;"
            });
            this.payTypeList.addChild(listItem);

            //余额支付
            //htmlStr += "<li class='h-four-pane none payDeposit' paytype='payDeposit'>余额支付</li>";
            listItem = new ListItem({
                "class" : "h-four-pane none payDeposit",
                paytype : 'payDeposit',
                label : "余额支付",
                style : "width:auto; padding: 0 15px;"
            });
            this.payTypeList.addChild(listItem);

            //找人代付
            htmlStr += "<li class='h-four-pane payByOther none' paytype='payByOther'>找人代付</li>";
            listItem = new ListItem({
                "class" : "h-four-pane payByOther",
                paytype : 'payByOther',
                label : "找人代付",
                style : "width:auto; padding: 0 15px;"
            });
            this.payTypeList.addChild(listItem);

            //确认和取消按钮
            var option;
            option = {
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick : function() {
                        this.domNode.parentNode.parentNode.removeChild(this.domNode.parentNode);
                        this.isEditing=false;
                    }
                },
                title:""
            };
            this.addHeader(option);
            option = {
                columns: [{
                    label: "确认",
                    onClick: lang.hitch(this, function() {
                        var selected = query(".selected", this.payTypeList.domNode);
                        if (selected.length) {
                            this.payTypeChoose(registry.getEnclosingWidget(selected[0]).paytype);
                        } else {
                            alert("您还没有选择支付方式!");
                        }
                    }),
                    className: "footer-tab-highlight"
                }, {
                    label: "取消",
                    onClick: lang.hitch(this, function() {
                        this.payTypeChoose();
                    }),
                    className: "footer-tab-dark"
                }],
                labelClass: 'font-size2',
                className: 'fix-footer',
                isFooter: true
            };
            this.addColumns(option);
        },
        // getPayTypeInfo:function(){
            // return shop.getPayType();
        // },
        payTypeChoose: function(paytype){
            var ids = [];
            var payAmounts = [];
            for (var shop in this.orders) {
                if (this.orders.hasOwnProperty(shop)) {
                    ids.push(this.orders[shop].order._id);
                    payAmounts.push(this.orders[shop].order.payAmount);
                }
            }
            order.loadDetailById(ids[0]).then(lang.hitch(this,function(data){
                this.dName = user.getUserData().pName||user.getUserData().pName || "未知";
            }))
            if (paytype) {
                window.busy();
                //找人代付
                if(paytype == "payByOther"){
                    window.free();
                    this.userToPay().then(lang.hitch(this,function(data){
                        if(data){
							alert("发送成功！");
                            var param = {};
                            param.receiverId = data._id;
                            param.moveTo = "payToAnother";
                            param.userName = data.userName;
                            param.taskType = 2;
                            if((ids.length > 1 || payAmounts.length > 1)&&ids.length == payAmounts.length){
                                for(var i = 0 ; i < ids.length; i ++){
                                    param._id = ids[i];
                                    param.content = this.dName+"请求您帮其付款，付款金额" 
                                    +payAmounts[i]+"元";
                                    order.findAnotherToPay(param);
                                }
                            }else{
                                param._id = ids[0];
                                param.content = this.dName+"请求您帮其付款，付款金额"+
                                payAmounts[0]+"元";
                                order.findAnotherToPay(param);
                            }
                        } else {
							alert("发送失败！");
						}
                    }));
                }else {
                    //有选择支付方式
                    this.onPayOrder({
                        ids : JSON.stringify(ids),
                        payType : this.payTypes[paytype]
                    }).then(lang.hitch(this, function (data) {
                        window.free();
                        if (data && data.data && data.data.ok !== 1) {
                            alert(data && data.data && data.data.msg || "支付失败!")
                        }
                        this.moveToOrder(ids);
                        if(window.did){
                            this.updatePacTeam(window.did);
                        }
                        this.domNode.parentNode.parentNode.removeChild(this.domNode.parentNode);
                    }));
                }
            } else {
                alert("支付取消!");
                this.moveToOrder(ids);
                this.domNode.parentNode.parentNode.removeChild(this.domNode.parentNode);
            }
        },
        moveToOrder : function (ids) {
            this.isEditing = false;
            if(ids.length > 1){
                //订单数量超过一条进入订单列表
                window.moveToView("orderList");
            } else {
                //单条订单进入订单详情
                window.moveToView("orderDetail",ids[0]);
            }
            //this.domNode.parentNode.removeChild(this.domNode);
        },
        choosePayType: function (e) {
            var dom = e.target,listItem = registry.getEnclosingWidget(dom);
            if(listItem.declaredClass != "dojox.mobile.ListItem") return;
            array.forEach(this.payTypeList.domNode.children, function (li) {
                domClass.remove(li, "selected");
            });
            domClass.add(listItem.domNode, "selected");
        },
        onAfterShow : function (orders) {
            //amount 订单总额含运费
            //mAmount 商品总额.不含运费
            //payAmount 需要现金支付的金额
            //tAmount 运费金额
            var count = 0,
            tranFees = 0,
            payCount = 0;
            for (var shop in orders) {
                if (orders.hasOwnProperty(shop)) {
                    if(orders[shop].order){
                        count += orders[shop].order.amount;
                        tranFees += orders[shop].order.tAmount;
                        payCount += orders[shop].order.payAmount;
                    }
                }
            }

            this.getPayTypeInfo().then(lang.hitch(this,function(payTypes){
                //支付按钮
                var payAli = query(".payAli", this.domNode),
                payWeiXin = query(".payWeiXin", this.domNode),
                payBocB2C = query(".payBocB2C", this.domNode),
                payDeposit = query(".payDeposit", this.domNode),
                payByOther = query(".payByOther", this.domNode);
                this.payAmount = payCount;
                if(payCount > 0){
                    //需要支付的金额大于0才显示其它支付方式,并隐藏余额支付
                    if (payTypes.payAli) {
                        domClass.remove(payAli[0], "none");
                    }
                    if (payTypes.payBocB2C) {
                        domClass.remove(payBocB2C[0], "none");
                    }
                    if (payTypes.payWeiXin) {
                        domClass.remove(payWeiXin[0], "none");
                    }
                     domClass.add(payDeposit[0], "none");
                    //选中默认支付方式
                    if (payTypes.payWeiXin && window.util.versions.weixin) {
                        domClass.add(payWeiXin[0], "selected");
                    }else if (payTypes.payAli) {
                        domClass.add(payAli[0], "selected");
                    }
                }else {
                    domClass.remove(payDeposit[0], "none");
                    //默认选中余额支付
                    domClass.add(payDeposit[0], "selected");

                    domClass.add(payAli[0], "none");
                    domClass.remove(payAli[0], "selected");
                    domClass.add(payWeiXin[0], "none");
                    domClass.remove(payWeiXin[0], "selected");
                }
                //隐藏找人代付按钮
                domClass.remove(payByOther[0], "none");

                this.footerAmt.innerHTML = "￥" + window.fixedTo(payCount, 3);
                //余额抵扣大于0才显示余额抵扣
                if ((count - payCount) > 0) {
                    domClass.remove(this.footerTranFees,"none");
                    this.footerTranFees.innerHTML = "（余额(优惠券)抵扣：￥" + window.fixedTo((count-payCount), 3) + "）";
                }else {
                    domClass.add(this.footerTranFees,"none");
                }
            }));

        },
        // 找人代付,客户列表
		userToPay : function () {
			this.payByOtherUser = new PayByOther();
			this.payByOtherDiv = domConstruct.create("div", {
				style : "height:400px;"
			});
			this.payByOtherDiv.appendChild(this.payByOtherUser.domNode);
			this.showInOverlay(this.payByOtherDiv);
			return this.payByOtherUser.showPayUser();
		}
    });
    return declare("whz.view.OrderInfoB2B", OrderInfo,{
        onAfterShow : function () {
            if(!this.isEditing){
                this.isEditing = true;
                this.refreshOrderInfo();
            }
        },
        refreshOrderInfo:function(){
            this.getDefaultAddr();
        },
        //加载购物车中商品
        loadMatsByIds:function(mids){
            return mat.loadByIds(mids);
        },
        //加载本次的运费
        loadTranFee:function(mids){
            if (this.addrId) {
                mids.addressId = this.addrId;
            } else {
                delete mids.addressId;
            }
            return order.getB2BCouponsAndTAmount(mids);
        },
        //提交订单
        postOrder:function(orderInfo){
            if (this.addrId) {
                orderInfo.addressId = this.addrId;
            } else {
                delete orderInfo.addressId;
            }
            return order.createB2BOrder(orderInfo);
        },
        //支付订单——一组订单
        onPayOrder:function(orderInfo){
            return order.onB2BPayByIds(orderInfo);
        },
        getPayTypeInfos:function(){
            return shop.getB2BPayType();
        },
        //获取地址
        getDefaultAddr:function(){
            userAddress.loadDefaultAddress().then(lang.hitch(this,function(data){
                if(data.data.item&&data.data.item.provinceId){
                    this.setAddr(data.data.item);
                }else {
                    this.setAddr();
                }
            }));
        },
        connectAddrEve:function(){
            this.connect(this.defaultAddr.containerNode,"onclick",this.defaultAddrClick);
        },
        //地址选择点击
        defaultAddrClick:function(e){
            var listitem = registry.getEnclosingWidget(e.target);
            if (listitem.params) {
                addrPick.startEdit(this.addrId ? this.addrId : "",this).then(lang.hitch(this,function(id){
                    if (id) {
                        this.addrId = id;
                    }
                    userAddress.loadById(this.addrId).then(lang.hitch(this, function (data) {
                        this.setAddr(data.data.item);
                    }));
                }));
            } else {
                this.isEditing = false;
                window.moveToView("userAddDetail");
            }
        },
        //地址变化后更新地址,并更新运费
        setAddr:function(data){
            if (data) {
                this.addrId = data._id;
                data.address = data.provinceId.distName + data.cityId.distName + data.countyId.distName + data.detailAddress;
                this.addDefaultAddr(data);
                var m = this.getData();
                m.pName = data.contactName;
                m.phone = data.tel;
                m.address = data.address;
                this.setData(m);
            }else {
                this.addrId = "";
                this.addDefaultAddr();
            }
            this.loadMatsInfo();
        },
        //设置默认地址
        setDefaultAddr:function(data){
        },
        addDefaultAddr:function(data){
            var htmlStr = "";
            this.defaultAddr.destroyDescendants();
            if (data) {
                htmlStr = "<div><p>收货人：<span class='buyerName'>"+ data.contactName +"</span>"+
                "<span class='buyerTel'>"+ data.tel +"</span></p>"+
                "<p>收货地址：<span class='buyerAddr'>"+ data.address +"</span></p></div>";
            } else {
                htmlStr = "<div><p>请添加收货地址</p></div>"
            }
            var listitem = new ListItem({
                label:htmlStr,
                variableHeight:true,
                moveTo:"moveTo",
                params:data
            });
            this.defaultAddr.addChild(listitem);
        },
        //创建订单的商品信息
        makeOrderList:function(shopMatHash,shop,shopId){
            this.matList.addChild(new OrderListItem({
                details:shopMatHash[shopId],
                amount:shop.totalPrice,
                tAmount:shop.tAmount,
                shopName:shop.shopInfo&&shop.shopInfo.shopName||"",
                shopId:shopId
            }));
        },
        payTypeSelectors:function(){
            this.payTypeDiv = domConstruct.create("div", {
                "class": "order-type",
                style : "height:100%;display:block;"
            },this.domNode,"after");
            this.payTypeSelector = new PayTypeSelector({
                getPayTypeInfo : lang.hitch(this.getPayTypeInfos),
                onPayOrder : lang.hitch(this.onPayOrder)
            });
            this.payTypeSelector.placeAt(this.payTypeDiv);
        }
        /* ,
        // 刷新底部
        refreshFooter:function(info){
            var count=query(".footerAmt",this.domNode)[0];
            var countBox = query(".countBox",this.domNode)[0];
            var tranFeesTotal = query(".footerTranFees", this.domNode)[0];
            count.innerHTML="￥"+info.totalPrice;
            domStyle.set(tranFeesTotal,"display","none");
            domStyle.set(countBox,"height","45px");
            domStyle.set(countBox,"line-height","45px");
        },
        // 计算合计
        countCart:function(mats){
            mats = mats||this.mats;
            var qty = 0;
            var totalPrice = 0;
            var tranFees = 0
            //商品价格合计
            for(var item in mats){
                qty+=mats[item].qty;
                totalPrice+=mats[item].retailPrice*mats[item].qty;
            }
            return {
                qty : qty,
                totalPrice : window.fixedTo(totalPrice,3)
            };
        } */
    });
});
