// 变更日期：2016-7-26
// 变更人：干劲
// 变更原因：平台服务页面的初始化

//20160727:干劲，添加平台商品模板的管理入口。
//变更人: 周科吉
//变更日期：2016-7-29
//变更内容：添加直播选项，点击后跳转到聊天详情页面
define([
	"dojo/_base/declare",
	"dojo/_base/lang",
	"dojox/mobile/View",
	"cq/ui/view/_ViewMixin",
	"cq/biz/shop/shop",
	"cq/biz/user/user"
],function(declare, lang, View, _ViewMixin, shop, user){
	return declare("whz.view.PlatformService",[View,_ViewMixin],{
		
		// 初始化页面元素,绑定事件
		onFirstShow:function(){
            var option ={
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "",
                    onClick : function () {
                        history.back();
                    }
                },
                title : "平台服务"
            }
			this.addHeader(option);

            option = {
                isEdge:true,
                lists:[{
                    label:"平台商品管理",
                    noArrow:false,
                    moveTo:"#",
                    onClick:function(){
                        window.moveToView("platMatList");
                        
                    }
                },{
                    label:"平台微信配置",
                    noArrow:false,
                    moveTo:"#",
                    onClick:function(){
                        window.moveToView("shopWeiXin");
                        
                    }
                },{
                    label:"平台支付配置",
                    noArrow:false,
                    moveTo:"#",
                    onClick:function(){
                        window.moveToView("shopPay");
                        
                    }
                },{
                    label:"平台政策配置",
                    noArrow:false,
                    moveTo:"#",
                    onClick:function(){
                        window.moveToView("setPlatform");
                        
                    }
                },{
                    label:"平台商家管理",
                    noArrow:false,
                    moveTo:"#",
                    onClick:function(){
                        window.moveToView("merchantList");
                    }
                },{
                    label:"平台商品模板",
                    noArrow:false,
                    moveTo:"#",
                    onClick:function(){
                        window.moveToView("richTextTempList");
                        
                    }
                },{
                    label:"平台商品分类",
                    noArrow:false,
                    moveTo:"#",
                    onClick:function(){
                        window.moveToView("sortList");
                        
                    }
                },{
                    label:"平台结算",
                    noArrow:false,
                    moveTo:"#",
                    onClick:function(){
                        window.moveToView("shopBalanceList");
                        
                    }
                },{
                    label:"平台退款",
                    noArrow:false,
                    moveTo:"#",
                    onClick:function(){
                        window.moveToView("refundRecordList");
                        
                    }
                },{
                    label:"平台资讯",
                    noArrow:false,
                    moveTo:"#",
                    onClick:function(){
                        window.moveToView("newsList");
                        
                    }
                },{
                    label:"销售员统计",
                    noArrow:false,
                    moveTo:"#",
                    onClick:function(){
                        window.moveToView("saleStatisticList");
                        
                    }
                },{
                    //添加直播选项，点击后跳转到聊天详情页面
                    label:"直播",
                    noArrow:false,
                    moveTo:"#",
                    onClick:function(){
                        window.moveToView("channelListB");
                    }
                },{
                    label:"商家统计",
                    noArrow:false,
                    moveTo:"#",
                    onClick:function(){
                        window.moveToView("trainProcess");
                    }
                }]
            };
            this.addLists(option);
			option = {
				columns:[{
					icon:'images/icon/shop_footer_highlight.png',
					iconClass:'footer-tab-img',
					label:'首页',
					onClick:function(){
						window.moveToView("home");
					}
				},{
					icon:'images/icon/member_footer.png',
					iconClass:'footer-tab-img',
					label:'买',
					onClick:function(){
						window.moveToView("b2bBuy");
					}
				},{
					icon:'images/icon/sale_footer.png',
					iconClass:'footer-tab-img',
					label:'卖',
					onClick:function(){
						localStorage.setItem("fromTrends","ok");
						window.moveToView("sale");
					}
				},{
                    icon:'images/icon/news_footer.png',
                    iconClass:'footer-tab-img',
                    label:'资讯',
                    onClick:function(){
                        window.moveToView("trends");
                    }
                },{
					icon:'images/icon/more_footer_highlight.png',
					iconClass:'footer-tab-img',
					label:'更多',
					onClick:function(){
						window.moveToView("others");
					}
				}],
				valueClass:'font-size3',
				labelClass:'font-size1',
				className:'fix-footer',
				isFooter:true
			};
			user.getUserInfo().then(lang.hitch(this,function(data){
                var item = data && data.data && data.data.item;
                if(item.role == 2){
                    option.columns.splice(2,1);
                }
                this.addColumns(option);                
            }));
		}
	});
});
