// 变更人：潘云
// 变更时间；2016-05-17
// 变更内容：
define(
    [
      "dojo/_base/declare", 
	  "dojo/_base/lang", 
	  "dojox/mobile/View",
	  "dojox/mobile/EdgeToEdgeStoreList", 
	  "cq/ui/view/_ViewMixin",
	  "dojo/query",
      "dojox/mobile/IconItem",
	  "cq/biz/mk/qrCode",
	  "cq/biz/user/user"
    ],
    function(declare, lang,View, EdgeToEdgeStoreList, _ViewMixin, query, IconItem, qrCode, user) {
      return declare("whz.view.QrCodeDetail", [ View, _ViewMixin ], { 
        
        isEditing : false,
        indexElement : function() {

        },
        //初始化事件
        initEvent : function() {},

        onAfterShow : function() {
			// 如果是修改，加载二维码信息
			if (!this.isEditing) {
				this.isEditing = true;
				if(!window.did){
					this.setData({
						isUse:true
					});
					this.refreshData();
				}else{
					/* xxx.xxx(window.did).then(lang.hitch(this, function(data) {
						// 显示二维码信息
						this.setData(data.data.item);
						this.refreshData();
					})); */
				}
			}
        },
        refreshData : function() {
          this.inherited(arguments);
          // 判断是否有图
          // 删除添加按钮外的所有图标
          var m = this.getData();
        },
        onFirstShow : function() {
          this.setData({});
          var option = {
            left : {
              iconButton : ' ',
              arrow : "left",
              label : "返回",
              onClick : lang.hitch(this,function() {
				  this.isEditing = false;
				  window.moveToView("qrCode");
				})
            },
            title : window.did?"添加二维码":"编辑二维码",
            right :
                {iconButton : ' ', onClick : this.onSaveStore, label : "完成"}
          };
          this.addHeader(option);
          option =
              {canAdd : true, icons : [], editable : true, class : "no-shake"};
          this.iconContainer = this.addImagePicker(option);
          option = {
            isEdge : true,
            lists : [
              {
				label:'姓名',
				rightText : '',
				moveTo : "#",
				__view_id : this.id,
				edit:{
					type:'ref',
					field:'userId',
					moveTo:"#",
					//选择商品的示例
					params:{
						target:user.getOnSaleUrl(),
						query:{
							isUse:true,
						},
						searchField:"modelName",labelField:"modelName"
					},
					placeHolder:"必填"
				}
              },
              {
                label : '二维码是否临时',
                noArrow : true,
                edit : {type : 'checkbox', field : 'isTemp'}
              },
			  {
					label:'临时的二维码过期时间',
					rightText : '',
					moveTo : "#",
					__view_id : this.id,
					edit:{
						type:'date',
						field:'expireDate'
					}
				},
            ],
          };
          this.addLists(option);
		  this.onAfterShow();
        },
        onSaveStore : function() {
			if(this.isEditing){
				this.isEditing = false;

				// 当前节点失去焦点
				focusUtil.curNode&&focusUtil.curNode.blur();
				// setTimeout 保存数据
				setTimeout(lang.hitch(this, function(){
					var m = this.getData();
					var iconItems = this.iconContainer.getChildren();
					//检查是否设置了图
					if (iconItems.length > 1) {
						m.logo = iconItems[0].icon;
					} else{
						m.logo = "";
					}
					// 检查必填项是否已填
					var msg=this.verify(m);
					if(msg){
						alert(msg);
						this.isEditing = true;
						return;
					}
					m.images = detailImages;
					mat.save(m).then(function() {
						window.moveToView("qrCode");
					});
				}), 0);
			}
        },
		verify:function(data){
			var msg="";
			if(!data.code){
				msg="二维码";
			}
			return msg;
		}
      });
    });
