//创建人：周超
//创建时间：2016/9/7
//创建内容：注册页面邀请人
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "cq/ui/b/s/Svcregist",
    "cq/biz/user/user"
],function(declare, lang, Svcregist, user){
    return declare("whz.view.RegisterB", [Svcregist], {
        onFirstShow: function() {
            this.inherited(arguments);
            option = {
                isEdge: true,
                class: "top-bottom-margin16",
                lists: [{
                    label: '邀请人',
                    noArrow: true,
                    edit: {
                        type: 'tel',
                        field: 'inviter',
                        placeHolder: '请输入邀请人'
                    }
                }]
            };
            this.addLists(option);   
        },
        submi:function(info){
            //判断邀请人是否存在
            if(info.inviter){
                this.inviter = info.inviter;
                window.busy();
                //若存在则通过其值查找id
                user.checkPlatformUser(info.inviter).then(lang.hitch(this, function(data) {
                    window.free();
                    if(data.data.ok === 0){
                        //不存在，提示并返回
                        alert("邀请人不存在，请重新检查！");
                        return;
                    }else{
                        //id 存在  id从新赋值给邀请人字段
                        info.inviter = data.data.item._id
                        this.saveData(info);
                    }
                }));
            }else{
                this.saveData(info);
            }
        },
    });
});