//  变更人:张松
//  变更时间:2016/7/25
//  变更原因:盐业产品卖家页面
//  变更人:张松
//  变更时间:2016/8/1
//  变更原因:订单数错误
//  变更人:张金鹏
//  变更时间:2016/09/05
//  变更原因:新增评价管理入口
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
	"dojo/query",
    "dojo/dom-style",
    "dojox/mobile/View",
    "dojox/mobile/FixedSplitter",
    "dojox/mobile/Pane",
	"cq/ui/view/_ViewMixin",
	"cq/biz/shop/shop",
    "cq/biz/ts/order"
], function (declare, lang, array, query, domStyle, View, FixedSplitter, Pane, _ViewMixin, shop, order) {
    return declare("whz.view.Sale", [View,_ViewMixin], {
        onFirstShow : function () {
            option = {src:'images/banner.jpg', onClick:function(){}};
			this.addImage(option);
            this.addIoInfoArea();
            option = {
                columns:[{
                    icon:'images/icon/shop.png',
                    iconClass:'width-32',
                    className:'flex1',
                    label:'卖家服务',
                    onClick:function(){
                        localStorage.removeItem("fromTrends");
                        window.moveToView("saleService");
                    }
                },{
                    icon:'images/icon/mat.png',
                    iconClass:'width-32',
                    className:'flex1 saleVerified',
                    label:'商品管理',
                    onClick:function(){
                        window.moveToView("matList");
                    }
                },{
                    icon:'images/icon/crmicon.png',
                    iconClass:'width-32',
                    className:'flex1 saleVerified',
                    label:'客户管理',
                    onClick:function(){
                        window.moveToView("userList");
                    }
                },{
                    icon:'images/icon/order.png',
                    iconClass:'width-32',
                    className:'flex1 saleVerified',
                    label:'订单管理',
                    onClick:function(){
                        window.moveToView("orderListB");
                    }
                }],
                valueClass:'font-size3',
                labelClass:'font-size1',
                forceWidth:false,
                className:'bottom-margin8 padding-top-bottom16'
            };
            this.addColumns(option);
            option={
                columns:[{
                    icon:'images/icon/news.png',
                    iconClass:'width-32',
                    className:'flex1',
                    label:'优惠活动',
                    onClick:function(){
                        window.moveToView("coupon");
                    }
                },{
                    icon:'images/icon/distribution.png',
                    iconClass:'width-32',
                    className:'flex1',
                    label:'客户分销',
                    onClick:function(){
                        window.moveToView("cShop");
                    }
                },{
                    icon:'images/icon/cusSservice.png',
                    iconClass:'width-32',
                    className:'flex1',
                    label:'客服',
                    onClick:function(){
                        window.moveToView("pendingMsg");
                    }
                },
                //添加评价管理的入口    2016/09/05    张金鹏
				{
                    icon:'images/icon/crmicon.png',
                    iconClass:'width-32',
                    className:'flex1',
                    label:'评价管理',
                    onClick:function(){
                        window.moveToView("evaListb");
                    }
                }],
                valueClass:'font-size3',
                labelClass:'font-size1',
                forceWidth:false,
                className:'bottom-margin8 padding-top-bottom16'
            };
            this.gblAndpm = this.addColumns(option);
            option={
                columns:[{
                    icon:'images/icon/news.png',
                    iconClass:'width-32',
                    className:'flex1',
                    label:'抽奖活动',
                    onClick:function(){
                        window.moveToView("prizeList");
                    }
                },{
                    icon:'images/icon/news.png',
                    iconClass:'width-32',
                    className:'flex1',
                    label:'注册送',
                    onClick:function(){
                        window.moveToView("registerGiftList");
                    }
                },{
                    icon:'images/icon/news.png',
                    iconClass:'width-32',
                    className:'flex1',
                    label:'商品送',
                    onClick:function(){
                        window.moveToView("shopGiftList");
                    }
                },{
                    icon:'images/icon/coupon.png',
                    iconClass:'width-32',
                    className:'flex1',
                    label:'优惠活动',
                    onClick:function(){
                        window.moveToView("coupon");
                    }
                }],
                valueClass:'font-size3',
                labelClass:'font-size1',
                forceWidth:false,
                className:'bottom-margin8 padding-top-bottom16'
            };
            //this.gblAndpm = this.addColumns(option);
            option = {
				columns:[{
					icon:'images/icon/shop_footer_highlight.png',
					iconClass:'footer-tab-img',
					label:'首页',
					onClick:function(){
						window.moveToView("home");
					}
				},{
					icon:'images/icon/member_footer.png',
					iconClass:'footer-tab-img',
					label:'买',
					onClick:function(){
                        //修改买进入的view为b2bBuy-20160906-肖芳圆
                        window.moveToView("b2bBuy");
					}
				},{
					icon:'images/icon/sale_footer_highlight.png',
					iconClass:'footer-tab-img',
					label:'卖',
					onClick:function(){
						localStorage.setItem("fromTrends","ok");
						window.moveToView("sale");
					}
				},{
                    icon:'images/icon/news_footer.png',
                    iconClass:'footer-tab-img',
                    label:'资讯',
                    onClick:function(){
                        window.moveToView("trends");
                    }
                },{
					icon:'images/icon/more_footer.png',
					iconClass:'footer-tab-img',
					label:'更多',
					onClick:function(){
						window.moveToView("others");
					}
				}],
				valueClass:'font-size3',
				labelClass:'font-size1',
				className:'fix-footer',
				isFooter:true
			};
			this.addColumns(option);
            this.onAfterShow();
        },
        addIoInfoArea:function(){
            var option = {
				columns:[{
					value:'0',
					label:'今日销售'
				},{
					value:'0',
					label:'近30日销售'
				},{
					value:'0',
					label:'订单数',
                    onClick:function(){
                        window.moveToView("orderListB");
                    }
				}],
				splitter:'./splitter.jpg',
				valueClass:'font-size3',
				labelClass:'font-size1',
				className:'shopIoInfoArea padding-top-bottom16'
			};
			this.addColumns(option);
        },
        updateIOInfo:function(){
			var shopIoInfoArea = query(".shopIoInfoArea",this.domNode)[0];
			if(shopIoInfoArea){
				var shopIoNodes = query('.font-size3',shopIoInfoArea);
				if(3===shopIoNodes.length){
					shop.summary().then(function(ioInfo){
						shopIoNodes[0].innerHTML = ioInfo.data.item.todaySale.toFixed(2);
						shopIoNodes[1].innerHTML = ioInfo.data.item.monthSale.toFixed(2);
						// shopIoNodes[2].innerHTML = ioInfo.data.item.userCount.toFixed(0);
					});
                    order.summaryPayedCount({days:30}).then(function(data){
                        shopIoNodes[2].innerHTML = data&&data.data&&data.data.item&&data.data.item.count&&data.data.item.count.toFixed(0)||0;
                    });
				}
			}
		},
        createContent : function () {
            var fixedSplitter = new FixedSplitter({
                orientation:'H'
            });
            fixedSplitter.placeAt(this.centerPanel.containerNode);
            var groupPane = new Pane({
                style : "width:90px;"
            });
            fixedSplitter.addChild(groupPane);
            var matListPane = new Pane();
            fixedSplitter.addChild(matListPane);
        },
        onAfterShow : function () {
			shop.loadCurrentShop().then(lang.hitch(this,function(shopData){
				if(shopData.data.isVerified){
					domStyle.set(this.gblAndpm, "display", "flex");
					array.forEach(query(".saleVerified", this.domNode), function(item){
						domStyle.set(item, "display", "inline-block");
					});
				}else{
					domStyle.set(this.gblAndpm, "display", "none");
					array.forEach(query(".saleVerified", this.domNode), function(item){
						domStyle.set(item, "display", "none");
					});
				}
			}));
            this.updateIOInfo();
        }

    });
});
