define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-class",
    "dijit/registry",
    "cq/ui/b/s/ShopCustomerMsg"
], function(declare, lang, domClass, registry, ShopCustomerMsg) {
    return declare('whz.view.ShopCustomerMsg', [ShopCustomerMsg], {
        addModoleList: function() {
            return [{
                label: '包邮金额',
                noArrow: true,
                edit: {
                    type: 'text',
                    field: 'dirLmt',
                }
            }, {
                label: '运费',
                noArrow: true,
                edit: {
                    type: 'text',
                    field: 'tranFee',
                }
            }, {
                label: '发货地点',
                noArrow: true,
                edit: {
                    type: 'text',
                    field: 'tranAddr'
                }
            }//, {
             //   label : '销售区域',
             //   rightText : "<div class='saleLand' style='word-wrap: break-word'>{{tranRegion}}</div>",
             //   variableHeight:true,
             //   onClick:lang.hitch(this,function(){
                    //this.isEditing = false;
                    //window.moveToView("positionList");
             //   })
             //}
             ,{
                label: '启用运费模板',
                edit: {
                    type: 'checkbox',
                    field: 'freightTemplated'
                },
                onClick: lang.hitch(this, function(e) {
                    var domNode = registry.getEnclosingWidget(e.target);
                    if (e.target && domNode.declaredClass === "dojox.mobile.Switch") {
                        this.isShow = !this.isShow;
                        if (this.isShow) {
                            domClass.remove(this.footerButton, 'none');
                        } else {
                            domClass.add(this.footerButton, 'none');
                        }
                        this.resize();
                    }
                })
            }, {
                label: "是否启用白名单",
                moveTo: "#",
                edit: {
                    type: 'checkbox',
                    field: 'isWhiteList'
                }
            }];
        },
    });
});
