//变更人:周超
//变更时间:2016-09-08
//变更原因: 继承基类
//变更人:徐阿雪
//变更时间:2016/11/11
//变更原因: 隐藏导航栏最右边按钮
define([
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-class",
    "dojo/dom-style",
    "dojo/query",
    "dijit/registry",
    "cq/biz/shop/partner",
    "cq/biz/shop/shop",
    "cq/biz/user/user",
    "cq/ui/common/s/SupplyBus"
], function(array, declare, lang, domClass, domStyle, query, registry, partner, shop, user, SupplyBus) {
    return declare("whz.view.SupplyBus", [SupplyBus], {
        onFirstShow:function(){
            this.inherited(arguments);
            //添加供应商按钮
            //this.attendSupplyer = query(".attendSupplyer-btn", this.banner)[0];
			this.attendSupplyer = query(".attendSupplyer-btn", this.footerButton)[0].lastChild;
            //添加供应商
            //this.connect(this.attendSupplyer, "onclick", this.isShowAddSupplyState);              
            //同意按钮
            //this.argreeNode = query(".argreeNode", this.banner)[0];
            //this.connect(this.argreeNode, "onclick", this.agreeCustmer);
            //拒绝按钮
            //this.refuseNode = query(".refuseNode", this.banner)[0];
            //this.connect(this.refuseNode, "onclick", this.refuseCustmer);
        },
        onAfterShow:function(){
            this.inherited(arguments);
            domClass.add(query(".changestyle", this.domNode)[0],"none");
        },
		// 添加底部导航
		addFooterButton:function(){
			option = {
                columns:[{
                    className:'flex2 footer-tab-dark',
                    label:'首页',
                    onClick:function(){
                        window.moveToView("home");
                    }
                },{
                    className:'flex2 footer-tab-dark',
                    label:'买',
                    onClick:function(){
                        window.moveToView("b2bBuy");
                    }
                },{
                    className:'flex2 footer-tab-dark',
                    label:'联系客服',
                    onClick:function(){
                        this.toTalk();
                    }
                },{
                    className:'flex2 footer-tab-dark',
                    label:'认证信息',
                    onClick:function(){
                        window.moveToView("supplyBusDetail",window.did);
                    }
                },{
                    className:'flex2 footer-tab-dark attendSupplyer-btn',
                    label:'添加供应商',
                    onClick:function(){
                        this.isShowAddSupplyState(query(".attendSupplyer-btn", this.footerButton)[0]);
                    }
                }],
                isFooter:true,
				splitter : './splitter.jpg'
            };
            var role = user.getCurrentUserRole();
			// 销售员隐藏添加供应商
            if(role == 2){
                option.columns.splice(5,1);          
            }
            this.footerButton = this.addColumns(option);             
		},
        agreeCustmer : function(){
            shop.agreeAdd(window.did).then(lang.hitch(this,function(data){
                this.onAfterShow();
            }));
        },
        refuseCustmer : function(){
            shop.disAgree(window.did).then(lang.hitch(this,function(data){
                this.onAfterShow();
            }));
        },
        //依据是否为供应商决定是否显示价格
        processMatData : function(data){
            if(!this.isSupplier){
                array.forEach(data,function(item){
                    item.retailPrice="需要添加供应商后才能查看价格";
                });
            }
        },
		showState:function(targ,num){
            /*var out = query(".attendSupplyer-btn",this.domNode)[0];
            if(num == 1){
                //显示为添加供应商时为橘色样式
                domClass.add(targ, "notAttentioned");
                domClass.remove(targ, "attentioned");
                domClass.remove(out, "forth-btn-t");
            }else if(num == 0){
                //显示为删除供应商时为白色样式
                domClass.add(targ, "attentioned");
                domClass.remove(targ, "notAttentioned");
                domClass.remove(out, "forth-btn-t");
            }else if(num == 2){
                //显示为申请时样式为....样式
                domClass.add(out, "forth-btn-t");
                domClass.remove(targ, "notAttentioned");
                domClass.remove(targ, "attentioned");
            }*/
        },
        showButton:function(){
			// B2B模式下隐藏粉丝数、关注按钮
			domClass.add(this.fansNumNode,"none");
			domClass.add(this.attendStateNode,"none");
			domClass.remove(query(".mat-num",this.domNode)[0],"none");
			domClass.remove(query(".sale-num",this.domNode)[0],"none");
            //若当前商家已认证则显示添加按钮
			var targ = query(".attendSupplyer-btn", this.footerButton)[0];
            shop.loadCurrentShop().then(lang.hitch(this,function(data){
				//var targ = query(".attendSupplyer-btn", this.banner)[0];					
                // 销售员隐藏添加供应商按钮
				var role = user.getCurrentUserRole(); 
				if(data.data.isVerified&&role!=3){
                    domClass.remove(targ,"none");
                } else {
                    domClass.add(targ,"none");
                }
				// 底部按钮做显示隐藏后需要重新计算宽度，暂没有接口实现
            }));
        },
        //显示添加为供应商/删除供应商
        //  BUG：曾经添加过的供应商再次添加的筛选条件isUse
        isShowAddSupplyState:function(evt){			
            if(evt.lastChild.innerHTML === "添加供应商"){
                partner.addSupplier(window.did).then(lang.hitch(this,function(data){
                    if(data.data.ok == 1){
						if(data&&data.data&&data.data.item.isSupplier){
							alert("添加成功！");
						} else {
							alert("已向供应商发送申请，请等待审核！");
						}                        
                        this.onAfterShow();
                    }else if(data.data.msg == "不在销售区域"){
                        alert("不在该商销售区域！");
                    }else{
                        alert("添加失败！");
                    }
                }));
            }else if(evt.lastChild.innerHTML === "删除供应商"){
                partner.removeSupplier(window.did).then(lang.hitch(this,function(data){
                    if(data.data.ok == 1){
                        alert("删除成功！");
                        this.onAfterShow();
                    }else{
                        alert("删除失败！");
                    }
                }));
            }
        },
        loadMatDef:function(){
            var def = partner.loadById(window.did);
            def.then(lang.hitch(this,function(isSupplyData){
                if(isSupplyData.data){
                    this.isSupplier = isSupplyData.data.isSupplier;
                    this.customerState = isSupplyData.data.customerState;
                    if(isSupplyData.data.ok!==0){
                        if(isSupplyData.data&&(isSupplyData.data.isSupplier == true)&&(isSupplyData.data.isDelete !== true)){
                            this.attendSupplyer.innerHTML = "删除供应商";
                            //样式控制,白色
                            this.showState(this.attendSupplyer,0)
                        }else if(isSupplyData.data.supplierState==1){
                            this.attendSupplyer.innerHTML = "申请中";
                            this.showState(this.attendSupplyer,2)
                        }else{
                            this.attendSupplyer.innerHTML = "添加供应商";
                            this.showState(this.attendSupplyer,1)
                        }
                    }else{
                        this.attendSupplyer.innerHTML = "添加供应商";
                        this.showState(this.attendSupplyer,1)
                    }
                }
            }));
            return def;
        }
    });
});
