//创建人:周超
//创建时间:20176-07-12
//创建内容:畜舍档案
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-class",
    "dojo/query",
    "dojo/on",
    "dojo/store/JsonRest",
    "dojo/dom-construct",
    "dijit/registry",
    "dijit/_WidgetBase",
    "dojox/mobile/View",
    "dojox/mobile/EdgeToEdgeStoreList",
    "cq/biz/shop/shop",
    "cq/biz/shop/businessDynamics",
    "cq/ui/util/districtOverlay",
    "cq/ui/view/_ViewMixin"
], function (declare, lang, domClass, query, on, JsonRest, domConstruct, registry, _WidgetBase, View, EdgeToEdgeStoreList, shop, businessDynamics, districtOverlay, _ViewMixin) {
    /*
    var OrderListItem = declare("", [_WidgetBase], {
        params:null,
        shopName:"",
        saleAmount:"0",
        shopMatNum:"0",
        logo:"images/logo.png",
        baseClass:"mat-list-item",
        buildRendering:function(){
            this.inherited(arguments);
            //列表项的htmlStr
            var itemHtmlStr = ''
                +"<div class='hflex goShopDetail' style='height:'45px';float:left';width:76%;line-height:45px>"+
                "<div><img style='width: 64px;' src='" + this.logo + "' /></div>"+
                "<div style='width: 60%;'>"+
                "<div style='margin-left: 2%; margin-top: 1%;'>"+this.shopName+"</div>"+
                "<div style='margin-left: 2%; margin-top: 1%;'>商品数："+this.shopMatNum+"</div>"+
                "<div style='margin-left: 2%; margin-top: 1%;'>销量："+this.saleAmount+"</div>"+
                +"</div>"+
                "</div>"
            this.domNode.appendChild(domConstruct.toDom(itemHtmlStr));
        }
    });*/
    return declare("whz.view.SupplyListB", [View, _ViewMixin], {
        //筛选条件
        params : null,
        start : 0,
        pageSize:20,
        totalCount:0,
        onAfterShow : function () {
            if(!this.store){
                //数据源
                this.params = {
                    //isDelete : false,
                    isVerified:true
                };
                this.store = new JsonRest({
                    target : this.getShopByPlatformUrl()
                });
                var queryResult = this.storeList.setStore(this.store, this.params,{
                    start:this.start,
                    count:this.pageSize
                });
                // 将数据源赋值给storeList
                this.onLoadListData(queryResult,this.start,this.pageSize);
            }else{
                this.setQuery(this.storeList.get("query"));
            }
        },
        //获取头部option的函数,可重载
        getHeadOption:function () {
            return {
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick : function () {
                        this.displaySelect = false;
                        domClass.add(this.selectObject, 'none');
                        history.back();
                    }
                },
                title : "供应商",
                right: {
                    iconButton: ' ',
                    onClick: function() {
                        this.selectOption();
                    }//,
                    //label: "<div class='addFuHao'>+</div>",
                }
            };
        },
        //获取商品链接可重载
        getShopByPlatformUrl:function () {
            return businessDynamics.load();
            //return shop.getShopByPlatform();
        },
        onFirstShow : function () {
            var option = this.getHeadOption();
            this.addHeader(option);
            this.selectObject = domConstruct.create('ul', {
                class: 'selectOption none'
            }, this.domNode);
            domConstruct.create('li', {
                innerHTML: '全部',
                click: lang.hitch(this, function(e) {
                    this.displaySelect = true;
                    this.selectOption();
                    this.goToSelect(e);
                    //window.moveToView("matGroupList");
                })
            }, this.selectObject);
            domConstruct.create('li', {
                innerHTML: '新秀推荐',
                click: lang.hitch(this, function(e) {
                    this.selectState = true;
                    this.selectOption();
                    this.goToSelect();
                })
            }, this.selectObject);
            domConstruct.create('li', {
                innerHTML: '明星推荐',
                click: lang.hitch(this, function(e) {
                    this.selectState = true;
                    this.selectOption();
                    this.goToSelect();
                })
            }, this.selectObject);
            option = {
                isHeader:true,
                placeHolder : "请输入要查询条件，按回车查询",
                class : "cqSearchBox",
                type : "search",
                onInput : lang.hitch(this, function (evt) {
                    if (evt.keyCode == 13) {
                        this.params.search = evt.target.value;
                        this.params.using = true;
                        this.setQuery(this.params);
                        this.params.mName = '';
                        evt.target.value = "";
                    }
                })
            };
            this.addTextBox(option);
            option = {
                isHeader:true,
                columns : [{
                        label : '区划',
                        className : 'districtSelect',
                        onClick: this.changeDistrictSelect
                    }, /*{
                        label : '行业',
                        onClick: this.changeSaleOut
                    }, */{
                        label : '距离',
                        onClick: this.changeDistanceSelect
                    }, {
                        label : '销量',
                        onClick: this.changeSellAmountSelect
                    },/* {
                        label : '信用',
                        onClick: this.changeSaleOut
                    },{
                    'className':'verticalList2 flex1 changestyle',
                    onClick:lang.hitch(this,function(e){
                        this.tabNav(e,"2");
                    })
                }*/],
                labelClass : 'font-size1 tab-selector',
                //forceWidth: false
            };
            this.addColumns(option);
            this.storeList = new EdgeToEdgeStoreList({
                append : true,
                constraint : false,
                query : {},
                className:"mat-list-verticalList2",
                variableHeight : true,
                //获取数据完成后调用的的处理方法
                onComplete : lang.hitch(this, function (data) {
                    for (var i = 0; i < data.length; i++) {
                        if(data[i].mIds){
                            for(var j=0;j<6;j++){
                                if(!data[i].mIds[j]){
                                    data[i].mIds[j] = {};
                                    data[i].mIds[j].logo = "";
                                    data[i].mIds[j].retailPrice = "";
                                }else if(data[i].mIds[j]&&data[i].mIds[j].retailPrice){
                                    data[i].mIds[j].retailPrice = "￥"+data[i].mIds[j].retailPrice;
                                }
                            }
                        }
                        var htmlNode0,htmlNode1,htmlNode2;
                        if(data[i].mIds[0].logo){
                            htmlNode0 = "<div style='width: 33.3%;'>"
                                       +"<div style='width: 97%;'>"
                                       +"<img class='goMatDetail' style='width: 100%;float: left;border-radius: 3px;' src='" + data[i].mIds[0].logo + "' />"
                                       +"<div style='float: right;margin-top: -16px;color: #fbfcfc !important;background: rgba(128, 128, 128, 1);'>"+"</div>"
                                       +"</div>"
                                       +"</div>"
                        }
                        if(data[i].mIds[1].logo){
                            htmlNode1 = "<div style='width: 33.3%;'>"
                                       +"<div style='width: 97%;'>"
                                       +"<img class='goMatDetail' style='width: 100%;float: left;border-radius: 3px;' src='" + data[i].mIds[1].logo + "' />"
                                       +"<div style='float: right;margin-top: -16px;color: #fbfcfc !important;background: rgba(128, 128, 128, 1);'>"+"</div>"
                                       +"</div>"
                                       +"</div>"
                        }
                        if(data[i].mIds[2].logo){
                            htmlNode2 = "<div style='width: 33.3%;'>"
                                       +"<div style='width: 97%;'>"
                                       +"<img class='goMatDetail' style='width: 100%;float: left;border-radius: 3px;' src='" + data[i].mIds[2].logo + "' />"
                                       +"<div style='float: right;margin-top: -16px;color: #fbfcfc !important;background: rgba(128, 128, 128, 1);'>"+"</div>"
                                       +"</div>"
                                       +"</div>"
                        }
                        data[i]._label =
                        "<div class='hflex'>"
                        +"<div><img class='goShopDetail' style='width: 45px;' src='" + (data[i].fromShopId.logo||"images/logo.png") + "' /></div>"             
                        +"<div style='margin-left: 3%' class='flex1'><div style='font-size: 18px;' class='goShopDetail'>"+data[i].fromShopId.shopName+"</div>"
                        +"<div class='hflex' style='margin-top:10px;font-size:12px;'><div style='width: 45%;'>商品数："+(data[i].fromShopId.shopMatNum||"")+"</div>"
                        +"<div>销量："+data[i].fromShopId.saleAmount+"</div></div>"
                        +"<div>"
                        +"</div></div>"
                        +"</div>"
                        +"<hr/>"
                        +"<div class='hflex'>"
                        +(htmlNode0||"")
                        +(htmlNode1||"")
                        +(htmlNode2||"")
                        +"</div>"
                        data.moveTo = "#";
                        htmlNode0="";
                        htmlNode1="";
                        htmlNode2="";
                    }
                    this.storeList.generateList(data);
                    this.busy = false;
                }),
                queryOptions : {
                    count : this.pageSize,
                    start : this.start
                },
                itemMap : {
                    _label : "label",
                    _logo : "icon",
                    moveTo : "moveTo"
                }
            });
            this.storeList.placeAt(this.centerPanel.containerNode, "last");
            this.storeList.on("click", lang.hitch(this, this.onClickList));
            this.centerPanel.on("afterscroll", lang.hitch(this, this.onLoadMore));
            this.connectEvent();
            this.onAfterShow();
        },
        onClickList : function (evt) {
            // 得到点击的ListItem
            var li = registry.getEnclosingWidget(evt.target);
            var _id = li.params.fromShopId._id;
            if(domClass.contains(evt.target, "goShopDetail")){
                window.moveToView("supplyBus", _id);
            }else if(domClass.contains(evt.target, "goMatDetail")){
                for(var i=0;i<li.params.mIds.length;i++){
                    if(evt.target.src == li.params.mIds[i].logo){
                        var param = li.params.mIds[i].mId+"_"+_id
                        window.moveToView("matDetail",param);
                        break;
                    }
                }
            }
        },
        //只要点击的节点为+号之外的节点则隐藏这个节点
        connectEvent:function(){
            //this.connect(this.document,"onclick",this.selectHide);
        },
        selectHide : function(evt){
            if(!domClass.contains(evt.target, "addFuHao")&&!domClass.contains(evt.target.childNodes[0], "addFuHao")){
                this.displaySelect = true;
                this.selectOption();
            }
        },
        // 创建选项盒子
        selectOption: function() {
            if (this.displaySelect) {
                domClass.add(this.selectObject, 'none');
                this.displaySelect = false;
            } else {
                domClass.remove(this.selectObject, 'none');
                this.displaySelect = true;
            }
        },
        tabNav:function(e,type){
            var dom=e.target;
            //是否是切换列表显示
            if(dom && type != 2){
                array.forEach(this.appNavItems,function(index){
                    domClass.add(index,"none");
                },this);
                if(domClass.contains(dom,"selected")){
                    this.dropUp();
                }else{
                    this.clearSelected();
                    domClass.add(e.target,"selected");
                    domClass.remove(this.appNavItems[type],"none");
                    this.dropDown();
                }
            } else {
                var dom = query(".changestyle", this.domNode)[0];
                if (domClass.contains(dom, "verticalList2")) {
                    domClass.replace(dom, "levelList", "verticalList2");
                    domClass.replace(this.storeList.domNode, "mat-list-levelList", "mat-list-verticalList2");
                }else {
                    domClass.replace(dom, "verticalList2", "levelList");
                    domClass.replace(this.storeList.domNode, "mat-list-verticalList2", "mat-list-levelList");
                }
            }
        },
        onLoadMore : function (evt) {
            if(!this.busy&&evt.afterBottom){
                this.start = this.start+this.pageSize;
                if(this.canLoadMore(this.start)){
                    console.log("加载更多商品");
                    this.busy = true;
                    setTimeout(lang.hitch(this, function () {
                        var queryResult = this.storeList.setQuery(this.storeList.get("query"), {
                            start : this.start,
                            count : this.pageSize
                        });
                        this.onLoadListData(queryResult,this.start,this.pageSize);
                    }), 1000);
                }
            }
        },
        clearSelected: function() {
            var items = query('.tab-selector', this.domNode);
            for (var i = 0; i < items.length; i++) {
                domClass.remove(items[i], "selected");
            }
        },
        goToSelect : function(){
            alert("新秀推荐");
        },
        //根据销量排序
        changeSellAmountSelect : function(e){
            //alert("按销量排序");
            this.clearSelected();
            domClass.add(e.target, "selected");
            this.params.isVerified = true;
            this.params.isDelete = false;
            this.params.saleAmount = 1;
            delete this.params.road;
            this.setQuery(this.params);
        },
        //根据距离排序
        changeDistanceSelect : function(e){
            //alert("距离");
            this.clearSelected();
            domClass.add(e.target, "selected");
            this.params.isVerified = true;
            this.params.isDelete = false;
            this.params.road = 1;
            delete this.params.saleAmount;
            this.setQuery(this.params);
        },
        //根据区划筛选
        changeDistrictSelect : function(e){
            this.params.isVerified = true;
            this.params.isDelete = false;
            var param;
            districtOverlay.selectDistrict(param,true).then(lang.hitch(this, function(data) {
                var showLabel;
                if (data.province) {
                    showLabel = data.province.label;
                    this.params.provinceId = data.province._id;
                    if(data.city){
                        if("全部" != data.city.label)
                        showLabel += data.city.label;
                        this.params.cityId = data.city._id;
                        if(data.county){
                            showLabel += data.county.label;
                            this.params.countyId = data.county._id;
                        }
                    }
                    e.target.innerHTML = showLabel;
                }
                this.setQuery(this.params);
            }));
        },
        goToSelectAll : function(e){
            alert("全部")
        },
        goToSelectM : function(){
            alert("明星推荐")
        },
        setQuery : function (query) {
            this.start = 0;
            this.end = -1;
            this.totalCount = 0;
            this.storeList.destroyDescendants();
            // 依据查询条件加载数据
            var queryResult = this.storeList.setQuery(query, {
                start : this.start,
                count : this.pageSize
            });
            //依据加载数据得结果处理界面显示
            this.onLoadListData(queryResult,this.start,this.pageSize);
        }
    });
});