﻿// 变更人:徐阿雪
// 变更时间:2016/10/26
// 变更原因:
define([
    "dojo/_base/declare",
	"dojo/_base/lang",
    "dojo/store/JsonRest",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "cq/biz/summary/trainProcess",
    "dojox/mobile/EdgeToEdgeStoreList"
],function(declare,lang,JsonRest,View,_ViewMixin,trainProcess,EdgeToEdgeStoreList){
    return declare("whz.view.TrainProcess",[View,_ViewMixin],{
        start:0,
        pageSize:10,
        onFirstShow:function(){
            var option = {
               isHeader:true,
               left : {
                   iconButton : ' ',
                   arrow : "left",
                   label : "返回",
                   onClick : function(){
                       this.isEditing = false;
                       history.back();
                   }
               },
               title : "商家统计",
               right: {
                    iconButton: ' ',
                    onClick: function() {
                        this.updataAll();
                    },
                    label: "刷新",
                }
           };
           this.addHeader(option);
           option = {
                isHeader: true,
                placeHolder: "请输入要查询的条件，按回车查询",
                class: "cqSearchBox",
                type: "search",
                onInput: lang.hitch(this, function(evt) {
                    if (evt.keyCode == 13) {
                        this.query.search = evt.target.value;
                        this.loadList(this.query);
                        this.query.search = '';
                        evt.target.value = "";
                    }
                })
            };
            this.addTextBox(option);
            this.query = {};
            this.trainProcessList=new EdgeToEdgeStoreList({
                append: true,
                constraint: false,
                query:{
                },
                className:"mat-list-verticalList2",
                variableHeight:true,
                onComplete:lang.hitch(this,function(data){
                    data = data||[];
                    for(var i=0;i<data.length;i++){
                        data[i]._label="<div><div>商家名："+data[i].shopName+"</div>"
                            +"<span style='width:49%;display:inline-block;'>员工数量："+data[i].staffNum+"</span>"
                            +"<span style='width:49%;display:inline-block;'>客户数量："+data[i].customerNum+"</span>"
                            +"<span style='width:49%;display:inline-block;'>自营商品数量："+data[i].selfMatNum+"</span>"
                            +"<span style='width:49%;display:inline-block;'>采购商品数量："+data[i].purchaseMatNum+"</span>"
                            +"<span style='width:49%;display:inline-block;'>销售订单数量："+data[i].saleOrderNum+"</span></div>";
                    }
                    this.trainProcessList.generateList(data);
                    this.busy = false;
                }),
                itemMap:{
                    _label:"label"
                }
            });
            //将列表添加到内容后面   this.centerPanel.containerNode直接添加当前节点到接下来的内容中
            this.trainProcessList.placeAt(this.centerPanel.containerNode,"last");
            this.centerPanel.on("afterscroll",lang.hitch(this,this.onLoadMore));
            this.onAfterShow();
        },
        onAfterShow:function(){
            this.loadList();
        },
        onLoadMore:function(e){
            if(!this.busy&&e.afterBottom){
                this.start = this.start+this.pageSize;
                if(this.canLoadMore(this.start)){
                    console.log("加载商品");
                    this.busy = true;
                    setTimeout(lang.hitch(this, function () {
                        var queryResult = this.trainProcessList.setQuery(this.trainProcessList.get("query"), {
                            start : this.start,
                            count : this.pageSize
                        });
                        this.onLoadListData(queryResult,this.start,this.pageSize);
                    }), 1000);
                }
            }
        },
        loadList:function(){
            this.start=0;
            this.trainProcessList.destroyDescendants();
            //若store没有初始化  创建new的srote  否则直接setQuery
            if(!this.trainProcessList.store){
                var url = trainProcess.getLoadUrl();
                //创建new的store
                var store = new JsonRest({target:url});
                // 将数据源赋值给StoreList
                var queryResult=this.trainProcessList.setStore(store,this.query,{
                    start:this.start,
                    count:this.pageSize
                });
                this.onLoadListData(queryResult,this.start,this.pageSize);
            }else{
                var queryResult=this.trainProcessList.setQuery(this.trainProcessList.get("query"),{
                    start:this.start,
                    count:this.pageSize
                });
                this.onLoadListData(queryResult,this.start,this.pageSize);
            }
        },
        updataAll:function(){
            trainProcess.updateAll().then(lang.hitch(function(data){
                this.loadList();
            }));
        }
    });
});