define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
	"dojo/query",
    "dojo/dom-style",
    "dojox/mobile/View",
    "dojox/mobile/FixedSplitter",
    "dojox/mobile/Pane",
	"cq/ui/view/_ViewMixin",
	"cq/biz/shop/shop",
    "cq/biz/ts/order"
], function (declare, lang, array, query, domStyle, View, FixedSplitter, Pane, _ViewMixin, shop, order) {
    return declare("whz.view.Treasurer", [View,_ViewMixin], {
        onFirstShow : function () {
            option = {src:'images/banner.jpg', onClick:function(){}};
			this.addImage(option);
            option = {
                columns:[{
                    icon:'images/icon/order.png',
                    iconClass:'width-32',
                    className:'flex1 saleVerified',
                    label:'我的订单',
                    onClick:function(){
                        window.moveToView("orderList",0);
                    }
                },{
                    icon:'images/icon/news.png',
                    iconClass:'width-32',
                    className:'flex1',
                    label:'商家余额',
                    onClick:function(){
                        window.moveToView("shopBalance");
                    }
                },{
                    icon:'images/icon/crmicon.png',
                    iconClass:'width-32',
                    className:'flex1 saleVerified',
                    label:'客户管理',
                    onClick:function(){
                        window.moveToView("userList");
                    }
                },{
                    icon:'images/icon/crmicon.png',
                    iconClass:'width-32',
                    className:'flex1 saleVerified',
                    label:'个人信息',
                    onClick:function(){
                        window.moveToView("userSetting");
                    }
                },{
                    icon:'images/icon/mat.png',
                    iconClass:'width-32',
                    className:'flex1 saleVerified',
                    label:'切换店铺',
                    onClick:function(){
                        window.moveToView("shopList");
                    }
                }],
                valueClass:'font-size3',
                labelClass:'font-size1',
                forceWidth:false,
                className:'bottom-margin8 padding-top-bottom16'
            };
            this.addColumns(option);            
            this.onAfterShow();
        }

    });
});