// 变更人：潘云
// 变更时间：2016-06-01
// 变更内容：商品评论列表
//变更人:王龙
//变更时间:2016-06-28
//变更内容:商品详情处点击宝贝评价进入的页面，标题修改为商品评价;
//消费者未上传头像时，默认头像显示错误
//消费者上传头像后，显示的头像还是默认头像
//评价时间追加显示为时分秒
//评价图片点击后支持看大图

// 变更人：潘云
// 变更时间：2016-06-29
// 变更内容：列表的加载更多样式问题
define([
	"dojo/_base/declare",
	"dojo/_base/lang",
	"dojo/_base/array",
    "dojo/dom-class",
	"dojo/dom-style",
	"dojo/dom-construct",
	"dojo/query",
    "dojo/on",
    "dojo/store/JsonRest",
    "dojox/mobile/View",
	"dojox/mobile/EdgeToEdgeStoreList",
	"dojox/mobile/Rating",
	"cq/biz/mat/mat",
	"cq/biz/ts/cart",
	"cq/biz/article/ss/comment",
	"cq/util/sys/date",
	"cq/ui/view/_ViewMixin",
    "cq/widgets/item/itemProp"
],function(declare,lang,array,domClass,domStyle,domConstruct, query,on,when,JsonRest,View,EdgeToEdgeStoreList,Rating,mat,cart,comment,date, _ViewMixin,itemProp){
	return declare("whz.view.MatEvalList",[View,_ViewMixin],{
		start : 0,
		pageSize : 5,
		onAfterShow:function(){
			//this.scores = [];
			if (this.storeList.store) {
				this.setQuery();
			}else{
				this.onLoadListData(this.storeList.setStore(this.store,this.getQuery(),{
					start: 0,
					count: this.pageSize
				}),this.start,this.pageSize);
			}			
			//this.refreshData();
		},
		onFirstShow:function(){
			var option = {
				left : {
					iconButton : ' ',
					arrow : "left",
					label : "返回",
					onClick : function() {
                        history.back();
                        
					}
				},
				title:"商品评价"
			};
			this.addHeader(option);
			// 添加评论列表
			this.storeList=new EdgeToEdgeStoreList({
				append: true,
				constraint: false,
				query:{},
				"class":"icon-list-item",
				variableHeight:true,
				//获取数据完成后调用的的处理方法
				onComplete:lang.hitch(this,function(data){
                    if(data&&data.length){
                        //将设置rating样式写到基类使用
                        itemProp.initMatEvaData(data);
                    }
                    else{
                        data = [{
                            _label:"<div>暂无评价</div>"
                        }];
                    }
					this.storeList.generateList(data);
					itemProp.initEvalistRating(this.storeList);
					this.busy = false;
				}),
				queryOptions: {
					count: this.pageSize,
					start: this.start
				},
				itemMap:{_label:"label"}
			});
			this.store = new JsonRest({target:comment.getLoadUrl()});
			this.storeList.placeAt(this.centerPanel.containerNode,"last");
			this.own(on(this.centerPanel,"afterscroll",lang.hitch(this,this.onLoadMore)));
            this.on("click",lang.hitch(this,this.onContentClick));
			this.onAfterShow();
		},
        onContentClick:function(e){
            //点击图片，且图片为商品评价图片，看大图
            if(e.target.tagName==="IMG"&&domClass.contains(e.target.parentNode,"evalimages")){
                this.showImg(e.target.src);
            }
        },
		onLoadMore : function(evt){
			if(!this.busy && evt.afterBottom){
                this.start = this.start + this.pageSize;
                if (this.canLoadMore(this.start)) {
                    this.busy = true;
                    setTimeout(lang.hitch(this, function () {
                        this.onLoadListData(this.storeList.setQuery(this.storeList.get("query"), {
                            start : this.start,
                            count : this.pageSize
                        }),this.start,this.pageSize);
                    }), 1000);
                }
                
            }
		},
		getQuery : function(){
			var query = {};
			if(window.did){
				query.commentId = window.did;
			}
			query.commentType = "mat";
			return query;
		},
		setQuery : function(){
			this.start = 0;
			this.storeList.destroyDescendants();
			this.onLoadListData(this.storeList.setQuery(this.getQuery(),{
				start: this.start,
				count: this.pageSize
			}), this.start, this.pageSize);
		}
	});
});
