// 变更人员：母浚驰
// 变更时间：2016/5/18
// 变更内容：代码规范，添加注释

// 变更人员：母浚驰
// 变更时间：2016/6/20
// 变更内容：时间格式，页面样式修改

// 变更人员：周科吉
// 变更时间：2016/6/28
// 变更内容：处理列表，以及刷新显示问题,排序问题

// 变更人:徐阿雪
// 变更时间:2016/6/30
// 变更原因:设置标题，修改时间精确到时分秒,修改movetoview，重写一个函数，获取不同type的数据，加载显示出来

// 变更人:徐阿雪
// 变更时间:2016/7/01
// 变更原因:列表显示方式变更
// 变更人:冉伟
// 变更时间:2016/7/05
// 变更原因:1.修改返回按钮的window.moveToView()改为history.back() 2.修改商品名称的class为 shelf-mat-title
// 变更人:徐阿雪
// 变更时间:2016/7/06
// 变更原因:将orderStatus的状态按照优先级显示,已退款问题修复
// 变更人:徐阿雪
// 变更时间:2016/7/06
// 变更原因:添加运费信息，style.css新建tAmount样式，在

// 变更人:刘轩
// 变更时间:2016/7/13
// 变更原因:修改订单状态显示优先级
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/dom-class",
    "dojo/dom-construct",
    "dojox/mobile/View",
    "dojox/mobile/EdgeToEdgeList",
    "dojox/mobile/ListItem",
    "cq/ui/view/_ViewMixin",
    "dojo/query",
    "dijit/registry",
    "dijit/_WidgetBase",
    "dojox/mobile/EdgeToEdgeStoreList",
    "dojo/on",
    "dojo/when",
    "dojo/store/JsonRest",
    "cq/util/sys/date",
    "cq/biz/ts/order",
    "cq/biz/user/user"
],function(declare,lang,array,domClass,domConstruct,View,EdgeToEdgeList,ListItem,_ViewMixin,query,registry,_WidgetBase,EdgeToEdgeStoreList,on,when,JsonRest,date,order,user){
    var OrderListItem = declare("", [_WidgetBase], {
        details:[],
        orderStatus:"",
        params:null,
        mAmount:0,
        amount:0,
        tAmount:0,
        buildRendering:function(){
            this.inherited(arguments);
            var countQty = 0;
            domClass.add(this.domNode,"order-list-item");
            //创建订单状态栏
            domConstruct.create("div",{"class":"order-list-status",innerHTML:"<span class='date'>创建时间:"+date.formatISODateMinutes(this.params.createAt)+"</span>"+"<span class='status'>"+this.orderStatus+"</span>"},this.domNode);
            this.detailList = domConstruct.create("div",{"class":"order-detail-list"},this.domNode);
            array.forEach(this.details,function (detail){
                countQty+=detail.qty;
                this.detailList.appendChild(this.createDetails(detail));
            },this);
            this.count = domConstruct.create("div",{"class":"order-list-count",innerHTML:"<span class='qty'>共"+countQty+"件商品</span><span class='count'>合计:<i>￥"+window.fixedTo(this.amount,3)+"<i></span><span class='tAmount'>（含运费：￥"+window.fixedTo(this.tAmount,3)+"）</span>"},this.domNode);
        },//添加运费信息，style.css新建tAmount样式   2016/7/8 徐阿雪
        //创建订单详情的列表
        createDetails:function(data){
            var htmlStr = "";
            htmlStr+='<li class="order-detail-item">';
            htmlStr+=    '<img alt="" src="'+data.mId.logo+'" class="icon" style="margin-top: 1px;">';
            htmlStr+=    '<div class="right" style="display: block;">';
            htmlStr+=       '<div class="shelf-mat-title">'+data.mId.mName+'</div>';  //'<div class="mname">'+data.mId.mName+'</div>'  
            htmlStr+=        '<div><span class="price">￥'+window.fixedTo(data.price,3)+'</span><span class="qty">x'+data.qty+'</span></div>';
            htmlStr+=    '</div>';
            htmlStr+='</li>';
            return domConstruct.toDom(htmlStr);
        }
    });
    return declare("widgets.mobile.OrderList",[View,_ViewMixin],{
        // 设置初始显示第0行
        start:0,
        //设置页面显示条数
        pageSize:20,

        // 设置页面内容的url
        url:"",

        // 加载数据,并显示到页面上
        onAfterShow:function(){
            user.hasLogin().then(lang.hitch(this,function(s){
                if(s){
                    this.type=window.did;
                    this.loadFirstPage();
                    this.busy=false;
                }else{
                    window.moveToView("login");
                    user.nextPage="orderList";
                }
            }));
        },
        // 创建列表
        onCreatList: function(){
            this.storeList=new EdgeToEdgeStoreList({
                append: true,
                constraint: false,
                query:{
                },
                className:"icon-list-item",
                variableHeight:true,
                //获取数据完成后调用的的处理方法
                onComplete:lang.hitch(this,function(data){
                    /*for(var i=0;i<data.length;i++){
                        data[i]._label="<img class='edit-car-matimg' src='"+data[i].mId.logo+"' /><span class='edit-car-matname'>"+data[i].mId.mName+"</span>",
                        +"<span class='edit-car-matprice'>单价:￥"+window.fixedTo(data[i].price,3)+"</span>",
                        +"<span class='edit-car-priceAll'>小计:￥"+window.fixedTo(data[i].price*data[i].qty,3)+"</span>",
                        data[i].rightText=this.getDetailLabel(data[i]);
                    }*/
                    array.forEach(data, function(item) {
                        item.orderStatus = this.getOrderStatus(item);
                    },this);
                    this.storeList.generateList(data);
                    this.busy = false;
                }),
                itemRenderer:OrderListItem,
                itemMap:{
                    mAmount:"mAmount",
                    amount:"amount",
                    details:"details",
                    orderStatus:"orderStatus",
                    tAmount:"tAmount"
                }
                //itemMap:{_label:"label", logo:"icon"}
            });

            this.storeList.placeAt(this.centerPanel.containerNode,"last");
            this.storeList.on("click",lang.hitch(this,this.onClickList));
            this.centerPanel.on("afterscroll",lang.hitch(this,this.onLoadMore));
        },
        //获取订单的状态
        getOrderStatus:function(data){
            // 将orderStatus的状态按照优先级显示已退款问题修复  2016/7/6  徐阿雪 
            // 已退款是根据主表的已支付和已取消来重新定义
            //data.isRefounded=Boolean(date.isPayed&&data.isCanceled);
            //console.log("shuchu "+data.isRefounded);
            var state = "";
            // 待付款
            if(false===data.isPayed&&false===data.isCanceled){
                state = "待付款";
            }
            // 已取消
            else if(data.isPayed==false&&data.isCanceled){
                state = "已取消";
            }
            // 已退款
            else if(data.isPayed&&data.isCanceled){
                state = "已退款"
            }
            // 待发货
            else if(data.isPayed&&(false===data.isAccepted||false===data.isDelived)&&false===data.isCanceled){
                state = "待发货";
            }
            // 待收货
            else if(data.isPayed&&data.isAccepted&&data.isDelived&&false===data.isCanceled&&data.isReceipted===false){
                state = "待收货";
            }
            // 待评价
            else if(data.isPayed&&false===data.isCanceled&&data.isReceipted&&data.isClosed==false){
                state = "待评价";
            }
            // 已完成
            else if(data.isPayed&&false===data.isCanceled&&data.isReceipted&&data.isClosed){
                state = "已完成";
            }
            //else if(data.isPayed&&false===data.isAccepted&&false===data.isCanceled){
            //    state = "待审核";
            //}else if(data.isPayed&&data.isAccepted&&false===data.isDelived&&false===data.isCanceled){
            //    state = "待发货";
            //}else if(data.isPayed&&data.isAccepted&&data.isDelived&&false===data.isCanceled&&false===data.isClosed&&false===data.isReceipted){
            //    state = "已发货";
            //}else if(data.isPayed&&data.isAccepted&&data.isDelived&&data.isReceipted&&false===data.isCanceled&&false===data.isClosed){
            //    state = "已收货";
            //}else if(data.isPayed && data.isAccepted && data.isDelived &&data.isCanceled&&false===data.isClosed&&false===data.isReceipted){
            //    state = "已退款";
            //}else if (data.isPayed&&data.isClosed) {
            //    state = "已完成";
            //}else if(data.isCanceled&& false === data.isDelived&& false===data.isAccepted){
            //    state = "已取消";
            //}
            return state;
        },
        //初始化页面元素,绑定事件
        onFirstShow : function() {
            var option = {
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick : function() {
                        window.moveToView("user");
                    }
                },
                title:"我的订单",
                /* right :
                    {iconButton : ' ', onClick : this.onSaveStore, label : "完成"} */
            };
            this.addHeader(option);
            option = {
                isHeader: true,
                columns:[{
                    label:'全部',
                    className:'footer-tab-col-highlight sale',
                    onClick:lang.hitch(this,function(e){
                        // 徐阿雪 修改movetoview，重写一个函数，获取不同type的数据，加载显示出来
                        this.type="";
                        this.loadFirstPage();
                    })
                },
                {
                    label:'待付款',
                    className:'sale',
                    onClick:lang.hitch(this,function(e){
                        this.type = 0;
                        this.loadFirstPage();
                    })
                },
                {
                    label:'待发货',
                    className:'sale',
                    onClick:lang.hitch(this,function(e){
                        this.type = 1;
                        this.loadFirstPage();
                    })
                },
                {
                    label:'待收货',
                    className:'sale',
                    onClick:lang.hitch(this,function(e){
                        this.type = 2;
                        this.loadFirstPage();
                    })
                },
                {
                    label:'待评价',
                    className:'sale',
                    onClick:lang.hitch(this,function(e){
                        this.type = 3;
                        this.loadFirstPage();
                    })
                }],
                labelClass:'font-size1 tab-selector'
            },
            this.addColumns(option);
            this.onCreatList();
            //发生loadFirstPage函数时，调用changeOnall
            this.connect(this,"loadFirstPage",function(){
                this.changeOnAll(this.type);
            });
            this.onAfterShow();
        },
        // 订单查询时的属性
        getParse: function(type){
            type = type+"";
            if(type === "0"){
                return {isPayed:false,isCanceled:false,orderBy:'-createAt'};
            } else if(type === "1"){
                return {isPayed:true,isAccepted:true,isDelived:false,isCanceled:false,orderBy:'-createAt'};
            } else if(type === "2"){
                return {isDelived:true,isReceipted:false,isCanceled:false,orderBy:'-createAt'};
            } else if(type === "3"){
                return {isReceipted:true,isEvaluated:false,orderBy:'-createAt'};
            }else{
                return {orderBy:'-createAt'};
            }
        },
        //订单类型改变
        changeOnAll : function(type){
            if(""===type){
                type=-1;
            }else{
                type = type-0;
            }
            type = type+1;
            array.forEach(query(".sale",this.domNode),function(list,index){
                domClass[type===index?"add":"remove"](list, "footer-tab-col-highlight");
            });
        },
        // 订单列表点击
        onClickList:function(evt){
            // 得到点击的ListItem
            var li = registry.getEnclosingWidget(evt.target);
            if(li.declaredClass!="dijit._WidgetBase") return;
            var _tsId = li.params._id;
            window.moveToView("orderDetail",_tsId);
        },
        // 下拉列表加载更多
        // 重写加载方法
        onLoadMore:function(evt){
            if(!this.busy&&evt.afterBottom){
                this.start = this.start+this.pageSize;
                //使用canLoadMore判断加载更多的条件
                if(this.canLoadMore(this.start)){
                    this.busy = true;
                    setTimeout(lang.hitch(this,function(){
                        var queryResult = this.storeList.setQuery(this.storeList.get("query"), {
                            start: this.start,
                            count: this.pageSize
                        });
                        this.onLoadListData(queryResult,this.start,this.pageSize);
                    }), 1000);
                }
            }
        },
        //依据当前页面状态，加载第一页订单数据
        loadFirstPage:function(){
            this.start = 0;
            this.storeList.destroyDescendants();
            //若取订单的地址发生了变化，重新setStore，否则setQuery
            //徐阿雪 2016/6/30
            if(this.store){
                this.busy = true;
                    var queryResult = this.storeList.setQuery(this.getParse(this.type), {
                        start: this.start,
                        count: this.pageSize
                    });
                    this.onLoadListData(queryResult,this.start,this.pageSize);
            }else{
                // 创建数据源
                this.store = new JsonRest({target:order.getWithDetailsUrl()});
                // 将数据源赋值给storeList
                this.busy=true;
                    var queryResult = this.storeList.setStore(this.store,this.getParse(this.type),{
                        start: this.start,
                        count: this.pageSize
                    });
                    this.onLoadListData(queryResult,this.start,this.pageSize);
            }
        }
    });
});
