
//修改人: 杜飞军
//修改时间: 2016-06-08
//修改内容:
    //获取验证码按钮位置
// 变更人:刘轩
// 变更时间:2016/7/19
// 变更内容:
//          注册成功后成功清楚页面输入信息
//          注册成功后自动登录
//          注释掉pageToview,没看懂什么意思??
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-attr",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "dojo/query",
    "cq/biz/user/user",
    "cq/biz/sms/sms"
], function(declare, lang, domAttr, View, _ViewMixin, query, user, sms) {
    return declare("widgets.mobile.Register", [View, _ViewMixin], {
        //pageToview: false,
        onAfterShow: function() {
            this.emptyData();
        },
        onFirstShow: function() {
            // 头部设置
            var options = {
                left: {
                    iconButton: ' ',
                    arrow: "left",
                    label: "返回",
                    onClick: lang.hitch(this, function() {
                        this.emptyData();
                        this.clearTimeView(this.vCode);
                        history.back();
                        //window.moveToView("main");
                    })
                },
                title: "注册"
            };
            this.addHeader(options);
            // text文本框添加  
            options = {
                isEdge: true,
                class: "top-bottom-margin16",
                lists: [{
                    label: '手机号码',
                    noArrow: true,
                    edit: { type: 'text', field: 'userName', placeHolder: '你登陆使用名称' }
                }, {
                    className: "mblListItem btn-vcode",
                    rightText: '获取验证码',
                    onClick: lang.hitch(this, function(e) {
                        // 可能点击在 整个列表中
                        if (e.target.className !== "mblListItemRightText") {
                            return;
                        }
                        //if (this.pageToview) {
                        this.setVerifyCodeWaite(e.target, 60, lang.hitch(this, function() {
                            var data = this.getData();
                            sms.sendVcode(data.userName);
                        }));
                        //}
                    })
                }, {
                    label: '验证码',
                    noArrow: true,
                    edit: {
                        type: 'text',
                        field: 'vCode',
                        placeHolder: '请填写短信验证码'
                    },
                }, {
                    label: '密码',
                    noArrow: true,
                    edit: { type: 'password', field: 'password', placeHolder: '你登录使用的密码' }
                }, {
                    label: '确认密码',
                    noArrow: true,
                    edit: { type: 'password', field: 'repassword', placeHolder: '重复你的登陆密码' }
                }]
            };
            // 获得电话号码的对象
            this.addLists(options);
            var verStore;
            query("input[__data_field='userName']", this.domNode).forEach(lang.hitch(this, function(list) {
                this.connect(list, "onblur", lang.hitch(this, function(e) {
                    if (/^(0|86|17951)?(13[0-9]|15[012356789]|17[678]|18[0-9]|14[57])[0-9]{8}$/.test(e.target.value)) {
                        if (verStore != e.target.value) {
                            user.onCheckExist(e.target.value).then(lang.hitch(this, function(data) {
                                if (data.data.ok === 1) {
                                    alert("手机号已经注册，请直接登陆");
                                    window.moveToView("login");
                                }
                                //else {
                                //    this.pageToview = true;
                                //}
                            }));
                        }
                    } else {
                        alert("请输入正解的11位电话号码");
                    }
                    verStore = e.target.value;
                }));
            }));
            // 确认按钮 登陆
            options = {
                columns: [{
                        label: "登陆",
                        className: "flex1 footer-tab-dark",
                        onClick: function() {
                            window.moveToView("login");
                        }
                    }, {
                        label: "确认",
                        className: "flex2 footer-tab-highlight",
                        onClick: lang.hitch(this, this.onVerify)
                    }
                    // {
                    //   label:"获取验证码",
                    //   className:"flex1 footer-tab-dark",
                    //   onClick : lang.hitch(this,this.getVetify)
                    // }
                ],
                className: '',
                forceWidth: false,
                isFooter: true
            };
            this.addColumns(options);
            // 获得验证码节点
            this.vCode = query(".btn-vcode .mblListItemRightText", this.domNode)[0];
            this.onAfterShow();
        },

        // 清空数据
        emptyData: function() {
            this.setData({});
            this.refreshData();
        },

        // 私有存储字符串
        _userInfo: {},
        // 提交处理
        onRegister: function() {
            user.register({
                "userName": this._userInfo.userName,
                "password": this._userInfo.password,
                "vCode": this._userInfo.verify
            }).then(lang.hitch(this, function(result) {
                if (result.data.ok === 1) {
                    this.emptyData();
                    this.clearTimeView(this.vCode);
                    //window.moveToView("login");
                    // 注册成功后直接登录
                    user.loginByPassword(this._userInfo.userName, this._userInfo.password).then(lang.hitch(this, function(r){
                        if(r.data.ok==1){
                            window.moveToView(user.nextPage||"user");
                        }else{
                            alert("登录失败");
                        }
                    }));
                } else if (result.data.status === 101) {
                    alert("验证码错误");
                } else if (result.data.status === 102) {
                    alert("验证码已过期");
                } else if (result.data.status === 310) {
                    alert("用户名已存在");
                }
            }));
        },
        // 验证字段
        onVerify: function() {
            this._userInfo.userName = query("[__data_field='userName']", this.domNode)[0].value;
            this._userInfo.verify = query("[__data_field='vCode']", this.domNode)[0].value;
            this._userInfo.password = query("[__data_field='password']", this.domNode)[0].value;
            this._userInfo.repassword = query("[__data_field='repassword']", this.domNode)[0].value;
            // 提示处理
            if (!/^(0|86|17951)?(13[0-9]|15[012356789]|17[678]|18[0-9]|14[57])[0-9]{8}$/.test(this._userInfo.userName)) {
                alert("请输入正确的11位电话号码");
            } else if (this._userInfo.verify === "") {
                alert("验证码不能为空");
            } else if (this._userInfo.password === "" || this._userInfo.repassword === "") {
                alert("密码不能为空");
            } else if (this._userInfo.password != this._userInfo.repassword) {
                alert("两次密码不一致");
            } else {
                this.onRegister();
            }
        },

        // 设置定时器
        setVerifyCodeWaite: function(domNode, wTime, callback) {
            var registData = this.getData();
            if (/^(0|86|17951)?(13[0-9]|15[012356789]|17[678]|18[0-9]|14[57])[0-9]{8}$/.test(registData.userName)) {
                if (this.vCodeWaite) {
                    alert("请稍后再发");
                    return;
                } else {
                    alert("验证码已经发送");
                    this.codeHtml = domAttr.get(domNode, "innerHTML");
                    this.vCodeWaite = true;
                    // 执行回调
                    callback.apply(this);
                    this.animate = setInterval(lang.hitch(this, function() {
                        wTime--;
                        // 获得传递的对象
                        domAttr.set(domNode, "innerHTML", this.codeHtml + "(" + wTime + ")");
                        if (wTime === 0) {
                            this.vCodeWaite = false;
                            clearInterval(this.animate);
                            domAttr.set(domNode, "innerHTML", this.codeHtml);
                        }
                    }), 1000);
                }
            } else {
                alert("请输入正确的11位电话号码");
            }
        },

        // 清除计时器显示
        clearTimeView: function(domNode) {
            this.vCodeWaite = false;
            // 可能存在没有点击发送验证码就清除的问题
            if (this.codeHtml) {
                domAttr.set(domNode, "innerHTML", this.codeHtml);
            }
            clearInterval(this.animate);
        }
    });
});
