/**
 * 修改人: 杜飞军
 * 修改内容  图片显示大小问题
 */
 //修改人：周超
 //修改内容：余额字段显示
 //修改时间：2016-6-30
  //修改人：冉伟
 //修改内容：点击我的信息->点击首页,商家默认LOGO错误，this.banner.domNode未定义
 //修改时间：2016-6-30
/* 
修改人：张金鹏
修改内容：增加我的评价入口
修改时间：2016/09/06
 
修改人：张金鹏
修改内容：增加我关注的商品、已购买的商品、我的收货地址的入口、调整余额显示的位置
修改时间：2016/09/21 
*/

define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/xhr",
    "dojo/Deferred",
    "dojo/dom-construct",
    "dojo/dom-class",
    "dojo/dom-style",
    "dojo/query",
    "dojo/topic",
    "dijit/registry",
    "dojox/mobile/View",
    "cq/biz/user/user",
    "cq/biz/ts/order",
    "cq/ui/view/_ViewMixin"
], function (declare, lang, xhr, Deferred, domConstruct, domClass, domStyle, query, topic, registry, View, user, order, _ViewMixin) {
    return declare("widgets.mobile.User", [View, _ViewMixin], {
        onFirstShow : function () {
            var options = {
                boxes: [{
                    icon: g_sys_info.logo,
                    banner: "/static/images/mobile/user_header.jpg",
                    title: "未登录",
                    userSetting: true
                }]
			};
			this.banner = this.addIconBanner(options);
			option = {
				columns: [{
                    label: '待付款',
                    iconClass: 'width-24',
                    icon: '/static/images/mobile/user_toeva.png',
                    isBadge: true,
                    badgeClass: "user_toeva_num",
                    onClick: lang.hitch(this, function (e) {
                        this.loginToview("orderList-0");
                    })
                }, {
                    label : '待发货',
                    badgeClass : "user_tostate_num",
                    iconClass : 'width-24',
                    isBadge : true,
                    icon : '/static/images/mobile/user_tostate.png',
                    onClick : lang.hitch(this, function (e) {
                        this.loginToview("orderList-1");
                    })
                }, {
                    label : '待收货',
                    iconClass : 'width-24',
                    badgeClass : "user_todeli_num",
                    isBadge : true,
                    icon : '/static/images/mobile/user_todeli.png',
                    onClick : lang.hitch(this, function (e) {
                        this.loginToview("orderList-2");
                    })
                }, {
                    label : '待评价',
                    iconClass : 'width-24',
                    badgeClass : "user_topay_num",
                    isBadge : true,
                    icon : '/static/images/mobile/user_topay.png',
                    onClick : lang.hitch(this, function (e) {
                        this.loginToview("orderList-3");
                    })
                }],
				labelClass : 'font-size1 tab-selector',
				className : "orderNumList"
			};
			this.addColumns(option);
			option = {
				isEdge : true,
				lists : [{
                    icon : '/static/images/mobile/user_allorder.png',
                    //iconPos : '0,0,29,29',
                    label : '我的订单',
                    rightText : '',
                    noArrow : false,
                    moveTo : "#",
                    onClick : lang.hitch(this, function () {
                        this.loginToview("orderList");
                    })
                }, {
					//添加我关注的商品
                    icon : '/static/images/mobile/user_concerned_goods.png',
                    label : '我的关注商品',
					rightText : '',
                    noArrow : false,
                    moveTo : "#",
                    onClick : lang.hitch(this, function () {
                        this.loginToview("attentionMatList");
                    })
                }, {
					//添加我已购买的商品
                    icon : '/static/images/mobile/user_purchased_goods.png',
                    label : '已购买商品',
					rightText : '',
                    noArrow : false,
                    moveTo : "#",
                    onClick : lang.hitch(this, function () {
                        this.loginToview("boughtMatList");
                    })
                },{
                    icon : '/static/images/mobile/user_my_partner.png',
                    //iconPos : '0,0,29,29',
                    //iconClass : "nav_dropdowm",
                    label : '我的伙伴',
                    rightText : '',
                    noArrow : false,
                    moveTo : "#",
                    onClick : lang.hitch(this, function () {
                        this.loginToview("clientDistribute");
                    })
                }, {
                    icon : '/static/images/mobile/user_my_card.png',
                    //iconPos : '0,0,29,29',
                    //iconClass : "nav_dropdowm",
                    label : '我的卡券',
                    rightText : '',
                    noArrow : false,
                    moveTo : "#",
                    onClick : lang.hitch(this, function () {
                        this.loginToview("userCountSer");
                    })
                }, {
                    icon : '/static/images/mobile/user_my_evaluation.png',
                    //iconPos : '0,0,29,29',
                    //iconClass : "nav_dropdowm",
                    label : '我的评价',
                    rightText : '',
                    noArrow : false,
                    moveTo : "#",
                    onClick : lang.hitch(this, function () {
                        this.loginToview("evaList");
                    })
                },  {
					//添加我的收货地址
                    icon : '/static/images/mobile/user_my_receipt_address.png',
                    label : '我的收货地址',
                    rightText : '',
                    noArrow : false,
                    moveTo : "#",
                    onClick : lang.hitch(this, function () {
                        this.loginToview("userAddList");
                    })
                },]
			};
			var viewList = this.addLists(option);
            // 不知道写这两行代码的意义?    刘轩  2016-7-19注释掉
			//query("img", viewList.domNode).forEach(function (item) {
			//	domClass.add(item, "nav_dropdowm");
			//});
			var option = {
				columns : [{
                    icon : '/static/images/mobile/main1.png',
                    iconClass : 'footer-tab-img',
                    className : 'footer-tab-col-normal',
                    label : '首页',
                    onClick : function () {
                        window.moveToView("main");
                    }

                }, {
                    icon : '/static/images/mobile/contact1.png',
                    iconClass : 'footer-tab-img',
                    label : '动态',
                    className : 'footer-tab-col-normal',
                    onClick : function () {
                        window.moveToView("newsList");
                    }
                }, {
                    icon : '/static/images/mobile/orderCar1.png',
                    iconClass : 'footer-tab-img',
                    label : '购物车',
                    isBadge : true,
                    badgeClass : "orderCarNum",
                    className : 'footer-tab-col-normal',
                    onClick : function () {
                        window.moveToView("orderCar");
                    }
                }, {
                    icon : '/static/images/mobile/user.png',
                    iconClass : 'footer-tab-img',
                    label : '我的信息',
                    className : 'footer-tab-col-highlight',
                    onClick : function () {
                        window.moveToView("user");
                    }
                }],
				labelClass : 'font-size1',
				className : 'fix-footer',
				isFooter : true
			};
			// this.addColumns(option);
            this.addFooterColumns();
            this.objAmt="0.00";
            this.payDomNode = "<div class='getPayDom' style='position: absolute;right: 12px;top: 17%;text-align: right'>余额：" + this.objAmt + "</div>";
            var target = domConstruct.toDom(this.payDomNode);
            this.banner = query(".banner", this.domNode)[0];
            this.banner.appendChild(target);
			this._topSplitter.resize();
			//每次firstShow时侦听广播
			//topic.subscribe("cq/biz/ts/cart/numChanged", lang.hitch(this,function(num){
			//		this.matNumNode.innerHTML = num;
			//}));
            
			this.onAfterShow();
			this.queryDom();
			this.connect(query(".banner-title", this.banner.domNode)[0], "onclick", function (e) {
				this.loginToview("user");
			});
			this.connect(query(".user-setting", this.banner.domNode)[0], "onclick", function () {
				this.loginToview("userSetting");
			});
		},
		queryDom : function () {
			this.orderNumList = query(".orderNumList", this.domNode)[0];
			this.user_toeva_num = query(".user_toeva_num", this.orderNumList)[0];
			this.user_tostate_num = query(".user_tostate_num", this.orderNumList)[0];
			this.user_todeli_num = query(".user_todeli_num", this.orderNumList)[0];
			this.user_topay_num = query(".user_topay_num", this.orderNumList)[0];
		},
		loginToview : function (page) {
			if (this.isLogin) {
				window.moveToView(page);
			} else {
				window.moveToView("login");
				user.nextPage = page;
			}
		},
		isLogin : false,
		onAfterShow : function () {
			this.inherited(arguments);
			var userDomNode = query(".banner", this.domNode)[0];
			domStyle.set(userDomNode, "background-color", "white");
			user.hasLogin().then(lang.hitch(this, function (s) {
                //console.log(s);
                //this.banner.domNode未定义
                var bannerTitle = query(".banner-title", this.domNode)[0];
                var bannerIcon = query(".banner-icon", this.domNode)[0];
                if (s) {
                    this.isLogin = true;
                    this.refreshOrderNum();
                    user.loadById(user.getCurrentUserId()).then(lang.hitch(this, function (data) {
                        var item = data && data.data && data.data.item;
                        if (data && data.data && data.data.ok == "1") {
                            domClass.add(bannerTitle, "isLogin");
                            bannerTitle.innerHTML = item.pName || "未填写";
                            bannerIcon.src = item.logo || "/static/images/mobile/user_userIcon.png";
                        }
                        //余额：
                        if(data && data.data && data.data.ok == "1"){
                            this.objAmt = window.fixedTo((data.data.item.amount) || 0, 3);
                        }else{
                            this.objAmt = "0.00";
                        }
                        var payDom = query(".getPayDom", this.domNode)[0];
                        payDom.innerHTML = "余额：" + this.objAmt;
                        }));
                } else {
                    this.isLogin = false;
                    bannerTitle.innerHTML = "未登录";
                    domClass.remove(bannerTitle, "isLogin");
                    bannerIcon.src = "/static/images/mobile/user_userIcon.png";
                    this.objAmt = "0.00";
                    //this.objAmt = window.fixedTo((data.data.item.amount) || 0, 3);
                    var payDom = query(".getPayDom", this.domNode)[0];
                    payDom.innerHTML = "余额：" + this.objAmt;
                }
            }));
		},
		refreshOrderNum : function () {
			order.getDetailCount().then(lang.hitch(this, function (data) {
                data = data && data.data;
                this.user_toeva_num.innerHTML = data.toPayCount || 0;
                this.user_tostate_num.innerHTML = data.toDeliverCount || 0;
                this.user_todeli_num.innerHTML = data.toReceiptCount || 0;
                this.user_topay_num.innerHTML = data.toEvaluateCount || 0;
                // 张松   当数量为0时，隐藏badge      2016/06/29
                domStyle.set(this.user_toeva_num, "display", (data.toPayCount || 0) ? "" : "none");
                domStyle.set(this.user_tostate_num, "display", (data.toDeliverCount || 0) ? "" : "none");
                domStyle.set(this.user_todeli_num, "display", (data.toReceiptCount || 0) ? "" : "none");
                domStyle.set(this.user_topay_num, "display", (data.toEvaluateCount || 0) ? "" : "none");
            }));
		}
	});
});
