//特性：
//  view嵌套
//  view布局配置完全独立
//  无需为每个view写一个程序
//  支持view和内部widget联动
//  支持view内部widget之间联动
//  支持纯静态内容定义
//所有程序全部写到这个文件中，需要时将各个对象单独分离
require([
    "dojo/ready",
    "dojox/mobile/Heading"
], function(ready,Heading) {
    require([
        "cq/app/config",
        "cq/app/builder/mobileBuilder",
        "cq/app/layout/loader/memoryLayoutLoader",
        "cq/app/view/view/FullScreenWeb",
        "cq/util/config/config",
        "cq/app/layout/mobile/layout",
        "dojo/dom-construct"
    ], function(config, mobileBuilder, memoryLayoutLoader, View, config2,layout,domConstruct) {
        config2.dataOrigin = config2.dataOrigin||"http://192.168.0.2";
        config2.shopId = config2.platformShopId = config2.platformShopId||"5768266836bbf3701f5a303a";
        domConstruct.create("link",{rel:"stylesheet",type:"text/css",href:"../../../static/common/app.css"},document.head,"first");
        //根view
        config.view = {
            //默认下级view为欢迎页
            defaultView: "widgetTest",
            subViews: {
                widgetTest: {},
                login:{},
                personalInformation:{},
                changePassword:{},
                retrieve:{},
                register:{}
            }
        };
        config.layoutBuilder = mobileBuilder;
        config.ViewRender = View;
        config.loadLayout = function() {
            return memoryLayoutLoader.loadLayout.apply(memoryLayoutLoader, arguments);
        };
        config.nextPageOnLogin = "user";
        memoryLayoutLoader.layouts = {
            "": [{
                type: "viewContainer"
            }],
            widgetTest:[{
                fixed:"top",
                type:"topBar",
                label:"店铺登陆",
                left:[{
                    type:"iconMenuItem",
                    label:"返回",
                    icon:"",
                    arrow:"left",
                    href:"back"
                }]
            },{
                dojoType: "cq/app/widget/web/DataLayout",
                dataProvider: "cq/bo/widgetTest",
                layoutMethod: "getWidgetTestLayout"
            }],
            login:layout.loginC,
            personalInformation:layout.personalInformation,
            changePassword:layout.changePasswordC,
            retrieve:layout.retrieve,
            register:layout.register
        };
    });
});
